/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/process","vs/base/common/labels","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(V){for(var e=[],E=0,t=V.length;E<t;E++)e[E]=te[V[E]];return e};define(te[122],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(D){return D?D.replace(/\$\((.*?)\)/g,(R,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(R,I,d){this.id=R,this.fontCharacter=I,this.description=d,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add","\\ea60"),t.plus=new t("plus",t.add.fontCharacter),t.gistNew=new t("gist-new",t.add.fontCharacter),t.repoCreate=new t("repo-create",t.add.fontCharacter),t.lightbulb=new t("lightbulb","\\ea61"),t.lightBulb=new t("light-bulb","\\ea61"),t.repo=new t("repo","\\ea62"),t.repoDelete=new t("repo-delete","\\ea62"),t.gistFork=new t("gist-fork","\\ea63"),t.repoForked=new t("repo-forked","\\ea63"),t.gitPullRequest=new t("git-pull-request","\\ea64"),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned","\\ea64"),t.recordKeys=new t("record-keys","\\ea65"),t.keyboard=new t("keyboard","\\ea65"),t.tag=new t("tag","\\ea66"),t.tagAdd=new t("tag-add","\\ea66"),t.tagRemove=new t("tag-remove","\\ea66"),t.person=new t("person","\\ea67"),t.personFollow=new t("person-follow","\\ea67"),t.personOutline=new t("person-outline","\\ea67"),t.personFilled=new t("person-filled","\\ea67"),t.gitBranch=new t("git-branch","\\ea68"),t.gitBranchCreate=new t("git-branch-create","\\ea68"),t.gitBranchDelete=new t("git-branch-delete","\\ea68"),t.sourceControl=new t("source-control","\\ea68"),t.mirror=new t("mirror","\\ea69"),t.mirrorPublic=new t("mirror-public","\\ea69"),t.star=new t("star","\\ea6a"),t.starAdd=new t("star-add","\\ea6a"),t.starDelete=new t("star-delete","\\ea6a"),t.starEmpty=new t("star-empty","\\ea6a"),t.comment=new t("comment","\\ea6b"),t.commentAdd=new t("comment-add","\\ea6b"),t.alert=new t("alert","\\ea6c"),t.warning=new t("warning","\\ea6c"),t.search=new t("search","\\ea6d"),t.searchSave=new t("search-save","\\ea6d"),t.logOut=new t("log-out","\\ea6e"),t.signOut=new t("sign-out","\\ea6e"),t.logIn=new t("log-in","\\ea6f"),t.signIn=new t("sign-in","\\ea6f"),t.eye=new t("eye","\\ea70"),t.eyeUnwatch=new t("eye-unwatch","\\ea70"),t.eyeWatch=new t("eye-watch","\\ea70"),t.circleFilled=new t("circle-filled","\\ea71"),t.primitiveDot=new t("primitive-dot",t.circleFilled.fontCharacter),t.closeDirty=new t("close-dirty",t.circleFilled.fontCharacter),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.fontCharacter),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.fontCharacter),t.debugHint=new t("debug-hint",t.circleFilled.fontCharacter),t.primitiveSquare=new t("primitive-square","\\ea72"),t.edit=new t("edit","\\ea73"),t.pencil=new t("pencil","\\ea73"),t.info=new t("info","\\ea74"),t.issueOpened=new t("issue-opened","\\ea74"),t.gistPrivate=new t("gist-private","\\ea75"),t.gitForkPrivate=new t("git-fork-private","\\ea75"),t.lock=new t("lock","\\ea75"),t.mirrorPrivate=new t("mirror-private","\\ea75"),t.close=new t("close","\\ea76"),t.removeClose=new t("remove-close","\\ea76"),t.x=new t("x","\\ea76"),t.repoSync=new t("repo-sync","\\ea77"),t.sync=new t("sync","\\ea77"),t.clone=new t("clone","\\ea78"),t.desktopDownload=new t("desktop-download","\\ea78"),t.beaker=new t("beaker","\\ea79"),t.microscope=new t("microscope","\\ea79"),t.vm=new t("vm","\\ea7a"),t.deviceDesktop=new t("device-desktop","\\ea7a"),t.file=new t("file","\\ea7b"),t.fileText=new t("file-text","\\ea7b"),t.more=new t("more","\\ea7c"),t.ellipsis=new t("ellipsis","\\ea7c"),t.kebabHorizontal=new t("kebab-horizontal","\\ea7c"),t.mailReply=new t("mail-reply","\\ea7d"),t.reply=new t("reply","\\ea7d"),t.organization=new t("organization","\\ea7e"),t.organizationFilled=new t("organization-filled","\\ea7e"),t.organizationOutline=new t("organization-outline","\\ea7e"),t.newFile=new t("new-file","\\ea7f"),t.fileAdd=new t("file-add","\\ea7f"),t.newFolder=new t("new-folder","\\ea80"),t.fileDirectoryCreate=new t("file-directory-create","\\ea80"),t.trash=new t("trash","\\ea81"),t.trashcan=new t("trashcan","\\ea81"),t.history=new t("history","\\ea82"),t.clock=new t("clock","\\ea82"),t.folder=new t("folder","\\ea83"),t.fileDirectory=new t("file-directory","\\ea83"),t.symbolFolder=new t("symbol-folder","\\ea83"),t.logoGithub=new t("logo-github","\\ea84"),t.markGithub=new t("mark-github","\\ea84"),t.github=new t("github","\\ea84"),t.terminal=new t("terminal","\\ea85"),t.console=new t("console","\\ea85"),t.repl=new t("repl","\\ea85"),t.zap=new t("zap","\\ea86"),t.symbolEvent=new t("symbol-event","\\ea86"),t.error=new t("error","\\ea87"),t.stop=new t("stop","\\ea87"),t.variable=new t("variable","\\ea88"),t.symbolVariable=new t("symbol-variable","\\ea88"),t.array=new t("array","\\ea8a"),t.symbolArray=new t("symbol-array","\\ea8a"),t.symbolModule=new t("symbol-module","\\ea8b"),t.symbolPackage=new t("symbol-package","\\ea8b"),t.symbolNamespace=new t("symbol-namespace","\\ea8b"),t.symbolObject=new t("symbol-object","\\ea8b"),t.symbolMethod=new t("symbol-method","\\ea8c"),t.symbolFunction=new t("symbol-function","\\ea8c"),t.symbolConstructor=new t("symbol-constructor","\\ea8c"),t.symbolBoolean=new t("symbol-boolean","\\ea8f"),t.symbolNull=new t("symbol-null","\\ea8f"),t.symbolNumeric=new t("symbol-numeric","\\ea90"),t.symbolNumber=new t("symbol-number","\\ea90"),t.symbolStructure=new t("symbol-structure","\\ea91"),t.symbolStruct=new t("symbol-struct","\\ea91"),t.symbolParameter=new t("symbol-parameter","\\ea92"),t.symbolTypeParameter=new t("symbol-type-parameter","\\ea92"),t.symbolKey=new t("symbol-key","\\ea93"),t.symbolText=new t("symbol-text","\\ea93"),t.symbolReference=new t("symbol-reference","\\ea94"),t.goToFile=new t("go-to-file","\\ea94"),t.symbolEnum=new t("symbol-enum","\\ea95"),t.symbolValue=new t("symbol-value","\\ea95"),t.symbolRuler=new t("symbol-ruler","\\ea96"),t.symbolUnit=new t("symbol-unit","\\ea96"),t.activateBreakpoints=new t("activate-breakpoints","\\ea97"),t.archive=new t("archive","\\ea98"),t.arrowBoth=new t("arrow-both","\\ea99"),t.arrowDown=new t("arrow-down","\\ea9a"),t.arrowLeft=new t("arrow-left","\\ea9b"),t.arrowRight=new t("arrow-right","\\ea9c"),t.arrowSmallDown=new t("arrow-small-down","\\ea9d"),t.arrowSmallLeft=new t("arrow-small-left","\\ea9e"),t.arrowSmallRight=new t("arrow-small-right","\\ea9f"),t.arrowSmallUp=new t("arrow-small-up","\\eaa0"),t.arrowUp=new t("arrow-up","\\eaa1"),t.bell=new t("bell","\\eaa2"),t.bold=new t("bold","\\eaa3"),t.book=new t("book","\\eaa4"),t.bookmark=new t("bookmark","\\eaa5"),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified","\\eaa6"),t.debugBreakpointConditional=new t("debug-breakpoint-conditional","\\eaa7"),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled","\\eaa7"),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified","\\eaa8"),t.debugBreakpointData=new t("debug-breakpoint-data","\\eaa9"),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled","\\eaa9"),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified","\\eaaa"),t.debugBreakpointLog=new t("debug-breakpoint-log","\\eaab"),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled","\\eaab"),t.briefcase=new t("briefcase","\\eaac"),t.broadcast=new t("broadcast","\\eaad"),t.browser=new t("browser","\\eaae"),t.bug=new t("bug","\\eaaf"),t.calendar=new t("calendar","\\eab0"),t.caseSensitive=new t("case-sensitive","\\eab1"),t.check=new t("check","\\eab2"),t.checklist=new t("checklist","\\eab3"),t.chevronDown=new t("chevron-down","\\eab4"),t.dropDownButton=new t("drop-down-button",t.chevronDown.fontCharacter),t.chevronLeft=new t("chevron-left","\\eab5"),t.chevronRight=new t("chevron-right","\\eab6"),t.chevronUp=new t("chevron-up","\\eab7"),t.chromeClose=new t("chrome-close","\\eab8"),t.chromeMaximize=new t("chrome-maximize","\\eab9"),t.chromeMinimize=new t("chrome-minimize","\\eaba"),t.chromeRestore=new t("chrome-restore","\\eabb"),t.circle=new t("circle","\\eabc"),t.circleOutline=new t("circle-outline",t.circle.fontCharacter),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.fontCharacter),t.circleSlash=new t("circle-slash","\\eabd"),t.circuitBoard=new t("circuit-board","\\eabe"),t.clearAll=new t("clear-all","\\eabf"),t.clippy=new t("clippy","\\eac0"),t.closeAll=new t("close-all","\\eac1"),t.cloudDownload=new t("cloud-download","\\eac2"),t.cloudUpload=new t("cloud-upload","\\eac3"),t.code=new t("code","\\eac4"),t.collapseAll=new t("collapse-all","\\eac5"),t.colorMode=new t("color-mode","\\eac6"),t.commentDiscussion=new t("comment-discussion","\\eac7"),t.compareChanges=new t("compare-changes","\\eafd"),t.creditCard=new t("credit-card","\\eac9"),t.dash=new t("dash","\\eacc"),t.dashboard=new t("dashboard","\\eacd"),t.database=new t("database","\\eace"),t.debugContinue=new t("debug-continue","\\eacf"),t.debugDisconnect=new t("debug-disconnect","\\ead0"),t.debugPause=new t("debug-pause","\\ead1"),t.debugRestart=new t("debug-restart","\\ead2"),t.debugStart=new t("debug-start","\\ead3"),t.debugStepInto=new t("debug-step-into","\\ead4"),t.debugStepOut=new t("debug-step-out","\\ead5"),t.debugStepOver=new t("debug-step-over","\\ead6"),t.debugStop=new t("debug-stop","\\ead7"),t.debug=new t("debug","\\ead8"),t.deviceCameraVideo=new t("device-camera-video","\\ead9"),t.deviceCamera=new t("device-camera","\\eada"),t.deviceMobile=new t("device-mobile","\\eadb"),t.diffAdded=new t("diff-added","\\eadc"),t.diffIgnored=new t("diff-ignored","\\eadd"),t.diffModified=new t("diff-modified","\\eade"),t.diffRemoved=new t("diff-removed","\\eadf"),t.diffRenamed=new t("diff-renamed","\\eae0"),t.diff=new t("diff","\\eae1"),t.discard=new t("discard","\\eae2"),t.editorLayout=new t("editor-layout","\\eae3"),t.emptyWindow=new t("empty-window","\\eae4"),t.exclude=new t("exclude","\\eae5"),t.extensions=new t("extensions","\\eae6"),t.eyeClosed=new t("eye-closed","\\eae7"),t.fileBinary=new t("file-binary","\\eae8"),t.fileCode=new t("file-code","\\eae9"),t.fileMedia=new t("file-media","\\eaea"),t.filePdf=new t("file-pdf","\\eaeb"),t.fileSubmodule=new t("file-submodule","\\eaec"),t.fileSymlinkDirectory=new t("file-symlink-directory","\\eaed"),t.fileSymlinkFile=new t("file-symlink-file","\\eaee"),t.fileZip=new t("file-zip","\\eaef"),t.files=new t("files","\\eaf0"),t.filter=new t("filter","\\eaf1"),t.flame=new t("flame","\\eaf2"),t.foldDown=new t("fold-down","\\eaf3"),t.foldUp=new t("fold-up","\\eaf4"),t.fold=new t("fold","\\eaf5"),t.folderActive=new t("folder-active","\\eaf6"),t.folderOpened=new t("folder-opened","\\eaf7"),t.gear=new t("gear","\\eaf8"),t.gift=new t("gift","\\eaf9"),t.gistSecret=new t("gist-secret","\\eafa"),t.gist=new t("gist","\\eafb"),t.gitCommit=new t("git-commit","\\eafc"),t.gitCompare=new t("git-compare","\\eafd"),t.gitMerge=new t("git-merge","\\eafe"),t.githubAction=new t("github-action","\\eaff"),t.githubAlt=new t("github-alt","\\eb00"),t.globe=new t("globe","\\eb01"),t.grabber=new t("grabber","\\eb02"),t.graph=new t("graph","\\eb03"),t.gripper=new t("gripper","\\eb04"),t.heart=new t("heart","\\eb05"),t.home=new t("home","\\eb06"),t.horizontalRule=new t("horizontal-rule","\\eb07"),t.hubot=new t("hubot","\\eb08"),t.inbox=new t("inbox","\\eb09"),t.issueClosed=new t("issue-closed","\\eba4"),t.issueReopened=new t("issue-reopened","\\eb0b"),t.issues=new t("issues","\\eb0c"),t.italic=new t("italic","\\eb0d"),t.jersey=new t("jersey","\\eb0e"),t.json=new t("json","\\eb0f"),t.kebabVertical=new t("kebab-vertical","\\eb10"),t.key=new t("key","\\eb11"),t.law=new t("law","\\eb12"),t.lightbulbAutofix=new t("lightbulb-autofix","\\eb13"),t.linkExternal=new t("link-external","\\eb14"),t.link=new t("link","\\eb15"),t.listOrdered=new t("list-ordered","\\eb16"),t.listUnordered=new t("list-unordered","\\eb17"),t.liveShare=new t("live-share","\\eb18"),t.loading=new t("loading","\\eb19"),t.location=new t("location","\\eb1a"),t.mailRead=new t("mail-read","\\eb1b"),t.mail=new t("mail","\\eb1c"),t.markdown=new t("markdown","\\eb1d"),t.megaphone=new t("megaphone","\\eb1e"),t.mention=new t("mention","\\eb1f"),t.milestone=new t("milestone","\\eb20"),t.mortarBoard=new t("mortar-board","\\eb21"),t.move=new t("move","\\eb22"),t.multipleWindows=new t("multiple-windows","\\eb23"),t.mute=new t("mute","\\eb24"),t.noNewline=new t("no-newline","\\eb25"),t.note=new t("note","\\eb26"),t.octoface=new t("octoface","\\eb27"),t.openPreview=new t("open-preview","\\eb28"),t.package_=new t("package","\\eb29"),t.paintcan=new t("paintcan","\\eb2a"),t.pin=new t("pin","\\eb2b"),t.play=new t("play","\\eb2c"),t.run=new t("run","\\eb2c"),t.plug=new t("plug","\\eb2d"),t.preserveCase=new t("preserve-case","\\eb2e"),t.preview=new t("preview","\\eb2f"),t.project=new t("project","\\eb30"),t.pulse=new t("pulse","\\eb31"),t.question=new t("question","\\eb32"),t.quote=new t("quote","\\eb33"),t.radioTower=new t("radio-tower","\\eb34"),t.reactions=new t("reactions","\\eb35"),t.references=new t("references","\\eb36"),t.refresh=new t("refresh","\\eb37"),t.regex=new t("regex","\\eb38"),t.remoteExplorer=new t("remote-explorer","\\eb39"),t.remote=new t("remote","\\eb3a"),t.remove=new t("remove","\\eb3b"),t.replaceAll=new t("replace-all","\\eb3c"),t.replace=new t("replace","\\eb3d"),t.repoClone=new t("repo-clone","\\eb3e"),t.repoForcePush=new t("repo-force-push","\\eb3f"),t.repoPull=new t("repo-pull","\\eb40"),t.repoPush=new t("repo-push","\\eb41"),t.report=new t("report","\\eb42"),t.requestChanges=new t("request-changes","\\eb43"),t.rocket=new t("rocket","\\eb44"),t.rootFolderOpened=new t("root-folder-opened","\\eb45"),t.rootFolder=new t("root-folder","\\eb46"),t.rss=new t("rss","\\eb47"),t.ruby=new t("ruby","\\eb48"),t.saveAll=new t("save-all","\\eb49"),t.saveAs=new t("save-as","\\eb4a"),t.save=new t("save","\\eb4b"),t.screenFull=new t("screen-full","\\eb4c"),t.screenNormal=new t("screen-normal","\\eb4d"),t.searchStop=new t("search-stop","\\eb4e"),t.server=new t("server","\\eb50"),t.settingsGear=new t("settings-gear","\\eb51"),t.settings=new t("settings","\\eb52"),t.shield=new t("shield","\\eb53"),t.smiley=new t("smiley","\\eb54"),t.sortPrecedence=new t("sort-precedence","\\eb55"),t.splitHorizontal=new t("split-horizontal","\\eb56"),t.splitVertical=new t("split-vertical","\\eb57"),t.squirrel=new t("squirrel","\\eb58"),t.starFull=new t("star-full","\\eb59"),t.starHalf=new t("star-half","\\eb5a"),t.symbolClass=new t("symbol-class","\\eb5b"),t.symbolColor=new t("symbol-color","\\eb5c"),t.symbolCustomColor=new t("symbol-customcolor","\\eb5c"),t.symbolConstant=new t("symbol-constant","\\eb5d"),t.symbolEnumMember=new t("symbol-enum-member","\\eb5e"),t.symbolField=new t("symbol-field","\\eb5f"),t.symbolFile=new t("symbol-file","\\eb60"),t.symbolInterface=new t("symbol-interface","\\eb61"),t.symbolKeyword=new t("symbol-keyword","\\eb62"),t.symbolMisc=new t("symbol-misc","\\eb63"),t.symbolOperator=new t("symbol-operator","\\eb64"),t.symbolProperty=new t("symbol-property","\\eb65"),t.wrench=new t("wrench","\\eb65"),t.wrenchSubaction=new t("wrench-subaction","\\eb65"),t.symbolSnippet=new t("symbol-snippet","\\eb66"),t.tasklist=new t("tasklist","\\eb67"),t.telescope=new t("telescope","\\eb68"),t.textSize=new t("text-size","\\eb69"),t.threeBars=new t("three-bars","\\eb6a"),t.thumbsdown=new t("thumbsdown","\\eb6b"),t.thumbsup=new t("thumbsup","\\eb6c"),t.tools=new t("tools","\\eb6d"),t.triangleDown=new t("triangle-down","\\eb6e"),t.triangleLeft=new t("triangle-left","\\eb6f"),t.triangleRight=new t("triangle-right","\\eb70"),t.triangleUp=new t("triangle-up","\\eb71"),t.twitter=new t("twitter","\\eb72"),t.unfold=new t("unfold","\\eb73"),t.unlock=new t("unlock","\\eb74"),t.unmute=new t("unmute","\\eb75"),t.unverified=new t("unverified","\\eb76"),t.verified=new t("verified","\\eb77"),t.versions=new t("versions","\\eb78"),t.vmActive=new t("vm-active","\\eb79"),t.vmOutline=new t("vm-outline","\\eb7a"),t.vmRunning=new t("vm-running","\\eb7b"),t.watch=new t("watch","\\eb7c"),t.whitespace=new t("whitespace","\\eb7d"),t.wholeWord=new t("whole-word","\\eb7e"),t.window=new t("window","\\eb7f"),t.wordWrap=new t("word-wrap","\\eb80"),t.zoomIn=new t("zoom-in","\\eb81"),t.zoomOut=new t("zoom-out","\\eb82"),t.listFilter=new t("list-filter","\\eb83"),t.listFlat=new t("list-flat","\\eb84"),t.listSelection=new t("list-selection","\\eb85"),t.selection=new t("selection","\\eb85"),t.listTree=new t("list-tree","\\eb86"),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified","\\eb87"),t.debugBreakpointFunction=new t("debug-breakpoint-function","\\eb88"),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled","\\eb88"),t.debugStackframeActive=new t("debug-stackframe-active","\\eb89"),t.circleSmallFilled=new t("circle-small-filled","\\eb8a"),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.fontCharacter),t.debugStackframe=new t("debug-stackframe","\\eb8b"),t.debugStackframeFocused=new t("debug-stackframe-focused","\\eb8b"),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported","\\eb8c"),t.symbolString=new t("symbol-string","\\eb8d"),t.debugReverseContinue=new t("debug-reverse-continue","\\eb8e"),t.debugStepBack=new t("debug-step-back","\\eb8f"),t.debugRestartFrame=new t("debug-restart-frame","\\eb90"),t.callIncoming=new t("call-incoming","\\eb92"),t.callOutgoing=new t("call-outgoing","\\eb93"),t.menu=new t("menu","\\eb94"),t.expandAll=new t("expand-all","\\eb95"),t.feedback=new t("feedback","\\eb96"),t.groupByRefType=new t("group-by-ref-type","\\eb97"),t.ungroupByRefType=new t("ungroup-by-ref-type","\\eb98"),t.account=new t("account","\\eb99"),t.bellDot=new t("bell-dot","\\eb9a"),t.debugConsole=new t("debug-console","\\eb9b"),t.library=new t("library","\\eb9c"),t.output=new t("output","\\eb9d"),t.runAll=new t("run-all","\\eb9e"),t.syncIgnored=new t("sync-ignored","\\eb9f"),t.pinned=new t("pinned","\\eba0"),t.githubInverted=new t("github-inverted","\\eba1"),t.debugAlt=new t("debug-alt","\\eb91"),t.serverProcess=new t("server-process","\\eba2"),t.serverEnvironment=new t("server-environment","\\eba3"),t.pass=new t("pass","\\eba4"),t.stopCircle=new t("stop-circle","\\eba5"),t.playCircle=new t("play-circle","\\eba6"),t.record=new t("record","\\eba7"),t.debugAltSmall=new t("debug-alt-small","\\eba8"),t.vmConnect=new t("vm-connect","\\eba9"),t.cloud=new t("cloud","\\ebaa"),t.merge=new t("merge","\\ebab"),t.exportIcon=new t("export","\\ebac"),t.graphLeft=new t("graph-left","\\ebad"),t.magnet=new t("magnet","\\ebae"),t.notebook=new t("notebook","\\ebaf"),t.redo=new t("redo","\\ebb0"),t.checkAll=new t("check-all","\\ebb1"),t.pinnedDirty=new t("pinned-dirty","\\ebb2"),t.passFilled=new t("pass-filled","\\ebb3"),t.circleLargeFilled=new t("circle-large-filled","\\ebb4"),t.circleLarge=new t("circle-large","\\ebb5"),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.fontCharacter),t.combine=new t("combine","\\ebb6"),t.gather=new t("gather","\\ebb6"),t.table=new t("table","\\ebb7"),t.variableGroup=new t("variable-group","\\ebb8"),t.typeHierarchy=new t("type-hierarchy","\\ebb9"),t.typeHierarchySub=new t("type-hierarchy-sub","\\ebba"),t.typeHierarchySuper=new t("type-hierarchy-super","\\ebbb"),t.gitPullRequestCreate=new t("git-pull-request-create","\\ebbc"),t.runAbove=new t("run-above","\\ebbd"),t.runBelow=new t("run-below","\\ebbe"),t.notebookTemplate=new t("notebook-template","\\ebbf"),t.debugRerun=new t("debug-rerun","\\ebc0"),t.workspaceTrusted=new t("workspace-trusted","\\ebc1"),t.workspaceUntrusted=new t("workspace-untrusted","\\ebc2"),t.workspaceUnspecified=new t("workspace-unspecified","\\ebc3"),t.terminalCmd=new t("terminal-cmd","\\ebc4"),t.terminalDebian=new t("terminal-debian","\\ebc5"),t.terminalLinux=new t("terminal-linux","\\ebc6"),t.terminalPowershell=new t("terminal-powershell","\\ebc7"),t.terminalTmux=new t("terminal-tmux","\\ebc8"),t.terminalUbuntu=new t("terminal-ubuntu","\\ebc9"),t.terminalBash=new t("terminal-bash","\\ebca"),t.arrowSwap=new t("arrow-swap","\\ebcb"),t.copy=new t("copy","\\ebcc"),t.personAdd=new t("person-add","\\ebcd"),t.filterFilled=new t("filter-filled","\\ebce"),t.wand=new t("wand","\\ebcf"),t.debugLineByLine=new t("debug-line-by-line","\\ebd0"),t.inspect=new t("inspect","\\ebd1"),t.layers=new t("layers","\\ebd2"),t.layersDot=new t("layers-dot","\\ebd3"),t.layersActive=new t("layers-active","\\ebd4"),t.compass=new t("compass","\\ebd5"),t.compassDot=new t("compass-dot","\\ebd6"),t.compassActive=new t("compass-active","\\ebd7"),t.azure=new t("azure","\\ebd8"),t.issueDraft=new t("issue-draft","\\ebd9"),t.gitPullRequestClosed=new t("git-pull-request-closed","\\ebda"),t.gitPullRequestDraft=new t("git-pull-request-draft","\\ebdb"),t.debugAll=new t("debug-all","\\ebdc"),t.debugCoverage=new t("debug-coverage","\\ebdd"),t.runErrors=new t("run-errors","\\ebde"),t.folderLibrary=new t("folder-library","\\ebdf"),t.debugContinueSmall=new t("debug-continue-small","\\ebe0"),t.beakerStop=new t("beaker-stop","\\ebe1"),t.graphLine=new t("graph-line","\\ebe2"),t.graphScatter=new t("graph-scatter","\\ebe3"),t.pieChart=new t("pie-chart","\\ebe4"),t.bracket=new t("bracket",t.json.fontCharacter),t.bracketDot=new t("bracket-dot","\\ebe5"),t.bracketError=new t("bracket-error","\\ebe6"),t.lockSmall=new t("lock-small","\\ebe7"),t.azureDevops=new t("azure-devops","\\ebe8"),t.verifiedFilled=new t("verified-filled","\\ebe9"),t.newLine=new t("newline","\\ebea"),t.layout=new t("layout","\\ebeb"),t.layoutActivitybarLeft=new t("layout-activitybar-left","\\ebec"),t.layoutActivitybarRight=new t("layout-activitybar-right","\\ebed"),t.layoutPanelLeft=new t("layout-panel-left","\\ebee"),t.layoutPanelCenter=new t("layout-panel-center","\\ebef"),t.layoutPanelJustify=new t("layout-panel-justify","\\ebf0"),t.layoutPanelRight=new t("layout-panel-right","\\ebf1"),t.layoutPanel=new t("layout-panel","\\ebf2"),t.layoutSidebarLeft=new t("layout-sidebar-left","\\ebf3"),t.layoutSidebarRight=new t("layout-sidebar-right","\\ebf4"),t.layoutStatusbar=new t("layout-statusbar","\\ebf5"),t.layoutMenubar=new t("layout-menubar","\\ebf6"),t.layoutCentered=new t("layout-centered","\\ebf7"),t.layoutSidebarRightOff=new t("layout-sidebar-right-off","\\ec00"),t.layoutPanelOff=new t("layout-panel-off","\\ec01"),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off","\\ec02"),t.target=new t("target","\\ebf8"),t.indent=new t("indent","\\ebf9"),t.recordSmall=new t("record-small","\\ebfa"),t.errorSmall=new t("error-small","\\ebfb"),t.arrowCircleDown=new t("arrow-circle-down","\\ebfc"),t.arrowCircleLeft=new t("arrow-circle-left","\\ebfd"),t.arrowCircleRight=new t("arrow-circle-right","\\ebfe"),t.arrowCircleUp=new t("arrow-circle-up","\\ebff"),t.heartFilled=new t("heart-filled","\\ec04"),t.map=new t("map","\\ec05"),t.mapFilled=new t("map-filled","\\ec06"),t.circleSmall=new t("circle-small","\\ec07"),t.bellSlash=new t("bell-slash","\\ec08"),t.bellSlashDot=new t("bell-slash-dot","\\ec09"),t.commentUnresolved=new t("comment-unresolved","\\ec0a"),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes","\\ec0b"),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes","\\ec0c"),t.searchFuzzy=new t("search-fuzzy","\\ec0d"),t.commentDraft=new t("comment-draft","\\ec0e"),t.dialogError=new t("dialog-error",t.error.fontCharacter),t.dialogWarning=new t("dialog-warning",t.warning.fontCharacter),t.dialogInfo=new t("dialog-info",t.info.fontCharacter),t.dialogClose=new t("dialog-close",t.close.fontCharacter),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.fontCharacter),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.fontCharacter),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.fontCharacter),t.treeFilterClear=new t("tree-filter-clear",t.close.fontCharacter),t.treeItemLoading=new t("tree-item-loading",t.loading.fontCharacter),t.menuSelection=new t("menu-selection",t.check.fontCharacter),t.menuSubmenu=new t("menu-submenu",t.chevronRight.fontCharacter),t.menuBarMore=new t("menubar-more",t.more.fontCharacter),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.fontCharacter),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.fontCharacter),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.fontCharacter),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.fontCharacter),t.toolBarMore=new t("toolbar-more",t.more.fontCharacter),t.quickInputBack=new t("quick-input-back",t.arrowLeft.fontCharacter);var P;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function I(y){if(y instanceof t)return["codicon","codicon-"+y.id];const p=R.exec(y.id);if(!p)return I(t.error);const[,b,f]=p,w=["codicon","codicon-"+b];return f&&w.push("codicon-modifier-"+f.substring(1)),w}D.asClassNameArray=I;function d(y){return I(y).join(" ")}D.asClassName=d;function h(y){return"."+I(y).join(".")}D.asCSSSelector=h})(P=e.CSSIcon||(e.CSSIcon={}))}),define(te[123],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(I,d){const h=Math.pow(10,d);return Math.round(I*h)/h}class t{constructor(d,h,y,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=E(Math.max(Math.min(1,p),0),3)}static equals(d,h){return d.r===h.r&&d.g===h.g&&d.b===h.b&&d.a===h.a}}e.RGBA=t;class P{constructor(d,h,y,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,h),0),3),this.l=E(Math.max(Math.min(1,y),0),3),this.a=E(Math.max(Math.min(1,p),0),3)}static equals(d,h){return d.h===h.h&&d.s===h.s&&d.l===h.l&&d.a===h.a}static fromRGBA(d){const h=d.r/255,y=d.g/255,p=d.b/255,b=d.a,f=Math.max(h,y,p),w=Math.min(h,y,p);let v=0,c=0;const u=(w+f)/2,g=f-w;if(g>0){switch(c=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),f){case h:v=(y-p)/g+(y<p?6:0);break;case y:v=(p-h)/g+2;break;case p:v=(h-y)/g+4;break}v*=60,v=Math.round(v)}return new P(v,c,u,b)}static i(d,h,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?d+(h-d)*6*y:y<1/2?h:y<2/3?d+(h-d)*(2/3-y)*6:d}static toRGBA(d){const h=d.h/360,{s:y,l:p,a:b}=d;let f,w,v;if(y===0)f=w=v=p;else{const c=p<.5?p*(1+y):p+y-p*y,u=2*p-c;f=P.i(u,c,h+1/3),w=P.i(u,c,h),v=P.i(u,c,h-1/3)}return new t(Math.round(f*255),Math.round(w*255),Math.round(v*255),b)}}e.HSLA=P;class D{constructor(d,h,y,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,h),0),3),this.v=E(Math.max(Math.min(1,y),0),3),this.a=E(Math.max(Math.min(1,p),0),3)}static equals(d,h){return d.h===h.h&&d.s===h.s&&d.v===h.v&&d.a===h.a}static fromRGBA(d){const h=d.r/255,y=d.g/255,p=d.b/255,b=Math.max(h,y,p),f=Math.min(h,y,p),w=b-f,v=b===0?0:w/b;let c;return w===0?c=0:b===h?c=((y-p)/w%6+6)%6:b===y?c=(p-h)/w+2:c=(h-y)/w+4,new D(Math.round(c*60),v,b,d.a)}static toRGBA(d){const{h,s:y,v:p,a:b}=d,f=p*y,w=f*(1-Math.abs(h/60%2-1)),v=p-f;let[c,u,g]=[0,0,0];return h<60?(c=f,u=w):h<120?(c=w,u=f):h<180?(u=f,g=w):h<240?(u=w,g=f):h<300?(c=w,g=f):h<=360&&(c=f,g=w),c=Math.round((c+v)*255),u=Math.round((u+v)*255),g=Math.round((g+v)*255),new t(c,u,g,b)}}e.HSVA=D;class R{static fromHex(d){return R.Format.CSS.parseHex(d)||R.red}static equals(d,h){return!d&&!h?!0:!d||!h?!1:d.equals(h)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:D.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof t)this.rgba=d;else if(d instanceof P)this.i=d,this.rgba=P.toRGBA(d);else if(d instanceof D)this.j=d,this.rgba=D.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&t.equals(this.rgba,d.rgba)&&P.equals(this.hsla,d.hsla)&&D.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=R.k(this.rgba.r),h=R.k(this.rgba.g),y=R.k(this.rgba.b),p=.2126*d+.7152*h+.0722*y;return E(p,4)}static k(d){const h=d/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(d){const h=this.getRelativeLuminance(),y=d.getRelativeLuminance();return h>y?(h+.05)/(y+.05):(y+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const h=this.getRelativeLuminance(),y=d.getRelativeLuminance();return h>y}isDarkerThan(d){const h=this.getRelativeLuminance(),y=d.getRelativeLuminance();return h<y}lighten(d){return new R(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new R(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:h,g:y,b:p,a:b}=this.rgba;return new R(new t(h,y,p,b*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const h=d.rgba,y=this.rgba.a,p=h.a,b=y+p*(1-y);if(b<1e-6)return R.transparent;const f=this.rgba.r*y/b+h.r*p*(1-y)/b,w=this.rgba.g*y/b+h.g*p*(1-y)/b,v=this.rgba.b*y/b+h.b*p*(1-y)/b;return new R(new t(f,w,v,b))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:h,g:y,b:p,a:b}=this.rgba;return new R(new t(d.rgba.r-b*(d.rgba.r-h),d.rgba.g-b*(d.rgba.g-y),d.rgba.b-b*(d.rgba.b-p),1))}flatten(...d){const h=d.reduceRight((y,p)=>R.o(p,y));return R.o(this,h)}static o(d,h){const y=1-d.rgba.a;return new R(new t(y*h.rgba.r+d.rgba.a*d.rgba.r,y*h.rgba.g+d.rgba.a*d.rgba.g,y*h.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(d,h,y){if(d.isLighterThan(h))return d;y=y||.5;const p=d.getRelativeLuminance(),b=h.getRelativeLuminance();return y=y*(b-p)/b,d.lighten(y)}static getDarkerColor(d,h,y){if(d.isDarkerThan(h))return d;y=y||.5;const p=d.getRelativeLuminance(),b=h.getRelativeLuminance();return y=y*(p-b)/p,d.darken(y)}}e.Color=R,R.white=new R(new t(255,255,255,1)),R.black=new R(new t(0,0,0,1)),R.red=new R(new t(255,0,0,1)),R.blue=new R(new t(0,0,255,1)),R.green=new R(new t(0,255,0,1)),R.cyan=new R(new t(0,255,255,1)),R.lightgrey=new R(new t(211,211,211,1)),R.transparent=new R(new t(0,0,0,0)),function(I){let d;(function(h){let y;(function(p){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}p.formatRGB=b;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}p.formatRGBA=f;function w(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}p.formatHSL=w;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}p.formatHSLA=v;function c(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function u(i){return`#${c(i.rgba.r)}${c(i.rgba.g)}${c(i.rgba.b)}`}p.formatHex=u;function g(i,l=!1){return l&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${c(i.rgba.r)}${c(i.rgba.g)}${c(i.rgba.b)}${c(Math.round(i.rgba.a*255))}`}p.formatHexA=g;function k(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}p.format=k;function S(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const n=16*L(i.charCodeAt(1))+L(i.charCodeAt(2)),o=16*L(i.charCodeAt(3))+L(i.charCodeAt(4)),s=16*L(i.charCodeAt(5))+L(i.charCodeAt(6));return new I(new t(n,o,s,1))}if(l===9){const n=16*L(i.charCodeAt(1))+L(i.charCodeAt(2)),o=16*L(i.charCodeAt(3))+L(i.charCodeAt(4)),s=16*L(i.charCodeAt(5))+L(i.charCodeAt(6)),a=16*L(i.charCodeAt(7))+L(i.charCodeAt(8));return new I(new t(n,o,s,a/255))}if(l===4){const n=L(i.charCodeAt(1)),o=L(i.charCodeAt(2)),s=L(i.charCodeAt(3));return new I(new t(16*n+n,16*o+o,16*s+s))}if(l===5){const n=L(i.charCodeAt(1)),o=L(i.charCodeAt(2)),s=L(i.charCodeAt(3)),a=L(i.charCodeAt(4));return new I(new t(16*n+n,16*o+o,16*s+s,(16*a+a)/255))}return null}p.parseHex=S;function L(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=h.CSS||(h.CSS={}))})(d=I.Format||(I.Format={}))}(R=e.Color||(e.Color={}))}),define(te[54],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(R){return(I,d,h)=>{let y=null,p=null;if(typeof h.value=="function"?(y="value",p=h.value):typeof h.get=="function"&&(y="get",p=h.get),!p)throw new Error("not supported");h[y]=R(p,d)}}function t(R,I,d){let h=null,y=null;if(typeof d.value=="function"?(h="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(h="get",y=d.get),!y)throw new Error("not supported");const p=`$memoize$${I}`;d[h]=function(...b){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,b)}),this[p]}}e.memoize=t;function P(R,I,d){return E((h,y)=>{const p=`$debounce$${y}`,b=`$debounce$result$${y}`;return function(...f){this[b]||(this[b]=d?d():void 0),clearTimeout(this[p]),I&&(this[b]=I(this[b],...f),f=[this[b]]),this[p]=setTimeout(()=>{h.apply(this,f),this[b]=d?d():void 0},R)}})}e.debounce=P;function D(R,I,d){return E((h,y)=>{const p=`$throttle$timer$${y}`,b=`$throttle$result$${y}`,f=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...v){if(this[b]||(this[b]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[b]=I(this[b],...v)),this[w])return;const c=this[f]+R;c<=Date.now()?(this[f]=Date.now(),h.apply(this,[this[b]]),this[b]=d?d():void 0):(this[w]=!0,this[p]=setTimeout(()=>{this[w]=!1,this[f]=Date.now(),h.apply(this,[this[b]]),this[b]=d?d():void 0},c-Date.now()))}})}e.throttle=D}),define(te[13],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=E,e.errorHandler=new E;function t(L){e.errorHandler.setUnexpectedErrorHandler(L)}e.setUnexpectedErrorHandler=t;function P(L){d(L)||e.errorHandler.onUnexpectedError(L)}e.onUnexpectedError=P;function D(L){d(L)||e.errorHandler.onUnexpectedExternalError(L)}e.onUnexpectedExternalError=D;function R(L){if(L instanceof Error){const{name:i,message:l}=L,n=L.stacktrace||L.stack;return{$isError:!0,name:i,message:l,stack:n,noTelemetry:k.isErrorNoTelemetry(L)}}return L}e.transformErrorForSerialization=R;const I="Canceled";function d(L){return L instanceof h?!0:L instanceof Error&&L.name===I&&L.message===I}e.isCancellationError=d;class h extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=h;function y(){const L=new Error(I);return L.name=L.message,L}e.canceled=y;function p(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}e.illegalArgument=p;function b(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}e.illegalState=b;function f(L){return L?new Error(`readonly property '${L} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function w(L){const i=new Error(`${L} has been disposed`);return i.name="DISPOSED",i}e.disposed=w;function v(L){return L?L.message?L.message:L.stack?L.stack.split(`
`)[0]:String(L):"Error"}e.getErrorMessage=v;class c extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=c;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const l=new k;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class S extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(te[25],ie([0,1,13]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(N,q=0){return N[N.length-(1+q)]}e.tail=t;function P(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=P;function D(N,q,Z=(oe,le)=>oe===le){if(N===q)return!0;if(!N||!q||N.length!==q.length)return!1;for(let oe=0,le=N.length;oe<le;oe++)if(!Z(N[oe],q[oe]))return!1;return!0}e.equals=D;function R(N,q){const Z=N.length-1;q<Z&&(N[q]=N[Z]),N.pop()}e.removeFastWithoutKeepingOrder=R;function I(N,q,Z){return d(N.length,oe=>Z(N[oe],q))}e.binarySearch=I;function d(N,q){let Z=0,oe=N-1;for(;Z<=oe;){const le=(Z+oe)/2|0,be=q(le);if(be<0)Z=le+1;else if(be>0)oe=le-1;else return le}return-(Z+1)}e.binarySearch2=d;function h(N,q){let Z=0,oe=N.length;if(oe===0)return 0;for(;Z<oe;){const le=Math.floor((Z+oe)/2);q(N[le])?oe=le:Z=le+1}return Z}e.findFirstInSorted=h;function y(N,q,Z){if(N=N|0,N>=q.length)throw new TypeError("invalid index");const oe=q[Math.floor(q.length*Math.random())],le=[],be=[],Ce=[];for(const Oe of q){const Le=Z(Oe,oe);Le<0?le.push(Oe):Le>0?be.push(Oe):Ce.push(Oe)}return N<le.length?y(N,le,Z):N<le.length+Ce.length?Ce[0]:y(N-(le.length+Ce.length),be,Z)}e.quickSelect=y;function p(N,q){const Z=[];let oe;for(const le of N.slice(0).sort(q))!oe||q(oe[0],le)!==0?(oe=[le],Z.push(oe)):oe.push(le);return Z}e.groupBy=p;function b(N,q,Z){const oe=[];function le(Oe,Le,we){if(Le===0&&we.length===0)return;const ve=oe[oe.length-1];ve&&ve.start+ve.deleteCount===Oe?(ve.deleteCount+=Le,ve.toInsert.push(...we)):oe.push({start:Oe,deleteCount:Le,toInsert:we})}let be=0,Ce=0;for(;;){if(be===N.length){le(be,0,q.slice(Ce));break}if(Ce===q.length){le(be,N.length-be,[]);break}const Oe=N[be],Le=q[Ce],we=Z(Oe,Le);we===0?(be+=1,Ce+=1):we<0?(le(be,1,[]),be+=1):we>0&&(le(be,0,[Le]),Ce+=1)}return oe}e.sortedDiff=b;function f(N,q,Z){const oe=b(N,q,Z),le=[],be=[];for(const Ce of oe)le.push(...N.slice(Ce.start,Ce.start+Ce.deleteCount)),be.push(...Ce.toInsert);return{removed:le,added:be}}e.delta=f;function w(N,q,Z){if(Z===0)return[];const oe=N.slice(0,Z).sort(q);return c(N,q,oe,Z,N.length),oe}e.top=w;function v(N,q,Z,oe,le){return Z===0?Promise.resolve([]):new Promise((be,Ce)=>{(async()=>{const Oe=N.length,Le=N.slice(0,Z).sort(q);for(let we=Z,ve=Math.min(Z+oe,Oe);we<Oe;we=ve,ve=Math.min(ve+oe,Oe)){if(we>Z&&await new Promise(Ee=>setTimeout(Ee)),le&&le.isCancellationRequested)throw new E.CancellationError;c(N,q,Le,we,ve)}return Le})().then(be,Ce)})}e.topAsync=v;function c(N,q,Z,oe,le){for(const be=Z.length;oe<le;oe++){const Ce=N[oe];if(q(Ce,Z[be-1])<0){Z.pop();const Oe=h(Z,Le=>q(Ce,Le)<0);Z.splice(Oe,0,Ce)}}}function u(N){return N.filter(q=>!!q)}e.coalesce=u;function g(N){let q=0;for(let Z=0;Z<N.length;Z++)N[Z]&&(N[q]=N[Z],q+=1);N.length=q}e.coalesceInPlace=g;function k(N,q,Z){N.splice(Z,0,N.splice(q,1)[0])}e.move=k;function S(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=S;function L(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=L;function i(N,q=Z=>Z){const Z=new Set;return N.filter(oe=>{const le=q(oe);return Z.has(le)?!1:(Z.add(le),!0)})}e.distinct=i;function l(N){const q=new Set;return Z=>{const oe=N(Z);return q.has(oe)?!1:(q.add(oe),!0)}}e.uniqueFilter=l;function n(N,q){const Z=o(N,q);if(Z!==-1)return N[Z]}e.findLast=n;function o(N,q){for(let Z=N.length-1;Z>=0;Z--){const oe=N[Z];if(q(oe))return Z}return-1}e.lastIndex=o;function s(N,q){return N.length>0?N[0]:q}e.firstOrDefault=s;function a(N,q){return N.length>0?N[N.length-1]:q}e.lastOrDefault=a;function r(N,q,Z=(oe,le)=>oe===le){let oe=0;for(let le=0,be=Math.min(N.length,q.length);le<be&&Z(N[le],q[le]);le++)oe++;return oe}e.commonPrefixLength=r;function m(N){return[].concat(...N)}e.flatten=m;function C(N,q){let Z=typeof q=="number"?N:0;typeof q=="number"?Z=N:(Z=0,q=N);const oe=[];if(Z<=q)for(let le=Z;le<q;le++)oe.push(le);else for(let le=Z;le>q;le--)oe.push(le);return oe}e.range=C;function M(N,q,Z){return N.reduce((oe,le)=>(oe[q(le)]=Z?Z(le):le,oe),Object.create(null))}e.index=M;function O(N,q){return N.push(q),()=>B(N,q)}e.insert=O;function B(N,q){const Z=N.indexOf(q);if(Z>-1)return N.splice(Z,1),q}e.remove=B;function J(N,q,Z){const oe=N.slice(0,q),le=N.slice(q);return oe.concat(Z,le)}e.arrayInsert=J;function G(N,q){let Z;if(typeof q=="number"){let oe=q;Z=()=>{const le=Math.sin(oe++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let oe=N.length-1;oe>0;oe-=1){const le=Math.floor(Z()*(oe+1)),be=N[oe];N[oe]=N[le],N[le]=be}}e.shuffle=G;function X(N,q){const Z=N.indexOf(q);Z>-1&&(N.splice(Z,1),N.unshift(q))}e.pushToStart=X;function re(N,q){const Z=N.indexOf(q);Z>-1&&(N.splice(Z,1),N.push(q))}e.pushToEnd=re;function se(N,q){for(const Z of q)N.push(Z)}e.pushMany=se;function ae(N,q){return Array.isArray(N)?N.map(q):q(N)}e.mapArrayOrNot=ae;function fe(N){return Array.isArray(N)?N:[N]}e.asArray=fe;function ge(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=ge;function H(N,q){for(const Z of N){const oe=q(Z);if(oe!==void 0)return oe}}e.mapFind=H;function F(N,q,Z){const oe=z(N,q),le=N.length,be=Z.length;N.length=le+be;for(let Ce=le-1;Ce>=oe;Ce--)N[Ce+be]=N[Ce];for(let Ce=0;Ce<be;Ce++)N[Ce+oe]=Z[Ce]}e.insertInto=F;function U(N,q,Z,oe){const le=z(N,q),be=N.splice(le,Z);return F(N,le,oe),be}e.splice=U;function z(N,q){return q<0?Math.max(q+N.length,0):Math.min(q,N.length)}var Q;(function(N){function q(le){return le<0}N.isLessThan=q;function Z(le){return le>0}N.isGreaterThan=Z;function oe(le){return le===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function ne(N,q){return(Z,oe)=>q(N(Z),N(oe))}e.compareBy=ne;function _(...N){return(q,Z)=>{for(const oe of N){const le=oe(q,Z);if(!Q.isNeitherLessOrGreaterThan(le))return le}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=_;const $=(N,q)=>N-q;e.numberComparator=$;function A(N,q){if(N.length===0)return;let Z=N[0];for(let oe=1;oe<N.length;oe++){const le=N[oe];q(le,Z)>0&&(Z=le)}return Z}e.findMaxBy=A;function T(N,q){if(N.length===0)return;let Z=N[0];for(let oe=1;oe<N.length;oe++){const le=N[oe];q(le,Z)>=0&&(Z=le)}return Z}e.findLastMaxBy=T;function W(N,q){return A(N,(Z,oe)=>-q(Z,oe))}e.findMinBy=W;class j{constructor(q){this.f=q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(q){let Z=this.c;for(;Z<this.f.length&&q(this.f[Z]);)Z++;const oe=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,oe}takeFromEndWhile(q){let Z=this.d;for(;Z>=0&&q(this.f[Z]);)Z--;const oe=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const q=this.f[this.c];return this.c++,q}removeLast(){const q=this.f[this.d];return this.d--,q}takeCount(q){const Z=this.f.slice(this.c,this.c+q);return this.c+=q,Z}}e.ArrayQueue=j;class K{constructor(q){this.iterate=q}forEach(q){this.iterate(Z=>(q(Z),!0))}toArray(){const q=[];return this.iterate(Z=>(q.push(Z),!0)),q}filter(q){return new K(Z=>this.iterate(oe=>q(oe)?Z(oe):!0))}map(q){return new K(Z=>this.iterate(oe=>Z(q(oe))))}some(q){let Z=!1;return this.iterate(oe=>(Z=q(oe),!Z)),Z}findFirst(q){let Z;return this.iterate(oe=>q(oe)?(Z=oe,!1):!0),Z}findLast(q){let Z;return this.iterate(oe=>(q(oe)&&(Z=oe),!0)),Z}findLastMaxBy(q){let Z,oe=!0;return this.iterate(le=>((oe||Q.isGreaterThan(q(le,Z)))&&(oe=!1,Z=le),!0)),Z}}e.CallbackIterable=K,K.empty=new K(N=>{})}),define(te[124],ie([0,1,13]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(d,h){if(!d)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=t;function P(d,h="Unreachable"){throw new Error(h)}e.assertNever=P;function D(d){if(!d)throw new E.BugIndicatingError("Assertion Failed")}e.assert=D;function R(d){if(!d()){debugger;d(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function I(d,h){let y=0;for(;y<d.length-1;){const p=d[y],b=d[y+1];if(!h(p,b))return!1;y++}return!0}e.checkAdjacentItems=I}),define(te[50],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const P=this;let D=!1,R;return function(){return D||(D=!0,R=t.apply(P,arguments)),R}}e.once=E}),define(te[69],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function P(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}t.is=P;const D=Object.freeze([]);function R(){return D}t.empty=R;function*I(S){yield S}t.single=I;function d(S){return P(S)?S:I(S)}t.wrap=d;function h(S){return S||D}t.from=h;function y(S){return!S||S[Symbol.iterator]().next().done===!0}t.isEmpty=y;function p(S){return S[Symbol.iterator]().next().value}t.first=p;function b(S,L){for(const i of S)if(L(i))return!0;return!1}t.some=b;function f(S,L){for(const i of S)if(L(i))return i}t.find=f;function*w(S,L){for(const i of S)L(i)&&(yield i)}t.filter=w;function*v(S,L){let i=0;for(const l of S)yield L(l,i++)}t.map=v;function*c(...S){for(const L of S)for(const i of L)yield i}t.concat=c;function u(S,L,i){let l=i;for(const n of S)l=L(l,n);return l}t.reduce=u;function*g(S,L,i=S.length){for(L<0&&(L+=S.length),i<0?i+=S.length:i>S.length&&(i=S.length);L<i;L++)yield S[L]}t.slice=g;function k(S,L=Number.POSITIVE_INFINITY){const i=[];if(L===0)return[i,S];const l=S[Symbol.iterator]();for(let n=0;n<L;n++){const o=l.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return l}}]}t.consume=k})(E=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(i){i.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let n=0;const o=i.length;let s="",a=0,r=16,m=0;function C(re){let se=0,ae=0;for(;se<re;){const fe=i.charCodeAt(n);if(fe>=48&&fe<=57)ae=ae*16+fe-48;else if(fe>=65&&fe<=70)ae=ae*16+fe-65+10;else if(fe>=97&&fe<=102)ae=ae*16+fe-97+10;else break;n++,se++}return se<re&&(ae=-1),ae}function M(re){n=re,s="",a=0,r=16,m=0}function O(){const re=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&h(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&h(i.charCodeAt(n)))for(n++;n<i.length&&h(i.charCodeAt(n));)n++;else return m=3,i.substring(re,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&h(i.charCodeAt(n))){for(n++;n<i.length&&h(i.charCodeAt(n));)n++;se=n}else m=3;return i.substring(re,se)}function B(){let re="",se=n;for(;;){if(n>=o){re+=i.substring(se,n),m=2;break}const ae=i.charCodeAt(n);if(ae===34){re+=i.substring(se,n),n++;break}if(ae===92){if(re+=i.substring(se,n),n++,n>=o){m=2;break}switch(i.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const ge=C(4);ge>=0?re+=String.fromCharCode(ge):m=4;break}default:m=5}se=n;continue}if(ae>=0&&ae<=31)if(d(ae)){re+=i.substring(se,n),m=2;break}else m=6;n++}return re}function J(){if(s="",m=0,a=n,n>=o)return a=o,r=17;let re=i.charCodeAt(n);if(I(re)){do n++,s+=String.fromCharCode(re),re=i.charCodeAt(n);while(I(re));return r=15}if(d(re))return n++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),r=14;switch(re){case 123:return n++,r=1;case 125:return n++,r=2;case 91:return n++,r=3;case 93:return n++,r=4;case 58:return n++,r=6;case 44:return n++,r=5;case 34:return n++,s=B(),r=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!d(i.charCodeAt(n));)n++;return s=i.substring(se,n),r=12}if(i.charCodeAt(n+1)===42){n+=2;const ae=o-1;let fe=!1;for(;n<ae;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,fe=!0;break}n++}return fe||(n++,m=1),s=i.substring(se,n),r=13}return s+=String.fromCharCode(re),n++,r=16}case 45:if(s+=String.fromCharCode(re),n++,n===o||!h(i.charCodeAt(n)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),r=11;default:for(;n<o&&G(re);)n++,re=i.charCodeAt(n);if(a!==n){switch(s=i.substring(a,n),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode(re),n++,r=16}}function G(re){if(I(re)||d(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let re;do re=J();while(re>=12&&re<=15);return re}return{setPosition:M,getPosition:()=>n,scan:l?X:J,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>m}}e.createScanner=R;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function p(i,l){const n=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function m(C,M,O,B){a.value=C,a.offset=M,a.length=O,a.type=B,a.colonOffset=void 0,s=a}try{k(i,{onObjectBegin:(C,M)=>{if(l<=C)throw o;s=void 0,r=l>C,n.push("")},onObjectProperty:(C,M,O)=>{if(l<M||(m(C,M,O,"property"),n[n.length-1]=C,l<=M+O))throw o},onObjectEnd:(C,M)=>{if(l<=C)throw o;s=void 0,n.pop()},onArrayBegin:(C,M)=>{if(l<=C)throw o;s=void 0,n.push(0)},onArrayEnd:(C,M)=>{if(l<=C)throw o;s=void 0,n.pop()},onLiteralValue:(C,M,O)=>{if(l<M||(m(C,M,O,L(C)),l<=M+O))throw o},onSeparator:(C,M,O)=>{if(l<=M)throw o;if(C===":"&&s&&s.type==="property")s.colonOffset=M,r=!1,s=void 0;else if(C===","){const B=n[n.length-1];typeof B=="number"?n[n.length-1]=B+1:(r=!0,n[n.length-1]=""),s=void 0}}})}catch(C){if(C!==o)throw C}return{path:n,previousNode:s,isAtPropertyKey:r,matches:C=>{let M=0;for(let O=0;M<C.length&&O<n.length;O++)if(C[M]===n[O]||C[M]==="*")M++;else if(C[M]!=="**")return!1;return M===C.length}}}e.getLocation=p;function b(i,l=[],n=D.DEFAULT){let o=null,s=[];const a=[];function r(C){Array.isArray(s)?s.push(C):o!==null&&(s[o]=C)}return k(i,{onObjectBegin:()=>{const C={};r(C),a.push(s),s=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const C=[];r(C),a.push(s),s=C,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:r,onError:(C,M,O)=>{l.push({error:C,offset:M,length:O})}},n),s[0]}e.parse=b;function f(i,l=[],n=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(C){o.type==="property"&&(o.length=C-o.offset,o=o.parent)}function a(C){return o.children.push(C),C}k(i,{onObjectBegin:C=>{o=a({type:"object",offset:C,length:-1,parent:o,children:[]})},onObjectProperty:(C,M,O)=>{o=a({type:"property",offset:M,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:C,offset:M,length:O,parent:o})},onObjectEnd:(C,M)=>{o.length=C+M-o.offset,o=o.parent,s(C+M)},onArrayBegin:(C,M)=>{o=a({type:"array",offset:C,length:-1,parent:o,children:[]})},onArrayEnd:(C,M)=>{o.length=C+M-o.offset,o=o.parent,s(C+M)},onLiteralValue:(C,M,O)=>{a({type:L(C),offset:M,length:O,parent:o,value:C}),s(M+O)},onSeparator:(C,M,O)=>{o.type==="property"&&(C===":"?o.colonOffset=M:C===","&&s(M))},onError:(C,M,O)=>{l.push({error:C,offset:M,length:O})}},n);const m=o.children[0];return m&&delete m.parent,m}e.parseTree=f;function w(i,l){if(!i)return;let n=i;for(const o of l)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===o){n=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=w;function v(i){if(!i.parent||!i.parent.children)return[];const l=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}e.getNodePath=v;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const l=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(l[n.children[0].value]=c(o))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=c;function u(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}e.contains=u;function g(i,l,n=!1){if(u(i,l,n)){const o=i.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=l;s++){const a=g(o[s],l,n);if(a)return a}return i}}e.findNodeAtOffset=g;function k(i,l,n=D.DEFAULT){const o=R(i,!1);function s(ne){return ne?()=>ne(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(ne){return ne?_=>ne(_,o.getTokenOffset(),o.getTokenLength()):()=>!0}const r=s(l.onObjectBegin),m=a(l.onObjectProperty),C=s(l.onObjectEnd),M=s(l.onArrayBegin),O=s(l.onArrayEnd),B=a(l.onLiteralValue),J=a(l.onSeparator),G=s(l.onComment),X=a(l.onError),re=n&&n.disallowComments,se=n&&n.allowTrailingComma;function ae(){for(;;){const ne=o.scan();switch(o.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:re||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:re?fe(10):G();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,_=[],$=[]){if(X(ne),_.length+$.length>0){let A=o.getToken();for(;A!==17;){if(_.indexOf(A)!==-1){ae();break}else if($.indexOf(A)!==-1)break;A=ae()}}}function ge(ne){const _=o.getTokenValue();return ne?B(_):m(_),ae(),!0}function H(){switch(o.getToken()){case 11:{let ne=0;try{ne=JSON.parse(o.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}B(ne);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ae(),!0}function F(){return o.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),o.getToken()===6?(J(":"),ae(),Q()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function U(){r(),ae();let ne=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ne||fe(4,[],[]),J(","),ae(),o.getToken()===2&&se)break}else ne&&fe(6,[],[]);F()||fe(4,[],[2,5]),ne=!0}return C(),o.getToken()!==2?fe(7,[2],[]):ae(),!0}function z(){M(),ae();let ne=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ne||fe(4,[],[]),J(","),ae(),o.getToken()===4&&se)break}else ne&&fe(6,[],[]);Q()||fe(4,[],[4,5]),ne=!0}return O(),o.getToken()!==4?fe(8,[4],[]):ae(),!0}function Q(){switch(o.getToken()){case 3:return z();case 1:return U();case 10:return ge(!0);default:return H()}}return ae(),o.getToken()===17?n.allowEmptyContent?!0:(fe(4,[],[]),!1):Q()?(o.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function S(i,l){const n=R(i),o=[];let s,a=0,r;do switch(r=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==r&&o.push(i.substring(a,r)),l!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,l)),a=n.getPosition();break}while(s!==17);return o.join("")}e.stripComments=S;function L(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(te[125],ie([0,1,43]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(h,y,p){let b,f,w,v,c;if(y){for(v=y.offset,c=v+y.length,w=v;w>0&&!d(h,w-1);)w--;let r=c;for(;r<h.length&&!d(h,r);)r++;f=h.substring(w,r),b=R(f,p)}else f=h,b=0,w=0,v=0,c=h.length;const u=I(p,h);let g=!1,k=0,S;p.insertSpaces?S=D(" ",p.tabSize||4):S="	";const L=(0,E.createScanner)(f,!1);let i=!1;function l(){return u+D(S,b+k)}function n(){let r=L.scan();for(g=!1;r===15||r===14;)g=g||r===14,r=L.scan();return i=r===16||L.getTokenError()!==0,r}const o=[];function s(r,m,C){!i&&m<c&&C>v&&h.substring(m,C)!==r&&o.push({offset:m,length:C-m,content:r})}let a=n();if(a!==17){const r=L.getTokenOffset()+w,m=D(S,b);s(m,w,r)}for(;a!==17;){let r=L.getTokenOffset()+L.getTokenLength()+w,m=n(),C="";for(;!g&&(m===12||m===13);){const O=L.getTokenOffset()+w;s(" ",r,O),r=L.getTokenOffset()+L.getTokenLength()+w,C=m===12?l():"",m=n()}if(m===2)a!==1&&(k--,C=l());else if(m===4)a!==3&&(k--,C=l());else{switch(a){case 3:case 1:k++,C=l();break;case 5:case 12:C=l();break;case 13:g?C=l():C=" ";break;case 6:C=" ";break;case 10:if(m===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?C=" ":m!==5&&m!==17&&(i=!0);break;case 16:i=!0;break}g&&(m===12||m===13)&&(C=l())}const M=L.getTokenOffset()+w;s(C,r,M),a=m}return o}e.format=t;function P(h,y){const p=JSON.stringify(h,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?p.replace(/\r\n|\r|\n/g,y.eol):p}e.toFormattedString=P;function D(h,y){let p="";for(let b=0;b<y;b++)p+=h;return p}function R(h,y){let p=0,b=0;const f=y.tabSize||4;for(;p<h.length;){const w=h.charAt(p);if(w===" ")b++;else if(w==="	")b+=f;else break;p++}return Math.floor(b/f)}function I(h,y){for(let p=0;p<y.length;p++){const b=y.charAt(p);if(b==="\r")return p+1<y.length&&y.charAt(p+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=I;function d(h,y){return`\r
`.indexOf(h.charAt(y))!==-1}e.isEOL=d}),define(te[126],ie([0,1,43,125]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(h,y,p){return D(h,y,void 0,p)}e.removeProperty=P;function D(h,y,p,b,f){const w=y.slice(),v=[],c=(0,E.parseTree)(h,v);let u,g;for(;w.length>0&&(g=w.pop(),u=(0,E.findNodeAtLocation)(c,w),u===void 0&&p!==void 0);)typeof g=="string"?p={[g]:p}:p=[p];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const k=(0,E.findNodeAtLocation)(u,[g]);if(k!==void 0)if(p===void 0){if(!k.parent)throw new Error("Malformed AST");const S=u.children.indexOf(k.parent);let L,i=k.parent.offset+k.parent.length;if(S>0){const l=u.children[S-1];L=l.offset+l.length}else L=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return R(h,{offset:L,length:i-L,content:""},b)}else return R(h,{offset:k.offset,length:k.length,content:JSON.stringify(p)},b);else{if(p===void 0)return[];const S=`${JSON.stringify(g)}: ${JSON.stringify(p)}`,L=f?f(u.children.map(l=>l.children[0].value)):u.children.length;let i;if(L>0){const l=u.children[L-1];i={offset:l.offset+l.length,length:0,content:","+S}}else u.children.length===0?i={offset:u.offset+1,length:0,content:S}:i={offset:u.offset+1,length:0,content:S+","};return R(h,i,b)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(p!==void 0){const k=`${JSON.stringify(p)}`;let S;if(u.children.length===0||g===0)S={offset:u.offset+1,length:0,content:u.children.length===0?k:k+","};else{const L=g===-1||g>u.children.length?u.children.length:g,i=u.children[L-1];S={offset:i.offset+i.length,length:0,content:","+k}}return R(h,S,b)}else{const k=g,S=u.children[k];let L;if(u.children.length===1)L={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===k){const i=u.children[k-1],l=i.offset+i.length,n=u.offset+u.length;L={offset:l,length:n-2-l,content:""}}else L={offset:S.offset,length:u.children[k+1].offset-S.offset,content:""};return R(h,L,b)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return R(h,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(p)},b)}}e.setProperty=D;function R(h,y,p){let b=I(h,y),f=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;f>0&&!(0,t.isEOL)(b,f-1);)f--;for(;w<b.length&&!(0,t.isEOL)(b,w);)w++}const v=(0,t.format)(b,{offset:f,length:w-f},p);for(let u=v.length-1;u>=0;u--){const g=v[u];b=I(b,g),f=Math.min(f,g.offset),w=Math.max(w,g.offset+g.length),w+=g.content.length-g.length}const c=h.length-(b.length-w)-f;return[{offset:f,length:c,content:b.substring(f,w)}]}e.withFormatting=R;function I(h,y){return h.substring(0,y.offset)+y.content+h.substring(y.offset+y.length)}e.applyEdit=I;function d(h,y){const p=y.slice(0).sort((f,w)=>{const v=f.offset-w.offset;return v===0?f.length-w.length:v});let b=h.length;for(let f=p.length-1;f>=0;f--){const w=p[f];if(w.offset+w.length<=b)h=I(h,w);else throw new Error("Overlapping edit");b=w.offset}return h}e.applyEdits=d}),define(te[127],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(te[2],ie([0,1,50,69]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let D=null;function R(a){D=a}if(e.setDisposableTracker=R,P){const a="__is_disposable_tracked__";R(new class{trackDisposable(r){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(m)},3e3)}setParent(r,m){if(r&&r!==g.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==g.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function I(a){return D?.trackDisposable(a),a}function d(a){D?.markAsDisposed(a)}function h(a,r){D?.setParent(a,r)}function y(a,r){if(!!D)for(const m of a)D.setParent(m,r)}function p(a){return D?.markAsSingleton(a),a}e.markAsSingleton=p;function b(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=b;function f(a){if(t.Iterable.is(a)){const r=[];for(const m of a)if(m)try{m.dispose()}catch(C){r.push(C)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=f;function w(a){for(const r of a)b(r)&&r.dispose();return[]}e.disposeIfDisposable=w;function v(...a){const r=c(()=>f(a));return y(a,r),r}e.combinedDisposable=v;function c(a){const r=I({dispose:(0,E.once)(()=>{d(r),a()})});return r}e.toDisposable=c;class u{constructor(){this.c=new Set,this.f=!1,I(this)}dispose(){this.f||(d(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return h(r,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this.q=new u,I(this),h(this.q,this)}dispose(){d(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&h(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&h(r,null),r}}e.MutableDisposable=k;class S{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(r){let m=r;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,d(this))},this}}e.SafeDisposable=L;class i{constructor(){this.a=new Map}acquire(r,...m){let C=this.a.get(r);C||(C={counter:0,object:this.b(r,...m)},this.a.set(r,C));const{object:M}=C,O=(0,E.once)(()=>{--C.counter===0&&(this.c(r,C.object),this.a.delete(r))});return C.counter++,{object:M,dispose:O}}}e.ReferenceCollection=i;class l{constructor(r){this.a=r}async acquire(r,...m){const C=this.a.acquire(r,...m);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(M){throw C.dispose(),M}}}e.AsyncReferenceCollection=l;class n{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=n;function o(a){const r=new u;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=o;class s{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,m,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(r)?.dispose(),this.a.set(r,m)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(te[98],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(D){this.element=D,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let D=this.a;for(;D!==E.Undefined;){const R=D.next;D.prev=E.Undefined,D.next=E.Undefined,D=R}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,R){const I=new E(D);if(this.a===E.Undefined)this.a=I,this.b=I;else if(R){const h=this.b;this.b=I,I.prev=h,h.next=I}else{const h=this.a;this.a=I,I.next=h,h.prev=I}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(I))}}shift(){if(this.a!==E.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==E.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==E.Undefined&&D.next!==E.Undefined){const R=D.prev;R.next=D.next,D.next.prev=R}else D.prev===E.Undefined&&D.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):D.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):D.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==E.Undefined;)yield D.element,D=D.next}}e.LinkedList=t}),define(te[38],ie([0,1]),function(V,e){"use strict";var E,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(w,v,c){let u=w.get(v);return u===void 0&&(u=c,w.set(v,u)),u}e.getOrSet=D;function R(w){const v=[];return w.forEach((c,u)=>{v.push(`${u} => ${c}`)}),`Map(${w.size}) {${v.join(", ")}}`}e.mapToString=R;function I(w){const v=[];return w.forEach(c=>{v.push(c)}),`Set(${w.size}) {${v.join(", ")}}`}e.setToString=I;class d{constructor(v,c){this.uri=v,this.value=c}}class h{constructor(v,c){this[E]="ResourceMap",v instanceof h?(this.b=new Map(v.b),this.c=c??h.a):(this.b=new Map,this.c=v??h.a)}set(v,c){return this.b.set(this.c(v),new d(v,c)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,c){typeof c<"u"&&(v=v.bind(c));for(const[u,g]of this.b)v(g.value,g.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=h,h.a=w=>w.toString();class y{constructor(v,c){this[t]="ResourceSet",!v||typeof v=="function"?this.a=new h(v):(this.a=new h(c),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,c){this.a.forEach((u,g)=>v.call(c,g,g,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var p;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class b{constructor(){this[P]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,c=0){const u=this.a.get(v);if(!!u)return c!==0&&this.j(u,c),u.value}set(v,c,u=0){let g=this.a.get(v);if(g)g.value=c,u!==0&&this.j(g,u);else{switch(g={key:v,value:c,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(v,g),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const c=this.a.get(v);if(!!c)return this.a.delete(v),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,c){const u=this.e;let g=this.b;for(;g;){if(c?v.bind(c)(g.value,g.key,this):v(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const v=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.key,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}values(){const v=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.value,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}entries(){const v=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:[u.key,u.value],done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let c=this.b,u=this.size;for(;c&&u>v;)this.a.delete(c.key),c=c.next,u--;this.b=c,this.d=u,c&&(c.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const c=v.next,u=v.previous;if(!c||!u)throw new Error("Invalid list");c.previous=u,u.next=c}v.next=void 0,v.previous=void 0,this.e++}j(v,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(v===this.b)return;const u=v.next,g=v.previous;v===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(c===2){if(v===this.c)return;const u=v.next,g=v.previous;v===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((c,u)=>{v.push([u,c])}),v}fromJSON(v){this.clear();for(const[c,u]of v)this.set(c,u)}}e.LinkedMap=b;class f extends b{constructor(v,c=1){super(),this.k=v,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,c=2){return super.get(v,c)}peek(v){return super.get(v,0)}set(v,c){return super.set(v,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(te[79],ie([0,1,38]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function P(h){return d(h,"NFC",t)}e.normalizeNFC=P;const D=new E.LRUCache(1e4);function R(h){return d(h,"NFD",D)}e.normalizeNFD=R;const I=/[^\u0000-\u0080]/;function d(h,y,p){if(!h)return h;const b=p.get(h);if(b)return b;let f;return I.test(h)?f=h.normalize(y):f=h,p.set(h,f),f}e.removeAccents=function(){const h=/[\u0300-\u036f]/g;return function(y){return R(y).replace(h,"")}}()}),define(te[128],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(I,d,h){return Math.min(Math.max(I,d),h)}e.clamp=E;function t(I,d){return(d+I%d)%d}e.rot=t;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class D{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class R{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const h=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function V(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function R(d){D.push(d,Date.now())}function I(){const d=[];for(let h=0;h<D.length;h+=2)d.push({name:D[h],startTime:D[h+1]});return d}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(P+R.startTime)});return D}};if(typeof process=="object"){const P=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:V)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function E(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return V[t].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=V,E.c=e,E.d=function(t,P,D){E.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:D})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,P){if(1&P&&(t=E(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var D=Object.create(null);if(E.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var R in t)E.d(D,R,function(I){return t[I]}.bind(null,R));return D},E.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(P,"a",P),P},E.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},E.p="",E(E.s=0)}([function(V,e,E){(function(t){var P;e=V.exports=$,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],d=e.src=[],h=0,y=h++;d[y]="0|[1-9]\\d*";var p=h++;d[p]="[0-9]+";var b=h++;d[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=h++;d[f]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var w=h++;d[w]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var v=h++;d[v]="(?:"+d[y]+"|"+d[b]+")";var c=h++;d[c]="(?:"+d[p]+"|"+d[b]+")";var u=h++;d[u]="(?:-("+d[v]+"(?:\\."+d[v]+")*))";var g=h++;d[g]="(?:-?("+d[c]+"(?:\\."+d[c]+")*))";var k=h++;d[k]="[0-9A-Za-z-]+";var S=h++;d[S]="(?:\\+("+d[k]+"(?:\\."+d[k]+")*))";var L=h++,i="v?"+d[f]+d[u]+"?"+d[S]+"?";d[L]="^"+i+"$";var l="[v=\\s]*"+d[w]+d[g]+"?"+d[S]+"?",n=h++;d[n]="^"+l+"$";var o=h++;d[o]="((?:<|>)?=?)";var s=h++;d[s]=d[p]+"|x|X|\\*";var a=h++;d[a]=d[y]+"|x|X|\\*";var r=h++;d[r]="[v=\\s]*("+d[a]+")(?:\\.("+d[a]+")(?:\\.("+d[a]+")(?:"+d[u]+")?"+d[S]+"?)?)?";var m=h++;d[m]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[g]+")?"+d[S]+"?)?)?";var C=h++;d[C]="^"+d[o]+"\\s*"+d[r]+"$";var M=h++;d[M]="^"+d[o]+"\\s*"+d[m]+"$";var O=h++;d[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=h++;d[B]="(?:~>?)";var J=h++;d[J]="(\\s*)"+d[B]+"\\s+",I[J]=new RegExp(d[J],"g");var G=h++;d[G]="^"+d[B]+d[r]+"$";var X=h++;d[X]="^"+d[B]+d[m]+"$";var re=h++;d[re]="(?:\\^)";var se=h++;d[se]="(\\s*)"+d[re]+"\\s+",I[se]=new RegExp(d[se],"g");var ae=h++;d[ae]="^"+d[re]+d[r]+"$";var fe=h++;d[fe]="^"+d[re]+d[m]+"$";var ge=h++;d[ge]="^"+d[o]+"\\s*("+l+")$|^$";var H=h++;d[H]="^"+d[o]+"\\s*("+i+")$|^$";var F=h++;d[F]="(\\s*)"+d[o]+"\\s*("+l+"|"+d[r]+")",I[F]=new RegExp(d[F],"g");var U=h++;d[U]="^\\s*("+d[r]+")\\s+-\\s+("+d[r]+")\\s*$";var z=h++;d[z]="^\\s*("+d[m]+")\\s+-\\s+("+d[m]+")\\s*$";var Q=h++;d[Q]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,d[ne]),I[ne]||(I[ne]=new RegExp(d[ne]));function _(x,de){if(x instanceof $)return x;if(typeof x!="string"||x.length>D||!(de?I[n]:I[L]).test(x))return null;try{return new $(x,de)}catch{return null}}function $(x,de){if(x instanceof $){if(x.loose===de)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof $))return new $(x,de);P("SemVer",x,de),this.loose=de;var ue=x.trim().match(de?I[n]:I[L]);if(!ue)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var De=+ye;if(De>=0&&De<R)return De}return ye}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,de){var ue=_(x,de);return ue?ue.version:null},e.clean=function(x,de){var ue=_(x.trim().replace(/^[=v]+/,""),de);return ue?ue.version:null},e.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof $||(x=new $(x,this.loose)),this.compareMain(x)||this.comparePre(x)},$.prototype.compareMain=function(x){return x instanceof $||(x=new $(x,this.loose)),T(this.major,x.major)||T(this.minor,x.minor)||T(this.patch,x.patch)},$.prototype.comparePre=function(x){if(x instanceof $||(x=new $(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var de=0;do{var ue=this.prerelease[de],ye=x.prerelease[de];if(P("prerelease compare",de,ue,ye),ue===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ue===void 0)return-1;if(ue!==ye)return T(ue,ye)}while(++de)},$.prototype.inc=function(x,de){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,de,ue,ye){typeof ue=="string"&&(ye=ue,ue=void 0);try{return new $(x,ue).inc(de,ye).version}catch{return null}},e.diff=function(x,de){if(N(x,de))return null;var ue=_(x),ye=_(de);if(ue.prerelease.length||ye.prerelease.length){for(var De in ue)if((De==="major"||De==="minor"||De==="patch")&&ue[De]!==ye[De])return"pre"+De;return"prerelease"}for(var De in ue)if((De==="major"||De==="minor"||De==="patch")&&ue[De]!==ye[De])return De},e.compareIdentifiers=T;var A=/^[0-9]+$/;function T(x,de){var ue=A.test(x),ye=A.test(de);return ue&&ye&&(x=+x,de=+de),ue&&!ye?-1:ye&&!ue?1:x<de?-1:x>de?1:0}function W(x,de,ue){return new $(x,ue).compare(new $(de,ue))}function j(x,de,ue){return W(x,de,ue)>0}function K(x,de,ue){return W(x,de,ue)<0}function N(x,de,ue){return W(x,de,ue)===0}function q(x,de,ue){return W(x,de,ue)!==0}function Z(x,de,ue){return W(x,de,ue)>=0}function oe(x,de,ue){return W(x,de,ue)<=0}function le(x,de,ue,ye){var De;switch(de){case"===":typeof x=="object"&&(x=x.version),typeof ue=="object"&&(ue=ue.version),De=x===ue;break;case"!==":typeof x=="object"&&(x=x.version),typeof ue=="object"&&(ue=ue.version),De=x!==ue;break;case"":case"=":case"==":De=N(x,ue,ye);break;case"!=":De=q(x,ue,ye);break;case">":De=j(x,ue,ye);break;case">=":De=Z(x,ue,ye);break;case"<":De=K(x,ue,ye);break;case"<=":De=oe(x,ue,ye);break;default:throw new TypeError("Invalid operator: "+de)}return De}function be(x,de){if(x instanceof be){if(x.loose===de)return x;x=x.value}if(!(this instanceof be))return new be(x,de);P("comparator",x,de),this.loose=de,this.parse(x),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(x,de){return T(de,x)},e.major=function(x,de){return new $(x,de).major},e.minor=function(x,de){return new $(x,de).minor},e.patch=function(x,de){return new $(x,de).patch},e.compare=W,e.compareLoose=function(x,de){return W(x,de,!0)},e.rcompare=function(x,de,ue){return W(de,x,ue)},e.sort=function(x,de){return x.sort(function(ue,ye){return e.compare(ue,ye,de)})},e.rsort=function(x,de){return x.sort(function(ue,ye){return e.rcompare(ue,ye,de)})},e.gt=j,e.lt=K,e.eq=N,e.neq=q,e.gte=Z,e.lte=oe,e.cmp=le,e.Comparator=be;var Ce={};function Oe(x,de){if(x instanceof Oe)return x.loose===de?x:new Oe(x.raw,de);if(x instanceof be)return new Oe(x.value,de);if(!(this instanceof Oe))return new Oe(x,de);if(this.loose=de,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function we(x,de,ue,ye,De,Ue,Te,He,We,qe,Xe,Ne,Ge){return((de=Le(ue)?"":Le(ye)?">="+ue+".0.0":Le(De)?">="+ue+"."+ye+".0":">="+de)+" "+(He=Le(We)?"":Le(qe)?"<"+(+We+1)+".0.0":Le(Xe)?"<"+We+"."+(+qe+1)+".0":Ne?"<="+We+"."+qe+"."+Xe+"-"+Ne:"<="+He)).trim()}function ve(x,de){for(var ue=0;ue<x.length;ue++)if(!x[ue].test(de))return!1;if(de.prerelease.length){for(ue=0;ue<x.length;ue++)if(P(x[ue].semver),x[ue].semver!==Ce&&x[ue].semver.prerelease.length>0){var ye=x[ue].semver;if(ye.major===de.major&&ye.minor===de.minor&&ye.patch===de.patch)return!0}return!1}return!0}function Ee(x,de,ue){try{de=new Oe(de,ue)}catch{return!1}return de.test(x)}function Ie(x,de,ue,ye){var De,Ue,Te,He,We;switch(x=new $(x,ye),de=new Oe(de,ye),ue){case">":De=j,Ue=oe,Te=K,He=">",We=">=";break;case"<":De=K,Ue=Z,Te=j,He="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,de,ye))return!1;for(var qe=0;qe<de.set.length;++qe){var Xe=de.set[qe],Ne=null,Ge=null;if(Xe.forEach(function(Y){Y.semver===Ce&&(Y=new be(">=0.0.0")),Ne=Ne||Y,Ge=Ge||Y,De(Y.semver,Ne.semver,ye)?Ne=Y:Te(Y.semver,Ge.semver,ye)&&(Ge=Y)}),Ne.operator===He||Ne.operator===We||(!Ge.operator||Ge.operator===He)&&Ue(x,Ge.semver)||Ge.operator===We&&Te(x,Ge.semver))return!1}return!0}be.prototype.parse=function(x){var de=this.loose?I[ge]:I[H],ue=x.match(de);if(!ue)throw new TypeError("Invalid comparator: "+x);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new $(ue[2],this.loose):this.semver=Ce},be.prototype.toString=function(){return this.value},be.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===Ce||(typeof x=="string"&&(x=new $(x,this.loose)),le(x,this.operator,this.semver,this.loose))},be.prototype.intersects=function(x,de){if(!(x instanceof be))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Oe(x.value,de),Ee(this.value,ue,de);if(x.operator==="")return ue=new Oe(this.value,de),Ee(x.semver,ue,de);var ye=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ue=this.semver.version===x.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),He=le(this.semver,"<",x.semver,de)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),We=le(this.semver,">",x.semver,de)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ye||De||Ue&&Te||He||We},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(x){var de=this.loose;x=x.trim(),P("range",x,de);var ue=de?I[z]:I[U];x=x.replace(ue,we),P("hyphen replace",x),x=x.replace(I[F],"$1$2$3"),P("comparator trim",x,I[F]),x=(x=(x=x.replace(I[J],"$1~")).replace(I[se],"$1^")).split(/\s+/).join(" ");var ye=de?I[ge]:I[H],De=x.split(" ").map(function(Ue){return function(Te,He){return P("comp",Te),Te=function(We,qe){return We.trim().split(/\s+/).map(function(Xe){return function(Ne,Ge){P("caret",Ne,Ge);var Y=Ge?I[fe]:I[ae];return Ne.replace(Y,function(ce,he,me,Se,Ae){var ze;return P("caret",Ne,ce,he,me,Se,Ae),Le(he)?ze="":Le(me)?ze=">="+he+".0.0 <"+(+he+1)+".0.0":Le(Se)?ze=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Ae?(P("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),ze=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Ae+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Ae+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Ae+" <"+(+he+1)+".0.0"):(P("no pr"),ze=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),P("caret return",ze),ze})}(Xe,qe)}).join(" ")}(Te,He),P("caret",Te),Te=function(We,qe){return We.trim().split(/\s+/).map(function(Xe){return function(Ne,Ge){var Y=Ge?I[X]:I[G];return Ne.replace(Y,function(ce,he,me,Se,Ae){var ze;return P("tilde",Ne,ce,he,me,Se,Ae),Le(he)?ze="":Le(me)?ze=">="+he+".0.0 <"+(+he+1)+".0.0":Le(Se)?ze=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Ae?(P("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),ze=">="+he+"."+me+"."+Se+Ae+" <"+he+"."+(+me+1)+".0"):ze=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",P("tilde return",ze),ze})}(Xe,qe)}).join(" ")}(Te,He),P("tildes",Te),Te=function(We,qe){return P("replaceXRanges",We,qe),We.split(/\s+/).map(function(Xe){return function(Ne,Ge){Ne=Ne.trim();var Y=Ge?I[M]:I[C];return Ne.replace(Y,function(ce,he,me,Se,Ae,ze){P("xRange",Ne,ce,he,me,Se,Ae,ze);var it=Le(me),_e=it||Le(Se),Ve=_e||Le(Ae);return he==="="&&Ve&&(he=""),it?ce=he===">"||he==="<"?"<0.0.0":"*":he&&Ve?(_e&&(Se=0),Ve&&(Ae=0),he===">"?(he=">=",_e?(me=+me+1,Se=0,Ae=0):Ve&&(Se=+Se+1,Ae=0)):he==="<="&&(he="<",_e?me=+me+1:Se=+Se+1),ce=he+me+"."+Se+"."+Ae):_e?ce=">="+me+".0.0 <"+(+me+1)+".0.0":Ve&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),P("xRange return",ce),ce})}(Xe,qe)}).join(" ")}(Te,He),P("xrange",Te),Te=function(We,qe){return P("replaceStars",We,qe),We.trim().replace(I[Q],"")}(Te,He),P("stars",Te),Te}(Ue,de)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ue){return!!Ue.match(ye)})),De=De.map(function(Ue){return new be(Ue,de)})},Oe.prototype.intersects=function(x,de){if(!(x instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(ye){return x.set.some(function(De){return De.every(function(Ue){return ye.intersects(Ue,de)})})})})},e.toComparators=function(x,de){return new Oe(x,de).set.map(function(ue){return ue.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new $(x,this.loose));for(var de=0;de<this.set.length;de++)if(ve(this.set[de],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,de,ue){var ye=null,De=null;try{var Ue=new Oe(de,ue)}catch{return null}return x.forEach(function(Te){Ue.test(Te)&&(ye&&De.compare(Te)!==-1||(De=new $(ye=Te,ue)))}),ye},e.minSatisfying=function(x,de,ue){var ye=null,De=null;try{var Ue=new Oe(de,ue)}catch{return null}return x.forEach(function(Te){Ue.test(Te)&&(ye&&De.compare(Te)!==1||(De=new $(ye=Te,ue)))}),ye},e.validRange=function(x,de){try{return new Oe(x,de).range||"*"}catch{return null}},e.ltr=function(x,de,ue){return Ie(x,de,"<",ue)},e.gtr=function(x,de,ue){return Ie(x,de,">",ue)},e.outside=Ie,e.prerelease=function(x,de){var ue=_(x,de);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(x,de,ue){return x=new Oe(x,ue),de=new Oe(de,ue),x.intersects(de)},e.coerce=function(x){if(x instanceof $)return x;if(typeof x!="string")return null;var de=x.match(I[O]);return de==null?null:_((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,E(1))},function(V,e){var E,t,P=V.exports={};function D(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function I(c){if(E===setTimeout)return setTimeout(c,0);if((E===D||!E)&&setTimeout)return E=setTimeout,setTimeout(c,0);try{return E(c,0)}catch{try{return E.call(null,c,0)}catch{return E.call(this,c,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:D}catch{E=D}try{t=typeof clearTimeout=="function"?clearTimeout:R}catch{t=R}})();var d,h=[],y=!1,p=-1;function b(){y&&d&&(y=!1,d.length?h=d.concat(h):p=-1,h.length&&f())}function f(){if(!y){var c=I(b);y=!0;for(var u=h.length;u;){for(d=h,h=[];++p<u;)d&&d[p].run();p=-1,u=h.length}d=null,y=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===R||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(c)}}function w(c,u){this.fun=c,this.array=u}function v(){}P.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];h.push(new w(c,u)),h.length!==1||y||I(f)},w.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(te[129],ie([0,1]),function(V,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,d,h){this.level=I,this.key=d,this.value=h,this.forward=[]}}const P=void 0;class D{constructor(I,d=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new t(this.c,P,P)}get size(){return this.f}clear(){this.e=new t(this.c,P,P)}has(I){return Boolean(D.g(this,I,this.comparator))}get(I){return D.g(this,I,this.comparator)?.value}set(I,d){return D.h(this,I,d,this.comparator)&&(this.f+=1),this}delete(I){const d=D.k(this,I,this.comparator);return d&&(this.f-=1),d}forEach(I,d){let h=this.e.forward[0];for(;h;)I.call(d,h.value,h.key,this),h=h.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",d=this.e.forward[0];for(;d;)I+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return I}static g(I,d,h){let y=I.e;for(let p=I.d-1;p>=0;p--)for(;y.forward[p]&&h(y.forward[p].key,d)<0;)y=y.forward[p];if(y=y.forward[0],y&&h(y.key,d)===0)return y}static h(I,d,h,y){const p=[];let b=I.e;for(let f=I.d-1;f>=0;f--){for(;b.forward[f]&&y(b.forward[f].key,d)<0;)b=b.forward[f];p[f]=b}if(b=b.forward[0],b&&y(b.key,d)===0)return b.value=h,!1;{const f=D.j(I);if(f>I.d){for(let w=I.d;w<f;w++)p[w]=I.e;I.d=f}b=new t(f,d,h);for(let w=0;w<f;w++)b.forward[w]=p[w].forward[w],p[w].forward[w]=b;return!0}}static j(I,d=.5){let h=1;for(;Math.random()<d&&h<I.c;)h+=1;return h}static k(I,d,h){const y=[];let p=I.e;for(let b=I.d-1;b>=0;b--){for(;p.forward[b]&&h(p.forward[b].key,d)<0;)p=p.forward[b];y[b]=p}if(p=p.forward[0],!p||h(p.key,d)!==0)return!1;for(let b=0;b<I.d&&y[b].forward[b]===p;b++)y[b].forward[b]=p.forward[b];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.SkipList=D}),define(te[59],ie([0,1,13,2]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(S){const L=S;return L?typeof L.read=="function":!1}e.isReadable=P;function D(S){const L=S;return L?[L.on,L.pause,L.resume,L.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=D;function R(S){const L=S;return L?D(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=R;function I(S,L){return new d(S,L)}e.newWriteableStream=I;class d{constructor(L,i){this.e=L,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(i=>i(L))}h(L){this.c.error.length===0?(0,E.onUnexpectedError)(L):this.c.error.slice(0).forEach(i=>i(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,i){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(L,i){if(this.a.destroyed)return;let l;switch(L){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const n=l.indexOf(i);n>=0&&l.splice(n,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(S,L){const i=[];let l;for(;(l=S.read())!==null;)i.push(l);return L(i)}e.consumeReadable=h;function y(S,L,i){const l=[];let n;for(;(n=S.read())!==null&&l.length<i;)l.push(n);return n===null&&l.length>0?L(l):{read:()=>{if(l.length>0)return l.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return S.read()}}}e.peekReadable=y;function p(S,L){return new Promise((i,l)=>{const n=[];b(S,{onData:o=>{L&&n.push(o)},onError:o=>{L?l(o):i(void 0)},onEnd:()=>{i(L?L(n):void 0)}})})}e.consumeStream=p;function b(S,L){let i=!1;return S.on("error",l=>{i||L.onError(l)}),S.on("end",()=>{i||L.onEnd()}),S.on("data",l=>{i||L.onData(l)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=b;function f(S,L){return new Promise((i,l)=>{const n=new t.DisposableStore,o=[],s=m=>{if(o.push(m),o.length>L)return n.dispose(),S.pause(),i({stream:S,buffer:o,ended:!1})},a=m=>l(m),r=()=>i({stream:S,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>S.removeListener("error",a))),S.on("error",a),n.add((0,t.toDisposable)(()=>S.removeListener("end",r))),S.on("end",r),n.add((0,t.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}e.peekStream=f;function w(S,L){const i=I(L);return i.end(S),i}e.toStream=w;function v(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=v;function c(S){let L=!1;return{read:()=>L?null:(L=!0,S)}}e.toReadable=c;function u(S,L,i){const l=I(i);return b(S,{onData:n=>l.write(L.data(n)),onError:n=>l.error(L.error?L.error(n):n),onEnd:()=>l.end()}),l}e.transform=u;function g(S,L,i){let l=!1;return{read:()=>{const n=L.read();return l?n:(l=!0,n!==null?i([S,n]):S)}}}e.prefixedReadable=g;function k(S,L,i){let l=!1;const n=I(i);return b(L,{onData:o=>l?n.write(o):(l=!0,n.write(i([S,o]))),onError:o=>n.error(o),onEnd:()=>{l||(l=!0,n.write(S)),n.end()}}),n}e.prefixedStream=k}),define(te[17],ie([0,1,59]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,D;class R{static alloc(m){return t?new R(Buffer.allocUnsafe(m)):new R(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new R(m)}static fromString(m,C){return!(C?.dontUseNodeBuffer||!1)&&t?new R(Buffer.from(m)):(P||(P=new TextEncoder),new R(P.encode(m)))}static fromByteArray(m){const C=R.alloc(m.length);for(let M=0,O=m.length;M<O;M++)C.buffer[M]=m[M];return C}static concat(m,C){if(typeof C>"u"){C=0;for(let B=0,J=m.length;B<J;B++)C+=m[B].byteLength}const M=R.alloc(C);let O=0;for(let B=0,J=m.length;B<J;B++){const G=m[B];M.set(G,O),O+=G.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=R.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(m,C){return new R(this.buffer.subarray(m,C))}set(m,C){if(m instanceof R)this.buffer.set(m.buffer,C);else if(m instanceof Uint8Array)this.buffer.set(m,C);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),C);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return h(this.buffer,m)}writeUInt32BE(m,C){y(this.buffer,m,C)}readUInt32LE(m){return p(this.buffer,m)}writeUInt32LE(m,C){b(this.buffer,m,C)}readUInt8(m){return f(this.buffer,m)}writeUInt8(m,C){w(this.buffer,m,C)}}e.VSBuffer=R;function I(r,m){return r[m+0]<<0>>>0|r[m+1]<<8>>>0}e.readUInt16LE=I;function d(r,m,C){r[C+0]=m&255,m=m>>>8,r[C+1]=m&255}e.writeUInt16LE=d;function h(r,m){return r[m]*2**24+r[m+1]*2**16+r[m+2]*2**8+r[m+3]}e.readUInt32BE=h;function y(r,m,C){r[C+3]=m,m=m>>>8,r[C+2]=m,m=m>>>8,r[C+1]=m,m=m>>>8,r[C]=m}e.writeUInt32BE=y;function p(r,m){return r[m+0]<<0>>>0|r[m+1]<<8>>>0|r[m+2]<<16>>>0|r[m+3]<<24>>>0}e.readUInt32LE=p;function b(r,m,C){r[C+0]=m&255,m=m>>>8,r[C+1]=m&255,m=m>>>8,r[C+2]=m&255,m=m>>>8,r[C+3]=m&255}e.writeUInt32LE=b;function f(r,m){return r[m]}e.readUInt8=f;function w(r,m,C){r[C]=m}e.writeUInt8=w;function v(r){return E.consumeReadable(r,m=>R.concat(m))}e.readableToBuffer=v;function c(r){return E.toReadable(r)}e.bufferToReadable=c;function u(r){return E.consumeStream(r,m=>R.concat(m))}e.streamToBuffer=u;async function g(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=g;function k(r){return E.toStream(r,m=>R.concat(m))}e.bufferToStream=k;function S(r){return E.transform(r,{data:m=>typeof m=="string"?R.fromString(m):R.wrap(m)},m=>R.concat(m))}e.streamToBufferReadableStream=S;function L(r){return E.newWriteableStream(m=>R.concat(m),r)}e.newWriteableBufferStream=L;function i(r,m){return E.prefixedReadable(r,m,C=>R.concat(C))}e.prefixedBufferReadable=i;function l(r,m){return E.prefixedStream(r,m,C=>R.concat(C))}e.prefixedBufferStream=l;function n(r){let m=0,C=0,M=0;const O=new Uint8Array(Math.floor(r.length/4*3)),B=G=>{switch(C){case 3:O[M++]=m|G,C=0;break;case 2:O[M++]=m|G>>>2,m=G<<6,C=3;break;case 1:O[M++]=m|G>>>4,m=G<<4,C=2;break;default:m=G<<2,C=1}};for(let G=0;G<r.length;G++){const X=r.charCodeAt(G);if(X>=65&&X<=90)B(X-65);else if(X>=97&&X<=122)B(X-97+26);else if(X>=48&&X<=57)B(X-48+52);else if(X===43||X===45)B(62);else if(X===47||X===95)B(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${r[G]}`)}}const J=M;for(;C>0;)B(0);return R.wrap(O).slice(0,J)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:r},m=!0,C=!1){const M=C?s:o;let O="";const B=r.byteLength%3;let J=0;for(;J<r.byteLength-B;J+=3){const G=r[J+0],X=r[J+1],re=r[J+2];O+=M[G>>>2],O+=M[(G<<4|X>>>4)&63],O+=M[(X<<2|re>>>6)&63],O+=M[re&63]}if(B===1){const G=r[J+0];O+=M[G>>>2],O+=M[G<<4&63],m&&(O+="==")}else if(B===2){const G=r[J+0],X=r[J+1];O+=M[G>>>2],O+=M[(G<<4|X>>>4)&63],O+=M[X<<2&63],m&&(O+="=")}return O}e.encodeBase64=a}),define(te[11],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(l){return typeof l=="string"}e.isString=E;function t(l){return Array.isArray(l)&&l.every(n=>E(n))}e.isStringArray=t;function P(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=P;function D(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}e.isTypedArray=D;function R(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=R;function I(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=I;function d(l){return l===!0||l===!1}e.isBoolean=d;function h(l){return typeof l>"u"}e.isUndefined=h;function y(l){return!p(l)}e.isDefined=y;function p(l){return h(l)||l===null}e.isUndefinedOrNull=p;function b(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=b;function f(l){if(p(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=f;function w(...l){const n=[];for(let o=0;o<l.length;o++){const s=l[o];if(p(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(s)}return n}e.assertAllDefined=w;const v=Object.prototype.hasOwnProperty;function c(l){if(!P(l))return!1;for(const n in l)if(v.call(l,n))return!1;return!0}e.isEmptyObject=c;function u(l){return typeof l=="function"}e.isFunction=u;function g(...l){return l.length>0&&l.every(u)}e.areFunctions=g;function k(l,n){const o=Math.min(l.length,n.length);for(let s=0;s<o;s++)S(l[s],n[s])}e.validateConstraints=k;function S(l,n){if(E(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(l instanceof n)return}catch{}if(!p(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function L(l){return l===null?void 0:l}e.withNullAsUndefined=L;function i(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=i}),define(te[44],ie([0,1,11]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([k,S])=>{g[k]=S&&typeof S=="object"?t(S):S}),g}e.deepClone=t;function P(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const k=g.shift();Object.freeze(k);for(const S in k)if(D.call(k,S)){const L=k[S];typeof L=="object"&&!Object.isFrozen(L)&&!(0,E.isTypedArray)(L)&&g.push(L)}}return u}e.deepFreeze=P;const D=Object.prototype.hasOwnProperty;function R(u,g){return I(u,g,new Set)}e.cloneAndChange=R;function I(u,g,k){if((0,E.isUndefinedOrNull)(u))return u;const S=g(u);if(typeof S<"u")return S;if(Array.isArray(u)){const L=[];for(const i of u)L.push(I(i,g,k));return L}if((0,E.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const L={};for(const i in u)D.call(u,i)&&(L[i]=I(u[i],g,k));return k.delete(u),L}return u}function d(u,g,k=!0){return(0,E.isObject)(u)?((0,E.isObject)(g)&&Object.keys(g).forEach(S=>{S in u?k&&((0,E.isObject)(u[S])&&(0,E.isObject)(g[S])?d(u[S],g[S],k):u[S]=g[S]):u[S]=g[S]}),u):g}e.mixin=d;function h(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let k,S;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(k=0;k<u.length;k++)if(!h(u[k],g[k]))return!1}else{const L=[];for(S in u)L.push(S);L.sort();const i=[];for(S in g)i.push(S);if(i.sort(),!h(L,i))return!1;for(k=0;k<L.length;k++)if(!h(u[L[k]],g[L[k]]))return!1}return!0}e.equals=h;function y(u){const g=new Set;return JSON.stringify(u,(k,S)=>{if((0,E.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}e.safeStringify=y;function p(u,g){const k=Object.create(null);return!u||!g||Object.keys(g).forEach(L=>{const i=u[L],l=g[L];h(i,l)||(k[L]=l)}),k}e.distinct=p;function b(u,g){const k=g.toLowerCase(),S=Object.keys(u).find(L=>L.toLowerCase()===k);return S?u[S]:u[g]}e.getCaseInsensitive=b;function f(u,g){const k=Object.create(null);for(const[S,L]of Object.entries(u))g(S,L)&&(k[S]=L);return k}e.filter=f;function w(u){let g=[],k=Object.getPrototypeOf(u);for(;Object.prototype!==k;)g=g.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return g}e.getAllPropertyNames=w;function v(u){const g=[];for(const k of w(u))typeof u[k]=="function"&&g.push(k);return g}e.getAllMethodNames=v;function c(u,g){const k=L=>function(){const i=Array.prototype.slice.call(arguments,0);return g(L,i)},S={};for(const L of u)S[L]=k(L);return S}e.createProxyObject=c}),define(te[31],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return E.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let d=0;d<I.length;d++)I[d]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),R=[];for(let I=0;I<256;I++)R.push(I.toString(16).padStart(2,"0"));return function(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,h="";return h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h+="-",h+=R[D[d++]],h+=R[D[d++]],h+="-",h+=R[D[d++]],h+=R[D[d++]],h+="-",h+=R[D[d++]],h+=R[D[d++]],h+="-",h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h+=R[D[d++]],h}}()}),define(te[130],ie([0,1,80,41,50]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(R,I){if(await new Promise((y,p)=>{const b=t.createReadStream(R),f=E.createHash("sha1");b.pipe(f);const w=(0,P.once)((v,c)=>{b.removeAllListeners(),f.removeAllListeners(),v?p(v):y(c)});b.once("error",w),b.once("end",w),f.once("error",w),f.once("data",v=>w(void 0,v.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=D}),define(te[131],ie([0,1,26]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(R){const I=R.replace(/\-/g,":").toLowerCase();return!t.has(I)}function D(){const R=(0,E.networkInterfaces)();for(const I in R){const d=R[I];if(d){for(const{mac:h}of d)if(P(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(te[99],ie([0,1,81]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,d,h,y=1){let p=!1;return new Promise(b=>{const f=setTimeout(()=>{if(!p)return p=!0,b(0)},h);P(I,d,y,w=>{if(!p)return p=!0,clearTimeout(f),b(w)})})}e.findFreePort=t;function P(I,d,h,y){if(d===0)return y(0);const p=new E.Socket;p.once("connect",()=>(R(p),P(I+h,d-1,h,y))),p.once("data",()=>{}),p.once("error",b=>(R(p),b.code!=="ECONNREFUSED"?P(I+h,d-1,h,y):y(I))),p.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,d,h,y="127.0.0.1"){let p=!1,b,f=1;const w=E.createServer({pauseOnConnect:!0});function v(c,u){p||(p=!0,w.removeAllListeners(),w.close(),b&&clearTimeout(b),u(c))}return new Promise(c=>{b=setTimeout(()=>{v(0,c)},h),w.on("listening",()=>{v(I,c)}),w.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<d?(I++,f++,w.listen(I,y)):v(0,c)}),w.on("close",()=>{v(0,c)}),w.listen(I,y)})}e.findFreePortFaster=D;function R(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(te[132],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[133],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(P,D){this.a=P,this.onMessage=D}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(te[42],ie([0,1,14,13]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class P{constructor(){this.a=new WeakMap}on(R,I){const d=(h,...y)=>{this.b(R,h)&&I(h,...y)};return this.a.set(I,d),E.ipcMain.on(R,d),this}once(R,I){return E.ipcMain.once(R,(d,...h)=>{this.b(R,d)&&I(d,...h)}),this}handle(R,I){return E.ipcMain.handle(R,(d,...h)=>this.b(R,d)?I(d,...h):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,I){const d=this.a.get(I);return d&&(E.ipcMain.removeListener(R,d),this.a.delete(I)),this}b(R,I){if(!R||!R.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const d=I.senderFrame,h=d.url;if(!h)return!0;let y="unknown";try{y=new URL(h).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${h}'.`),!1}return y!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${y}'.`),!1):d.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new P}),define(te[134],ie([0,1,14,42,11,132]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){t.validatedIpcMain.on(D.CONTEXT_MENU_CHANNEL,(d,h,y,p,b)=>{const f=I(d,p,y);f.popup({window:(0,P.withNullAsUndefined)(E.BrowserWindow.fromWebContents(d.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{f&&d.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=R;function I(d,h,y){const p=new E.Menu;return y.forEach(b=>{let f;b.type==="separator"?f=new E.MenuItem({type:b.type}):Array.isArray(b.submenu)?f=new E.MenuItem({submenu:I(d,h,b.submenu),label:b.label}):f=new E.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(w,v,c)=>d.sender.send(h,b.id,c)}),p.append(f)}),p}}),define(te[100],ie([0,1,14]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=E.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(te[135],ie([12,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(te[136],ie([0,1,135]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,D=P*24,R=D*7,I=D*30,d=D*365;function h(p,b,f,w){typeof p!="number"&&(p=p.getTime());const v=Math.round((new Date().getTime()-p)/1e3);if(v<-30)return(0,E.localize)(0,null,h(new Date().getTime()+v*1e3,!1));if(!w&&v<30)return(0,E.localize)(1,null);let c;return v<t?(c=v,b?c===1?f?(0,E.localize)(2,null,c):(0,E.localize)(3,null,c):f?(0,E.localize)(4,null,c):(0,E.localize)(5,null,c):c===1?f?(0,E.localize)(6,null,c):(0,E.localize)(7,null,c):f?(0,E.localize)(8,null,c):(0,E.localize)(9,null,c)):v<P?(c=Math.floor(v/t),b?c===1?f?(0,E.localize)(10,null,c):(0,E.localize)(11,null,c):f?(0,E.localize)(12,null,c):(0,E.localize)(13,null,c):c===1?f?(0,E.localize)(14,null,c):(0,E.localize)(15,null,c):f?(0,E.localize)(16,null,c):(0,E.localize)(17,null,c)):v<D?(c=Math.floor(v/P),b?c===1?f?(0,E.localize)(18,null,c):(0,E.localize)(19,null,c):f?(0,E.localize)(20,null,c):(0,E.localize)(21,null,c):c===1?f?(0,E.localize)(22,null,c):(0,E.localize)(23,null,c):f?(0,E.localize)(24,null,c):(0,E.localize)(25,null,c)):v<R?(c=Math.floor(v/D),b?c===1?(0,E.localize)(26,null,c):(0,E.localize)(27,null,c):c===1?(0,E.localize)(28,null,c):(0,E.localize)(29,null,c)):v<I?(c=Math.floor(v/R),b?c===1?f?(0,E.localize)(30,null,c):(0,E.localize)(31,null,c):f?(0,E.localize)(32,null,c):(0,E.localize)(33,null,c):c===1?f?(0,E.localize)(34,null,c):(0,E.localize)(35,null,c):f?(0,E.localize)(36,null,c):(0,E.localize)(37,null,c)):v<d?(c=Math.floor(v/I),b?c===1?f?(0,E.localize)(38,null,c):(0,E.localize)(39,null,c):f?(0,E.localize)(40,null,c):(0,E.localize)(41,null,c):c===1?f?(0,E.localize)(42,null,c):(0,E.localize)(43,null,c):f?(0,E.localize)(44,null,c):(0,E.localize)(45,null,c)):(c=Math.floor(v/d),b?c===1?f?(0,E.localize)(46,null,c):(0,E.localize)(47,null,c):f?(0,E.localize)(48,null,c):(0,E.localize)(49,null,c):c===1?f?(0,E.localize)(50,null,c):(0,E.localize)(51,null,c):f?(0,E.localize)(52,null,c):(0,E.localize)(53,null,c))}e.fromNow=h;function y(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(te[137],ie([12,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(te[45],ie([0,1,25,11,137]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(p,b){return b&&(p.stack||p.stacktrace)?P.localize(0,null,I(p),R(p.stack)||R(p.stacktrace)):I(p)}function R(p){return Array.isArray(p)?p.join(`
`):p}function I(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?P.localize(1,null,p.message):p.message||P.localize(2,null)}function d(p=null,b=!1){if(!p)return P.localize(3,null);if(Array.isArray(p)){const f=E.coalesce(p),w=d(f[0],b);return f.length>1?P.localize(4,null,w,f.length):w}if(t.isString(p))return p;if(p.detail){const f=p.detail;if(f.error)return D(f.error,b);if(f.exception)return D(f.exception,b)}return p.stack?D(p,b):p.message?p.message:P.localize(5,null)}e.toErrorMessage=d;function h(p){const b=p;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=h;function y(p,b){let f;return typeof p=="string"?f=new Error(p):f=p,f.actions=b,f}e.createErrorWithActions=y}),define(te[138],ie([12,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(te[139],ie([0,1,138]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(P){switch(P){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[140],ie([12,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,140]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,P=!1,D=!1,R=!1,I=!1,d=!1,h=!1,y=!1,p=!1,b=!1,f,w=e.LANGUAGE_DEFAULT,v,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",k=g&&u?.type==="renderer";if(typeof navigator=="object"&&!k)c=navigator.userAgent,t=c.indexOf("Windows")>=0,P=c.indexOf("Macintosh")>=0,y=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,d=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,w=f;else if(typeof u=="object"){t=u.platform==="win32",P=u.platform==="darwin",D=u.platform==="linux",R=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,h=g,p=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const m=JSON.parse(r),C=m.availableLanguages["*"];f=m.locale,w=C||e.LANGUAGE_DEFAULT,v=m._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function L(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=L;let i=0;P?i=1:t?i=3:D&&(i=2),e.isWindows=t,e.isMacintosh=P,e.isLinux=D,e.isLinuxSnap=R,e.isNative=I,e.isElectron=h,e.isWeb=d,e.isWebWorker=d&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=b,e.isCI=p,e.platform=i,e.userAgent=c,e.language=w;var l;(function(r){function m(){return e.language}r.value=m;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=C;function M(){return e.language==="en"}r.isDefault=M})(l=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let M=0,O=r.length;M<O;M++){const B=r[M];if(B.id===C.data.vscodeScheduleAsyncWork){r.splice(M,1),B.callback();return}}});let m=0;return C=>{const M=++m;r.push({id:M,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return r=>setTimeout(r)})();var n;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||y?2:t?1:3;let o=!0,s=!1;function a(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,o=new Uint16Array(r.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const P=E.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,35]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,D=90,R=122,I=46,d=47,h=92,y=58,p=63;class b extends Error{constructor(l,n,o){let s;typeof n=="string"&&n.indexOf("not ")===0?(s="must not be",n=n.replace(/^not /,"")):s="must be";const a=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${a} ${s} of type ${n}`;r+=`. Received type ${typeof o}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,l){if(i===null||typeof i!="object")throw new b(l,"Object",i)}function w(i,l){if(typeof i!="string")throw new b(l,"string",i)}const v=E.platform==="win32";function c(i){return i===d||i===h}function u(i){return i===d}function g(i){return i>=t&&i<=D||i>=P&&i<=R}function k(i,l,n,o){let s="",a=0,r=-1,m=0,C=0;for(let M=0;M<=i.length;++M){if(M<i.length)C=i.charCodeAt(M);else{if(o(C))break;C=d}if(o(C)){if(!(r===M-1||m===1))if(m===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const O=s.lastIndexOf(n);O===-1?(s="",a=0):(s=s.slice(0,O),a=s.length-1-s.lastIndexOf(n)),r=M,m=0;continue}else if(s.length!==0){s="",a=0,r=M,m=0;continue}}l&&(s+=s.length>0?`${n}..`:"..",a=2)}else s.length>0?s+=`${n}${i.slice(r+1,M)}`:s=i.slice(r+1,M),a=M-r-1;r=M,m=0}else C===I&&m!==-1?++m:m=-1}return s}function S(i,l){f(l,"pathObject");const n=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return n?n===l.root?`${n}${o}`:`${n}${i}${o}`:o}e.win32={resolve(...i){let l="",n="",o=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],w(a,"path"),a.length===0)continue}else l.length===0?a=E.cwd():(a=E.env[`=${l}`]||E.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===h)&&(a=`${l}\\`));const r=a.length;let m=0,C="",M=!1;const O=a.charCodeAt(0);if(r===1)c(O)&&(m=1,M=!0);else if(c(O))if(M=!0,c(a.charCodeAt(1))){let B=2,J=B;for(;B<r&&!c(a.charCodeAt(B));)B++;if(B<r&&B!==J){const G=a.slice(J,B);for(J=B;B<r&&c(a.charCodeAt(B));)B++;if(B<r&&B!==J){for(J=B;B<r&&!c(a.charCodeAt(B));)B++;(B===r||B!==J)&&(C=`\\\\${G}\\${a.slice(J,B)}`,m=B)}}}else m=1;else g(O)&&a.charCodeAt(1)===y&&(C=a.slice(0,2),m=2,r>2&&c(a.charCodeAt(2))&&(M=!0,m=3));if(C.length>0)if(l.length>0){if(C.toLowerCase()!==l.toLowerCase())continue}else l=C;if(o){if(l.length>0)break}else if(n=`${a.slice(m)}\\${n}`,o=M,M&&l.length>0)break}return n=k(n,!o,"\\",c),o?`${l}\\${n}`:`${l}${n}`||"."},normalize(i){w(i,"path");const l=i.length;if(l===0)return".";let n=0,o,s=!1;const a=i.charCodeAt(0);if(l===1)return u(a)?"\\":i;if(c(a))if(s=!0,c(i.charCodeAt(1))){let m=2,C=m;for(;m<l&&!c(i.charCodeAt(m));)m++;if(m<l&&m!==C){const M=i.slice(C,m);for(C=m;m<l&&c(i.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&!c(i.charCodeAt(m));)m++;if(m===l)return`\\\\${M}\\${i.slice(C)}\\`;m!==C&&(o=`\\\\${M}\\${i.slice(C,m)}`,n=m)}}}else n=1;else g(a)&&i.charCodeAt(1)===y&&(o=i.slice(0,2),n=2,l>2&&c(i.charCodeAt(2))&&(s=!0,n=3));let r=n<l?k(i.slice(n),!s,"\\",c):"";return r.length===0&&!s&&(r="."),r.length>0&&c(i.charCodeAt(l-1))&&(r+="\\"),o===void 0?s?`\\${r}`:r:s?`${o}\\${r}`:`${o}${r}`},isAbsolute(i){w(i,"path");const l=i.length;if(l===0)return!1;const n=i.charCodeAt(0);return c(n)||l>2&&g(n)&&i.charCodeAt(1)===y&&c(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,n;for(let a=0;a<i.length;++a){const r=i[a];w(r,"path"),r.length>0&&(l===void 0?l=n=r:l+=`\\${r}`)}if(l===void 0)return".";let o=!0,s=0;if(typeof n=="string"&&c(n.charCodeAt(0))){++s;const a=n.length;a>1&&c(n.charCodeAt(1))&&(++s,a>2&&(c(n.charCodeAt(2))?++s:o=!1))}if(o){for(;s<l.length&&c(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(i,l){if(w(i,"from"),w(l,"to"),i===l)return"";const n=e.win32.resolve(i),o=e.win32.resolve(l);if(n===o||(i=n.toLowerCase(),l=o.toLowerCase(),i===l))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===h;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===h;)a--;const r=a-s;let m=0;for(;m<l.length&&l.charCodeAt(m)===h;)m++;let C=l.length;for(;C-1>m&&l.charCodeAt(C-1)===h;)C--;const M=C-m,O=r<M?r:M;let B=-1,J=0;for(;J<O;J++){const X=i.charCodeAt(s+J);if(X!==l.charCodeAt(m+J))break;X===h&&(B=J)}if(J!==O){if(B===-1)return o}else{if(M>O){if(l.charCodeAt(m+J)===h)return o.slice(m+J+1);if(J===2)return o.slice(m+J)}r>O&&(i.charCodeAt(s+J)===h?B=J:J===2&&(B=3)),B===-1&&(B=0)}let G="";for(J=s+B+1;J<=a;++J)(J===a||i.charCodeAt(J)===h)&&(G+=G.length===0?"..":"\\..");return m+=B,G.length>0?`${G}${o.slice(m,C)}`:(o.charCodeAt(m)===h&&++m,o.slice(m,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=e.win32.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===h){if(l.charCodeAt(1)===h){const n=l.charCodeAt(2);if(n!==p&&n!==I)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(g(l.charCodeAt(0))&&l.charCodeAt(1)===y&&l.charCodeAt(2)===h)return`\\\\?\\${l}`;return i},dirname(i){w(i,"path");const l=i.length;if(l===0)return".";let n=-1,o=0;const s=i.charCodeAt(0);if(l===1)return c(s)?i:".";if(c(s)){if(n=o=1,c(i.charCodeAt(1))){let m=2,C=m;for(;m<l&&!c(i.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&c(i.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&!c(i.charCodeAt(m));)m++;if(m===l)return i;m!==C&&(n=o=m+1)}}}}else g(s)&&i.charCodeAt(1)===y&&(n=l>2&&c(i.charCodeAt(2))?3:2,o=n);let a=-1,r=!0;for(let m=l-1;m>=o;--m)if(c(i.charCodeAt(m))){if(!r){a=m;break}}else r=!1;if(a===-1){if(n===-1)return".";a=n}return i.slice(0,a)},basename(i,l){l!==void 0&&w(l,"ext"),w(i,"path");let n=0,o=-1,s=!0,a;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===y&&(n=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,m=-1;for(a=i.length-1;a>=n;--a){const C=i.charCodeAt(a);if(c(C)){if(!s){n=a+1;break}}else m===-1&&(s=!1,m=a+1),r>=0&&(C===l.charCodeAt(r)?--r===-1&&(o=a):(r=-1,o=m))}return n===o?o=m:o===-1&&(o=i.length),i.slice(n,o)}for(a=i.length-1;a>=n;--a)if(c(i.charCodeAt(a))){if(!s){n=a+1;break}}else o===-1&&(s=!1,o=a+1);return o===-1?"":i.slice(n,o)},extname(i){w(i,"path");let l=0,n=-1,o=0,s=-1,a=!0,r=0;i.length>=2&&i.charCodeAt(1)===y&&g(i.charCodeAt(0))&&(l=o=2);for(let m=i.length-1;m>=l;--m){const C=i.charCodeAt(m);if(c(C)){if(!a){o=m+1;break}continue}s===-1&&(a=!1,s=m+1),C===I?n===-1?n=m:r!==1&&(r=1):n!==-1&&(r=-1)}return n===-1||s===-1||r===0||r===1&&n===s-1&&n===o+1?"":i.slice(n,s)},format:S.bind(null,"\\"),parse(i){w(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const n=i.length;let o=0,s=i.charCodeAt(0);if(n===1)return c(s)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(c(s)){if(o=1,c(i.charCodeAt(1))){let B=2,J=B;for(;B<n&&!c(i.charCodeAt(B));)B++;if(B<n&&B!==J){for(J=B;B<n&&c(i.charCodeAt(B));)B++;if(B<n&&B!==J){for(J=B;B<n&&!c(i.charCodeAt(B));)B++;B===n?o=B:B!==J&&(o=B+1)}}}}else if(g(s)&&i.charCodeAt(1)===y){if(n<=2)return l.root=l.dir=i,l;if(o=2,c(i.charCodeAt(2))){if(n===3)return l.root=l.dir=i,l;o=3}}o>0&&(l.root=i.slice(0,o));let a=-1,r=o,m=-1,C=!0,M=i.length-1,O=0;for(;M>=o;--M){if(s=i.charCodeAt(M),c(s)){if(!C){r=M+1;break}continue}m===-1&&(C=!1,m=M+1),s===I?a===-1?a=M:O!==1&&(O=1):a!==-1&&(O=-1)}return m!==-1&&(a===-1||O===0||O===1&&a===m-1&&a===r+1?l.base=l.name=i.slice(r,m):(l.name=i.slice(r,a),l.base=i.slice(r,m),l.ext=i.slice(a,m))),r>0&&r!==o?l.dir=i.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(v){const i=/\\/g;return()=>{const l=E.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...i){let l="",n=!1;for(let o=i.length-1;o>=-1&&!n;o--){const s=o>=0?i[o]:L();w(s,"path"),s.length!==0&&(l=`${s}/${l}`,n=s.charCodeAt(0)===d)}return l=k(l,!n,"/",u),n?`/${l}`:l.length>0?l:"."},normalize(i){if(w(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===d,n=i.charCodeAt(i.length-1)===d;return i=k(i,!l,"/",u),i.length===0?l?"/":n?"./":".":(n&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return w(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let l;for(let n=0;n<i.length;++n){const o=i[n];w(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":e.posix.normalize(l)},relative(i,l){if(w(i,"from"),w(l,"to"),i===l||(i=e.posix.resolve(i),l=e.posix.resolve(l),i===l))return"";const n=1,o=i.length,s=o-n,a=1,r=l.length-a,m=s<r?s:r;let C=-1,M=0;for(;M<m;M++){const B=i.charCodeAt(n+M);if(B!==l.charCodeAt(a+M))break;B===d&&(C=M)}if(M===m)if(r>m){if(l.charCodeAt(a+M)===d)return l.slice(a+M+1);if(M===0)return l.slice(a+M)}else s>m&&(i.charCodeAt(n+M)===d?C=M:M===0&&(C=0));let O="";for(M=n+C+1;M<=o;++M)(M===o||i.charCodeAt(M)===d)&&(O+=O.length===0?"..":"/..");return`${O}${l.slice(a+C)}`},toNamespacedPath(i){return i},dirname(i){if(w(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===d;let n=-1,o=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===d){if(!o){n=s;break}}else o=!1;return n===-1?l?"/":".":l&&n===1?"//":i.slice(0,n)},basename(i,l){l!==void 0&&w(l,"ext"),w(i,"path");let n=0,o=-1,s=!0,a;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,m=-1;for(a=i.length-1;a>=0;--a){const C=i.charCodeAt(a);if(C===d){if(!s){n=a+1;break}}else m===-1&&(s=!1,m=a+1),r>=0&&(C===l.charCodeAt(r)?--r===-1&&(o=a):(r=-1,o=m))}return n===o?o=m:o===-1&&(o=i.length),i.slice(n,o)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===d){if(!s){n=a+1;break}}else o===-1&&(s=!1,o=a+1);return o===-1?"":i.slice(n,o)},extname(i){w(i,"path");let l=-1,n=0,o=-1,s=!0,a=0;for(let r=i.length-1;r>=0;--r){const m=i.charCodeAt(r);if(m===d){if(!s){n=r+1;break}continue}o===-1&&(s=!1,o=r+1),m===I?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||o===-1||a===0||a===1&&l===o-1&&l===n+1?"":i.slice(l,o)},format:S.bind(null,"/"),parse(i){w(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const n=i.charCodeAt(0)===d;let o;n?(l.root="/",o=1):o=0;let s=-1,a=0,r=-1,m=!0,C=i.length-1,M=0;for(;C>=o;--C){const O=i.charCodeAt(C);if(O===d){if(!m){a=C+1;break}continue}r===-1&&(m=!1,r=C+1),O===I?s===-1?s=C:M!==1&&(M=1):s!==-1&&(M=-1)}if(r!==-1){const O=a===0&&n?1:a;s===-1||M===0||M===1&&s===r-1&&s===a+1?l.base=l.name=i.slice(O,r):(l.name=i.slice(O,s),l.base=i.slice(O,r),l.ext=i.slice(s,r))}return a>0?l.dir=i.slice(0,a-1):n&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(te[82],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(I,...d){const h=d.reduce((b,f)=>(b[f]=!0,b),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(b=>!h[b]).forEach(b=>{for(let f=0;f<y.length;f++)if(b.search(y[f])!==-1){delete I[b];break}})}e.sanitizeProcessEnvironment=D;function R(I){!I||(delete I.DEBUG,E.isMacintosh&&delete I.DYLD_LIBRARY_PATH,E.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(te[70],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class P{static create(R=!0){return new P(R)}constructor(R){this.a=t&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=P}),define(te[3],ie([0,1,13,50,2,98,70]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,d=!1;var h;(function(a){a.None=()=>P.Disposable.None;function r(W){if(d){const{onDidAddListener:j}=W,K=w.create();let N=0;W.onDidAddListener=()=>{++N===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),j?.()}}}function m(W,j){return se(W,()=>{},0,void 0,void 0,j)}a.defer=m;function C(W){return(j,K=null,N)=>{let q=!1,Z;return Z=W(oe=>{if(!q)return Z?Z.dispose():q=!0,j.call(K,oe)},null,N),q&&Z.dispose(),Z}}a.once=C;function M(W,j,K){return re((N,q=null,Z)=>W(oe=>N.call(q,j(oe)),null,Z),K)}a.map=M;function O(W,j,K){return re((N,q=null,Z)=>W(oe=>{j(oe),N.call(q,oe)},null,Z),K)}a.forEach=O;function B(W,j,K){return re((N,q=null,Z)=>W(oe=>j(oe)&&N.call(q,oe),null,Z),K)}a.filter=B;function J(W){return W}a.signal=J;function G(...W){return(j,K=null,N)=>(0,P.combinedDisposable)(...W.map(q=>q(Z=>j.call(K,Z),null,N)))}a.any=G;function X(W,j,K,N){let q=K;return M(W,Z=>(q=j(q,Z),q),N)}a.reduce=X;function re(W,j){let K;const N={onWillAddFirstListener(){K=W(q.fire,q)},onDidRemoveLastListener(){K?.dispose()}};j||r(N);const q=new c(N);return j?.add(q),q.event}function se(W,j,K=100,N=!1,q,Z){let oe,le,be,Ce=0;const Oe={leakWarningThreshold:q,onWillAddFirstListener(){oe=W(we=>{Ce++,le=j(le,we),N&&!be&&(Le.fire(le),le=void 0),clearTimeout(be),be=setTimeout(()=>{const ve=le;le=void 0,be=void 0,(!N||Ce>1)&&Le.fire(ve),Ce=0},K)})},onDidRemoveLastListener(){oe.dispose()}};Z||r(Oe);const Le=new c(Oe);return Z?.add(Le),Le.event}a.debounce=se;function ae(W,j=0,K){return a.debounce(W,(N,q)=>N?(N.push(q),N):[q],j,void 0,void 0,K)}a.accumulate=ae;function fe(W,j=(N,q)=>N===q,K){let N=!0,q;return B(W,Z=>{const oe=N||!j(Z,q);return N=!1,q=Z,oe},K)}a.latch=fe;function ge(W,j,K){return[a.filter(W,j,K),a.filter(W,N=>!j(N),K)]}a.split=ge;function H(W,j=!1,K=[]){let N=K.slice(),q=W(le=>{N?N.push(le):oe.fire(le)});const Z=()=>{N?.forEach(le=>oe.fire(le)),N=null},oe=new c({onWillAddFirstListener(){q||(q=W(le=>oe.fire(le)))},onDidAddFirstListener(){N&&(j?setTimeout(Z):Z())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return oe.event}a.buffer=H;class F{constructor(j){this.event=j,this.c=new P.DisposableStore}map(j){return new F(M(this.event,j,this.c))}forEach(j){return new F(O(this.event,j,this.c))}filter(j){return new F(B(this.event,j,this.c))}reduce(j,K){return new F(X(this.event,j,K,this.c))}latch(){return new F(fe(this.event,void 0,this.c))}debounce(j,K=100,N=!1,q){return new F(se(this.event,j,K,N,q,this.c))}on(j,K,N){return this.event(j,K,N)}once(j,K,N){return C(this.event)(j,K,N)}dispose(){this.c.dispose()}}function U(W){return new F(W)}a.chain=U;function z(W,j,K=N=>N){const N=(...le)=>oe.fire(K(...le)),q=()=>W.on(j,N),Z=()=>W.removeListener(j,N),oe=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Z});return oe.event}a.fromNodeEventEmitter=z;function Q(W,j,K=N=>N){const N=(...le)=>oe.fire(K(...le)),q=()=>W.addEventListener(j,N),Z=()=>W.removeEventListener(j,N),oe=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Z});return oe.event}a.fromDOMEventEmitter=Q;function ne(W){return new Promise(j=>C(W)(j))}a.toPromise=ne;function _(W,j){return j(void 0),W(K=>j(K))}a.runAndSubscribe=_;function $(W,j){let K=null;function N(Z){K?.dispose(),K=new P.DisposableStore,j(Z,K)}N(void 0);const q=W(Z=>N(Z));return(0,P.toDisposable)(()=>{q.dispose(),K?.dispose()})}a.runAndSubscribeWithStore=$;class A{constructor(j,K){this.obs=j,this.c=0,this.d=!1;const N={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};K||r(N),this.emitter=new c(N),K&&K.add(this.emitter)}beginUpdate(j){this.c++}handleChange(j,K){this.d=!0}endUpdate(j){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function T(W,j){return new A(W,j).emitter.event}a.fromObservable=T})(h=e.Event||(e.Event={}));class y{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${y.c++}`,y.all.add(this)}start(r){this.d=new R.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=y,y.all=new Set,y.c=0;let p=-1;function b(a){const r=p;return p=a,{dispose(){p=r}}}e.setGlobalLeakWarningThreshold=b;class f{constructor(r,m=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=m,this.d=0}dispose(){this.c?.clear()}check(r,m){const C=this.threshold;if(C<=0||m<C)return;this.c||(this.c=new Map);const M=this.c.get(r.value)||0;if(this.c.set(r.value,M+1),this.d-=1,this.d<=0){this.d=C*.5;let O,B=0;for(const[J,G]of this.c)(!O||B<G)&&(O=J,B=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${B}):`),console.warn(O)}return()=>{const O=this.c.get(r.value)||0;this.c.set(r.value,O-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(r,m,C){this.callback=r,this.callbackThis=m,this.stack=C,this.subscription=new P.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class c{constructor(r){this.j=!1,this.d=r,this.f=p>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??p):void 0,this.g=this.d?._profName?new y(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(I){const r=Array.from(this.q);queueMicrotask(()=>{for(const m of r)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,m,C)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=w.create(),O=this.f.check(B,this.q.size+1)),I&&(B=B??w.create());const J=new v(r,m,B),G=this.q.push(J);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,m);const X=J.subscription.set(()=>{O?.(),this.j||(G(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof P.DisposableStore?C.add(X):Array.isArray(C)&&C.push(X),X}),this.l}fire(r){if(this.q){this.m||(this.m=new g);for(const m of this.q)this.m.push(this,m,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class u{constructor(){this.c=new D.LinkedList}get size(){return this.c.size}push(r,m,C){this.c.push(new k(r,m,C))}clear(r){const m=new D.LinkedList;for(const C of this.c)C.emitter!==r&&m.push(C);this.c=m}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(m){(0,E.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=u;class g extends u{clear(r){this.c.clear()}}class k{constructor(r,m,C){this.emitter=r,this.listener=m,this.event=C}}class S extends c{async fireAsync(r,m,C){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const M of this.q)this.c.push([M,r]);for(;this.c.size>0&&!m.isCancellationRequested;){const[M,O]=this.c.shift(),B=[],J={...O,token:m,waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");C&&(G=C(G,M.callback)),B.push(G)}};try{M.invoke(J)}catch(G){(0,E.onUnexpectedError)(G);continue}Object.freeze(B),await Promise.allSettled(B).then(G=>{for(const X of G)X.status==="rejected"&&(0,E.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=S;class L extends c{constructor(r){super(r),this.h=0,this.s=new D.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=L;class i extends L{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class l extends c{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(m=>super.fire(m)),this.c=[]}))}}e.MicrotaskEmitter=l;class n{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const m={event:r,listener:null};this.f.push(m),this.d&&this.j(m);const C=()=>{this.d&&this.k(m);const M=this.f.indexOf(m);this.f.splice(M,1)};return(0,P.toDisposable)((0,t.once)(C))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(m=>this.c.fire(m))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.c=[]}wrapEvent(r){return(m,C,M)=>r(O=>{const B=this.c[this.c.length-1];B?B.push(()=>m.call(C,O)):m.call(C,O)},void 0,M)}bufferEvents(r){const m=[];this.c.push(m);const C=r();return this.c.pop(),m.forEach(M=>M()),C}}e.EventBufferer=o;class s{constructor(){this.c=!1,this.d=h.None,this.f=P.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(te[22],ie([0,1,3]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,d){const h=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(h)}}});var P;(function(I){function d(h){return h===I.None||h===I.Cancelled||h instanceof D?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(d){this.a=void 0,this.b=void 0,this.b=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=P.Cancelled}dispose(d=!1){d&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=P.None}}e.CancellationTokenSource=R}),define(te[141],ie([0,1,22]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new E.CancellationTokenSource,d=this.b(I.token);return this.a={promise:d,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.Cache=t;class P{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const d=JSON.stringify(I);return this.b!==d&&(this.b=d,this.a=this.c(I)),this.a}}e.LRUCachedFunction=P;class D{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const d=this.b(I);return this.a.set(I,d),d}}e.CachedFunction=D}),define(te[27],ie([0,1,141,127]),function(V,e,E,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=D;const R=/{(\d+)}/g;function I(Y,...ce){return ce.length===0?Y:Y.replace(R,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?he:ce[Se]})}e.format=I;const d=/{([^}]+)}/g;function h(Y,ce){return Y.replace(d,(he,me)=>ce[me]??he)}e.format2=h;function y(Y){return Y.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=y;function p(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function b(Y,ce){let he=0;const me=ce.charCodeAt(0);for(let Se=Y.length-1;Se>=0;Se--)Y.charCodeAt(Se)===me&&he++;return he}e.count=b;function f(Y,ce,he="\u2026"){return Y.length<=ce?Y:`${Y.substr(0,ce)}${he}`}e.truncate=f;function w(Y,ce=" "){const he=v(Y,ce);return c(he,ce)}e.trim=w;function v(Y,ce){if(!Y||!ce)return Y;const he=ce.length;if(he===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(ce,me)===me;)me=me+he;return Y.substring(me)}e.ltrim=v;function c(Y,ce){if(!Y||!ce)return Y;const he=ce.length,me=Y.length;if(he===0||me===0)return Y;let Se=me,Ae=-1;for(;Ae=Y.lastIndexOf(ce,Se-1),!(Ae===-1||Ae+he!==Se);){if(Ae===0)return"";Se=Ae}return Y.substring(0,Se)}e.rtrim=c;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function k(Y,ce,he={}){if(!Y)throw new Error("Cannot create regex from empty string");ce||(Y=p(Y)),he.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=k;function S(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function L(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function i(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=i;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function n(Y){for(let ce=0,he=Y.length;ce<he;ce++){const me=Y.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function o(Y,ce=0,he=Y.length){for(let me=ce;me<he;me++){const Se=Y.charCodeAt(me);if(Se!==32&&Se!==9)return Y.substring(ce,me)}return Y.substring(ce,he)}e.getLeadingWhitespace=o;function s(Y,ce=Y.length-1){for(let he=ce;he>=0;he--){const me=Y.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function a(Y,ce,he){const me=[];let Se=0;for(const Ae of Y.matchAll(ce)){if(me.push(Y.slice(Se,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Se=Ae.index+Ae[0].length,me.push(he(Ae[0],...Ae.slice(1),Ae.index,Y,Ae.groups))}return me.push(Y.slice(Se)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=a;function r(Y,ce){return Y<ce?-1:Y>ce?1:0}e.compare=r;function m(Y,ce,he=0,me=Y.length,Se=0,Ae=ce.length){for(;he<me&&Se<Ae;he++,Se++){const _e=Y.charCodeAt(he),Ve=ce.charCodeAt(Se);if(_e<Ve)return-1;if(_e>Ve)return 1}const ze=me-he,it=Ae-Se;return ze<it?-1:ze>it?1:0}e.compareSubstring=m;function C(Y,ce){return M(Y,ce,0,Y.length,0,ce.length)}e.compareIgnoreCase=C;function M(Y,ce,he=0,me=Y.length,Se=0,Ae=ce.length){for(;he<me&&Se<Ae;he++,Se++){let _e=Y.charCodeAt(he),Ve=ce.charCodeAt(Se);if(_e===Ve)continue;if(_e>=128||Ve>=128)return m(Y.toLowerCase(),ce.toLowerCase(),he,me,Se,Ae);B(_e)&&(_e-=32),B(Ve)&&(Ve-=32);const tt=_e-Ve;if(tt!==0)return tt}const ze=me-he,it=Ae-Se;return ze<it?-1:ze>it?1:0}e.compareSubstringIgnoreCase=M;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function B(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=B;function J(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=J;function G(Y,ce){return Y.length===ce.length&&M(Y,ce)===0}e.equalsIgnoreCase=G;function X(Y,ce){const he=ce.length;return ce.length>Y.length?!1:M(Y,ce,0,he)===0}e.startsWithIgnoreCase=X;function re(Y,ce){const he=Math.min(Y.length,ce.length);let me;for(me=0;me<he;me++)if(Y.charCodeAt(me)!==ce.charCodeAt(me))return me;return he}e.commonPrefixLength=re;function se(Y,ce){const he=Math.min(Y.length,ce.length);let me;const Se=Y.length-1,Ae=ce.length-1;for(me=0;me<he;me++)if(Y.charCodeAt(Se-me)!==ce.charCodeAt(Ae-me))return me;return he}e.commonSuffixLength=se;function ae(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ae;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,ce){return(Y-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ge;function H(Y,ce,he){const me=Y.charCodeAt(he);if(ae(me)&&he+1<ce){const Se=Y.charCodeAt(he+1);if(fe(Se))return ge(me,Se)}return me}e.getNextCodePoint=H;function F(Y,ce){const he=Y.charCodeAt(ce-1);if(fe(he)&&ce>1){const me=Y.charCodeAt(ce-2);if(ae(me))return ge(me,he)}return he}class U{get offset(){return this.e}constructor(ce,he=0){this.c=ce,this.d=ce.length,this.e=he}setOffset(ce){this.e=ce}prevCodePoint(){const ce=F(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=H(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=U;class z{get offset(){return this.c.offset}constructor(ce,he=0){this.c=new U(ce,he)}nextGraphemeLength(){const ce=Ue.getInstance(),he=this.c,me=he.offset;let Se=ce.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ae=he.offset,ze=ce.getGraphemeBreakType(he.nextCodePoint());if(ye(Se,ze)){he.setOffset(Ae);break}Se=ze}return he.offset-me}prevGraphemeLength(){const ce=Ue.getInstance(),he=this.c,me=he.offset;let Se=ce.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ae=he.offset,ze=ce.getGraphemeBreakType(he.prevCodePoint());if(ye(ze,Se)){he.setOffset(Ae);break}Se=ze}return me-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Q(Y,ce){return new z(Y,ce).nextGraphemeLength()}e.nextCharLength=Q;function ne(Y,ce){return new z(Y,ce).prevGraphemeLength()}e.prevCharLength=ne;function _(Y,ce){ce>0&&fe(Y.charCodeAt(ce))&&ce--;const he=ce+Q(Y,ce);return[he-ne(Y,he),he]}e.getCharContainingOffset=_;function $(Y){const ce=new z(Y);let he=0;for(;!ce.eol();)he++,ce.nextGraphemeLength();return he}e.charCount=$;let A;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Y){return A||(A=T()),A.test(Y)}e.containsRTL=W;const j=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return j.test(Y)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=N;function q(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=q;function Z(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=Z;function oe(Y,ce){if(Y.length<ce)return Y;const he=/\b/g;let me=0;for(;he.test(Y)&&!(Y.length-he.lastIndex<ce);)me=he.lastIndex,he.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,Ce=/\x1b\[0?m/g;function Oe(Y){return Y&&(Y=Y.replace(le,""),Y=Y.replace(be,""),Y=Y.replace(Ce,"")),Y}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function we(Y){return Le(Y)?Y.substr(1):Y}e.stripUTF8BOM=we;function ve(Y,ce){if(!Y||!ce||Y.length<ce.length)return!1;const he=ce.length,me=Y.toLowerCase();let Se=0,Ae=-1;for(;Se<he;){const ze=me.indexOf(ce[Se],Ae+1);if(ze<0)return!1;Ae=ze,Se++}return!0}e.fuzzyContains=ve;function Ee(Y,ce=!1){return Y?(ce&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ee;function Ie(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ie;function x(Y,ce=1){if(ce===0)return"";let he=-1;do he=Y.indexOf(`
`,he+1),ce--;while(ce>0&&he>=0);return he===-1?Y:(Y[he-1]==="\r"&&he--,Y.substr(0,he))}e.getNLines=x;function de(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=de;function ue(Y){return Ue.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=ue;function ye(Y,ce){return Y===0?ce!==5&&ce!==7:Y===2&&ce===3?!1:Y===4||Y===2||Y===3||ce===4||ce===2||ce===3?!0:!(Y===8&&(ce===8||ce===9||ce===11||ce===12)||(Y===11||Y===9)&&(ce===9||ce===10)||(Y===12||Y===10)&&ce===10||ce===5||ce===13||ce===7||Y===1||Y===13&&ce===14||Y===6&&ce===6)}var De;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(De=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const he=this.d,me=he.length/3;let Se=1;for(;Se<=me;)if(ce<he[3*Se])Se=2*Se;else if(ce>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Ue.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Y,ce){if(Y===0)return 0;const he=We(Y,ce);if(he!==void 0)return he;const me=new U(ce,Y);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=He;function We(Y,ce){const he=new U(ce,Y);let me=he.prevCodePoint();for(;qe(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!Z(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function qe(Y){return 127995<=Y&&Y<=127999}var Xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ce){return Ne.d.get(Array.from(ce))}static getLocales(){return Ne.e.value}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ne,P=Ne,Ne.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new E.LRUCachedFunction(Y=>{function ce(Ve){const tt=new Map;for(let nt=0;nt<Ve.length;nt+=2)tt.set(Ve[nt],Ve[nt+1]);return tt}function he(Ve,tt){const nt=new Map(Ve);for(const[ct,ot]of tt)nt.set(ct,ot);return nt}function me(Ve,tt){if(!Ve)return tt;const nt=new Map;for(const[ct,ot]of Ve)tt.has(ct)&&nt.set(ct,ot);return nt}const Se=P.c.value;let Ae=Y.filter(Ve=>!Ve.startsWith("_")&&Ve in Se);Ae.length===0&&(Ae=["_default"]);let ze;for(const Ve of Ae){const tt=ce(Se[Ve]);ze=me(ze,tt)}const it=ce(Se._common),_e=he(it,ze);return new Ne(_e)}),Ne.e=new t.Lazy(()=>Object.keys(Ne.c.value).filter(Y=>!Y.startsWith("_")));class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(ce){return Ge.e().has(ce)}static get codePoints(){return Ge.e()}}e.InvisibleCharacters=Ge,Ge.d=void 0}),define(te[32],ie([0,1,9,4,27,11]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(s){return s===47||s===92}e.isPathSeparator=R;function I(s){return s.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=I;function d(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=d;function h(s,a=E.posix.sep){if(!s)return"";const r=s.length,m=s.charCodeAt(0);if(R(m)){if(R(s.charCodeAt(1))&&!R(s.charCodeAt(2))){let M=3;const O=M;for(;M<r&&!R(s.charCodeAt(M));M++);if(O!==M&&!R(s.charCodeAt(M+1))){for(M+=1;M<r;M++)if(R(s.charCodeAt(M)))return s.slice(0,M+1).replace(/[\\/]/g,a)}}return a}else if(u(m)&&s.charCodeAt(1)===58)return R(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let C=s.indexOf("://");if(C!==-1){for(C+=3;C<r;C++)if(R(s.charCodeAt(C)))return s.slice(0,C+1)}return""}e.getRoot=h;function y(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let r=2;const m=r;for(;r<s.length&&(a=s.charCodeAt(r),a!==92);r++);return!(m===r||(a=s.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=y;const p=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(s,a=t.isWindows){const r=a?p:b;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||a&&f.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=w;function v(s,a,r){const m=s===a;return!r||m?m:!s||!a?!1:(0,P.equalsIgnoreCase)(s,a)}e.isEqual=v;function c(s,a,r,m=E.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let M=a.length;return a.charAt(a.length-1)===m&&M--,s.charAt(M)===m}return a.charAt(a.length-1)!==m&&(a+=m),s.indexOf(a)===0}e.isEqualOrParent=c;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function g(s,a){return t.isWindows&&s.endsWith(":")&&(s+=E.sep),(0,E.isAbsolute)(s)||(s=(0,E.join)(a,s)),s=(0,E.normalize)(s),t.isWindows?(s=(0,P.rtrim)(s,E.sep),s.endsWith(":")&&(s+=E.sep)):(s=(0,P.rtrim)(s,E.sep),s||(s=E.sep)),s}e.sanitizeFilePath=g;function k(s){const a=(0,E.normalize)(s);return t.isWindows?s.length>3?!1:S(a)&&(s.length===2||a.charCodeAt(2)===92):a===E.posix.sep}e.isRootOrDriveLetter=k;function S(s,a=t.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function L(s){return S(s)?s[0]:void 0}e.getDriveLetter=L;function i(s,a,r){return a.length>s.length?-1:s===a?0:(r&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function l(s){const a=s.split(":");let r,m,C;for(const M of a){const O=Number(M);(0,D.isNumber)(O)?m===void 0?m=O:C===void 0&&(C=O):r=r?[r,M].join(":"):M}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:m!==void 0?m:void 0,column:C!==void 0?C:m!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,a,r=8){let m="";for(let M=0;M<r;M++)m+=n.charAt(Math.floor(Math.random()*n.length));let C;return a?C=`${a}-${m}`:C=m,s?(0,E.join)(s,C):C}e.randomPath=o}),define(te[71],ie([0,1,27]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return P(u,0)}e.hash=t;function P(u,g){switch(typeof u){case"object":return u===null?D(349,g):Array.isArray(u)?d(u,g):h(u,g);case"string":return I(u,g);case"boolean":return R(u,g);case"number":return D(u,g);case"undefined":return D(937,g);default:return D(617,g)}}e.doHash=P;function D(u,g){return(g<<5)-g+u|0}e.numberHash=D;function R(u,g){return D(u?433:863,g)}function I(u,g){g=D(149417,g);for(let k=0,S=u.length;k<S;k++)g=D(u.charCodeAt(k),g);return g}e.stringHash=I;function d(u,g){return g=D(104579,g),u.reduce((k,S)=>P(S,k),g)}function h(u,g){return g=D(181387,g),Object.keys(u).sort().reduce((k,S)=>(k=I(S,k),P(u[S],k)),g)}class y{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=P(g,this.g),this.g}}e.Hasher=y;var p;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function b(u,g,k=32){const S=k-g,L=~((1<<S)-1);return(u<<g|(L&u)>>>S)>>>0}function f(u,g=0,k=u.byteLength,S=0){for(let L=0;L<k;L++)u[g+L]=S}function w(u,g,k="0"){for(;u.length<g;)u=k+u;return u}function v(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(k=>k.toString(16).padStart(2,"0")).join(""):w((u>>>0).toString(16),g/4)}e.toHexString=v;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const k=g.length;if(k===0)return;const S=this.p;let L=this.r,i=this.u,l,n;for(i!==0?(l=i,n=-1,i=0):(l=g.charCodeAt(0),n=0);;){let o=l;if(E.isHighSurrogate(l))if(n+1<k){const s=g.charCodeAt(n+1);E.isLowSurrogate(s)?(n++,o=E.computeCodePoint(l,s)):o=65533}else{i=l;break}else E.isLowSurrogate(l)&&(o=65533);if(L=this.w(S,L,o),n++,n<k)l=g.charCodeAt(n);else break}this.r=L,this.u=i}w(g,k,S){return S<128?g[k++]=S:S<2048?(g[k++]=192|(S&1984)>>>6,g[k++]=128|(S&63)>>>0):S<65536?(g[k++]=224|(S&61440)>>>12,g[k++]=128|(S&4032)>>>6,g[k++]=128|(S&63)>>>0):(g[k++]=240|(S&1835008)>>>18,g[k++]=128|(S&258048)>>>12,g[k++]=128|(S&4032)>>>6,g[k++]=128|(S&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=c.g,k=this.q;for(let r=0;r<64;r+=4)g.setUint32(r,k.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)g.setUint32(r,b(g.getUint32(r-12,!1)^g.getUint32(r-32,!1)^g.getUint32(r-56,!1)^g.getUint32(r-64,!1),1),!1);let S=this.h,L=this.l,i=this.m,l=this.n,n=this.o,o,s,a;for(let r=0;r<80;r++)r<20?(o=L&i|~L&l,s=1518500249):r<40?(o=L^i^l,s=1859775393):r<60?(o=L&i|L&l|i&l,s=2400959708):(o=L^i^l,s=3395469782),a=b(S,5)+o+n+s+g.getUint32(r*4,!1)&4294967295,n=l,l=i,i=b(L,30),L=S,S=a;this.h=this.h+S&4294967295,this.l=this.l+L&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=c,c.g=new DataView(new ArrayBuffer(320))}),define(te[83],ie([0,1,27]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const D="error",R="warning",I="warn",d="info",h="ignore";function y(b){return b?E.equalsIgnoreCase(D,b)?P.Error:E.equalsIgnoreCase(R,b)||E.equalsIgnoreCase(I,b)?P.Warning:E.equalsIgnoreCase(d,b)?P.Info:P.Ignore:P.Ignore}P.fromValue=y;function p(b){switch(b){case P.Error:return D;case P.Warning:return R;case P.Info:return d;default:return h}}P.toString=p}(t||(t={})),e.default=t}),define(te[60],ie([0,1,25,27]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const w=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return w-v}value(){return this.b[this.c]}}e.StringIterator=P;class D{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,t.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class R{constructor(f=!0,w=!0){this.f=f,this.g=w}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let w=f.length-1;w>=0;w--,this.c--){const v=this.b.charCodeAt(w);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,t.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var I;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(I||(I={}));class d{constructor(f,w){this.f=f,this.g=w,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,t.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=d;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(y||(y={}));class p{static forUris(f=()=>!1,w=()=>!1){return new p(new d(f,w))}static forPaths(f=!1){return new p(new R(void 0,!f))}static forStrings(){return new p(new P)}static forConfigKeys(){return new p(new D)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,w){if(w){const v=w.slice(0);(0,E.shuffle)(v);for(const c of v)this.set(c,f)}else{const v=f.slice(0);(0,E.shuffle)(v);for(const c of v)this.set(c[0],c[1])}}set(f,w){const v=this.b.reset(f);let c;this.c||(this.c=new h,this.c.segment=v.value());const u=[];for(c=this.c;;){const k=v.cmp(c.segment);if(k>0)c.left||(c.left=new h,c.left.segment=v.value()),u.push([-1,c]),c=c.left;else if(k<0)c.right||(c.right=new h,c.right.segment=v.value()),u.push([1,c]),c=c.right;else if(v.hasNext())v.next(),c.mid||(c.mid=new h,c.mid.segment=v.value()),u.push([0,c]),c=c.mid;else break}const g=c.value;c.value=w,c.key=f;for(let k=u.length-1;k>=0;k--){const S=u[k][1];S.updateHeight();const L=S.balanceFactor();if(L<-1||L>1){const i=u[k][0],l=u[k+1][0];if(i===1&&l===1)u[k][1]=S.rotateLeft();else if(i===-1&&l===-1)u[k][1]=S.rotateRight();else if(i===1&&l===-1)S.right=u[k+1][1]=u[k+1][1].rotateRight(),u[k][1]=S.rotateLeft();else if(i===-1&&l===1)S.left=u[k+1][1]=u[k+1][1].rotateLeft(),u[k][1]=S.rotateRight();else throw new Error;if(k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this.c=u[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const w=this.b.reset(f);let v=this.c;for(;v;){const c=w.cmp(v.segment);if(c>0)v=v.left;else if(c<0)v=v.right;else if(w.hasNext())w.next(),v=v.mid;else break}return v}has(f){const w=this.d(f);return!(w?.value===void 0&&w?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,w){const v=this.b.reset(f),c=[];let u=this.c;for(;u;){const g=v.cmp(u.segment);if(g>0)c.push([-1,u]),u=u.left;else if(g<0)c.push([1,u]),u=u.right;else if(v.hasNext())v.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(w?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:k,value:S,segment:L}=g;this.e(g.key,!1),u.key=k,u.value=S,u.segment=L}}else{const g=u.left??u.right;if(c.length>0){const[k,S]=c[c.length-1];switch(k){case-1:S.left=g;break;case 0:S.mid=g;break;case 1:S.right=g;break}}else this.c=g}for(let g=c.length-1;g>=0;g--){const k=c[g][1];k.updateHeight();const S=k.balanceFactor();if(S>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),c[g][1]=k.rotateLeft()):S<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),c[g][1]=k.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this.c=c[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const w=this.b.reset(f);let v=this.c,c;for(;v;){const u=w.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(w.hasNext())w.next(),c=v.value||c,v=v.mid;else break}return v&&v.value||c}findSuperstr(f){return this.g(f,!1)}g(f,w){const v=this.b.reset(f);let c=this.c;for(;c;){const u=v.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else return c.mid?this.h(c.mid):w?c.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[w,v]of this)f(v,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const w=[];return this.j(f,w),w[Symbol.iterator]()}j(f,w){!f||(f.left&&this.j(f.left,w),f.value&&w.push([f.key,f.value]),f.mid&&this.j(f.mid,w),f.right&&this.j(f.right,w))}_isBalanced(){const f=w=>{if(!w)return!0;const v=w.balanceFactor();return v<-1||v>1?!1:f(w.left)&&f(w.right)};return f(this.c)}}e.TernarySearchTree=p}),define(te[7],ie([0,1,9,4]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,D=/^\//,R=/^\/\//;function I(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!P.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!D.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(n,o){return!n&&!o?"file":n}function h(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==p&&(o=p+o):o=p;break}return o}const y="",p="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(o){return o instanceof f?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,a,r,m,C=!1){typeof o=="object"?(this.scheme=o.scheme||y,this.authority=o.authority||y,this.path=o.path||y,this.query=o.query||y,this.fragment=o.fragment||y):(this.scheme=d(o,C),this.authority=s||y,this.path=h(this.scheme,a||y),this.query=r||y,this.fragment=m||y,I(this,C))}get fsPath(){return k(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:a,path:r,query:m,fragment:C}=o;return s===void 0?s=this.scheme:s===null&&(s=y),a===void 0?a=this.authority:a===null&&(a=y),r===void 0?r=this.path:r===null&&(r=y),m===void 0?m=this.query:m===null&&(m=y),C===void 0?C=this.fragment:C===null&&(C=y),s===this.scheme&&a===this.authority&&r===this.path&&m===this.query&&C===this.fragment?this:new v(s,a,r,m,C)}static parse(o,s=!1){const a=b.exec(o);return a?new v(a[2]||y,l(a[4]||y),l(a[5]||y),l(a[7]||y),l(a[9]||y),s):new v(y,y,y,y,y)}static file(o){let s=y;if(t.isWindows&&(o=o.replace(/\\/g,p)),o[0]===p&&o[1]===p){const a=o.indexOf(p,2);a===-1?(s=o.substring(2),o=p):(s=o.substring(2,a),o=o.substring(a)||p)}return new v("file",s,o,y,y)}static from(o){const s=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return I(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&o.scheme==="file"?a=f.file(E.win32.join(k(o,!0),...s)).path:a=E.posix.join(o.path,...s),o.with({path:a})}toString(o=!1){return S(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof f)return o;{const s=new v(o);return s._formatted=o.external,s._fsPath=o._sep===w?o.fsPath:null,s}}else return o}}e.URI=f;const w=t.isWindows?1:void 0;class v extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(o=!1){return o?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,o,s){let a,r=-1;for(let m=0;m<n.length;m++){const C=n.charCodeAt(m);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||o&&C===47||s&&C===91||s&&C===93||s&&C===58)r!==-1&&(a+=encodeURIComponent(n.substring(r,m)),r=-1),a!==void 0&&(a+=n.charAt(m));else{a===void 0&&(a=n.substr(0,m));const M=c[C];M!==void 0?(r!==-1&&(a+=encodeURIComponent(n.substring(r,m)),r=-1),a+=M):r===-1&&(r=m)}}return r!==-1&&(a+=encodeURIComponent(n.substring(r))),a!==void 0?a:n}function g(n){let o;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(o===void 0&&(o=n.substr(0,s)),o+=c[a]):o!==void 0&&(o+=n[s])}return o!==void 0?o:n}function k(n,o){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=k;function S(n,o){const s=o?g:u;let a="",{scheme:r,authority:m,path:C,query:M,fragment:O}=n;if(r&&(a+=r,a+=":"),(m||r==="file")&&(a+=p,a+=p),m){let B=m.indexOf("@");if(B!==-1){const J=m.substr(0,B);m=m.substr(B+1),B=J.lastIndexOf(":"),B===-1?a+=s(J,!1,!1):(a+=s(J.substr(0,B),!1,!1),a+=":",a+=s(J.substr(B+1),!1,!0)),a+="@"}m=m.toLowerCase(),B=m.lastIndexOf(":"),B===-1?a+=s(m,!1,!0):(a+=s(m.substr(0,B),!1,!0),a+=m.substr(B))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const B=C.charCodeAt(1);B>=65&&B<=90&&(C=`/${String.fromCharCode(B+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const B=C.charCodeAt(0);B>=65&&B<=90&&(C=`${String.fromCharCode(B+32)}:${C.substr(2)}`)}a+=s(C,!0,!1)}return M&&(a+="?",a+=s(M,!1,!1)),O&&(a+="#",a+=o?O:u(O,!1,!1)),a}function L(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+L(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(n){return n.match(i)?n.replace(i,o=>L(o)):n}}),define(te[142],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(h){const y=h;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=t;function P(h){const y=[];let p;try{const b=JSON.parse(h.arguments),f=b[b.length-1];f&&f.__$stack&&(b.pop(),p=f.__$stack),y.push(...b)}catch{y.push("Unable to log remote console arguments",h.arguments)}return{args:y,stack:p}}e.parse=P;function D(h){if(typeof h!="string")return D(P(h).stack);const y=h;if(y){const p=R(y),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=D;function R(h){if(!h)return h;const y=h.indexOf(`
`);return y===-1?h:h.substring(0,y)}function I(h,y){const{args:p,stack:b}=P(h),f=typeof p[0]=="string"&&p.length===1;let w=R(b);w&&(w=`(${w.trim()})`);let v=[];if(typeof p[0]=="string"?w&&f?v=[`%c[${y}] %c${p[0]} %c${w}`,d("blue"),d(""),d("grey")]:v=[`%c[${y}] %c${p[0]}`,d("blue"),d(""),...p.slice(1)]:v=[`%c[${y}]%`,d("blue"),...p],w&&!f&&v.push(w),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,v)}e.log=I;function d(h){return`color: ${h}`}}),define(te[72],ie([0,1,17,27,7]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(h){return JSON.stringify(h,I)}e.stringify=D;function R(h){let y=JSON.parse(h);return y=d(y),y}e.parse=R;function I(h,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function d(h,y=0){if(!h||y>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return P.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof E.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let p=0;p<h.length;++p)h[p]=d(h[p],y+1);else for(const p in h)Object.hasOwnProperty.call(h,p)&&(h[p]=d(h[p],y+1))}return h}e.revive=d}),define(te[15],ie([0,1,13,4,7]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebook="vscode-notebook",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${D.vscodeRemoteResource}`}set(y,p,b){this.a[y]=p,this.b[y]=b}setConnectionToken(y,p){this.c[y]=p}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(c){return E.onUnexpectedError(c),y}const p=y.authority;let b=this.a[p];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[p],w=this.c[p];let v=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),P.URI.from({scheme:t.isWeb?this.d:D.vscodeRemoteResource,authority:`${b}:${f}`,path:this.f,query:v})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(y){const p=this.b(y,V);return this.uriToBrowserUri(p)}uriToBrowserUri(y){return y.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===D.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${D.vscodeFileResource}://${I.a}`)?y.with({scheme:D.vscodeFileResource,authority:y.authority||I.a,query:null,fragment:null}):y}asFileUri(y){const p=this.b(y,V);return this.uriToFileUri(p)}uriToFileUri(y){return y.scheme===D.vscodeFileResource?y.with({scheme:D.file,authority:y.authority!==I.a?y.authority:null,query:null,fragment:null}):y}b(y,p){return P.URI.isUri(y)?y:P.URI.parse(p.toUrl(y))}}I.a="vscode-app",e.FileAccess=new I;var d;(function(h){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(y.get("3"));const p="vscode-coi";function b(w){let v;typeof w=="string"?v=new URL(w).searchParams:w instanceof URL?v=w.searchParams:P.URI.isUri(w)&&(v=new URL(w.toString(!0)).searchParams);const c=v?.get(p);if(!!c)return y.get(c)}h.getHeadersFromQuery=b;function f(w,v,c){if(!globalThis.crossOriginIsolated)return;const u=v&&c?"3":c?"2":"1";w instanceof URLSearchParams?w.set(p,u):w[p]=u}h.addSearchParam=f})(d=e.COI||(e.COI={}))}),define(te[20],ie([0,1,32,15,9,4,27,7]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(f){return(0,I.uriToFsPath)(f,!0)}e.originalFSPath=d;class h{constructor(w){this.a=w}compare(w,v,c=!1){return w===v?0:(0,R.compare)(this.getComparisonKey(w,c),this.getComparisonKey(v,c))}isEqual(w,v,c=!1){return w===v?!0:!w||!v?!1:this.getComparisonKey(w,c)===this.getComparisonKey(v,c)}getComparisonKey(w,v=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,v,c=!1){if(w.scheme===v.scheme){if(w.scheme===t.Schemas.file)return E.isEqualOrParent(d(w),d(v),this.a(w))&&w.query===v.query&&(c||w.fragment===v.fragment);if((0,e.isEqualAuthority)(w.authority,v.authority))return E.isEqualOrParent(w.path,v.path,this.a(w),"/")&&w.query===v.query&&(c||w.fragment===v.fragment)}return!1}joinPath(w,...v){return I.URI.joinPath(w,...v)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return P.posix.basename(w.path)}extname(w){return P.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let v;return w.scheme===t.Schemas.file?v=I.URI.file(P.dirname(d(w))).path:(v=P.posix.dirname(w.path),w.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),v="/")),w.with({path:v})}normalizePath(w){if(!w.path.length)return w;let v;return w.scheme===t.Schemas.file?v=I.URI.file(P.normalize(d(w))).path:v=P.posix.normalize(w.path),w.with({path:v})}relativePath(w,v){if(w.scheme!==v.scheme||!(0,e.isEqualAuthority)(w.authority,v.authority))return;if(w.scheme===t.Schemas.file){const g=P.relative(d(w),d(v));return D.isWindows?E.toSlashes(g):g}let c=w.path||"/";const u=v.path||"/";if(this.a(w)){let g=0;for(const k=Math.min(c.length,u.length);g<k&&!(c.charCodeAt(g)!==u.charCodeAt(g)&&c.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);c=u.substr(0,g)+c.substr(g)}return P.posix.relative(c,u)}resolvePath(w,v){if(w.scheme===t.Schemas.file){const c=I.URI.file(P.resolve(d(w),v));return w.with({authority:c.authority,path:c.path})}return v=E.toPosixPath(v),w.with({path:P.posix.resolve(w.path,v)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,v){return w===v||w!==void 0&&v!==void 0&&(0,R.equalsIgnoreCase)(w,v)}hasTrailingPathSeparator(w,v=P.sep){if(w.scheme===t.Schemas.file){const c=d(w);return c.length>E.getRoot(c).length&&c[c.length-1]===v}else{const c=w.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,v=P.sep){return(0,e.hasTrailingPathSeparator)(w,v)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,v=P.sep){let c=!1;if(w.scheme===t.Schemas.file){const u=d(w);c=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=w.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(w,v)?w.with({path:w.path+"/"}):w}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(f=>f.scheme===t.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new h(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(f,w){const v=[];for(let c=0;c<f.length;c++){const u=w(f[c]);f.some((g,k)=>k===c?!1:(0,e.isEqualOrParent)(u,w(g)))||v.push(f[c])}return v}e.distinctParents=y;var p;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function w(v){const c=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(k=>{const[S,L]=k.split(":");S&&L&&c.set(S,L)});const g=v.path.substring(0,v.path.indexOf(";"));return g&&c.set(f.META_DATA_MIME,g),c}f.parseMetaData=w})(p=e.DataUri||(e.DataUri={}));function b(f,w,v){if(w){let c=f.path;return c&&c[0]!==P.posix.sep&&(c=P.posix.sep+c),f.with({scheme:v,authority:w,path:c})}return f.with({scheme:v})}e.toLocalResource=b}),define(te[8],ie([0,1,22,13,3,2,20,4]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(_){return!!_&&typeof _.then=="function"}e.isThenable=d;function h(_){const $=new E.CancellationTokenSource,A=_($.token),T=new Promise((W,j)=>{const K=$.token.onCancellationRequested(()=>{K.dispose(),$.dispose(),j(new t.CancellationError)});Promise.resolve(A).then(N=>{K.dispose(),$.dispose(),W(N)},N=>{K.dispose(),$.dispose(),j(N)})});return new class{cancel(){$.cancel()}then(W,j){return T.then(W,j)}catch(W){return this.then(void 0,W)}finally(W){return T.finally(W)}}}e.createCancelablePromise=h;function y(_,$,A){return new Promise((T,W)=>{const j=$.onCancellationRequested(()=>{j.dispose(),T(A)});_.then(T,W).finally(()=>j.dispose())})}e.raceCancellation=y;function p(_,$){return new Promise((A,T)=>{const W=$.onCancellationRequested(()=>{W.dispose(),T(new t.CancellationError)});_.then(A,T).finally(()=>W.dispose())})}e.raceCancellationError=p;async function b(_){let $=-1;const A=_.map((W,j)=>W.then(K=>($=j,K))),T=await Promise.race(A);return _.forEach((W,j)=>{j!==$&&W.cancel()}),T}e.raceCancellablePromises=b;function f(_,$,A){let T;const W=setTimeout(()=>{T?.(void 0),A?.()},$);return Promise.race([_.finally(()=>clearTimeout(W)),new Promise(j=>T=j)])}e.raceTimeout=f;function w(_){return new Promise(($,A)=>{const T=_();d(T)?T.then($,A):$(T)})}e.asPromise=w;class v{constructor(){this.a=null,this.b=null,this.d=null}queue($){if(this.a){if(this.d=$,!this.b){const A=()=>{this.b=null;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(A,A).then(T)})}return new Promise((A,T)=>{this.b.then(A,T)})}return this.a=$(),new Promise((A,T)=>{this.a.then(W=>{this.a=null,A(W)},W=>{this.a=null,T(W)})})}}e.Throttler=v;class c{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}e.Sequencer=c;class u{constructor(){this.a=new Map}queue($,A){const W=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get($)===W&&this.a.delete($)});return this.a.set($,W),W}}e.SequencerByKey=u;const g=(_,$)=>{let A=!0;const T=setTimeout(()=>{A=!1,$()},_);return{isTriggered:()=>A,dispose:()=>{clearTimeout(T),A=!1}}},k=_=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,_())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,A=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((W,j)=>{this.d=W,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=A===e.MicrotaskDelay?k(T):g(A,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class L{constructor($){this.a=new S($),this.b=new v}trigger($,A){return this.a.trigger(()=>this.b.queue($),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=L;class i{constructor(){this.a=!1,this.b=new Promise(($,A)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class l extends i{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=l;function n(_,$){return $?new Promise((A,T)=>{const W=setTimeout(()=>{j.dispose(),A()},_),j=$.onCancellationRequested(()=>{clearTimeout(W),j.dispose(),T(new t.CancellationError)})}):h(A=>n(_,A))}e.timeout=n;function o(_,$=0){const A=setTimeout(_,$);return(0,D.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=o;function s(_){const $=[];let A=0;const T=_.length;function W(){return A<T?_[A++]():null}function j(K){K!=null&&$.push(K);const N=W();return N?N.then(j):Promise.resolve($)}return Promise.resolve(null).then(j)}e.sequence=s;function a(_,$=T=>!!T,A=null){let T=0;const W=_.length,j=()=>{if(T>=W)return Promise.resolve(A);const K=_[T++];return Promise.resolve(K()).then(q=>$(q)?Promise.resolve(q):j())};return j()}e.first=a;function r(_,$=T=>!!T,A=null){if(_.length===0)return Promise.resolve(A);let T=_.length;const W=()=>{T=-1;for(const j of _)j.cancel?.()};return new Promise((j,K)=>{for(const N of _)N.then(q=>{--T>=0&&$(q)?(W(),j(q)):T===0&&j(A)}).catch(q=>{--T>=0&&(W(),K(q))})})}e.firstParallel=r;class m{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new P.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((A,T)=>{this.f.push({factory:$,c:A,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const A=$.factory();A.then($.c,$.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class C extends m{constructor(){super(1)}}e.Queue=C;class M{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const $=new H;return this.b.add($),$.p}d(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,A=R.extUri){const T=A.getComparisonKey($);let W=this.a.get(T);return W||(W=new C,P.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(T),this.f()}),this.a.set(T,W)),W}f(){!this.d()||this.g()}g(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.g()}}e.ResourceQueue=M;class O{constructor($,A){this.a=-1,typeof $=="function"&&typeof A=="number"&&this.setIfNotSet($,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},A)}setIfNotSet($,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},A))}}e.TimeoutTimer=O;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,A){this.cancel(),this.a=setInterval(()=>{$()},A)}}e.IntervalTimer=B;class J{constructor($,A){this.b=-1,this.a=$,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=J;class G{constructor($,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=$,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class X extends J{constructor($,A){super($,A),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=X;class re extends D.Disposable{constructor($,A){super(),this.g=$,this.h=A,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of $)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=_=>{(0,I.setTimeout0)(()=>{if($)return;const A=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(_,$)=>{const A=requestIdleCallback(_,typeof $=="number"?{timeout:$}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(A))}}}}();class se{constructor($){this.d=!1,this.a=()=>{try{this.f=$()}catch(A){this.g=A}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ae(_,$,A){let T;for(let W=0;W<A;W++)try{return await _()}catch(j){T=j,await n($)}throw T}e.retry=ae;class fe{hasPending($){return this.a?typeof $=="number"?this.a.taskId===$:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending($,A,T){return this.a={taskId:$,cancel:()=>T?.(),promise:A},A.then(()=>this.d($),()=>this.d($)),A}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this.b)this.b.run=$;else{let A,T;const W=new Promise((j,K)=>{A=j,T=K});this.b={run:$,promise:W,promiseResolve:A,promiseReject:T}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=fe;class ge{constructor($,A=()=>Date.now()){this.d=$,this.f=A,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}e.IntervalCounter=ge;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise(($,A)=>{this.a=$,this.b=A})}complete($){return new Promise(A=>{this.a($),this.f=!0,A()})}error($){return new Promise(A=>{this.b($),this.d=!0,A()})}cancel(){new Promise($=>{this.b(new t.CancellationError),this.d=!0,$()})}}e.DeferredPromise=H;var F;(function(_){async function $(T){let W;const j=await Promise.all(T.map(K=>K.then(N=>N,N=>{W||(W=N)})));if(typeof W<"u")throw W;return j}_.settled=$;function A(T){return new Promise(async(W,j)=>{try{await T(W,j)}catch(K){j(K)}})}_.withAsyncBody=A})(F=e.Promises||(e.Promises={}));var U;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(U||(U={}));class z{static fromArray($){return new z(A=>{A.emitMany($)})}static fromPromise($){return new z(async A=>{A.emitMany(await $)})}static fromPromises($){return new z(async A=>{await Promise.all($.map(async T=>A.emitOne(await T)))})}static merge($){return new z(async A=>{await Promise.all($.map(async T=>{for await(const W of T)A.emitOne(W)}))})}constructor($){this.a=0,this.b=[],this.d=null,this.f=new P.Emitter,queueMicrotask(async()=>{const A={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve($(A)),this.j()}catch(T){this.k(T)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map($,A){return new z(async T=>{for await(const W of $)T.emitOne(A(W))})}map($){return z.map(this,$)}static filter($,A){return new z(async T=>{for await(const W of $)A(W)&&T.emitOne(W)})}filter($){return z.filter(this,$)}static coalesce($){return z.filter($,A=>!!A)}coalesce(){return z.coalesce(this)}static async toPromise($){const A=[];for await(const T of $)A.push(T);return A}toPromise(){return z.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Q extends z{constructor($,A){super(A),this.l=$}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function ne(_){const $=new E.CancellationTokenSource,A=_($.token);return new Q($,async T=>{const W=$.token.onCancellationRequested(()=>{W.dispose(),$.dispose(),T.reject(new t.CancellationError)});try{for await(const j of A){if($.token.isCancellationRequested)return;T.emitOne(j)}W.dispose(),$.dispose()}catch(j){W.dispose(),$.dispose(),T.reject(j)}})}e.createCancelableAsyncIterable=ne}),define(te[101],ie([0,1,25,8,32,38,9,4,27]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",p="[^/\\\\]",b=/\//g;function f(H,F){switch(H){case 0:return"";case 1:return`${p}*?`;default:return`(?:${y}|${p}+${y}${F?`|${y}${p}+`:""})*?`}}function w(H,F){if(!H)return[];const U=[];let z=!1,Q=!1,ne="";for(const _ of H){switch(_){case F:if(!z&&!Q){U.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ne+=_}return ne&&U.push(ne),U}e.splitGlobAware=w;function v(H){if(!H)return"";let F="";const U=w(H,e.GLOB_SPLIT);if(U.every(z=>z===e.GLOBSTAR))F=".*";else{let z=!1;U.forEach((Q,ne)=>{if(Q===e.GLOBSTAR){if(z)return;F+=f(2,ne===U.length-1)}else{let _=!1,$="",A=!1,T="";for(const W of Q){if(W!=="}"&&_){$+=W;continue}if(A&&(W!=="]"||!T)){let j;W==="-"?j=W:(W==="^"||W==="!")&&!T?j="^":W===e.GLOB_SPLIT?j="":j=(0,d.escapeRegExpCharacters)(W),T+=j;continue}switch(W){case"{":_=!0;continue;case"[":A=!0;continue;case"}":{F+=`(?:${w($,",").map(N=>v(N)).join("|")})`,_=!1,$="";break}case"]":{F+="["+T+"]",A=!1,T="";break}case"?":F+=p;continue;case"*":F+=f(1);continue;default:F+=(0,d.escapeRegExpCharacters)(W)}}ne<U.length-1&&(U[ne+1]!==e.GLOBSTAR||ne+2<U.length)&&(F+=y)}z=Q===e.GLOBSTAR})}return F}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new D.LRUCache(1e4),l=function(){return!1},n=function(){return null};function o(H,F){if(!H)return n;let U;typeof H!="string"?U=H.pattern:U=H,U=U.trim();const z=`${U}_${!!F.trimForExclusions}`;let Q=i.get(z);if(Q)return s(Q,H);let ne;return c.test(U)?Q=r(U.substr(4),U):(ne=u.exec(a(U,F)))?Q=m(ne[1],U):(F.trimForExclusions?k:g).test(U)?Q=C(U,F):(ne=S.exec(a(U,F)))?Q=M(ne[1].substr(1),U,!0):(ne=L.exec(a(U,F)))?Q=M(ne[1],U,!1):Q=O(U),i.set(z,Q),s(Q,H)}function s(H,F){if(typeof F=="string")return H;const U=function(z,Q){return(0,P.isEqualOrParent)(z,F.base,!I.isLinux)?H((0,d.ltrim)(z.substr(F.base.length),R.sep),Q):null};return U.allBasenames=H.allBasenames,U.allPaths=H.allPaths,U.basenames=H.basenames,U.patterns=H.patterns,U}function a(H,F){return F.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function r(H,F){return function(U,z){return typeof U=="string"&&U.endsWith(H)?F:null}}function m(H,F){const U=`/${H}`,z=`\\${H}`,Q=function(_,$){return typeof _!="string"?null:$?$===H?F:null:_===H||_.endsWith(U)||_.endsWith(z)?F:null},ne=[H];return Q.basenames=ne,Q.patterns=[F],Q.allBasenames=ne,Q}function C(H,F){const U=fe(H.slice(1,-1).split(",").map($=>o($,F)).filter($=>$!==n),H),z=U.length;if(!z)return n;if(z===1)return U[0];const Q=function($,A){for(let T=0,W=U.length;T<W;T++)if(U[T]($,A))return H;return null},ne=U.find($=>!!$.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const _=U.reduce(($,A)=>A.allPaths?$.concat(A.allPaths):$,[]);return _.length&&(Q.allPaths=_),Q}function M(H,F,U){const z=R.sep===R.posix.sep,Q=z?H:H.replace(b,R.sep),ne=R.sep+Q,_=R.posix.sep+H;let $;return U?$=function(A,T){return typeof A=="string"&&(A===Q||A.endsWith(ne)||!z&&(A===H||A.endsWith(_)))?F:null}:$=function(A,T){return typeof A=="string"&&(A===Q||!z&&A===H)?F:null},$.allPaths=[(U?"*/":"./")+H],$}function O(H){try{const F=new RegExp(`^${v(H)}$`);return function(U){return F.lastIndex=0,typeof U=="string"&&F.test(U)?H:null}}catch{return n}}function B(H,F,U){return!H||typeof F!="string"?!1:J(H)(F,void 0,U)}e.match=B;function J(H,F={}){if(!H)return l;if(typeof H=="string"||G(H)){const U=o(H,F);if(U===n)return l;const z=function(Q,ne){return!!U(Q,ne)};return U.allBasenames&&(z.allBasenames=U.allBasenames),U.allPaths&&(z.allPaths=U.allPaths),z}return se(H,F)}e.parse=J;function G(H){const F=H;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=G;function X(H){return H.allBasenames||[]}e.getBasenameTerms=X;function re(H){return H.allPaths||[]}e.getPathTerms=re;function se(H,F){const U=fe(Object.getOwnPropertyNames(H).map($=>ae($,H[$],F)).filter($=>$!==n)),z=U.length;if(!z)return n;if(!U.some($=>!!$.requiresSiblings)){if(z===1)return U[0];const $=function(W,j){let K;for(let N=0,q=U.length;N<q;N++){const Z=U[N](W,j);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(K||(K=[]),K.push(Z))}return K?(async()=>{for(const N of K){const q=await N;if(typeof q=="string")return q}return null})():null},A=U.find(W=>!!W.allBasenames);A&&($.allBasenames=A.allBasenames);const T=U.reduce((W,j)=>j.allPaths?W.concat(j.allPaths):W,[]);return T.length&&($.allPaths=T),$}const Q=function($,A,T){let W,j;for(let K=0,N=U.length;K<N;K++){const q=U[K];q.requiresSiblings&&T&&(A||(A=(0,R.basename)($)),W||(W=A.substr(0,A.length-(0,R.extname)($).length)));const Z=q($,A,W,T);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(j||(j=[]),j.push(Z))}return j?(async()=>{for(const K of j){const N=await K;if(typeof N=="string")return N}return null})():null},ne=U.find($=>!!$.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const _=U.reduce(($,A)=>A.allPaths?$.concat(A.allPaths):$,[]);return _.length&&(Q.allPaths=_),Q}function ae(H,F,U){if(F===!1)return n;const z=o(H,U);if(z===n)return n;if(typeof F=="boolean")return z;if(F){const Q=F.when;if(typeof Q=="string"){const ne=(_,$,A,T)=>{if(!T||!z(_,$))return null;const W=Q.replace("$(basename)",()=>A),j=T(W);return(0,t.isThenable)(j)?j.then(K=>K?H:null):j?H:null};return ne.requiresSiblings=!0,ne}}return z}function fe(H,F){const U=H.filter($=>!!$.basenames);if(U.length<2)return H;const z=U.reduce(($,A)=>{const T=A.basenames;return T?$.concat(T):$},[]);let Q;if(F){Q=[];for(let $=0,A=z.length;$<A;$++)Q.push(F)}else Q=U.reduce(($,A)=>{const T=A.patterns;return T?$.concat(T):$},[]);const ne=function($,A){if(typeof $!="string")return null;if(!A){let W;for(W=$.length;W>0;W--){const j=$.charCodeAt(W-1);if(j===47||j===92)break}A=$.substr(W)}const T=z.indexOf(A);return T!==-1?Q[T]:null};ne.basenames=z,ne.patterns=Q,ne.allBasenames=z;const _=H.filter($=>!$.basenames);return _.push(ne),_}function ge(H,F){return(0,E.equals)(H,F,(U,z)=>typeof U=="string"&&typeof z=="string"?U===z:typeof U!="string"&&typeof z!="string"?U.base===z.base&&U.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(te[36],ie([0,1,25,32,9,4,20,27]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(n,o){const{os:s,tildify:a,relative:r}=o;if(r){const M=h(n,r,s);if(typeof M=="string")return M}let m=n.fsPath;if(s===1&&!D.isWindows?m=m.replace(/\//g,"\\"):s!==1&&D.isWindows&&(m=m.replace(/\\/g,"/")),s!==1&&a?.userHome){const M=a.userHome.fsPath;let O;n.scheme!==a.userHome.scheme&&n.path.startsWith(P.posix.sep)?O=a.userHome.with({path:n.path}).fsPath:O=n.fsPath,m=b(O,M,s)}return(s===1?P.win32:P.posix).normalize(y(m,s===1))}e.getPathLabel=d;function h(n,o,s){const a=s===1?P.win32:P.posix,r=s===3?R.extUri:R.extUriIgnorePathCase,m=o.getWorkspace(),C=(0,E.firstOrDefault)(m.folders);if(!C)return;n.scheme!==C.uri.scheme&&n.path.startsWith(P.posix.sep)&&(n=C.uri.with({path:n.path}));const M=o.getWorkspaceFolder(n);if(!M)return;let O;if(r.isEqual(M.uri,n)?O="":O=r.relativePath(M.uri,n)??"",O&&(O=a.normalize(O)),m.folders.length>1&&!o.noPrefix){const B=M.name?M.name:r.basenameOrAuthority(M.uri);O=O?`${B} \u2022 ${O}`:B}return O}function y(n,o=D.isWindows){return(0,t.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=y;let p=Object.create(null);function b(n,o,s=D.OS){if(s===1||!n||!o)return n;let a=p.original===o?p.normalized:void 0;a||(a=o,D.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,I.rtrim)(a,P.posix.sep)}${P.posix.sep}`,p={original:o,normalized:a});let r=n;return D.isWindows&&(r=(0,t.toSlashes)(r)),(s===3?r.startsWith(a):(0,I.startsWithIgnoreCase)(r,a))?`~/${r.substr(a.length)}`:n}e.tildify=b;function f(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=f;const w="\u2026",v="\\\\",c="~";function u(n,o=P.sep){const s=new Array(n.length);let a=!1;for(let r=0;r<n.length;r++){const m=n[r];if(m===""){s[r]=`.${o}`;continue}if(!m){s[r]=m;continue}a=!0;let C="",M=m;M.indexOf(v)===0?(C=M.substr(0,M.indexOf(v)+v.length),M=M.substr(M.indexOf(v)+v.length)):M.indexOf(o)===0?(C=M.substr(0,M.indexOf(o)+o.length),M=M.substr(M.indexOf(o)+o.length)):M.indexOf(c)===0&&(C=M.substr(0,M.indexOf(c)+c.length),M=M.substr(M.indexOf(c)+c.length));const O=M.split(o);for(let B=1;a&&B<=O.length;B++)for(let J=O.length-B;a&&J>=0;J--){a=!1;let G=O.slice(J,J+B).join(o);for(let X=0;!a&&X<n.length;X++)if(X!==r&&n[X]&&n[X].indexOf(G)>-1){const re=J+B===O.length,se=J>0&&n[X].indexOf(o)>-1?o+G:G,ae=n[X].endsWith(se);a=!re||ae}if(!a){let X="";(O[0].endsWith(":")||C!=="")&&(J===1&&(J=0,B++,G=O[0]+o+G),J>0&&(X=O[0]+o),X=C+X),J>0&&(X=X+w+o),X=X+G,J+B<O.length&&(X=X+o+w),s[r]=X}}a&&(s[r]=m)}return s}e.shorten=u;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function k(n,o=Object.create(null)){const s=[];let a=!1,r="";for(const m of n)if(m==="$"||a&&m==="{")r&&s.push({value:r,type:g.TEXT}),r="",a=!0;else if(m==="}"&&a){const C=o[r];if(typeof C=="string")C.length&&s.push({value:C,type:g.VARIABLE});else if(C){const M=s[s.length-1];(!M||M.type!==g.SEPARATOR)&&s.push({value:C.label,type:g.SEPARATOR})}r="",a=!1}else r+=m;return r&&!a&&s.push({value:r,type:g.TEXT}),s.filter((m,C)=>{if(m.type===g.SEPARATOR){const M=s[C-1],O=s[C+1];return[M,O].every(B=>B&&(B.type===g.VARIABLE||B.type===g.TEXT)&&B.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=k;function S(n,o){return D.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function L(n,o){return D.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=L;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(n){const o=n.indexOf("/")!==-1?P.posix:P.win32,s=o.basename(n),a=o.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=l}),define(te[143],ie([0,1,17,7]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(p){return p.toJSON()}class D{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:P(t.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:P(t.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:t.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function R(p,b,f){if(!p||f>200)return null;if(typeof p=="object"){if(p instanceof t.URI)return b.transformOutgoing(p);for(const w in p)if(Object.hasOwnProperty.call(p,w)){const v=R(p[w],b,f+1);v!==null&&(p[w]=v)}}return null}function I(p,b){const f=R(p,b,0);return f===null?p:f}e.transformOutgoingURIs=I;function d(p,b,f,w){if(!p||w>200)return null;if(typeof p=="object"){if(p.$mid===1)return f?t.URI.revive(b.transformIncoming(p)):b.transformIncoming(p);if(p instanceof E.VSBuffer)return null;for(const v in p)if(Object.hasOwnProperty.call(p,v)){const c=d(p[v],b,f,w+1);c!==null&&(p[v]=c)}}return null}function h(p,b){const f=d(p,b,!1,0);return f===null?p:f}e.transformIncomingURIs=h;function y(p,b){const f=d(p,b,!0,0);return f===null?p:f}e.transformAndReviveIncomingURIs=y}),define(te[84],ie([0,1,26,13,60,31,131]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,p=0;const b=(0,E.networkInterfaces)();for(const f in b){const w=b[f];if(w)for(const{mac:v,internal:c}of w)c||(p+=1,this.c(v.toUpperCase())&&(y+=1))}this.b=p>0?y/p:0}return this.b}};let I;async function d(){return I||(I=(async()=>await h()||D.generateUuid())()),I}e.getMachineId=d;async function h(){try{const y=await new Promise((b,f)=>{V(["crypto"],b,f)}),p=(0,R.getMac)();return y.createHash("sha256").update(p,"utf8").digest("hex")}catch(y){t.onUnexpectedError(y);return}}}),define(te[23],ie([0,1,41,26,144,8,32,79,9,4,20,7]),function(V,e,E,t,P,D,R,I,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f(se,ae=b.UNLINK){if((0,R.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ae===b.UNLINK?v(se):w(se)}async function w(se){try{const ae=(0,R.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,ae)}catch(fe){return fe.code==="ENOENT"?void 0:v(se)}v(ae).catch(fe=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function v(se){return(0,P.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function c(se){if((0,R.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(se,ae){return S(await(ae?g(se):(0,P.promisify)(E.readdir)(se)))}async function g(se){try{return await(0,P.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ae=[],fe=await u(se);for(const ge of fe){let H=!1,F=!1,U=!1;try{const z=await e.Promises.lstat((0,d.join)(se,ge));H=z.isFile(),F=z.isDirectory(),U=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ae.push({name:ge,isFile:()=>H,isDirectory:()=>F,isSymbolicLink:()=>U})}return ae}function k(se){return S(E.readdirSync(se))}e.readdirSync=k;function S(se){return se.map(ae=>typeof ae=="string"?h.isMacintosh?(0,I.normalizeNFC)(ae):ae:(ae.name=h.isMacintosh?(0,I.normalizeNFC)(ae.name):ae.name,ae))}async function L(se){const ae=await u(se),fe=[];for(const ge of ae)await l.existsDirectory((0,d.join)(se,ge))&&fe.push(ge);return fe}function i(se,ae=1e3){return new Promise(fe=>{let ge=!1;const H=setInterval(()=>{ge||(ge=!0,E.access(se,F=>{ge=!1,F&&(clearInterval(H),fe(void 0))}))},ae)})}e.whenDeleted=i;var l;(function(se){async function ae(H){let F;try{if(F=await e.Promises.lstat(H),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(h.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw z}throw U}}se.stat=ae;async function fe(H){try{const{stat:F,symbolicLink:U}=await se.stat(H);return F.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=fe;async function ge(H){try{const{stat:F,symbolicLink:U}=await se.stat(H);return F.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=ge})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new D.ResourceQueue;function o(se,ae,fe){return n.queueFor(p.URI.file(se),y.extUriBiasedIgnorePathCase).queue(()=>{const ge=C(fe);return new Promise((H,F)=>r(se,ae,ge,U=>U?F(U):H()))})}let s=!0;function a(se){s=se}e.configureFlushOnWrite=a;function r(se,ae,fe,ge){if(!s)return E.writeFile(se,ae,{mode:fe.mode,flag:fe.flag},ge);E.open(se,fe.flag,fe.mode,(H,F)=>{if(H)return ge(H);E.writeFile(F,ae,U=>{if(U)return E.close(F,()=>ge(U));E.fdatasync(F,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a(!1)),E.close(F,Q=>ge(Q))))})})}function m(se,ae,fe){const ge=C(fe);if(!s)return E.writeFileSync(se,ae,{mode:ge.mode,flag:ge.flag});const H=E.openSync(se,ge.flag,ge.mode);try{E.writeFileSync(H,ae);try{E.fdatasyncSync(H)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a(!1)}}finally{E.closeSync(H)}}e.writeFileSync=m;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function M(se,ae){if(se!==ae)try{await e.Promises.rename(se,ae)}catch(fe){if(se.toLowerCase()!==ae.toLowerCase()&&fe.code==="EXDEV"||se.endsWith("."))await O(se,ae,{preserveSymlinks:!1}),await f(se,b.MOVE);else throw fe}}async function O(se,ae,fe){return J(se,ae,{root:{source:se,target:ae},options:fe,handledSourcePaths:new Set})}const B=511;async function J(se,ae,fe){if(fe.handledSourcePaths.has(se))return;fe.handledSourcePaths.add(se);const{stat:ge,symbolicLink:H}=await l.stat(se);if(H){if(fe.options.preserveSymlinks)try{return await re(se,ae,fe)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(H.dangling)return}return ge.isDirectory()?G(se,ae,ge.mode&B,fe):X(se,ae,ge.mode&B)}async function G(se,ae,fe,ge){await e.Promises.mkdir(ae,{recursive:!0,mode:fe});const H=await u(se);for(const F of H)await J((0,d.join)(se,F),(0,d.join)(ae,F),ge)}async function X(se,ae,fe){await e.Promises.copyFile(se,ae),await e.Promises.chmod(ae,fe)}async function re(se,ae,fe){let ge=await e.Promises.readlink(se);(0,R.isEqualOrParent)(ge,fe.root.source,!h.isLinux)&&(ge=(0,d.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ae)}e.Promises=new class{get access(){return(0,P.promisify)(E.access)}get stat(){return(0,P.promisify)(E.stat)}get lstat(){return(0,P.promisify)(E.lstat)}get utimes(){return(0,P.promisify)(E.utimes)}get read(){return(se,ae,fe,ge,H)=>new Promise((F,U)=>{E.read(se,ae,fe,ge,H,(z,Q,ne)=>z?U(z):F({bytesRead:Q,buffer:ne}))})}get readFile(){return(0,P.promisify)(E.readFile)}get write(){return(se,ae,fe,ge,H)=>new Promise((F,U)=>{E.write(se,ae,fe,ge,H,(z,Q,ne)=>z?U(z):F({bytesWritten:Q,buffer:ne}))})}get appendFile(){return(0,P.promisify)(E.appendFile)}get fdatasync(){return(0,P.promisify)(E.fdatasync)}get truncate(){return(0,P.promisify)(E.truncate)}get rename(){return(0,P.promisify)(E.rename)}get copyFile(){return(0,P.promisify)(E.copyFile)}get open(){return(0,P.promisify)(E.open)}get close(){return(0,P.promisify)(E.close)}get symlink(){return(0,P.promisify)(E.symlink)}get readlink(){return(0,P.promisify)(E.readlink)}get chmod(){return(0,P.promisify)(E.chmod)}get mkdir(){return(0,P.promisify)(E.mkdir)}get unlink(){return(0,P.promisify)(E.unlink)}get rmdir(){return(0,P.promisify)(E.rmdir)}get realpath(){return(0,P.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return L}get writeFile(){return o}get rm(){return f}get move(){return M}get copy(){return O}}}),define(te[102],ie([0,1,41,9,4,27,23]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(b){if(P.isLinux)return b;const f=(0,t.dirname)(b);if(b===f)return b;const w=((0,t.basename)(b)||b).toLowerCase();try{const c=(0,R.readdirSync)(f).filter(u=>u.toLowerCase()===w);if(c.length===1){const u=I(f);if(u)return(0,t.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(w);if(u>=0){const g=I(f);if(g)return(0,t.join)(g,c[u])}}}catch{}return null}e.realcaseSync=I;async function d(b){if(P.isLinux)return b;const f=(0,t.dirname)(b);if(b===f)return b;const w=((0,t.basename)(b)||b).toLowerCase();try{const c=(await R.Promises.readdir(f)).filter(u=>u.toLowerCase()===w);if(c.length===1){const u=await d(f);if(u)return(0,t.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(w);if(u>=0){const g=await d(f);if(g)return(0,t.join)(g,c[u])}}}catch{}return null}e.realcase=d;async function h(b){try{return await R.Promises.realpath(b)}catch{const w=p(b);return await R.Promises.access(w,E.constants.R_OK),w}}e.realpath=h;function y(b){try{return E.realpathSync(b)}catch{const w=p(b);return E.accessSync(w,E.constants.R_OK),w}}e.realpathSync=y;function p(b){return(0,D.rtrim)((0,t.normalize)(b),t.sep)}}),define(te[145],ie([0,1,26,9,23]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(d||(d={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class p{constructor(L,i,l){this.exePath=L,this.displayName=i,this.a=l}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:S=!1}={}){return S?h===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:S=!1,findPreview:L=!1}={}){const i=b({useAlternateBitness:S});if(!i)return null;const l=t.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(l))return null;let n=-1,o=null;for(const r of await P.Promises.readdir(l)){let m=-1;if(L){const M=r.indexOf("-");if(M<0)continue;const O=r.substring(0,M);if(!D.test(O)||r.substring(M+1)!=="preview")continue;m=parseInt(O,10)}else{if(!D.test(r))continue;m=parseInt(r,10)}if(m<=n)continue;const C=t.join(l,r,"pwsh.exe");!await P.SymlinkSupport.existsFile(C)||(o=C,n=m)}if(!o)return null;const s=i.includes("x86")?" (x86)":"",a=L?" Preview":"";return new p(o,`PowerShell${a}${s}`,!0)}async function w({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const L=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:i,pwshMsixName:l}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await P.Promises.readdir(L))if(i.test(n)){const o=t.join(L,n,"pwsh.exe");return new p(o,l)}return null}function v(){const S=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new p(S,".NET Core PowerShell Global Tool")}function c(){const S=t.join(process.env.windir,h===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(S,"Windows PowerShell",!0)}async function*u(){let S=await f();S&&(yield S),S=await f({useAlternateBitness:!0}),S&&(yield S),S=await w(),S&&(yield S),S=v(),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await f({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=c(),S&&(yield S)}async function*g(){for await(const S of u())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=g;async function k(){for await(const S of g())return S;return null}e.getFirstAvailablePowerShellInstallation=k}),define(te[85],ie([0,1,9,4,35,82,11,23]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function d(p=P.env){return p.comspec||"cmd.exe"}e.getWindowsShell=d;function h(p){let b=[],f=!1;const w=function(v){if(f){b.push(v);return}(!p.send(v,u=>{if(u&&console.error(u),f=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(k=>w(k))}})||t.isWindows)&&(f=!0)};return{send:w}}e.createQueuedSender=h;var y;(function(p){async function b(f,w,v){if(E.isAbsolute(f))return f;if(w===void 0&&(w=P.cwd()),E.dirname(f)!=="."||(v===void 0&&R.isString(P.env.PATH)&&(v=P.env.PATH.split(E.delimiter)),v===void 0||v.length===0))return E.join(w,f);async function u(g){if(await I.Promises.exists(g)){let k;try{k=await I.Promises.stat(g)}catch(S){S.message.startsWith("EACCES")&&(k=await I.Promises.lstat(g))}return k?!k.isDirectory():!1}return!1}for(const g of v){let k;if(E.isAbsolute(g)?k=E.join(g,f):k=E.join(w,g,f),await u(k))return k;let S=k+".com";if(await u(S)||(S=k+".exe",await u(S)))return S}return E.join(w,f)}p.findExecutable=b})(y=e.win32||(e.win32={}))}),define(te[103],ie([0,1,46,15]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(R){return new Promise((I,d)=>{let h;const y=new Map;function p(f,w,v,c,u){const g=y.get(w);if(f===R||g){const k={name:b(v),cmd:v,pid:f,ppid:w,load:c,mem:u};y.set(f,k),f===R&&(h=k),g&&(g.children||(g.children=[]),g.children.push(k),g.children.length>1&&(g.children=g.children.sort((S,L)=>S.pid-L.pid)))}}function b(f){const w=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,c=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,S=/\\pipe\\winpty-control/,L=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(k.exec(f))return"electron-crash-reporter";if(S.exec(f))return"winpty-process";if(L.exec(f))return"console-window-host (Windows internal process)";let l=i.exec(f);if(l&&l.length===2){if(l[1]==="renderer")return w.exec(f)?"shared-process":v.exec(f)?"issue-reporter":c.exec(f)?"process-explorer":"window";if(l[1]==="utility"){if(u.exec(f))return"utility-network-service";if(g.exec(f))return"extension-host"}else if(l[1]==="extensionHost")return"extension-host";return l[1]}const n=/[a-zA-Z-]+\.js/g;let o="";do l=n.exec(f),l&&(o+=l+" ");while(l);return o&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${o}`:f}if(process.platform==="win32"){const f=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,v)=>{V(["windows-process-tree"],w,v)}).then(w=>{w.getProcessList(R,v=>{if(!v){d(new Error(`Root process ${R} not found`));return}w.getProcessCpuUsage(v,c=>{const u=new Map;c.forEach(g=>{const k=f(g.commandLine||"");u.set(g.pid,{name:b(k),cmd:k,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),h=u.get(R),h?(u.forEach(g=>{const k=u.get(g.ppid);k&&(k.children||(k.children=[]),k.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((k,S)=>k.pid-S.pid))}),I(h)):d(new Error(`Root process ${R} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let f=function(){let w=[h];const v=[];for(;w.length;){const u=w.shift();u&&(v.push(u.pid),u.children&&(w=w.concat(u.children)))}let c=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+v.join(" "),(0,E.exec)(c,{},(u,g,k)=>{if(u||k)d(u||new Error(k.toString()));else{const S=g.toString().split(`
`);for(let L=0;L<v.length;L++){const i=y.get(v[L]);i.load=parseFloat(S[L])}if(!h){d(new Error(`Root process ${R} not found`));return}I(h)}})};(0,E.exec)("which ps",{},(w,v,c)=>{if(w||c)if(process.platform!=="linux")d(w||new Error(c.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(u,{},(g,k,S)=>{g||S?d(g||new Error(S.toString())):(D(k,p),f())})}else{const u=v.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,L)=>{k||L&&!L.includes("screen size is bogus")?d(k||new Error(L.toString())):(D(S,p),process.platform==="linux"?f():h?I(h):d(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=P;function D(R,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=R.toString().split(`
`);for(const y of h){const p=d.exec(y.trim());p&&p.length===6&&I(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(te[146],ie([0,1,26,4,145,85]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(p,b){return p===1?t.isWindows?y():D.getWindowsShell(b):d(p,b)}e.getSystemShell=R;let I=null;function d(p,b){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!I){let f;if(t.isWindows)f="/bin/bash";else{if(f=b.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}I=f}return I}let h=null;async function y(){return h||(h=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),h}});var pe=this&&this.__decorate||function(V,e,E,t){var P=arguments.length,D=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,E,t);else for(var I=V.length-1;I>=0;I--)(R=V[I])&&(D=(P<3?R(D):P>3?R(e,E,D):R(e,E))||D);return P>3&&D&&Object.defineProperty(e,E,D),D};define(te[47],ie([0,1,25,8,17,22,54,13,3,2,72,27,11]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f||(f={}));function w(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v||(v={}));function c(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));function g(F){let U=0;for(let z=0;;z+=7){const Q=F.read(1);if(U|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return U}}const k=n(0);function S(F,U){if(U===0){F.write(k);return}let z=0;for(let ne=U;ne!==0;ne=ne>>>7)z++;const Q=P.VSBuffer.alloc(z);for(let ne=0;U!==0;ne++)Q.buffer[ne]=U&127,U=U>>>7,U>0&&(Q.buffer[ne]|=128);F.write(Q)}class L{constructor(U){this.b=U,this.a=0}read(U){const z=this.b.slice(this.a,this.a+U);return this.a+=z.byteLength,z}}e.BufferReader=L;class i{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=i;var l;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(l||(l={}));function n(F){const U=P.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const o={Undefined:n(l.Undefined),String:n(l.String),Buffer:n(l.Buffer),VSBuffer:n(l.VSBuffer),Array:n(l.Array),Object:n(l.Object),Uint:n(l.Int)},s=typeof Buffer<"u";function a(F,U){if(typeof U>"u")F.write(o.Undefined);else if(typeof U=="string"){const z=P.VSBuffer.fromString(U);F.write(o.String),S(F,z.byteLength),F.write(z)}else if(s&&Buffer.isBuffer(U)){const z=P.VSBuffer.wrap(U);F.write(o.Buffer),S(F,z.byteLength),F.write(z)}else if(U instanceof P.VSBuffer)F.write(o.VSBuffer),S(F,U.byteLength),F.write(U);else if(Array.isArray(U)){F.write(o.Array),S(F,U.length);for(const z of U)a(F,z)}else if(typeof U=="number"&&(U|0)===U)F.write(o.Uint),S(F,U);else{const z=P.VSBuffer.fromString(JSON.stringify(U));F.write(o.Object),S(F,z.byteLength),F.write(z)}}e.serialize=a;function r(F){switch(F.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return F.read(g(F)).toString();case l.Buffer:return F.read(g(F)).buffer;case l.VSBuffer:return F.read(g(F));case l.Array:{const z=g(F),Q=[];for(let ne=0;ne<z;ne++)Q.push(r(F));return Q}case l.Object:return JSON.parse(F.read(g(F)).toString());case l.Int:return g(F)}}e.deserialize=r;class m{constructor(U,z,Q=null,ne=1e3){this.h=U,this.j=z,this.k=Q,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(U,z){this.b.set(U,z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const z=this.o([U.type]);this.k?.logOutgoing(z,0,1,c(U.type));return}case 201:case 202:case 204:case 203:{const z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(z,U.id,1,c(U.type),U.data);return}}}o(U,z=void 0){const Q=new i;return a(Q,U),a(Q,z),this.p(Q.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const z=new L(U),Q=r(z),ne=r(z),_=Q[0];switch(_){case 100:return this.k?.logIncoming(U.byteLength,Q[1],1,`${w(_)}: ${Q[2]}.${Q[3]}`,ne),this.s({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 102:return this.k?.logIncoming(U.byteLength,Q[1],1,`${w(_)}: ${Q[2]}.${Q[3]}`,ne),this.t({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 101:return this.k?.logIncoming(U.byteLength,Q[1],1,`${w(_)}`),this.u({type:_,id:Q[1]});case 103:return this.k?.logIncoming(U.byteLength,Q[1],1,`${w(_)}`),this.u({type:_,id:Q[1]})}}s(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=new D.CancellationTokenSource;let ne;try{ne=z.call(this.j,U.name,U.arg,Q.token)}catch(A){ne=Promise.reject(A)}const _=U.id;ne.then(A=>{this.m({id:_,data:A,type:201}),this.d.delete(U.id)},A=>{A instanceof Error?this.m({id:_,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.m({id:_,data:A,type:203}),this.d.delete(U.id)});const $=(0,h.toDisposable)(()=>Q.cancel());this.d.set(U.id,$)}t(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=U.id,_=z.listen(this.j,U.name,U.arg)($=>this.m({id:Q,data:$,type:204}));this.d.set(U.id,_)}u(U){const z=this.d.get(U.id);z&&(z.dispose(),this.d.delete(U.id))}v(U){let z=this.g.get(U.channelName);z||(z=[],this.g.set(U.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:U,timeoutTimer:Q})}w(U){const z=this.g.get(U);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,h.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=m;var C;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(U,z=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(U){const z=this;return{call(Q,ne,_){return z.a?Promise.reject(new I.CancellationError):z.m(U,Q,ne,_)},listen(Q,ne){return z.a?d.Event.None:z.o(U,Q,ne)}}}m(U,z,Q,ne=D.CancellationToken.None){const _=this.g++,A={id:_,type:100,channelName:U,name:z,arg:Q};if(ne.isCancellationRequested)return Promise.reject(new I.CancellationError);let T;return new Promise((j,K)=>{if(ne.isCancellationRequested)return K(new I.CancellationError);const N=()=>{const le=be=>{switch(be.type){case 201:this.f.delete(_),j(be.data);break;case 202:{this.f.delete(_);const Ce=new Error(be.data.message);Ce.stack=Array.isArray(be.data.stack)?be.data.stack.join(`
`):be.data.stack,Ce.name=be.data.name,K(Ce);break}case 203:this.f.delete(_),K(be.data);break}};this.f.set(_,le),this.p(A)};let q=null;this.b===u.Idle?N():(q=(0,t.createCancelablePromise)(le=>this.u()),q.then(()=>{q=null,N()}));const Z=()=>{q?(q.cancel(),q=null):this.p({id:_,type:101}),K(new I.CancellationError)},oe=ne.onCancellationRequested(Z);T=(0,h.combinedDisposable)((0,h.toDisposable)(Z),oe),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(U,z,Q){const ne=this.g++,$={id:ne,type:102,channelName:U,name:z,arg:Q};let A=null;const T=new d.Emitter({onWillAddFirstListener:()=>{A=(0,t.createCancelablePromise)(j=>this.u()),A.then(()=>{A=null,this.d.add(T),this.p($)})},onDidRemoveLastListener:()=>{A?(A.cancel(),A=null):(this.d.delete(T),this.p({id:ne,type:103}))}}),W=j=>T.fire(j.data);return this.f.set(ne,W),T.event}p(U){switch(U.type){case 100:case 102:{const z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(z,U.id,0,`${w(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const z=this.q([U.type,U.id]);this.j?.logOutgoing(z,U.id,0,w(U.type));return}}}q(U,z=void 0){const Q=new i;return a(Q,U),a(Q,z),this.r(Q.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const z=new L(U),Q=r(z),ne=r(z),_=Q[0];switch(_){case 200:return this.j?.logIncoming(U.byteLength,0,0,c(_)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Q[1],0,c(_),ne),this.t({type:Q[0],id:Q[1],data:ne})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,h.dispose)(this.d.values()),this.d.clear()}}pe([R.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class O{get connections(){const U=[];return this.f.forEach(z=>U.push(z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:z,onDidClientDisconnect:Q})=>{d.Event.once(z.onMessage)(_=>{const $=new L(_),A=r($),T=new m(z,A),W=new M(z);this.a.forEach((K,N)=>T.registerChannel(N,K));const j={channelServer:T,channelClient:W,ctx:A};this.f.add(j),this.g.fire(j),Q(()=>{T.dispose(),W.dispose(),this.f.delete(j),this.h.fire(j)})})})}getChannel(U,z){const Q=this;return{call(ne,_,$){let A;if((0,b.isFunction)(z)){const W=(0,E.getRandomElement)(Q.connections.filter(z));A=W?Promise.resolve(W):d.Event.toPromise(d.Event.filter(Q.onDidAddConnection,z))}else A=z.routeCall(Q,ne,_);const T=A.then(W=>W.channelClient.getChannel(U));return J(T).call(ne,_,$)},listen(ne,_){if((0,b.isFunction)(z))return Q.j(U,z,ne,_);const $=z.routeEvent(Q,ne,_).then(A=>A.channelClient.getChannel(U));return J($).listen(ne,_)}}}j(U,z,Q,ne){const _=this;let $=new h.DisposableStore;const A=new d.Emitter({onWillAddFirstListener:()=>{$=new h.DisposableStore;const T=new d.EventMultiplexer,W=new Map,j=N=>{const Z=N.channelClient.getChannel(U).listen(Q,ne),oe=T.add(Z);W.set(N,oe)},K=N=>{const q=W.get(N);!q||(q.dispose(),W.delete(N))};_.connections.filter(z).forEach(j),d.Event.filter(_.onDidAddConnection,z)(j,void 0,$),_.onDidRemoveConnection(K,void 0,$),T.event(A.fire,A,$),$.add(T)},onDidRemoveLastListener:()=>{$.dispose()}});return A.event}registerChannel(U,z){this.a.set(U,z),this.f.forEach(Q=>{Q.channelServer.registerChannel(U,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class B{constructor(U,z,Q=null){const ne=new i;a(ne,z),U.send(ne.buffer),this.a=new M(U,Q),this.d=new m(U,z,Q)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,z){this.d.registerChannel(U,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function J(F){return{call(U,z,Q){return F.then(ne=>ne.call(U,z,Q))},listen(U,z){const Q=new d.Relay;return F.then(ne=>Q.input=ne.listen(U,z)),Q.event}}}e.getDelayedChannel=J;function G(F){let U=!1;return{call(z,Q,ne){return U?F.call(z,Q,ne):(0,t.timeout)(0).then(()=>U=!0).then(()=>F.call(z,Q,ne))},listen(z,Q){if(U)return F.listen(z,Q);const ne=new d.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>ne.input=F.listen(z,Q)),ne.event}}}e.getNextTickChannel=G;class X{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const z of U.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await d.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=X;var re;(function(F){function U(_,$){const A=_,T=$&&$.disableMarshalling,W=new Map;for(const j in A)Q(j)&&W.set(j,d.Event.buffer(A[j],!0));return new class{listen(j,K,N){const q=W.get(K);if(q)return q;if(ne(K)){const Z=A[K];if(typeof Z=="function")return Z.call(A,N)}throw new Error(`Event not found: ${K}`)}call(j,K,N){const q=A[K];if(typeof q=="function"){if(!T&&Array.isArray(N))for(let Z=0;Z<N.length;Z++)N[Z]=(0,y.revive)(N[Z]);return q.apply(A,N)}throw new Error(`Method not found: ${K}`)}}}F.fromService=U;function z(_,$){const A=$&&$.disableMarshalling;return new Proxy({},{get(T,W){if(typeof W=="string")return $?.properties?.has(W)?$.properties.get(W):ne(W)?function(j){return _.listen(W,j)}:Q(W)?_.listen(W):async function(...j){let K;$&&!(0,b.isUndefinedOrNull)($.context)?K=[$.context,...j]:K=j;const N=await _.call(W,K);return A?N:(0,y.revive)(N)};throw new Error(`Property not found: ${String(W)}`)}})}F.toService=z;function Q(_){return _[0]==="o"&&_[1]==="n"&&p.isUpperAsciiLetter(_.charCodeAt(2))}function ne(_){return/^onDynamic/.test(_)&&p.isUpperAsciiLetter(_.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const U=F.toString();if(U!=="[object Object]")return U}return F}function fe(F){return Array.isArray(F)?F.map(ae):ae(F)}function ge(F,U,z,Q,ne,_,$){$=fe($);const A=se[ne],T=A[Q%A.length];let W=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(_)?(W=W.concat($),W.push(")")):W.push($),console.log.apply(console,W)}class H{constructor(U,z){this.d=U,this.f=z,this.a=0,this.b=0}logOutgoing(U,z,Q,ne,_){this.b+=U,ge(this.d,this.b,U,z,Q,ne,_)}logIncoming(U,z,Q,ne,_){this.a+=U,ge(this.f,this.a,U,z,Q,ne,_)}}e.IPCLogger=H}),define(te[147],ie([0,1,17,3,47]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(d){this.a=d,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",h=>E.VSBuffer.wrap(h.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.Protocol=D;class R extends P.IPCClient{constructor(d,h){const y=new D(d);super(y,h),this.b=y}dispose(){this.b.disconnect()}}e.Client=R}),define(te[104],ie([0,1,8,17,3,2,47]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var d;(function(M){M.enableDiagnostics=!1,M.records=[];const O=new WeakMap;let B=0;function J(X,re){if(!O.has(X)){const se=String(++B);O.set(X,se)}return O.get(X)}function G(X,re,se,ae){if(!M.enableDiagnostics)return;const fe=J(X,re);if(ae instanceof t.VSBuffer||ae instanceof Uint8Array||ae instanceof ArrayBuffer||ArrayBuffer.isView(ae)){const ge=t.VSBuffer.alloc(ae.byteLength);ge.set(ae),M.records.push({timestamp:Date.now(),id:fe,label:re,type:se,buff:ge})}else M.records.push({timestamp:Date.now(),id:fe,label:re,type:se,data:ae})}M.traceSocketEvent=G})(d=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function p(){return y||(y=t.VSBuffer.alloc(0)),y}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,B){if(O===0)return p();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const re=this.a[0];return B&&(this.a.shift(),this.b-=O),re}if(this.a[0].byteLength>O){const re=this.a[0].slice(0,O);return B&&(this.a[0]=this.a[0].slice(O),this.b-=O),re}const J=t.VSBuffer.alloc(O);let G=0,X=0;for(;O>0;){const re=this.a[X];if(re.byteLength>O){const se=re.slice(0,O);J.set(se,G),G+=O,B&&(this.a[X]=re.slice(O),this.b-=O),O-=O}else J.set(re,G),G+=re.byteLength,B?(this.a.shift(),this.b-=re.byteLength):X++,O-=re.byteLength}return J}}e.ChunkStream=b;var f;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function w(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(O,B,J,G){this.type=O,this.id=B,this.ack=J,this.data=G,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends D.Disposable{constructor(O){super(),this.f=this.B(new P.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new b,this.B(this.a.onData(B=>this.acceptChunk(B))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const B=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=B.readUInt32BE(9),this.g.messageType=B.readUInt8(0),this.g.id=B.readUInt32BE(1),this.g.ack=B.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const J=this.g.messageType,G=this.g.id,X=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",B),this.f.fire(new c(J,G,X,B)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const B=t.VSBuffer.alloc(13);B.writeUInt8(O.type,0),B.writeUInt32BE(O.id,1),B.writeUInt32BE(O.ack,5),B.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(B,O.data)}g(O,B){const J=this.f===0;return this.d.push(O,B),this.f+=O.byteLength+B.byteLength,J}h(){const O=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,B){this.g(O,B)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends D.Disposable{constructor(O){super(),this.f=new P.Emitter,this.onMessage=this.f.event,this.g=new P.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(B=>{B.type===1&&this.f.fire(B.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new c(1,0,0,O))}}e.Protocol=k;class S extends R.IPCClient{static fromSocket(O,B){return new S(new k(O),B)}get onDidDispose(){return this.b.onDidDispose}constructor(O,B,J=null){super(O,B,J),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=S;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new P.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class i{constructor(O){this.data=O,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let O=0,B=this.a;for(;B;)B=B.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let B=0,J=this.a;for(;J;)O[B++]=J.data,J=J.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const B=new i(O);if(!this.a){this.a=B,this.b=B;return}this.b.next=B,this.b=B}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const O=Date.now();for(let B=0;B<n.a;B++)this.c[B]=O-1e3*B;setInterval(()=>{for(let B=n.a;B>=1;B--)this.c[B]=this.c[B-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),B=(1+n.a)*1e3;let J=0;for(let G=0;G<n.a;G++)O-this.c[G]<=B&&J++;return 1-J/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var o;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function s(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=a;class r{constructor(O,B){this.roundTripTime=O,this.recentHighRoundTripCount=B}}e.HighRoundTripTimeEvent=r;class m{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??n.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=O.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(B=>this.E(B))),this.t.add(this.o.onClose(B=>this.A.fire(B))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(B=>this.J(B))),this.t.add(this.r.onHighRoundTripTime(B=>this.C.fire(B))),this.t.add(this.r.onDidChangeConnectionHealth(B=>this.D.fire(B))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new c(5,0,0,p());this.p.write(O),this.p.flush()}sendPause(){const O=new c(7,0,0,p());this.p.write(O)}sendResume(){const O=new c(8,0,0,p());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,B){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(J=>this.E(J))),this.t.add(this.o.onClose(J=>this.A.fire(J))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(J=>this.J(J))),this.t.add(this.r.onHighRoundTripTime(J=>this.C.fire(J))),this.t.add(this.r.onDidChangeConnectionHealth(J=>this.D.fire(J))),this.q.acceptChunk(B)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new c(3,0,this.h,p());this.p.write(O);const B=this.b.toArray();for(let J=0,G=B.length;J<G;J++)this.p.write(B[J]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const B=this.b.peek();if(B&&B.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const B=Date.now();B-this.m>1e4&&(this.m=B,this.p.write(new c(6,0,0,p())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const B=this.b.toArray();for(let J=0,G=B.length;J<G;J++)this.p.write(B[J]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const B=++this.c;this.h=this.g;const J=new c(1,B,this.h,O);this.b.push(J),this.a||(this.p.write(J),this.G())}sendControl(O){const B=new c(2,0,0,O);this.p.write(B)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),B=Date.now()-O.writtenTime,J=Date.now()-this.q.lastReadTime,G=Date.now()-this.n;if(B>=2e4&&J>=2e4&&G>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:B,timeSinceLastReceivedSomeData:J});return}const X=Math.max(2e4-B,2e4-J,2e4-G,500);this.f=setTimeout(()=>{this.f=null,this.G()},X)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new c(3,0,this.h,p());this.p.write(O)}I(){this.h=this.g;const O=new c(9,0,this.h,p());this.p.write(O)}J(O){this.h=this.g;const B=new c(10,0,this.h,O);this.p.write(B)}K(O){this.h=this.g;const B=new c(11,0,this.h,O);this.p.write(B)}}e.PersistentProtocol=m;class C extends D.Disposable{constructor(){super(),this.a=this.B(new P.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new P.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new P.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,B=t.VSBuffer.alloc(4);B.writeUInt32BE(O,0),this.a.fire(B)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const B=O.readUInt32BE(0);if(this.g<=0||B!==this.h)return;const J=Date.now()-this.g,G=this.k++;this.j[G%this.j.length]=J;const X=this.l,re=this.j.filter(se=>se>=1e3).length;this.l=re>=3?1:0,J>1e3&&this.b.fire(new r(J,re)),X!==this.l&&this.c.fire(this.l)}}}),define(te[148],ie([0,1,42,17,3,2,47,133]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,p){const b=P.Event.fromNodeEventEmitter(E.validatedIpcMain,p,(w,v)=>({event:w,message:v})),f=P.Event.filter(b,({event:w})=>w.sender.id===y);return P.Event.map(f,({message:w})=>w&&t.VSBuffer.wrap(w))}class h extends R.IPCServer{static d(){const p=P.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:b})=>b);return P.Event.map(p,b=>{const f=b.id;h.b.get(f)?.dispose();const v=new P.Emitter;h.b.set(f,(0,D.toDisposable)(()=>v.fire()));const c=d(f,"vscode:message"),u=P.Event.any(P.Event.signal(d(f,"vscode:disconnect")),v.event);return{protocol:new I.Protocol(b,c),onDidClientDisconnect:u}})}constructor(){super(h.d())}}e.Server=h,h.b=new Map}),define(te[105],ie([0,1,42,3,31,147]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends D.Client{constructor(h,y){super({addEventListener:(p,b)=>h.addListener(p,b),removeEventListener:(p,b)=>h.removeListener(p,b),postMessage:p=>h.postMessage(p),start:()=>h.start(),close:()=>h.close()},y)}}e.Client=R;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,P.generateUuid)();d.webContents.send("vscode:createMessageChannel",h);const y=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(b,f)=>({nonce:f,port:b.ports[0]})),{port:p}=await t.Event.toPromise(t.Event.once(t.Event.filter(y,b=>b.nonce===h)));return p}e.connect=I}),define(te[149],ie([0,1,46,8,17,22,142,13,3,2,44,85,82,47]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends f.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",g=>P.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=w;class v{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const k=g&&g.timeout?g.timeout:6e4;this.b=new t.Delayer(k),this.d=null,this.f=null}getChannel(u){const g=this;return{call(k,S,L){return g.k(u,k,S,L)},listen(k,S){return g.l(u,k,S)}}}k(u,g,k,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const L=this.n(u),i=(0,t.createCancelablePromise)(o=>L.call(g,k,o)),l=S.onCancellationRequested(()=>i.cancel()),n=(0,h.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{l.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,g,k){if(!this.b)return d.Event.None;this.b.cancel();let S;const L=new d.Emitter({onWillAddFirstListener:()=>{S=this.n(u).listen(g,k)(L.fire,L),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,b.removeDangerousEnvVariables)(g.env),this.d=(0,E.fork)(this.i,u,g);const k=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,R.isRemoteConsoleLog)(s)){(0,R.log)(s,`IPC Library: ${this.j.serverName}`);return}k.fire(P.VSBuffer.wrap(Buffer.from(s,"base64")))});const L=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&L.send(s.buffer.toString("base64")),l=k.event,n={send:i,onMessage:l};this.f=new f.ChannelClient(n);const o=()=>this.o();process.once("exit",o),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",o),this.c.forEach(r=>(0,h.dispose)(r)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(te[86],ie([0,1,17,13,3,2,9,4,31,47,104]),function(V,e,E,t,P,D,R,I,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function p(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(r,m){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,m)}constructor(r,m=""){this.f=!0,this.debugLabel=m,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,t.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const m=C=>{this.traceSocketEvent("read",C),r(E.VSBuffer.wrap(C))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(r){const m=C=>{r({type:0,hadError:C,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(r){const m=()=>{r()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=b;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var w;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(w||(w={}));class v extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,m){this.socket.traceSocketEvent(r,m)}constructor(r,m,C,M){super(),this.f=this.B(new P.Emitter),this.g=this.B(new P.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:C?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new c(this,m,C,M,this.f,(O,B)=>this.k(O,B))),this.B(this.a.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new y.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,m){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let C=2;r.byteLength<126?C+=0:r.byteLength<2**16?C+=2:C+=8;const M=E.VSBuffer.alloc(C);if(m?M.writeUInt8(194,0):M.writeUInt8(130,0),r.byteLength<126)M.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){M.writeUInt8(126,1);let O=1;M.writeUInt8(r.byteLength>>>8&255,++O),M.writeUInt8(r.byteLength>>>0&255,++O)}else{M.writeUInt8(127,1);let O=1;M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(r.byteLength>>>24&255,++O),M.writeUInt8(r.byteLength>>>16&255,++O),M.writeUInt8(r.byteLength>>>8&255,++O),M.writeUInt8(r.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([M,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),C=m.readUInt8(0),M=(C&128)>>>7,O=(C&64)>>>6,B=m.readUInt8(1),J=(B&128)>>>7,G=B&127;this.j.state=2,this.j.readLen=2+(J?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),C=m.readUInt8(1),M=(C&128)>>>7;let O=C&127,B=1;O===126?O=m.readUInt8(++B)*2**8+m.readUInt8(++B):O===127&&(O=m.readUInt8(++B)*0+m.readUInt8(++B)*0+m.readUInt8(++B)*0+m.readUInt8(++B)*0+m.readUInt8(++B)*2**24+m.readUInt8(++B)*2**16+m.readUInt8(++B)*2**8+m.readUInt8(++B));let J=0;M&&(J=m.readUInt8(++B)*2**24+m.readUInt8(++B)*2**16+m.readUInt8(++B)*2**8+m.readUInt8(++B)),this.j.state=3,this.j.readLen=O,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),k(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(m,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class c extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(r,m,C,M,O,B){super(),this.k=r,this.l=O,this.m=B,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,m?(this.b=this.B(new u(this.k,M,C,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const m=await this.r(this.f,r);this.m(m,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,m){return new Promise((C,M)=>{r.write(m),r.flush(O=>C(O))})}acceptFrame(r,m,C){this.h.push({data:r,isCompressed:m,isLastFrameOfMessage:C}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const m=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(m)}else this.l.fire(r.data)}this.s=!1}}u(r,m,C){return new Promise((M,O)=>{r.write(m),C&&r.write(E.VSBuffer.fromByteArray([0,0,255,255])),r.flush(B=>M(B))})}}class u extends D.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(r,m,C,M){super(),this.h=r,this.j=m,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=p().zlib.createInflateRaw(M),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=E.VSBuffer.concat(this.g);this.g.length=0,r(m)})}}class g extends D.Disposable{constructor(r,m){super(),this.g=r,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.b=p().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(E.VSBuffer.wrap(C))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=E.VSBuffer.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),r(m)})}}function k(a,r){if(r===0)return;const m=a.byteLength>>>2;for(let G=0;G<m;G++){const X=a.readUInt32BE(G*4);a.writeUInt32BE(X^r,G*4)}const C=m*4,M=a.byteLength-C,O=r>>>24&255,B=r>>>16&255,J=r>>>8&255;M>=1&&a.writeUInt8(a.readUInt8(C)^O,C),M>=2&&a.writeUInt8(a.readUInt8(C+1)^B,C+1),M>=3&&a.writeUInt8(a.readUInt8(C+2)^J,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function L(){const a=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):r=(0,R.join)(p().os.tmpdir(),`vscode-ipc-${a}.sock`),l(r),r}e.createRandomIPCHandle=L;function i(a,r,m){const C=p().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${m}-${r}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${C.substr(0,8)}-${m}-${r}.sock`):M=(0,R.join)(a,`${m}-${r}.sock`),l(M),M}e.createStaticIPCHandle=i;function l(a){const r=S[I.platform];typeof r=="number"&&a.length>=r&&console.warn(`WARNING: IPC handle "${a}" is longer than ${r} chars, try a shorter --user-data-dir`)}class n extends h.IPCServer{static b(r){const m=P.Event.fromNodeEventEmitter(r,"connection");return P.Event.map(m,C=>({protocol:new y.Protocol(new b(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(r){super(n.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function o(a){return new Promise((r,m)=>{const C=p().net.createServer();C.on("error",m),C.listen(a,()=>{C.removeListener("error",m),r(new n(C))})})}e.serve=o;function s(a,r){return new Promise((m,C)=>{const M=p().net.createConnection(a,()=>{M.removeListener("error",C),m(y.Client.fromSocket(new b(M,`ipc-client${r}`),r))});M.once("error",C)})}e.connect=s}),define(te[106],ie([0,1,8,3,2,11]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R=e.StorageHint||(e.StorageHint={}));function I(p){const b=p;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class h extends P.Disposable{constructor(b,f=Object.create(null)){super(),this.m=b,this.n=f,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new E.ThrottledDelayer(h.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((f,w)=>this.s(w,f)),b.deleted?.forEach(f=>this.s(f,void 0))}s(b,f){if(this.c===d.Closed)return;let w=!1;(0,D.isUndefinedOrNull)(f)?w=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),w=!0),w&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,f){const w=this.f.get(b);return(0,D.isUndefinedOrNull)(w)?f:w}getBoolean(b,f){const w=this.get(b);return(0,D.isUndefinedOrNull)(w)?f:w==="true"}getNumber(b,f){const w=this.get(b);return(0,D.isUndefinedOrNull)(w)?f:parseInt(w,10)}async set(b,f){if(this.c===d.Closed)return;if((0,D.isUndefinedOrNull)(f))return this.delete(b);const w=String(f);if(this.f.get(b)!==w)return this.f.set(b,w),this.j.set(b,w),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===d.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=h,h.a=100;class y{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,w)=>this.a.set(w,f)),b.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=y}),define(te[150],ie([0,1,8,3,38,9,23]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return t.Event.None}constructor(y,p=Object.create(null)){this.g=y,this.h=p,this.c=(0,D.basename)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,p=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(f=>p.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems(y){const p=await this.f;return this.j(p,y)}j(y,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,P.mapToString)(p.insert):"0"}), delete(${p.delete?(0,P.setToString)(p.delete):"0"})`),this.t(y,()=>{const b=p.insert,f=p.delete;if(b&&b.size>0){const w=[];w.push([]);let v=0;b.forEach((c,u)=>{let g=w[v];g.length>I.b&&(v++,g=[],w.push(g)),g.push(u,c)}),w.forEach(c=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(c.length/2).fill("(?,?)").join(",")}`,u=>u.run(c),()=>{const u=[];let g=0;return b.forEach((k,S)=>{u.push(S),g+=k.length}),`Keys: ${u.join(", ")} Length: ${g}`})})}if(f&&f.size){const w=[];w.push([]);let v=0;f.forEach(c=>{let u=w[v];u.length>I.b&&(v++,u=[],w.push(u)),u.push(c)}),w.forEach(c=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(c.length).fill("?").join(",")})`,u=>u.run(c),()=>{const u=[];return f.forEach(g=>{u.push(g)}),`Keys: ${u.join(", ")}`})})}})}async close(y){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,y)}k(y,p){return new Promise((b,f)=>{y.db.close(w=>(w&&this.o(y,`[storage ${this.c}] close(): ${w}`),this.g===I.IN_MEMORY_PATH?b():!y.isErroneous&&!y.isInMemory?this.l().then(b,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),b())):typeof p=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const c=()=>this.k(v,void 0);return this.j(v,{insert:p()}).then(()=>c(),u=>(c(),Promise.reject(u)))})).then(b,f):f(w||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return R.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const p=await this.f,b=await this.r(p,y?"PRAGMA integrity_check":"PRAGMA quick_check"),f=y?b.integrity_check:b.quick_check;return p.isErroneous?`${f} (last error: ${p.lastError})`:p.isInMemory?`${f} (in-memory!)`:f}async n(y,p=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${p})`);try{return await this.p(y)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&p)return await(0,E.timeout)(I.a),this.n(y,!1);try{await R.Promises.unlink(y);try{await R.Promises.rename(this.m(y),y)}catch{}return await this.p(y)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(I.IN_MEMORY_PATH)}}}o(y,p){y.isErroneous=!0,y.lastError=p,this.d.error(p)}p(y){return new Promise((p,b)=>{new Promise((f,w)=>{V(["@vscode/sqlite3"],f,w)}).then(f=>{const w={db:new(this.d.isTracing?f.verbose().Database:f.Database)(y,v=>v?w.db&&v.code!=="SQLITE_CANTOPEN"?w.db.close(()=>b(v)):b(v):this.q(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(w),c=>w.db.close(()=>b(c)))),isInMemory:y===I.IN_MEMORY_PATH};w.db.on("error",v=>this.o(w,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&w.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},b)})}q(y,p){return new Promise((b,f)=>{y.db.exec(p,w=>w?(this.o(y,`[storage ${this.c}] exec(): ${w}`),f(w)):b())})}r(y,p){return new Promise((b,f)=>{y.db.get(p,(w,v)=>w?(this.o(y,`[storage ${this.c}] get(): ${w}`),f(w)):b(v))})}s(y,p){return new Promise((b,f)=>{y.db.all(p,(w,v)=>w?(this.o(y,`[storage ${this.c}] all(): ${w}`),f(w)):b(v))})}t(y,p){return new Promise((b,f)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),p(),y.db.run("END TRANSACTION",w=>w?(this.o(y,`[storage ${this.c}] transaction(): ${w}`),f(w)):b())})})}u(y,p,b,f){const w=y.db.prepare(p),v=c=>{this.o(y,`[storage ${this.c}] prepare(): ${c} (${p}). Details: ${f()}`)};w.on("error",v),b(w),w.finalize(c=>{c&&v(c),w.removeListener("error",v)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.a=2e3,I.b=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.a=y.logTrace),y&&typeof y.logError=="function"&&(this.b=y.logError)}get isTracing(){return!!this.a}trace(y){this.a?.(y)}error(y){this.b?.(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[151],ie([12,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(te[152],ie([12,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[153],ie([12,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[154],ie([12,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(te[155],ie([12,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(te[156],ie([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[157],ie([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[158],ie([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[159],ie([12,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[160],ie([12,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[161],ie([12,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(te[162],ie([12,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(te[163],ie([12,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(te[164],ie([12,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[165],ie([12,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[166],ie([12,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[167],ie([12,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[168],ie([12,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[169],ie([12,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(te[170],ie([12,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(te[171],ie([12,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[172],ie([12,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(te[173],ie([12,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[174],ie([12,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[175],ie([12,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[176],ie([12,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(te[177],ie([12,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[178],ie([12,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[179],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(P){return P&&P.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(P){return P&&P.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[180],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function P(R){let I=[];try{Array.isArray(R.workspaces)&&(I=R.workspaces.map(d=>({workspace:{id:d.id,configPath:E.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=P;function D(R){let I=[];try{Array.isArray(R.folders)&&(I=R.folders.map(d=>({folderUri:E.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=D}),define(te[181],ie([0,1,3,2]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(I,d,h){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(I,d,h){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class D extends t.Disposable{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,d,h){this.b.call("attach",[I,d,h])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,d){this.b.call("terminate",[I,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.b.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=D}),define(te[182],ie([0,1,136,54,15,9,35,20,7]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,D.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=R.env.VSCODE_PORTABLE;return w?d.URI.file((0,D.join)(w,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.resolve)(w):(0,D.normalize)((0,D.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?d.URI.file((0,D.resolve)(w)):d.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.resolve)(w);const v=R.env.VSCODE_EXTENSIONS;if(v)return v;const c=R.env.VSCODE_PORTABLE;return c?(0,D.join)(c,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(v=>/^[^:/?#]+?:\/\//.test(v)?d.URI.parse(v):d.URI.file((0,D.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,D.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(w))}get extensionLogLevel(){const w=[];for(const v of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);c&&c[1]&&c[2]&&w.push([c[1],c[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=R.env.VSCODE_PORTABLE;return w?d.URI.file((0,D.join)(w,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,v,c){this.a=w,this.b=v,this.c=c,this.editSessionId=this.args.editSessionId}}pe([t.memoize],h.prototype,"appRoot",null),pe([t.memoize],h.prototype,"userHome",null),pe([t.memoize],h.prototype,"userDataPath",null),pe([t.memoize],h.prototype,"appSettingsHome",null),pe([t.memoize],h.prototype,"tmpDir",null),pe([t.memoize],h.prototype,"cacheHome",null),pe([t.memoize],h.prototype,"stateResource",null),pe([t.memoize],h.prototype,"userRoamingDataHome",null),pe([t.memoize],h.prototype,"userDataSyncHome",null),pe([t.memoize],h.prototype,"userDataSyncLogResource",null),pe([t.memoize],h.prototype,"editSessionsLogResource",null),pe([t.memoize],h.prototype,"sync",null),pe([t.memoize],h.prototype,"machineSettingsResource",null),pe([t.memoize],h.prototype,"workspaceStorageHome",null),pe([t.memoize],h.prototype,"localHistoryHome",null),pe([t.memoize],h.prototype,"keyboardLayoutResource",null),pe([t.memoize],h.prototype,"argvResource",null),pe([t.memoize],h.prototype,"isExtensionDevelopment",null),pe([t.memoize],h.prototype,"untitledWorkspacesHome",null),pe([t.memoize],h.prototype,"installSourcePath",null),pe([t.memoize],h.prototype,"builtinExtensionsPath",null),pe([t.memoize],h.prototype,"extensionsPath",null),pe([t.memoize],h.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],h.prototype,"extensionDevelopmentKind",null),pe([t.memoize],h.prototype,"extensionTestsLocationURI",null),pe([t.memoize],h.prototype,"debugExtensionHost",null),pe([t.memoize],h.prototype,"logLevel",null),pe([t.memoize],h.prototype,"extensionLogLevel",null),pe([t.memoize],h.prototype,"serviceMachineIdResource",null),pe([t.memoize],h.prototype,"telemetryLogResource",null),pe([t.memoize],h.prototype,"disableWorkspaceTrust",null),pe([t.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function y(f,w){return b(f["inspect-extensions"],f["inspect-brk-extensions"],5870,w,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=y;function p(f,w){return b(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,w,f.extensionEnvironment)}e.parsePtyHostPort=p;function b(f,w,v,c,u,g){const S=Number(w||f)||(c?null:v),L=S?Boolean(!!w):!1;let i;if(g)try{i=JSON.parse(g)}catch{}return{port:S,break:L,debugId:u,env:i}}}),define(te[107],ie([0,1,286,4,154]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},category:{type:"string",cat:"e",description:(0,P.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,c,u=R){const g=v.find(a=>a.length>0&&a[0]!=="-"),k={},S=["_"],L=[],i={};let l;for(const a in c){const r=c[a];r.type==="subcommand"?a===g&&(l=r):(r.alias&&(k[a]=r.alias),r.type==="string"||r.type==="string[]"?(S.push(a),r.deprecates&&S.push(...r.deprecates)):r.type==="boolean"&&(L.push(a),r.deprecates&&L.push(...r.deprecates)),r.global&&(i[a]=r))}if(l&&g){const a=i;for(const M in l.options)a[M]=l.options[M];const r=v.filter(M=>M!==g),m=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,C=I(r,a,m);return{[g]:C,_:[]}}const n=E(v,{string:S,boolean:L,alias:k}),o={},s=n;o._=n._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in c){const r=c[a];if(r.type==="subcommand")continue;r.alias&&delete s[r.alias];let m=s[a];if(r.deprecates)for(const C of r.deprecates)s.hasOwnProperty(C)&&(m||(m=s[C],m&&u.onDeprecatedOption(C,r.deprecationMessage||(0,P.localize)(36,null,a))),delete s[C]);if(typeof m<"u"){if(r.type==="string[]"){if(Array.isArray(m)||(m=[m]),!r.allowEmptyValue){const C=m.filter(M=>M.length>0);C.length!==m.length&&(u.onEmptyValue(a),m=C.length>0?C:void 0)}}else r.type==="string"&&(Array.isArray(m)?(m=m.pop(),u.onMultipleValues(a,m)):!m&&!r.allowEmptyValue&&(u.onEmptyValue(a),m=void 0));o[a]=m,r.deprecationMessage&&u.onDeprecatedOption(a,r.deprecationMessage)}delete s[a]}for(const a in s)u.onUnknownOption(a);return o}e.parseArgs=I;function d(v,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${v}${u}`:`--${v}${u}`}function h(v,c){const u=[];for(const g in v){const k=v[g],S=d(g,k);u.push([S,k.description])}return y(u,c)}e.formatOptions=h;function y(v,c){const g=v.reduce((L,i)=>Math.max(L,i[0].length),12)+2+1;if(c-g<25)return v.reduce((L,i)=>L.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const k=c-g-1,S=[];for(const L of v){const i=L[0],l=b(L[1],k),n=p(g-i.length-2);S.push("  "+i+n+l[0]);for(let o=1;o<l.length;o++)S.push(p(g)+l[o])}return S}function p(v){return" ".repeat(v)}function b(v,c){const u=[];for(;v.length;){const g=v.length<c?v.length:v.lastIndexOf(" ",c),k=v.slice(0,g).trim();v=v.slice(g),u.push(k)}return u}function f(v,c,u,g,k){const S=process.stdout.isTTY&&process.stdout.columns||80,L=k?.noInputFiles!==!0?`[${(0,P.localize)(37,null)}...]`:"",i=[`${v} ${u}`];i.push(""),i.push(`${(0,P.localize)(38,null)}: ${c} [${(0,P.localize)(39,null)}]${L}`),i.push(""),k?.noPipe!==!0&&(t.isWindows?i.push((0,P.localize)(40,null,c)):i.push((0,P.localize)(41,null,c)),i.push(""));const l={},n=[];for(const o in g){const s=g[o];if(s.type==="subcommand")s.description&&n.push({command:o,description:s.description});else if(s.description&&s.cat){let a=l[s.cat];a||(l[s.cat]=a={}),a[o]=s}}for(const o in l){const s=o,a=l[s];a&&(i.push(D[s]),i.push(...h(a,S)),i.push(""))}return n.length&&(i.push((0,P.localize)(42,null)),i.push(...y(n.map(o=>[o.command,o.description]),S)),i.push("")),i.join(`
`)}e.buildHelpMessage=f;function w(v,c){return`${v||(0,P.localize)(43,null)}
${c||(0,P.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(te[183],ie([0,1,81,181,107]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends t.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.f=I}call(I,d,h){return d==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(I,d,h)}async g(I,d){const h=(0,P.parseArgs)(I,P.OPTIONS);h.debugRenderer=d;const y=h.extensionDevelopmentPath;if(!y)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!d)return{success:!0};const b=p.win;if(!b)return{success:!0};const f=b.webContents.debugger;let w=f.isAttached()?1/0:0;const v=(0,E.createServer)(c=>{w++===0&&f.attach();let u=!1;const g=L=>{u||c.write(JSON.stringify(L)+"\0")},k=(L,i,l,n)=>g({method:i,params:l,sessionId:n});b.on("close",()=>{f.removeListener("message",k),c.end(),u=!0}),f.addListener("message",k);let S=Buffer.alloc(0);c.on("data",L=>{S=Buffer.concat([S,L]);for(let i=S.indexOf(0);i!==-1;i=S.indexOf(0)){let l;try{const n=S.slice(0,i).toString("utf8");S=S.slice(i+1),l=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(l.method,l.params,l.sessionId).then(n=>g({id:l.id,sessionId:l.sessionId,result:n})).catch(n=>g({id:l.id,sessionId:l.sessionId,error:{code:0,message:n.message}}))}}),c.on("error",L=>{console.error("error on cdp pipe:",L)}),c.on("close",()=>{u=!0,--w===0&&f.detach()})});return await new Promise(c=>v.listen(0,c)),b.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(te[61],ie([0,1,287,155,107]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function R(b,f){const w=(S,L)=>{console.warn((0,t.localize)(0,null,S,L))},v=S=>{console.warn((0,t.localize)(1,null,S))},c=(S,L)=>{console.warn((0,t.localize)(2,null,S,L))},u=S=>({onUnknownOption:L=>{S!=="tunnel"&&console.warn((0,t.localize)(3,null,L,S))},onMultipleValues:w,onEmptyValue:v,onDeprecatedOption:c,getSubcommandReporter:S!=="tunnel"?u:void 0}),g={onUnknownOption:S=>{console.warn((0,t.localize)(4,null,S))},onMultipleValues:w,onEmptyValue:v,onDeprecatedOption:c,getSubcommandReporter:u},k=(0,P.parseArgs)(b,P.OPTIONS,f?g:void 0);return k.goto&&k._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,t.localize)(5,null))),k["max-memory"]&&E(parseInt(k["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),k}function I(b){const f=b.findIndex(w=>!/^-/.test(w));if(f>-1)return[...b.slice(0,f),...b.slice(f+1)]}function d(b){let[,...f]=b;process.env.VSCODE_DEV&&(f=I(f)||[]);const w=!p(process.env);return R(f,w)}e.parseMainProcessArgv=d;function h(b){let[,,...f]=b;return process.env.VSCODE_DEV&&(f=I(f)||[]),R(f,!0)}e.parseCLIProcessArgv=h;function y(b,...f){const w=b.indexOf("--");return w===-1?b.push(...f):b.splice(w,0,...f),b}e.addArg=y;function p(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function V(e,E,t){function P(R,I){const d=D(R,I),h=[d];return e.isAbsolute(d)||h.unshift(t),e.resolve(...h)}function D(R,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,I);const y=R["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(p,"AppData","Roaming")}break;case"darwin":h=e.join(E.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,I)}return{getUserDataPath:P}}if(typeof define=="function")define(te[184],ie([185,26,35]),function(e,E,t){return V(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=V(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[186],ie([0,1,26,182,184]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends t.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I,d.nameShort)},d)}}e.NativeEnvironmentService=D}),define(te[187],ie([0,1,41,26,32]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function D(R){const I=(0,P.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(I,""),R&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){R&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFileSync=D}),define(te[188],ie([0,1,11,157]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(R,I,d){try{D(R,I,d)}catch(h){console.error(h?.message??h)}return R}e.localizeManifest=P;function D(R,I,d){const h=(y,p,b)=>{const f=y[p];if((0,E.isString)(f)){const w=f,v=w.length;if(v>1&&w[0]==="%"&&w[v-1]==="%"){const c=w.substr(1,v-2);let u=I[c];u===void 0&&d&&(u=d[c]);const g=typeof u=="string"?u:u?.message,k=d?.[c],S=typeof k=="string"?k:k?.message;if(!g){S||console.warn(`[${R.name}]: ${(0,t.localize)(0,null,c)}`);return}if(b&&(p==="title"||p==="category")&&S&&S!==g){const L={value:g,original:S};y[p]=L}else y[p]=g}}else if((0,E.isObject)(f))for(const w in f)f.hasOwnProperty(w)&&(w==="commands"?h(f,w,!0):h(f,w,b));else if(Array.isArray(f))for(let w=0;w<f.length;w++)h(f,w,b)};for(const y in R)R.hasOwnProperty(y)&&h(R,y)}}),define(te[189],ie([0,1,13]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(D,R){this.a.set(D,R)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const R in D.contributes){const I=this.a.get(R);if(!I)continue;const d=D.contributes[R],h=Array.isArray(d)?d:[d];try{I(h,D.activationEvents)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(te[190],ie([0,1,20,83,159,191]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function d(u){return u=u.trim(),u==="*"||R.test(u)}e.isValidVersionStr=d;function h(u){if(!d(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=h;function y(u){if(!u)return null;const g=u.majorBase,k=u.majorMustEqual,S=u.minorBase;let L=u.minorMustEqual;const i=u.patchBase;let l=u.patchMustEqual;u.hasCaret&&(g===0||(L=!1),l=!1);let n=0;if(u.preRelease){const o=I.exec(u.preRelease);if(o){const[,s,a,r]=o;n=Date.UTC(Number(s),Number(a)-1,Number(r))}}return{majorBase:g,majorMustEqual:k,minorBase:S,minorMustEqual:L,patchBase:i,patchMustEqual:l,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=y;function p(u,g,k){let S;typeof u=="string"?S=y(h(u)):S=u;let L;g instanceof Date?L=g.getTime():typeof g=="string"&&(L=new Date(g).getTime());let i;if(typeof k=="string"?i=y(h(k)):i=k,!S||!i)return!1;const l=S.majorBase,n=S.minorBase,o=S.patchBase;let s=i.majorBase,a=i.minorBase,r=i.patchBase;const m=i.notBefore;let C=i.majorMustEqual,M=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?l>s?!0:l<s?!1:n>a?!0:n<a||L&&L<m?!1:o>=r:(l===1&&s===0&&(!C||!M||!O)&&(s=1,a=0,r=0,C=!0,M=!1,O=!1),l<s?!1:l>s?!C:n<a?!1:n>a?!M:o<r?!1:o>r?!O:!(L&&L<m))}e.isValidVersion=p;function b(u,g,k,S,L){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof S.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!S.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!c(S.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!c(S.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const o=(0,E.joinPath)(k,S.main);(0,E.isEqualOrParent)(o,k)||i.push([t.default.Warning,P.localize(10,null,o.path,k.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const o=(0,E.joinPath)(k,S.browser);(0,E.isEqualOrParent)(o,k)||i.push([t.default.Warning,P.localize(13,null,o.path,k.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!D.valid(S.version))return i.push([t.default.Error,P.localize(15,null)]),i;const l=[];if(!f(u,g,S,L,l))for(const o of l)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=b;function f(u,g,k,S,L){return S||typeof k.main>"u"&&typeof k.browser>"u"?!0:v(u,g,k.engines.vscode,L)}e.isValidExtensionVersion=f;function w(u,g,k){return u==="*"||v(g,k,u)}e.isEngineValid=w;function v(u,g,k,S=[]){const L=y(h(k));if(!L)return S.push(P.localize(16,null,k)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return S.push(P.localize(17,null,k)),!1}else if(!L.majorMustEqual)return S.push(P.localize(18,null,k)),!1;return p(u,g,L)?!0:(S.push(P.localize(19,null,u,k)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let g=0,k=u.length;g<k;g++)if(typeof u[g]!="string")return!1;return!0}}),define(te[192],ie([0,1,17,31]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(D,R,I){let d=I&&I.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const y=(await R.readFile(D.serviceMachineIdResource)).value.toString();d=(0,t.isUUID)(y)?y:null}catch{d=null}if(!d){d=(0,t.generateUuid)();try{await R.writeFile(D.serviceMachineIdResource,E.VSBuffer.fromString(d))}catch{}}return I?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=P}),define(te[73],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(P,D=[],R=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=E}),define(te[193],ie([0,1,73]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function D(I,d,h){d instanceof E.SyncDescriptor||(d=new E.SyncDescriptor(d,[],Boolean(h))),t.push([I,d])}e.registerSingleton=D;function R(){return t}e.getSingletonServiceDescriptors=R}),define(te[194],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(D,R){this.key=D,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const R of this.a.values())R.outgoing.size===0&&D.push(R);return D}insertEdge(D,R){const I=this.lookupOrInsertNode(D),d=this.lookupOrInsertNode(R);I.outgoing.set(d.key,d),d.incoming.set(I.key,I)}removeNode(D){const R=this.b(D);this.a.delete(R);for(const I of this.a.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(D){const R=this.b(D);let I=this.a.get(R);return I||(I=new E(R,D),this.a.set(R,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[R,I]of this.a)D.push(`${R}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,R]of this.a){const I=new Set([D]),d=this.c(R,I);if(d)return d}}c(D,R){for(const[I,d]of D.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const h=this.c(d,R);if(h)return h;R.delete(I)}}}e.Graph=t}),define(te[6],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=I})(E=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(R,I,d){I[E.DI_TARGET]===I?I[E.DI_DEPENDENCIES].push({id:R,index:d}):(I[E.DI_DEPENDENCIES]=[{id:R,index:d}],I[E.DI_TARGET]=I)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const I=function(d,h,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,d,y)};return I.toString=()=>R,E.serviceIds.set(R,I),I}e.createDecorator=P;function D(R){return R}e.refineServiceDecorator=D}),define(te[62],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(te[18],ie([0,1,11,7,6]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=D;function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=R;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function h(u,g){const k=Object.create(null);for(const S in u)y(k,S,u[S],g);return k}e.toValuesTree=h;function y(u,g,k,S){const L=g.split("."),i=L.pop();let l=u;for(let n=0;n<L.length;n++){const o=L[n];let s=l[o];switch(typeof s){case"undefined":s=l[o]=Object.create(null);break;case"object":break;default:S(`Ignoring ${g} as ${L.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}l=s}if(typeof l=="object"&&l!==null)try{l[i]=k}catch{S(`Ignoring ${g} as ${L.join(".")} is ${JSON.stringify(l)}`)}else S(`Ignoring ${g} as ${L.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=y;function p(u,g){const k=g.split(".");b(u,k)}e.removeFromValueTree=p;function b(u,g){const k=g.shift();if(g.length===0){delete u[k];return}if(Object.keys(u).indexOf(k)!==-1){const S=u[k];typeof S=="object"&&!Array.isArray(S)&&(b(S,g),Object.keys(S).length===0&&delete u[k])}}function f(u,g,k){function S(l,n){let o=l;for(const s of n){if(typeof o!="object"||o===null)return;o=o[s]}return o}const L=g.split("."),i=S(u,L);return typeof i>"u"?k:i}e.getConfigurationValue=f;function w(u,g,k){Object.keys(g).forEach(S=>{S!=="__proto__"&&(S in u?E.isObject(u[S])&&E.isObject(g[S])?w(u[S],g[S],k):k&&(u[S]=g[S]):u[S]=g[S])})}e.merge=w;function v(u,g,k){const S=u.inspect(g),L=u.inspect(k);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof L.userValue<"u"||typeof L.workspaceValue<"u"||typeof L.workspaceFolderValue<"u"?L.value:S.defaultValue}e.getMigratedSettingValue=v;function c(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(te[74],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(D,R){return this.a[D]?.[R]??null}async setPassword(D,R,I){this.a[D]=this.a[D]??{},this.a[D][R]=I}async deletePassword(D,R){return this.a[D]?.[R]?(delete this.a[D][R],Object.keys(this.a[D]).length===0&&delete this.a[D],!0):!1}async findPassword(D){return JSON.stringify(this.a[D])??null}async findCredentials(D){const R=[];for(const I of Object.keys(this.a[D]||{}))R.push({account:I,password:this.a[D][I]});return R}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(te[87],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=t;class P{async getPerformanceInfo(R,I){return{}}async getSystemInfo(R,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,I){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=P}),define(te[108],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(te[33],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ie([0,1,54,9,86,33,186,6]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(D.IEnvironmentService);class d extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,P.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],d.prototype,"cachedLanguagesPath",null),pe([E.memoize],d.prototype,"backupHome",null),pe([E.memoize],d.prototype,"mainIPCHandle",null),pe([E.memoize],d.prototype,"mainLockfile",null),pe([E.memoize],d.prototype,"disableUpdates",null),pe([E.memoize],d.prototype,"disableKeytar",null),pe([E.memoize],d.prototype,"crossOriginIsolated",null),pe([E.memoize],d.prototype,"codeCachePath",null),pe([E.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(te[195],ie([0,1,156,6]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function D(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function R(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function I(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function d(u,g,k){return I(g,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:h(k).includes(u)}e.isTargetPlatformCompatible=d;function h(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=y;var p;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var w;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(g,k){super(g),this.code=k,this.name=k}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[196],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(te[197],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[109],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(te[198],ie([0,1,46,15,9,4,82,23,85,160,109]),function(V,e,E,t,P,D,R,I,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=h.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends b{openTerminal(S,L){return this.spawnTerminal(E,S,d.getWindowsShell(),L)}spawnTerminal(S,L,i,l){const n=L.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const o=P.basename(n).toLowerCase();if(o==="cmder"||o==="cmder.exe")return S.spawn(n,l?[l]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(o==="wt"||o==="wt.exe")&&s.push("-d ."),new Promise((a,r)=>{const m=c(process),C=S.spawn(i,s,{cwd:l,env:m});C.on("error",r),C.on("exit",()=>a())})}runInTerminal(S,L,i,l,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows();return new Promise((s,a)=>{const r=`"${L} - ${p}"`,m=`""${i.join('" "')}" & pause"`,C=["/c","start",r,"/wait",o,"/c",m],M=Object.assign({},c(process),l);Object.keys(M).filter(J=>M[J]===null).forEach(J=>delete M[J]);const O={cwd:L,env:M,windowsVerbatimArguments:!0};E.spawn(f.b,C,O).on("error",J=>{a(u(J))}),s(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class w extends b{openTerminal(S,L){return this.spawnTerminal(E,S,L)}runInTerminal(S,L,i,l,n){const o=n.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(o===y.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const r=o===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",S||p,"-w",L];for(const B of i)C.push("-a"),C.push(B);if(l){const B=Object.assign({},c(process),l);for(const J in B){const G=B[J];G===null?(C.push("-u"),C.push(J)):(C.push("-e"),C.push(`${J}=${G}`))}}let M="";const O=E.spawn(w.b,C);O.on("error",B=>{a(u(B))}),O.stderr.on("data",B=>{M+=B.toString()}),O.on("exit",B=>{if(B===0)s(void 0);else if(M){const J=M.split(`
`,1);a(new Error(J[0]))}else a(new Error(h.localize(1,null,r,B)))})}else a(new Error(h.localize(2,null,o)))})}spawnTerminal(S,L,i){const l=L.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{const s=["-a",l];i&&s.push(i);const a=c(process),r=S.spawn("/usr/bin/open",s,{cwd:i,env:a});r.on("error",o),r.on("exit",()=>n())})}}e.MacExternalTerminalService=w,w.b="/usr/bin/osascript";class v extends b{openTerminal(S,L){return this.spawnTerminal(E,S,L)}runInTerminal(S,L,i,l,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const r=[];o.then(m=>{m.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const C=`${g(i)}; echo; read -p "${v.b}" -n1;`;r.push(`''${C}''`);const M=Object.assign({},c(process),l);Object.keys(M).filter(G=>M[G]===null).forEach(G=>delete M[G]);const O={cwd:L,env:M};let B="";const J=E.spawn(m,r,O);J.on("error",G=>{a(u(G))}),J.stderr.on("data",G=>{B+=G.toString()}),J.on("exit",G=>{if(G===0)s(void 0);else if(B){const X=B.split(`
`,1);a(new Error(X[0]))}else a(new Error(h.localize(4,null,m,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!D.isLinux)v.d=Promise.resolve("xterm");else{const S=await I.Promises.exists("/etc/debian_version");v.d=new Promise(L=>{S?L("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?L("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?L("konsole"):process.env.COLORTERM?L(process.env.COLORTERM):process.env.TERM?L(process.env.TERM):L("xterm")})}return v.d}spawnTerminal(S,L,i){const l=L.linuxExec?Promise.resolve(L.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{l.then(s=>{const a=c(process),r=S.spawn(s,[],{cwd:i,env:a});r.on("error",o),r.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.b=h.localize(3,null);function c(k){const S={...k.env};return(0,R.sanitizeProcessEnvironment)(S),S}function u(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(h.localize(5,null,k.path)):k}function g(k){let S="";for(const L of k)L.indexOf(" ")>=0?S+='"'+L+'"':S+=L,S+=" ";return S}}),define(te[16],ie([0,1,60,9,27,11,7,162,6,4]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function y(F){return F.create===!0}e.isFileOpenForWriteOptions=y;var p;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var b;(function(F){F[F.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=w;function v(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=v;function c(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=c;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=g;function k(F){return w(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var S;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class L extends Error{constructor(U,z){super(U),this.code=z}}e.FileSystemProviderError=L;function i(F,U){const z=new L(F.toString(),U);return n(z,U),z}e.createFileSystemProviderError=i;function l(F){return F||i((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=l;function n(F,U){return F.name=U?`${U} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=n;function o(F){if(!F)return S.Unknown;if(F instanceof L)return F.code;const U=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!U)return S.Unknown;switch(U[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=o;function s(F){if(F instanceof O)return F.fileOperationResult;switch(o(F)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(U,z,Q){this.resource=U,this.operation=z,this.target=Q}isOperation(U){return this.operation===U}}e.FileOperationEvent=r;var m;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class C{constructor(U,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Q=new Map;for(const ne of U){const _=Q.get(ne.type);switch(_?_.push([ne.resource,ne]):Q.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,_]of Q)switch(ne){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(_);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(_);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(_);break}}contains(U,...z){return this.d(U,{includeChildren:!1},...z)}affects(U,...z){return this.d(U,{includeChildren:!0},...z)}d(U,z,...Q){if(!U)return!1;const ne=Q.length>0;return!!((!ne||Q.includes(1))&&(this.a?.get(U)||z.includeChildren&&this.a?.findSuperstr(U))||(!ne||Q.includes(0))&&(this.b?.get(U)||z.includeChildren&&this.b?.findSuperstr(U))||(!ne||Q.includes(2))&&(this.c?.findSubstr(U)||z.includeChildren&&this.c?.findSuperstr(U)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function M(F,U,z){return!F||!U||F===U||U.length>F.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),z?(0,P.startsWithIgnoreCase)(F,U):F.indexOf(U)===0)}e.isParent=M;class O extends Error{constructor(U,z,Q){super(U),this.fileOperationResult=z,this.options=Q}}e.FileOperationError=O;class B extends O{constructor(U,z,Q,ne){super(U,z,ne),this.fileOperationResult=z,this.size=Q}}e.TooLargeFileOperationError=B;class J extends O{constructor(U,z,Q){super(U,2,Q),this.stat=z}}e.NotModifiedSinceFileOperationError=J;var G;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var X;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(X=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=re;async function se(F,U){if(!U.hasProvider(R.URI.from({scheme:F.scheme})))return new Promise(z=>{const Q=U.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===F.scheme&&ne.added&&(Q.dispose(),z())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(U){return(0,D.isNumber)(U)||(U=0),U<ae.KB?(0,I.localize)(1,null,U.toFixed(0)):U<ae.MB?(0,I.localize)(2,null,(U/ae.KB).toFixed(2)):U<ae.GB?(0,I.localize)(3,null,(U/ae.MB).toFixed(2)):U<ae.TB?(0,I.localize)(4,null,(U/ae.GB).toFixed(2)):(0,I.localize)(5,null,(U/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var fe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(F){return{maxFileSize:F===0?300*ae.MB:16*ae.GB,maxHeapSize:F===0?700*ae.MB:2*700*ae.MB}}e.getPlatformFileLimits=ge;function H(F){return h.isWeb?F?10*ae.MB:50*ae.MB:F?100*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=H}),define(te[199],ie([0,1,17,45,13,3,2,59,7,31,16]),function(V,e,E,t,P,D,R,I,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class p extends R.Disposable{constructor(f,w){super(),this.a=f,this.b=w,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,h.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,w){const{buffer:v}=await this.a.call("readFile",[f,w]);return v}readFileStream(f,w,v){const c=(0,I.newWriteableStream)(g=>E.VSBuffer.concat(g.map(k=>E.VSBuffer.wrap(k))).buffer),u=this.a.listen("readFileStream",[f,w])(g=>{if(g instanceof E.VSBuffer)c.write(g.buffer);else{if(g==="end")c.end();else{let k;if(g instanceof Error)k=g;else{const S=g;k=(0,y.createFileSystemProviderError)(S.message??(0,t.toErrorMessage)(S),S.code??y.FileSystemProviderErrorCode.Unknown)}c.error(k),c.end()}u.dispose()}});return v.onCancellationRequested(()=>{c.error((0,P.canceled)()),c.end(),u.dispose()}),c}writeFile(f,w,v){return this.a.call("writeFile",[f,E.VSBuffer.wrap(w),v])}open(f,w){return this.a.call("open",[f,w])}close(f){return this.a.call("close",[f])}async read(f,w,v,c,u){const[g,k]=await this.a.call("read",[f,w,u]);return v.set(g.buffer.slice(0,k),c),k}write(f,w,v,c,u){return this.a.call("write",[f,w,E.VSBuffer.wrap(v),c,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,w){return this.a.call("delete",[f,w])}rename(f,w,v){return this.a.call("rename",[f,w,v])}copy(f,w,v){return this.a.call("copy",[f,w,v])}cloneFile(f,w){return this.a.call("cloneFile",[f,w])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const w=f;this.f.fire(w.map(v=>({resource:d.URI.revive(v.resource),type:v.type})))}else{const w=f;this.g.fire(w)}}))}watch(f,w){const v=(0,h.generateUuid)();return this.a.call("watch",[this.h,v,f,w]),(0,R.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=p}),define(te[110],ie([0,1,17,13,163,16]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(y,p,b,f,w,v){let c;try{await I(y,p,b,f,w,v)}catch(u){c=u}finally{c&&w.errorTransformer&&(c=w.errorTransformer(c)),typeof c<"u"&&b.error(c),b.end()}}e.readFileIntoStream=R;async function I(y,p,b,f,w,v){d(v);const c=await y.open(p,{create:!1});try{d(v);let u=0,g=0,k=w&&typeof w.length=="number"?w.length:void 0,S=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof k=="number"?k:w.bufferSize)),L=w&&typeof w.position=="number"?w.position:0,i=0;do g=await y.read(c,L,S.buffer,i,S.byteLength-i),L+=g,i+=g,u+=g,typeof k=="number"&&(k-=g),i===S.byteLength&&(await b.write(f(S)),S=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof k=="number"?k:w.bufferSize)),i=0);while(g>0&&(typeof k!="number"||k>0)&&d(v)&&h(u,w));if(i>0){let l=i;typeof k=="number"&&(l=Math.min(i,k)),b.write(f(S.slice(0,l)))}}catch(u){throw(0,D.ensureFileSystemProviderError)(u)}finally{await y.close(c)}}function d(y){if(y.isCancellationRequested)throw(0,t.canceled)();return!0}function h(y,p){if(p?.limits){if(typeof p.limits.memory=="number"&&y>p.limits.memory)throw(0,D.createFileSystemProviderError)((0,P.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&y>p.limits.size)throw(0,D.createFileSystemProviderError)((0,P.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[75],ie([0,1,101,2,9,4,7,16]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(u){return u.recursive===!0}e.isRecursiveWatchRequest=d;class h extends t.Disposable{constructor(g,k,S,L){super(),this.h=g,this.i=k,this.j=S,this.k=L,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new t.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(k=>this.h(k))),g.add(this.b.onDidLogMessage(k=>this.i(k))),g.add(this.b.onDidError(k=>this.n(k)))}n(g){this.k.restartOnError?this.g<h.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=h,h.a=5;class y extends h{constructor(g,k,S){super(g,k,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class p extends h{constructor(g,k,S){super(g,k,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=p;function b(u){return u.map(g=>({type:g.type,resource:R.URI.file(g.path)}))}e.toFileChanges=b;function f(u){const g=new c;for(const k of u)g.processEvent(k);return g.coalesce()}e.coalesceEvents=f;function w(u,g){return typeof g=="string"&&!g.startsWith(E.GLOBSTAR)&&!(0,P.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=w;function v(u,g){const k=[];for(const S of g)k.push((0,E.parse)(w(u,S)));return k}e.parseWatcherPatterns=v;class c{constructor(){this.a=new Set,this.b=new Map}c(g){return D.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const k=this.b.get(this.c(g));let S=!1;if(k){const L=k.type,i=g.type;k.path!==g.path&&(g.type===2||g.type===1)?S=!0:L===1&&i===2?(this.b.delete(this.c(g)),this.a.delete(k)):L===2&&i===1?k.type=0:L===1&&i===0||(k.type=i)}else S=!0;S&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],k=[];return Array.from(this.a).filter(S=>S.type!==2?(g.push(S),!1):!0).sort((S,L)=>S.path.length-L.path.length).filter(S=>k.some(L=>(0,I.isParent)(S.path,L,!D.isLinux))?!1:(k.push(S.path),!0)).concat(g)}}}),define(te[200],ie([0,1,41,8,22,32,2,79,9,4,102,23,75]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends R.Disposable{constructor(c,u,g,k){super(),this.j=c,this.k=u,this.l=g,this.m=k,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new t.RunOnceWorker(S=>this.u(S),f.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new P.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await p.Promises.stat(c);this.B(await this.s(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let u=c.path;try{u=await p.Promises.realpath(c.path),c.path===u&&(u=await(0,y.realcase)(c.path)??c.path),c.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async s(c,u){if(h.isMacintosh&&(0,D.isEqualOrParent)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new P.CancellationTokenSource(this.i.token),k=new R.DisposableStore;try{const S=(0,d.basename)(c),L=(0,E.watch)(c);k.add((0,R.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${c}'`);const i=new Set;if(u)try{for(const n of await p.Promises.readdir(c))i.add(n)}catch(n){this.w(n)}const l=new Map;k.add((0,R.toDisposable)(()=>{for(const[,n]of l)n.dispose();l.clear()})),L.on("error",(n,o)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),L.on("change",(n,o)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${o}`);let s="";if(o&&(s=o.toString(),h.isMacintosh&&(s=(0,I.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){l.get(s)?.dispose();const a=setTimeout(async()=>{if(l.delete(s),s===S&&!await p.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,d.join)(c,s));if(g.token.isCancellationRequested)return;let m;r?i.has(s)?m=0:(m=1,i.add(s)):(i.delete(s),m=2),this.t({path:(0,d.join)(this.j.path,s),type:m})},f.a);l.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.t({path:(0,d.join)(this.j.path,s),type:a})}else if(n==="rename"||s!==S){const a=setTimeout(async()=>{const r=await p.Promises.exists(c);g.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);k.clear(),k.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await p.Promises.exists(c)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${S.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),k.dispose()})}t(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(g=>g(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const u=(0,b.coalesceEvents)(c);if(u.length>0){if(this.m)for(const k of u)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(h.isLinux)return p.Promises.exists(c);try{const u=(0,d.basename)(c);return(await p.Promises.readdir((0,d.dirname)(c))).some(k=>k===u)}catch(u){return this.z(u),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function w(v,c,u,g,k=512){const S=await p.Promises.open(v,"r"),L=Buffer.allocUnsafe(k),i=new P.CancellationTokenSource(g);let l,n=!1;const o={path:v,excludes:[],recursive:!1},s=new f(o,a=>{(async()=>{for(const{type:r}of a)if(r===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:m}=await p.Promises.read(S,L,0,k,null);if(!m||i.token.isCancellationRequested)break;c(L.slice(0,m))}}catch(m){l=new Error(m),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,u(),new Promise((a,r)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await p.Promises.close(S)}catch(m){l=new Error(m)}l?r(l):a()})})}e.watchFileContents=w}),define(te[201],ie([0,1,3,101,2,4,200]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(h){const y=this.i(h),p=y.filter(f=>{const w=this.c.get(f.path);return w?!(0,t.patternsEquals)(w.request.excludes,f.excludes)||!(0,t.patternsEquals)(w.request.includes,f.includes):!0}),b=Array.from(this.c.values()).filter(({request:f})=>!y.find(w=>w.path===f.path&&(0,t.patternsEquals)(w.excludes,f.excludes)&&(0,t.patternsEquals)(w.includes,f.includes))).map(({request:f})=>f.path);p.length&&this.j(`Request to start watching: ${p.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const f of b)this.h(f);for(const f of p)this.g(f)}g(h){const y=new R.NodeJSFileWatcherLibrary(h,b=>this.a.fire(b),b=>this.b.fire(b),this.f),p={request:h,instance:y};this.c.set(h.path,p)}async stop(){for(const[h]of this.c)this.h(h);this.c.clear()}h(h){const y=this.c.get(h);y&&(this.c.delete(h),y.instance.dispose())}i(h){const y=new Map;for(const p of h){const b=D.isLinux?p.path:p.path.toLowerCase();y.set(b,p)}return Array.from(y.values())}async setVerboseLogging(h){this.f=h;for(const[,y]of this.c)y.instance.setVerboseLogging(h)}j(h){this.f&&this.b.fire({type:"trace",message:this.k(h)})}k(h,y){return y?`[File Watcher (node.js)] ${h} (path: ${y.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=I}),define(te[202],ie([0,1,75,201]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends E.AbstractNonRecursiveWatcherClient{constructor(R,I,d){super(R,I,d),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(te[203],ie([0,1,15,47,149,75]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends D.AbstractUniversalWatcherClient{constructor(d,h,y){super(d,h,y),this.m()}l(d){const h=d.add(new P.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(h.onDidProcessExit(({code:y,signal:p})=>this.n(`terminated by itself with code ${y}, signal: ${p}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(te[88],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...P){this.a=new Map;for(const[D,R]of P)this.set(D,R)}set(P,D){const R=this.a.get(P);return this.a.set(P,D),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=E}),define(te[204],ie([0,1,8,13,2,73,194,6,88,98]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class p extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class b{constructor(c=new d.ServiceCollection,u=!1,g,k=y){this.f=c,this.g=u,this.h=g,this.i=k,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=k?g?._globalGraph??new R.Graph(S=>S):void 0}createChild(c){return new b(c,this.g,this,this.i)}invokeFunction(c,...u){const g=w.traceInvocation(this.i,c);let k=!1;try{return c({get:L=>{if(k)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(L,g);if(!i)throw new Error(`[invokeFunction] unknown service '${L}'`);return i}},...u)}finally{k=!0,g.stop()}}createInstance(c,...u){let g,k;return c instanceof D.SyncDescriptor?(g=w.traceCreation(this.i,c.ctor),k=this.j(c.ctor,c.staticArguments.concat(u),g)):(g=w.traceCreation(this.i,c),k=this.j(c,u,g)),g.stop(),k}j(c,u=[],g){const k=I._util.getServiceDependencies(c).sort((i,l)=>i.index-l.index),S=[];for(const i of k){const l=this.m(i.id,g);l||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(l)}const L=k.length>0?k[0].index:u.length;if(u.length!==L){console.trace(`[createInstance] First service dependency of ${c.name} at position ${L+1} conflicts with ${u.length} static arguments`);const i=L-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,L)}return Reflect.construct(c,u.concat(S))}k(c,u){if(this.f.get(c)instanceof D.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const g=this.l(c);return g instanceof D.SyncDescriptor?this.q(c,g,u.branch(c,!0)):(u.branch(c,!1),g)}q(c,u,g){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,g)}finally{this.o.delete(c)}}r(c,u,g){const k=new R.Graph(i=>i.id.toString());let S=0;const L=[{id:c,desc:u,_trace:g}];for(;L.length;){const i=L.pop();if(k.lookupOrInsertNode(i),S++>1e3)throw new p(k);for(const l of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(l.id);if(n||this.u(`[createInstance] ${c} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),n instanceof D.SyncDescriptor){const o={id:l.id,desc:n,_trace:i._trace.branch(l.id,!0)};k.insertEdge(i,o),L.push(o)}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new p(k);break}for(const{data:l}of i){if(this.l(l.id)instanceof D.SyncDescriptor){const o=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,o)}k.removeNode(l)}}return this.l(c)}s(c,u,g=[],k,S){if(this.f.get(c)instanceof D.SyncDescriptor)return this.t(c,u,g,k,S);if(this.h)return this.h.s(c,u,g,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,g=[],k,S){if(k){const L=new b(void 0,this.g,this,this.i);L.c=String(c);const i=new Map,l=new E.IdleValue(()=>{const n=L.j(u,g,S);for(const[o,s]of i){const a=n[o];if(typeof a=="function")for(const r of s)a.apply(n,r)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!l.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let r=i.get(o);return r||(r=new h.LinkedList,i.set(o,r)),(C,M,O)=>{const B=r.push([C,M,O]);return(0,P.toDisposable)(B)}}if(o in n)return n[o];const s=l.value;let a=s[o];return typeof a!="function"||(a=a.bind(s),n[o]=a),a},set(n,o,s){return l.value[o]=s,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,g,S)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=b;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class w{static traceInvocation(c,u){return c?new w(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(c,u){return c?new w(1,u.name):w.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const g=new w(3,c.toString());return this.h.push([c,u,g]),g}stop(){const c=Date.now()-this.g;w.f+=c;let u=!1;function g(S,L){const i=[],l=new Array(S+1).join("	");for(const[n,o,s]of L.h)if(o&&s){u=!0,i.push(`${l}CREATES -> ${n}`);const a=g(S+1,s);a&&i.push(a)}else i.push(`${l}uses -> ${n}`);return i.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(c>2||u)&&w.all.add(k.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}},w.f=0}),define(te[5],ie([0,1,45,3,2,38,4,6]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function d(){return new Date().toISOString()}var h;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function y(s,a,r){switch(a){case h.Trace:s.trace(r);break;case h.Debug:s.debug(r);break;case h.Info:s.info(r);break;case h.Warning:s.warn(r);break;case h.Error:s.error(r);break;case h.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=y;function p(s){let a="";for(let r=0;r<s.length;r++){let m=s[r];if(typeof m=="object")try{m=JSON.stringify(m)}catch{}a+=(r>0?" ":"")+m}return a}e.format=p;class b extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==h.Off&&this.b<=a}}e.AbstractLogger=b;class f extends b{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...r){this.f(h.Trace)&&this.g(h.Trace,p([a,...r]))}debug(a,...r){this.f(h.Debug)&&this.g(h.Debug,p([a,...r]))}info(a,...r){this.f(h.Info)&&this.g(h.Info,p([a,...r]))}warn(a,...r){this.f(h.Warning)&&this.g(h.Warning,p([a,...r]))}error(a,...r){if(this.f(h.Error))if(a instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=a.stack,this.g(h.Error,p(m))}else this.g(h.Error,p([a,...r]))}flush(){}}e.AbstractMessageLogger=f;class w extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!R.isWindows}trace(a,...r){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,a,...r):console.log(`[main ${d()}]`,a,...r))}debug(a,...r){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,a,...r):console.log(`[main ${d()}]`,a,...r))}info(a,...r){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,a,...r):console.log(`[main ${d()}]`,a,...r))}warn(a,...r){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,a,...r):console.warn(`[main ${d()}]`,a,...r))}error(a,...r){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,a,...r):console.error(`[main ${d()}]`,a,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class v extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...r){this.f(h.Trace)&&console.log("%cTRACE","color: #888",a,...r)}debug(a,...r){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...r)}info(a,...r){this.f(h.Info)&&console.log("%c INFO","color: #33f",a,...r)}warn(a,...r){this.f(h.Warning)&&console.log("%c WARN","color: #993",a,...r)}error(a,...r){this.f(h.Error)&&console.log("%c  ERR","color: #f33",a,...r)}dispose(){}flush(){}}e.ConsoleLogger=v;class c extends b{constructor(a,r=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(r)}trace(a,...r){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(a),...r])}debug(a,...r){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(a),...r])}info(a,...r){this.f(h.Info)&&this.g.log(h.Info,[this.h(a),...r])}warn(a,...r){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(a),...r])}error(a,...r){this.f(h.Error)&&this.g.log(h.Error,[this.h(a),...r])}h(a){return typeof a=="string"?a:(0,E.toErrorMessage)(a,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=c;class u extends b{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const r of this.g)r.setLevel(a);super.setLevel(a)}trace(a,...r){for(const m of this.g)m.trace(a,...r)}debug(a,...r){for(const m of this.g)m.debug(a,...r)}info(a,...r){for(const m of this.g)m.info(a,...r)}warn(a,...r){for(const m of this.g)m.warn(a,...r)}error(a,...r){for(const m of this.g)m.error(a,...r)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=u;class g extends P.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...r){this.b.trace(a,...r)}debug(a,...r){this.b.debug(a,...r)}info(a,...r){this.b.info(a,...r)}warn(a,...r){this.b.warn(a,...r)}error(a,...r){this.b.error(a,...r)}flush(){this.b.flush()}}e.LogService=g;class k extends P.Disposable{constructor(a,r,m){if(super(),this.h=a,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new t.Emitter),this.onDidChangeLoggerResources=this.f.event,this.g=this.B(new t.Emitter),this.onDidChangeLogLevel=this.g.event,this.B(r(C=>this.j(C))),m)for(const C of m)this.c.set(C.resource,C)}getLogger(a){return this.b.get(a)}createLogger(a,r,m){let C=this.b.get(a);return C||(m=r?.always?h.Trace:m,C=this.k(a,m??this.getLogLevel(a)??this.h,r),this.b.set(a,C),this.registerLoggerResource({resource:a,logLevel:m,name:r?.name})),C}setLogLevel(a,r){const m=this.c.get(a);m&&r!==m.logLevel&&(m.logLevel=r===this.h?void 0:r,this.b.get(a)?.setLevel(r),this.c.set(m.resource,m),this.g.fire(m))}j(a){this.h=a;for(const[r,m]of this.b.entries())this.c.get(r)?.logLevel===void 0&&m.setLevel(this.h)}getLogLevel(a){return this.c.get(a)?.logLevel}registerLoggerResource(a){this.c.get(a.resource)||(this.c.set(a.resource,a),this.f.fire({added:[a],removed:[]}))}deregisterLoggerResource(a){const r=this.c.get(a);r&&(this.c.delete(a),this.f.fire({added:[],removed:[r]}))}getLoggerResources(){return this.c.values()}dispose(){this.b.forEach(a=>a.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=k;class S{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return h.Info}trace(a,...r){}debug(a,...r){}info(a,...r){}warn(a,...r){}error(a,...r){}critical(a,...r){}dispose(){}flush(){}}e.NullLogger=S;class L extends S{}e.NullLogService=L;class i extends k{constructor(){super(h.Info,t.Event.None)}k(a,r,m){return new S}}e.NullLoggerService=i;function l(s){if(s.verbose)return h.Trace;if(typeof s.logLevel=="string"){const a=o(s.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function n(s){switch(s){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=n;function o(s){switch(s){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=o});var ee=this&&this.__param||function(V,e){return function(E,t){e(E,t,V)}};define(te[205],ie([0,1,74,3,2,5,4,8]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let d=class Pt extends P.Disposable{constructor(y){super(),this.g=y,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(y,p){this.g.trace("Getting password from keytar:",y,p);let b;try{b=await this.h()}catch{return null}const f=await(0,I.retry)(()=>b.getPassword(y,p),50,3);if(!f)return this.g.trace("Did not get a password from keytar for account:",p),f;let w,v;try{const c=JSON.parse(f);w=c.content,v=c.hasNextChunk}catch{}if(!w||!v)return this.g.trace("Got password from keytar for account:",p),f;try{let c=1;for(;v;){const u=await(0,I.retry)(()=>b.getPassword(y,`${p}-${c}`),50,3),g=JSON.parse(u);w+=g.content,v=g.hasNextChunk,c++}return this.g.trace(`Got ${c}-chunked password from keytar for account:`,p),w}catch(c){return this.g.error(c),f}}async setPassword(y,p,b){this.g.trace("Setting password using keytar:",y,p);let f;try{f=await this.h()}catch(w){throw this.i?.(w),w}if(R.isWindows&&b.length>Pt.a){let w=0,v=0,c=!0;for(;c;){const u=b.substring(w,w+Pt.b);w+=Pt.b,c=b.length-w>0;const g={content:u,hasNextChunk:c};await(0,I.retry)(()=>f.setPassword(y,v?`${p}-${v}`:p,JSON.stringify(g)),50,3),v++}this.g.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,p)}else await(0,I.retry)(()=>f.setPassword(y,p,b),50,3),this.g.trace("Got password from keytar for account:",p);this.c.fire({service:y,account:p})}async deletePassword(y,p){this.g.trace("Deleting password using keytar:",y,p);let b;try{b=await this.h()}catch(u){throw this.i?.(u),u}const f=await b.getPassword(y,p);if(!f)return this.g.trace("Did not get a password to delete from keytar for account:",p),!1;let w,v;try{const u=JSON.parse(f);w=u.content,v=u.hasNextChunk}catch{}let c=0;if(w&&v)try{for(c++;v;){const u=`${p}-${c}`,g=await b.getPassword(y,u);await b.deletePassword(y,u),v=JSON.parse(g).hasNextChunk,c++}}catch(u){this.g.error(u)}return await b.deletePassword(y,p)?(this.c.fire({service:y,account:p}),this.g.trace(`Deleted${c?` ${c}-chunked`:""} password from keytar for account:`,p),!0):(this.g.trace(`Keytar failed to delete${c?` ${c}-chunked`:""} password for account:`,p),!1)}async findPassword(y){let p;try{p=await this.h()}catch{return null}return await p.findPassword(y)}async findCredentials(y){let p;try{p=await this.h()}catch{return[]}return await p.findCredentials(y)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};d.a=2500,d.b=d.a-100,d=pe([ee(0,D.ILogService)],d),e.BaseCredentialsMainService=d}),define(te[206],ie([0,1,5]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(D,R){this.a=D,this.b=R}c(){return new Promise((D,R)=>V(["vscode-encrypt"],D,R))}async encrypt(D){let R;try{R=await this.c()}catch{return D}try{return R.encrypt(this.a,D)}catch(I){return this.b.error(I),D}}async decrypt(D){let R;try{R=await this.c()}catch{return D}try{return R.decrypt(this.a,D)}catch(I){return this.b.error(I),D}}};t=pe([ee(1,E.ILogService)],t),e.EncryptionMainService=t}),define(te[207],ie([0,1,25,8,13,3,2,9,75,5]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends R.Disposable{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(b,f):this.u(b,f)}l(b,f){const w={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,E.insert)(this.j,w);return this.m(),(0,R.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,P.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,d.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,d.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,d.isRecursiveWatchRequest)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,f){const w={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,E.insert)(this.s,w);return this.v(),(0,R.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,P.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,d.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,I.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(te[208],ie([0,1,25,8,17,22,3,71,69,2,60,15,63,20,59,161,16,110,5,13]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends h.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new R.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new R.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(i,l){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${i}`);const n=new h.DisposableStore;return this.h.set(i,l),this.c.fire({added:!0,scheme:i,provider:l}),n.add(l.onDidChangeFile(o=>this.R.fire(new c.FileChangesEvent(o,!this.O(l))))),typeof l.onDidWatchError=="function"&&n.add(l.onDidWatchError(o=>this.S.fire(new Error(o)))),n.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:i}))),(0,h.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:l}),this.h.delete(i),(0,h.dispose)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const l=[];this.f.fire({scheme:i,join(n){l.push(n)}}),!this.h.has(i)&&await t.Promises.settled(l)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,l){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&l)}listCapabilities(){return d.Iterable.map(this.h,([i,l])=>({scheme:i,capabilities:l.capabilities}))}async j(i){if(!(0,f.isAbsolutePath)(i))throw new c.FileOperationError((0,v.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const l=this.h.get(i.scheme);if(!l){const n=new k.ErrorNoTelemetry;throw n.message=(0,v.localize)(1,null,i.toString()),n}return l}async k(i){const l=await this.j(i);if((0,c.hasOpenReadWriteCloseCapability)(l)||(0,c.hasReadWriteCapability)(l)||(0,c.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const l=await this.j(i);if((0,c.hasOpenReadWriteCloseCapability)(l)||(0,c.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,l){try{return await this.n(i,l)}catch(n){throw(0,c.toFileSystemProviderErrorCode)(n)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,v.localize)(2,null,this.nb(i)),1):(0,c.ensureFileSystemProviderError)(n)}}async n(i,l){const n=await this.j(i),o=this.O(n),s=l?.resolveTo,a=l?.resolveSingleChildDescendants,r=l?.resolveMetadata,m=await n.stat(i);let C;return this.p(n,i,m,void 0,!!r,(M,O)=>(C||(C=y.TernarySearchTree.forUris(()=>!o),C.set(i,!0),s&&C.fill(!0,s)),C.get(M.resource)||C.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&a?O===1:!1))}async p(i,l,n,o,s,a){const{providerExtUri:r}=this.N(i),m={resource:l,name:r.basename(l),isFile:(n.type&c.FileType.File)!==0,isDirectory:(n.type&c.FileType.Directory)!==0,isSymbolicLink:(n.type&c.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&c.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,c.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(m.isDirectory&&a(m,o)){try{const C=await i.readdir(l),M=await t.Promises.settled(C.map(async([O,B])=>{try{const J=r.joinPath(l,O),G=s?await i.stat(J):{type:B};return await this.p(i,J,G,C.length,s,a)}catch(J){return this.b.trace(J),null}}));m.children=(0,E.coalesce)(M)}catch(C){this.b.trace(C),m.children=[]}return m}return m}async resolveAll(i){return t.Promises.settled(i.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const l=await this.j(i),n=await l.stat(i);return this.p(l,i,n,void 0,!0,()=>!1)}async exists(i){const l=await this.j(i);try{return!!await l.stat(i)}catch{return!1}}async canCreateFile(i,l){try{await this.r(i,l)}catch(n){return n}return!0}async r(i,l){if(!l?.overwrite&&await this.exists(i))throw new c.FileOperationError((0,v.localize)(3,null,this.nb(i)),3,l)}async createFile(i,l=P.VSBuffer.fromString(""),n){await this.r(i,n);const o=await this.writeFile(i,l);return this.m.fire(new c.FileOperationEvent(i,0,o)),o}async writeFile(i,l,n){const o=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(o);try{await this.s(o,i,n)||await this.P(o,s.dirname(i));let r;if((0,c.hasReadWriteCapability)(o)&&!(l instanceof P.VSBuffer))if((0,w.isReadableStream)(l)){const m=await(0,w.peekStream)(l,3);m.ended?r=P.VSBuffer.concat(m.buffer):r=m}else r=(0,w.peekReadable)(l,m=>P.VSBuffer.concat(m),3);else r=l;!(0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)&&r instanceof P.VSBuffer?await this.cb(o,i,n,r):await this.Y(o,i,n,r instanceof P.VSBuffer?(0,P.bufferToReadable)(r):r),this.m.fire(new c.FileOperationEvent(i,4))}catch(a){throw new c.FileOperationError((0,v.localize)(4,null,this.nb(i),(0,c.ensureFileSystemProviderError)(a).toString()),(0,c.toFileOperationResult)(a),n)}return this.resolve(i,{resolveMetadata:!0})}async s(i,l,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(l)));let s;try{s=await i.stat(l)}catch{return}if((s.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,v.localize)(6,null,this.nb(l)),0,n);if(this.mb(l,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==c.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,c.etag)({mtime:n.mtime,size:s.size}))throw new c.FileOperationError((0,v.localize)(7,null),3,n);return s}async readFile(i,l,n){const o=await this.k(i);return l?.atomic?this.t(o,i,l,n):this.u(o,i,l,n)}async t(i,l,n,o){return new Promise((s,a)=>{this.X.queueFor(l,this.N(i).providerExtUri).queue(async()=>{try{const r=await this.u(i,l,n,o);s(r)}catch(r){a(r)}})})}async u(i,l,n,o){const s=await this.v(i,l,{...n,preferUnbuffered:!0},o);return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(i,l,n){const o=await this.k(i);return this.v(o,i,l,n)}async v(i,l,n,o){const s=new D.CancellationTokenSource(o),a=this.F(l,n).then(m=>m,m=>{throw s.cancel(),m});let r;try{return typeof n?.etag=="string"&&n.etag!==c.ETAG_DISABLED&&await a,n?.atomic&&(0,c.hasFileAtomicReadCapability)(i)||!((0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasFileReadStreamCapability)(i))||(0,c.hasReadWriteCapability)(i)&&n?.preferUnbuffered?r=this.D(i,l,n):(0,c.hasFileReadStreamCapability)(i)?r=this.z(i,l,s.token,n):r=this.C(i,l,s.token,n),{...await a,value:r}}catch(m){throw r&&await(0,w.consumeStream)(r),this.w(m,l,n)}}w(i,l,n){const o=(0,v.localize)(8,null,this.nb(l),(0,c.ensureFileSystemProviderError)(i).toString());return i instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(o,i.stat,n):i instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(o,i.fileOperationResult,i.size,i.options):new c.FileOperationError(o,(0,c.toFileOperationResult)(i),n)}z(i,l,n,o=Object.create(null)){const s=i.readFileStream(l,o,n);return(0,w.transform)(s,{data:a=>a instanceof P.VSBuffer?a:P.VSBuffer.wrap(a),error:a=>this.w(a,l,o)},a=>P.VSBuffer.concat(a))}C(i,l,n,o=Object.create(null)){const s=(0,P.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,l,s,a=>a,{...o,bufferSize:this.a,errorTransformer:a=>this.w(a,l,o)},n),s}D(i,l,n){const o=(0,w.newWriteableStream)(s=>P.VSBuffer.concat(s));return(async()=>{try{let s;n?.atomic&&(0,c.hasFileAtomicReadCapability)(i)?s=await i.readFile(l,{atomic:!0}):s=await i.readFile(l),typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.G(l,s.byteLength,n),o.end(P.VSBuffer.wrap(s))}catch(s){o.error(s),o.end()}})(),o}async F(i,l){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new c.FileOperationError((0,v.localize)(9,null,this.nb(i)),0,l);if(typeof l?.etag=="string"&&l.etag!==c.ETAG_DISABLED&&l.etag===n.etag)throw new c.NotModifiedSinceFileOperationError((0,v.localize)(10,null),n,l);return this.G(i,n.size,l),n}G(i,l,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&l>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&l>n.limits.size&&(o=7),typeof o=="number")throw new c.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(i)),o,l,n)}}async canMove(i,l,n){return this.H(i,l,"move",n)}async canCopy(i,l,n){return this.H(i,l,"copy",n)}async H(i,l,n,o){if(i.toString()!==l.toString())try{const s=n==="move"?this.lb(await this.l(i),i):await this.k(i),a=this.lb(await this.l(l),l);await this.M(s,i,a,l,n,o)}catch(s){return s}return!0}async move(i,l,n){const o=this.lb(await this.l(i),i),s=this.lb(await this.l(l),l),a=await this.I(o,i,s,l,"move",!!n),r=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,a==="move"?2:3,r)),r}async copy(i,l,n){const o=await this.k(i),s=this.lb(await this.l(l),l),a=await this.I(o,i,s,l,"copy",!!n),r=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,a==="copy"?3:2,r)),r}async I(i,l,n,o,s,a){if(l.toString()===o.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:m}=await this.M(i,l,n,o,s,a);if(r&&!m&&a&&await this.del(o,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(o)),s==="copy"){if(i===n&&(0,c.hasFileFolderCopyCapability)(i))await i.copy(l,o,{overwrite:a});else{const C=await this.resolve(l);C.isDirectory?await this.L(i,C,n,o):await this.J(i,l,n,o)}return s}else return i===n?(await i.rename(l,o,{overwrite:a}),s):(await this.I(i,l,n,o,"copy",a),await this.del(l,{recursive:!0}),"copy")}async J(i,l,n,o){if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.eb(i,l,n,o);if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasReadWriteCapability)(n))return this.kb(i,l,n,o);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.ib(i,l,n,o);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasReadWriteCapability)(n))return this.gb(i,l,n,o)}async L(i,l,n,o){await n.mkdir(o),Array.isArray(l.children)&&await t.Promises.settled(l.children.map(async s=>{const a=this.N(n).providerExtUri.joinPath(o,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),n,a):this.J(i,s.resource,n,a)}))}async M(i,l,n,o,s,a){let r=!1;if(i===n){const{providerExtUri:C,isPathCaseSensitive:M}=this.N(i);if(M||(r=C.isEqual(l,o)),r&&s==="copy")throw new Error((0,v.localize)(12,null,this.nb(l),this.nb(o)));if(!r&&C.isEqualOrParent(o,l))throw new Error((0,v.localize)(13,null,this.nb(l),this.nb(o)))}const m=await this.exists(o);if(m&&!r){if(!a)throw new c.FileOperationError((0,v.localize)(14,null,this.nb(l),this.nb(o)),4);if(i===n){const{providerExtUri:C}=this.N(i);if(C.isEqualOrParent(l,o))throw new Error((0,v.localize)(15,null,this.nb(l),this.nb(o)))}}return{exists:m,isSameResourceWithDifferentPathCase:r}}N(i){const l=this.O(i);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const l=this.lb(await this.j(i),i);await this.P(l,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,0,n)),n}async P(i,l){const n=[],{providerExtUri:o}=this.N(i);for(;!o.isEqual(l,o.dirname(l));)try{if(((await i.stat(l)).type&c.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(l)));break}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(l)),l=o.dirname(l)}for(let s=n.length-1;s>=0;s--){l=o.joinPath(l,n[s]);try{await i.mkdir(l)}catch(a){if((0,c.toFileSystemProviderErrorCode)(a)!==c.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,l){try{await this.Q(i,l)}catch(n){return n}return!0}async Q(i,l){const n=this.lb(await this.j(i),i);if(!!l?.useTrash&&!(n.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(i)));let s;try{s=await n.stat(i)}catch{}if(s)this.mb(i,s);else throw new c.FileOperationError((0,v.localize)(18,null,this.nb(i)),1);if(!!!l?.recursive){const r=await this.resolve(i);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(i)))}return n}async del(i,l){const n=await this.Q(i,l),o=!!l?.useTrash,s=!!l?.recursive;await n.delete(i,{recursive:s,useTrash:o}),this.m.fire(new c.FileOperationEvent(i,1))}async cloneFile(i,l){const n=await this.j(i),o=this.lb(await this.l(l),l);if(n===o&&this.N(n).providerExtUri.isEqual(i,l))return;if(n===o&&(0,c.hasFileCloneCapability)(n))return n.cloneFile(i,l);await this.P(o,this.N(o).providerExtUri.dirname(l));const s=this.X.queueFor(i,this.N(n).providerExtUri);return n===o&&(0,c.hasFileFolderCopyCapability)(n)?s.queue(()=>n.copy(i,l,{overwrite:!0})):s.queue(()=>this.J(n,i,o,l))}watch(i,l={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let o=!1,s=()=>{o=!0};return n.add((0,h.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(i,l);o?(0,h.dispose)(a):s=()=>(0,h.dispose)(a)}catch(a){this.b.error(a)}})(),n}async W(i,l){const n=await this.j(i),o=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(i),l]);let s=this.U.get(o);return s||(s={count:0,disposable:n.watch(i,l)},this.U.set(o,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.U.delete(o)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,h.dispose)(i.disposable);this.U.clear()}async Y(i,l,n,o){return this.X.queueFor(l,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(l,{create:!0,unlock:n?.unlock??!1});try{(0,w.isReadableStream)(o)||(0,w.isReadableBufferedStream)(o)?await this.Z(i,s,o):await this.ab(i,s,o)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await i.close(s)}})}async Z(i,l,n){let o=0,s;if((0,w.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=P.VSBuffer.concat(n.buffer);await this.bb(i,l,a,a.byteLength,o,0),o+=a.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((a,r)=>{(0,w.listenStream)(s,{onData:async m=>{s.pause();try{await this.bb(i,l,m,m.byteLength,o,0)}catch(C){return r(C)}o+=m.byteLength,setTimeout(()=>s.resume())},onError:m=>r(m),onEnd:()=>a()})})}async ab(i,l,n){let o=0,s;for(;(s=n.read())!==null;)await this.bb(i,l,s,s.byteLength,o,0),o+=s.byteLength}async bb(i,l,n,o,s,a){let r=0;for(;r<o;)r+=await i.write(l,s+r,n.buffer,a+r,o-r)}async cb(i,l,n,o){return this.X.queueFor(l,this.N(i).providerExtUri).queue(()=>this.db(i,l,n,o))}async db(i,l,n,o){let s;o instanceof P.VSBuffer?s=o:(0,w.isReadableStream)(o)?s=await(0,P.streamToBuffer)(o):(0,w.isReadableBufferedStream)(o)?s=await(0,P.bufferedStreamToBuffer)(o):s=(0,P.readableToBuffer)(o),await i.writeFile(l,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(i,l,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.fb(i,l,n,o))}async fb(i,l,n,o){let s,a;try{s=await i.open(l,{create:!1}),a=await n.open(o,{create:!0,unlock:!1});const r=P.VSBuffer.alloc(this.a);let m=0,C=0,M=0;do M=await i.read(s,m,r.buffer,C,r.byteLength-C),await this.bb(n,a,r,M,m,C),m+=M,C+=M,C===r.byteLength&&(C=0);while(M>0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await t.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async gb(i,l,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.hb(i,l,n,o))}async hb(i,l,n,o){return n.writeFile(o,await i.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async ib(i,l,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.jb(i,l,n,o))}async jb(i,l,n,o){const s=await n.open(o,{create:!0,unlock:!1});try{const a=await i.readFile(l);await this.bb(n,s,P.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await n.close(s)}}async kb(i,l,n,o){const s=await(0,P.streamToBuffer)(this.C(i,l,D.CancellationToken.None));await this.cb(n,o,void 0,s)}lb(i,l){if(i.capabilities&2048)throw new c.FileOperationError((0,v.localize)(20,null,this.nb(l)),6);return i}mb(i,l){if((l.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,v.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}};S=pe([ee(0,g.ILogService)],S),e.FileService=S}),define(te[89],ie([0,1,41,288,8,38,17,3,32,2,9,4,20,59,23,165,16,110,207,45,203,202]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(l){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(l)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o),this.onDidChangeCapabilities=I.Event.None,this.H=new D.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:o,symbolicLink:s}=await w.SymlinkSupport.stat(this.C(n));return{type:this.G(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(n){try{const o=await w.Promises.readdir(this.C(n),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async a=>{try{let r;a.isSymbolicLink()?r=(await this.stat((0,b.joinPath)(n,a.name))).type:r=this.G(a),s.push([a.name,r])}catch(r){this.a.trace(r)}})),s}catch(o){throw this.Y(o)}}G(n,o){let s;return o?.dangling?s=c.FileType.Unknown:n.isFile()?s=c.FileType.File:n.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,o&&(s|=c.FileType.SymbolicLink),s}async I(n){const o=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const a=new P.Barrier;return this.H.set(n,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,h.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(n)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),a.open()})}async readFile(n,o){let s;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),s=await this.I(n));const a=this.C(n);return await w.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,o,s){const a=(0,f.newWriteableStream)(r=>R.VSBuffer.concat(r.map(m=>R.VSBuffer.wrap(m))).buffer);return(0,u.readFileIntoStream)(this,n,a,r=>r.buffer,{...o,bufferSize:256*1024},s),a}async writeFile(n,o,s){let a;try{const r=this.C(n);if(!s.create||!s.overwrite){if(await w.Promises.exists(r)){if(!s.overwrite)throw(0,c.createFileSystemProviderError)((0,v.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.createFileSystemProviderError)((0,v.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,o,0,o.byteLength)}catch(r){throw await this.Z(n,r)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){i.O=n}async open(n,o){const s=this.C(n);let a;(0,c.isFileOpenForWriteOptions)(o)&&(a=await this.I(n));let r;try{if((0,c.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:C}=await w.SymlinkSupport.stat(s);C.mode&128||await w.Promises.chmod(s,C.mode|128)}catch(C){this.a.trace(C)}let m;if((0,c.isFileOpenForWriteOptions)(o)){if(p.isWindows)try{await w.Promises.truncate(s,0),m="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}m||(m="w")}else m="r";r=await w.Promises.open(s,m)}catch(m){throw a?.dispose(),(0,c.isFileOpenForWriteOptions)(o)?await this.Z(n,m):this.Y(m)}if(this.L.set(r,0),(0,c.isFileOpenForWriteOptions)(o)&&this.N.set(r,n),a){const m=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${s})`),this.M.set(r,a),m&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${s})`),m.dispose())}return r}async close(n){const o=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await w.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(n)}catch(s){throw this.Y(s)}finally{o&&(this.M.get(n)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,s,a,r){const m=this.P(n,o);let C=null;try{C=(await w.Promises.read(n,s,a,r,m)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(n,m,C)}return C}P(n,o){return o===this.L.get(n)?null:o}Q(n,o,s){const a=this.L.get(n);typeof a=="number"&&(typeof o=="number"||(typeof s=="number"?this.L.set(n,a+s):this.L.delete(n)))}async write(n,o,s,a,r){return(0,P.retry)(()=>this.R(n,o,s,a,r),100,3)}async R(n,o,s,a,r){const m=this.P(n,o);let C=null;try{C=(await w.Promises.write(n,s,a,r,m)).bytesWritten}catch(M){throw await this.Z(this.N.get(n),M)}finally{this.Q(n,m,C)}return C}async mkdir(n){try{await w.Promises.mkdir(this.C(n))}catch(o){throw this.Y(o)}}async delete(n,o){try{const s=this.C(n);o.recursive?await w.Promises.rm(s,w.RimRafMode.MOVE):await w.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(n,o,s){const a=this.C(n),r=this.C(o);if(a!==r)try{await this.S(n,o,"move",s.overwrite),await w.Promises.move(a,r)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,v.localize)(2,null,(0,y.basename)(a),(0,y.basename)((0,y.dirname)(r)),m.toString()))),this.Y(m)}}async copy(n,o,s){const a=this.C(n),r=this.C(o);if(a!==r)try{await this.S(n,o,"copy",s.overwrite),await w.Promises.copy(a,r,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,v.localize)(3,null,(0,y.basename)(a),(0,y.basename)((0,y.dirname)(r)),m.toString()))),this.Y(m)}}async S(n,o,s,a){const r=this.C(n),m=this.C(o);let C=!1;if(!!(this.capabilities&1024)||(C=(0,d.isEqual)(r,m,!0)),C&&s==="copy")throw(0,c.createFileSystemProviderError)((0,v.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!C&&await w.Promises.exists(m)){if(!a)throw(0,c.createFileSystemProviderError)((0,v.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.U(n,o,!1)}async U(n,o,s){const a=this.C(n),r=this.C(o),m=!!(this.capabilities&1024);if((0,d.isEqual)(a,r,!m))return;const C=new h.DisposableStore;try{const[M,O]=await Promise.all([this.I(n),this.I(o)]);C.add(M),C.add(O),s&&await w.Promises.mkdir((0,y.dirname)(r),{recursive:!0}),await w.Promises.copyFile(a,r)}catch(M){if(M.code==="ENOENT"&&!s)return this.U(n,o,!0);throw this.Y(M)}finally{C.dispose()}}p(n,o,s){return new S.UniversalWatcherClient(a=>n(a),a=>o(a),s)}y(n,o,s){return new L.NodeJSWatcherClient(a=>n(a),a=>o(a),s)}Y(n){if(n instanceof c.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=c.FileSystemProviderErrorCode.NoPermissions;break;default:o=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,o)}async Z(n,o){let s=this.Y(o);if(n&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await w.SymlinkSupport.stat(this.C(n));a.mode&128||(s=(0,c.createFileSystemProviderError)(o,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(te[209],ie([0,1,3,89,2,17,59,22]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends P.Disposable{constructor(p,b){super(),this.a=p,this.b=b,this.w=new Map,this.y=new Map}call(p,b,f){const w=this.c(p);switch(b){case"stat":return this.g(w,f[0]);case"readdir":return this.h(w,f[0]);case"open":return this.l(w,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(w,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(w,f[0],f[1],f[2]);case"rename":return this.t(w,f[0],f[1],f[2]);case"copy":return this.u(w,f[0],f[1],f[2]);case"cloneFile":return this.v(w,f[0],f[1]);case"mkdir":return this.r(w,f[0]);case"delete":return this.s(w,f[0],f[1]);case"watch":return this.C(w,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${b} not found`)}listen(p,b,f){const w=this.c(p);switch(b){case"fileChange":return this.z(w,f[0]);case"readFileStream":return this.j(w,f[0],f[1])}throw new Error(`Unknown event ${b}`)}g(p,b){const f=this.f(p,b,!0);return this.a.stat(f)}h(p,b){const f=this.f(p,b);return this.a.readdir(f)}async i(p,b,f){const w=this.f(p,b,!0),v=await this.a.readFile(w,f);return D.VSBuffer.wrap(v)}j(p,b,f){const w=this.f(p,b,!0),v=new I.CancellationTokenSource,c=new E.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),u=this.a.readFileStream(w,f,v.token);return(0,R.listenStream)(u,{onData:g=>c.fire(D.VSBuffer.wrap(g)),onError:g=>c.fire(g),onEnd:()=>{c.fire("end"),c.dispose(),v.dispose()}}),c.event}k(p,b,f,w){const v=this.f(p,b);return this.a.writeFile(v,f.buffer,w)}l(p,b,f){const w=this.f(p,b,!0);return this.a.open(w,f)}m(p){return this.a.close(p)}async n(p,b,f){const w=D.VSBuffer.alloc(f),v=0,c=await this.a.read(p,b,w.buffer,v,f);return[w,c]}p(p,b,f,w,v){return this.a.write(p,b,f.buffer,w,v)}r(p,b){const f=this.f(p,b);return this.a.mkdir(f)}s(p,b,f){const w=this.f(p,b);return this.a.delete(w,f)}t(p,b,f,w){const v=this.f(p,b),c=this.f(p,f);return this.a.rename(v,c,w)}u(p,b,f,w){const v=this.f(p,b),c=this.f(p,f);return this.a.copy(v,c,w)}v(p,b,f){const w=this.f(p,b),v=this.f(p,f);return this.a.cloneFile(w,v)}z(p,b){const f=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(p,f))},onDidRemoveLastListener:()=>{(0,P.dispose)(this.w.get(b)),this.w.delete(b)}});return f.event}async C(p,b,f,w,v){const c=this.w.get(b);if(c){const u=this.f(p,w),g=c.watch(f,u,v);this.y.set(b+f,g)}}async D(p,b){const f=p+b,w=this.y.get(f);w&&((0,P.dispose)(w),this.y.delete(f))}dispose(){super.dispose();for(const[,p]of this.y)p.dispose();this.y.clear();for(const[,p]of this.w)p.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class h extends P.Disposable{constructor(p,b,f,w){super(),this.c=p,this.f=f,this.g=w,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(p){const b=this.B(new E.Emitter);this.B(b.event(f=>{p.fire(f.map(w=>({resource:this.c.transformOutgoingURI(w.resource),type:w.type})))})),this.B(this.b.onDidChangeFile(f=>b.fire(f))),this.B(this.b.onDidWatchError(f=>p.fire(f)))}i(p){}j(p){}watch(p,b,f){const w=this.j(this.g);return Array.isArray(w)&&(f.excludes=[...f.excludes,...w]),this.a.set(p,this.b.watch(b,f)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.a.get(p)),this.a.delete(p)})}dispose(){super.dispose();for(const[,p]of this.a)p.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=h}),define(te[210],ie([0,1,14,164,4,7,16,9,209,143]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends d.AbstractDiskFileSystemProviderChannel{constructor(f,w,v){super(f,w),this.G=v}c(f){return h.DefaultURITransformer}f(f,w){return D.URI.revive(w)}async s(f,w,v){if(!v.useTrash)return super.s(f,w,v);const c=this.f(f,w),u=(0,I.normalize)(c.fsPath);try{await E.shell.trashItem(u)}catch{throw(0,R.createFileSystemProviderError)(P.isWindows?(0,t.localize)(0,null,(0,I.basename)(u)):(0,t.localize)(1,null,(0,I.basename)(u)),R.FileSystemProviderErrorCode.Unknown)}}F(f,w){return new p(f,w,this.b,this.G)}}e.DiskFileSystemProviderChannel=y;class p extends d.AbstractSessionFileWatcher{watch(f,w,v){if(v.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(f,w,v)}}}),define(te[211],ie([0,1,5]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends E.AbstractMessageLogger{constructor(D=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(D){this.l=D;for(const{level:R,message:I}of this.k)(0,E.log)(D,R,I);this.k=[]}g(D,R){this.l?(0,E.log)(this.l,D,R):this.getLevel()<=D&&this.k.push({level:D,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(te[212],ie([0,1,3,7,5]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(p,b){this.a=p,this.b=b,this.onDidChangeLogLevel=E.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(p,b,f){switch(b){case"setLevel":return f[1]?this.b.setLogLevel(t.URI.revive(f[1]),f[0]):this.a.setLevel(f[0])}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=D;class R{constructor(p){this.a=p}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(p,b){R.setLevel(this.a,p,b)}static setLevel(p,b,f){return p.call("setLevel",[b,f])}}e.LogLevelChannelClient=R;class I extends P.AbstractLoggerService{constructor(p,b,f,w,v){super(b,f,w.map(c=>({...c,resource:t.URI.revive(c.resource)}))),this.l=p,this.m=v,this.B(v.listen("onDidChangeLogLevel",p)(c=>super.setLogLevel(t.URI.revive(c.resource),c.logLevel??this.h))),this.B(v.listen("onDidChangeLoggerResources",p)(({added:c,removed:u})=>{for(const g of c)super.registerLoggerResource({...g,resource:t.URI.revive(g.resource)});for(const g of u)super.deregisterLoggerResource(g.resource)}))}createConsoleMainLogger(){return new P.AdapterLogger({log:(p,b)=>{this.m.call("consoleLog",[p,b])}})}registerLoggerResource(p){this.m.call("registerLoggerResource",[p,this.l])}deregisterLoggerResource(p){this.m.call("deregisterLoggerResource",[p,this.l])}setLogLevel(p,b){this.m.call("setLogLevel",[p,b])}k(p,b,f){return new d(this.m,p,b,f)}}e.LoggerChannelClient=I;class d extends P.AbstractMessageLogger{constructor(p,b,f,w){super(w?.always),this.m=p,this.n=b,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[b,w]).then(()=>{this.r(this.l),this.k=!0})}g(p,b){const f=[[p,b]];this.k?this.r(f):this.l.push(...f)}r(p){this.m.call("log",[this.n,p])}}class h extends P.LogService{constructor(p,b){super(b),this.c=p,this.B(p.onDidChangeLogLevel(f=>b.setLevel(f)))}setLevel(p){super.setLevel(p),this.c.setLevel(p)}}e.FollowerLogService=h}),define(te[213],ie([0,1,7,5]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class P{constructor(R){this.b=R,this.a=new Map}listen(R,I,d){switch(I){case"onDidChangeLoggerResources":return d?this.b.getOnDidChangeLoggerResourcesEvent(d):this.b.onDidChangeLoggerResources;case"onDidChangeLogLevel":return d?this.b.getOnDidChangeLogLevelEvent(d):this.b.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(R,I,d){switch(I){case"createLogger":this.c(E.URI.revive(d[0]),d[1]);return;case"log":return this.e(E.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1]);case"setLogLevel":return this.b.setLogLevel(E.URI.revive(d[0]),d[1]);case"registerLoggerResource":return this.b.registerLoggerResource({...d[0],resource:E.URI.revive(d[0].resource)},d[1]);case"deregisterLoggerResource":return this.b.deregisterLoggerResource(E.URI.revive(d[0]))}throw new Error(`Call not found: ${I}`)}c(R,I){this.a.set(R.toString(),this.b.createLogger(R,I))}d(R,I){let d=console.log;switch(R){case t.LogLevel.Error:d=console.error;break;case t.LogLevel.Warning:d=console.warn;break;case t.LogLevel.Info:d=console.info;break}d.call(console,...I)}e(R,I){const d=this.a.get(R.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,y]of I)(0,t.log)(d,h,y)}}e.LoggerChannel=P}),define(te[214],ie([0,1,16,5]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(P||(P={}));async function D(h,y,p,b,f){try{const w=await new Promise((c,u)=>{V(["spdlog"],c,u)});w.setFlushOn(P.Trace);const v=await w.createAsyncRotatingLogger(h,y,p,b);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(w){console.error(w)}return null}function R(h,y,p){switch(y){case t.LogLevel.Trace:h.trace(p);break;case t.LogLevel.Debug:h.debug(p);break;case t.LogLevel.Info:h.info(p);break;case t.LogLevel.Warning:h.warn(p);break;case t.LogLevel.Error:h.error(p);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function I(h,y){switch(y){case t.LogLevel.Trace:h.setLevel(P.Trace);break;case t.LogLevel.Debug:h.setLevel(P.Debug);break;case t.LogLevel.Info:h.setLevel(P.Info);break;case t.LogLevel.Warning:h.setLevel(P.Warning);break;case t.LogLevel.Error:h.setLevel(P.Error);break;case t.LogLevel.Off:h.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class d extends t.AbstractMessageLogger{constructor(y,p,b,f,w){super(),this.k=[],this.setLevel(w),this.l=this.n(y,p,b,f),this.B(this.onDidChangeLogLevel(v=>{this.m&&I(this.m,v)}))}async n(y,p,b,f){const w=b?6:1,v=30/w*E.ByteSize.MB,c=await D(y,p,v,w,f);if(c){this.m=c,I(this.m,this.getLevel());for(const{level:u,message:g}of this.k)R(this.m,u,g);this.k=[]}}g(y,p){this.m?R(this.m,y,p):this.getLevel()<=y&&this.k.push({level:y,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(te[215],ie([0,1,31,5,214]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let D=class extends t.AbstractLoggerService{constructor(I){super(I.getLevel(),I.onDidChangeLogLevel)}k(I,d,h){return new P.SpdLogLogger(h?.name||(0,E.generateUuid)(),I.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,d)}};D=pe([ee(0,t.ILogService)],D),e.LoggerService=D}),define(te[64],ie([0,1,38,3,6,5,215]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,P.refineServiceDecorator)(D.ILoggerService);class I extends R.LoggerService{constructor(){super(...arguments),this.m=new E.ResourceMap}registerLoggerResource(h,y){y!==void 0&&this.m.set(h.resource,y),super.registerLoggerResource(h)}deregisterLoggerResource(h){this.m.delete(h),super.deregisterLoggerResource(h)}getLoggerResources(h){const y=[];for(const p of super.getLoggerResources())this.n(p.resource,h)&&y.push(p);return y}getOnDidChangeLogLevelEvent(h){return t.Event.filter(this.onDidChangeLogLevel,y=>this.n(y.resource,h))}getOnDidChangeLoggerResourcesEvent(h){return t.Event.filter(t.Event.map(this.onDidChangeLoggerResources,y=>({added:[...y.added].filter(b=>this.n(b.resource,h)),removed:[...y.removed].filter(b=>this.n(b.resource,h))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggerResources(h){for(const[y,p]of this.m)p===h&&this.deregisterLoggerResource(y)}n(h,y){const p=this.m.get(h);return p===void 0||p===y}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=I}),define(te[216],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function P(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=P;function D(R){return!E(R)&&!t(R)&&!P(R)}e.isMenubarMenuItemAction=D}),define(te[39],ie([0,1,3,69,2,6]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class R extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(h){const y=Object.keys(this.f).length;return this.f={...h,...this.f},y!==Object.keys(this.f).length&&await this.i(h),t.Iterable.reduce(this.g.entries(),(p,[b,f])=>({...p,[b]:f}),{})}getPolicyValue(h){return this.g.get(h)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(h,[y,p])=>({...h,[y]:{definition:p,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=R;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(te[217],ie([0,1,8,3,69,11,16,5,39]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(p,b){const f=[];for(const w of new Set(P.Iterable.concat(p.keys(),b.keys())))p.get(w)!==b.get(w)&&f.push(w);return f}let y=class extends d.AbstractPolicyService{constructor(b,f,w){super(),this.j=b,this.k=f,this.l=w,this.c=this.B(new E.ThrottledDelayer(500));const v=t.Event.filter(f.onDidFilesChange,c=>c.affects(b));this.B(f.watch(b)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const f=await this.k.readFile(this.j),w=JSON.parse(f.value.toString());if(!(0,D.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(w))this.f[v]&&b.set(v,w[v])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return b}async p(){const b=await this.n(),f=h(this.g,b);this.g=b,f.length>0&&this.h.fire(f)}};y=pe([ee(1,R.IFileService),ee(2,I.ILogService)],y),e.FilePolicyService=y}),define(te[218],ie([0,1,3,2,39]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class D{constructor(d){this.b=d,this.a=new t.DisposableStore}listen(d,h){switch(h){case"onDidChange":return E.Event.map(this.b.onDidChange,y=>y.reduce((p,b)=>({...p,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${h}`)}call(d,h,y){switch(h){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${h}`)}dispose(){this.a.dispose()}}e.PolicyChannel=D;class R extends P.AbstractPolicyService{constructor(d,h){super(),this.a=h;for(const y in d){const{definition:p,value:b}=d[y];this.f[y]=p,b!==void 0&&this.g.set(y,b)}this.a.listen("onDidChange")(y=>{for(const p in y){const b=y[p];b===null?this.g.delete(p):this.g.set(p,b)}this.h.fire(Object.keys(y))})}async i(d){const h=await this.a.call("updatePolicyDefinitions",d);for(const y in h)this.g.set(y,h[y])}}e.PolicyChannelClient=R}),define(te[65],ie([0,1,4,35]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const D=E.globals.vscode.context.configuration();if(D)P=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(P=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(P,{version:D.version})}}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(te[19],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[219],ie([0,1,80,5,19]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(I,d){this.b=I,this.c=d,this.a=new Map}async isExtensionUrlTrusted(I,d){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(d);if(!h)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,p]=h;let b=this.a.get(I);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[I],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.a.set(I,[...b])}const f=Buffer.from(decodeURIComponent(p),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const w=f.slice(0,6),v=f.readUIntBE(0,6),c=Date.now()-v;if(c<0||c>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const u=f.slice(6),g=E.createVerify("SHA256");g.write(w),g.write(Buffer.from(y)),g.end();for(let k=0;k<b.length;k++){let S=b[k];if(S!==null){if(typeof S=="string")try{S=E.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),b[k]=S}catch(L){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${I}:`,L),b[k]=null;continue}if(g.verify(S,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};D=pe([ee(0,P.IProductService),ee(1,t.ILogService)],D),e.ExtensionUrlTrustService=D}),define(te[220],ie([0,1,8,5]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let P=class{constructor(R,I,d){this.a=R,this.b=I,this.c=d}async inspect(R){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(R);const d=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};P=pe([ee(2,t.ILogService)],P),e.WindowProfiler=P}),define(te[66],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(te[48],ie([0,1,124,11]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(R,I){E.ok(t.isString(R)),E.ok(t.isObject(I)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,I)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new P}),define(te[221],ie([0,1,3,48]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,h){this.a[P(d)]=h,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const R=new D;t.Registry.add(e.Extensions.JSONContribution,R)}),define(te[67],ie([0,1,25,3,11,152,18,221,48]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=d.Registry.as(I.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const n=new Set;this.n(i,l,n),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const l=new Set;this.o(i,l),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const n=new Set;this.o(l,n),this.n(i,!1,n),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const n=[];for(const{overrides:o,source:s}of i)for(const a in o)if(l.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const r=this.a.get(a),m=r?.valuesSources??new Map;if(s)for(const B of Object.keys(o[a]))m.set(B,s);const C={...r?.value||{},...o[a]};this.a.set(a,{source:s,value:C,valuesSources:m});const M=(0,R.getLanguageTagSettingPlainKey)(a),O={type:"object",default:C,description:D.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:P.isString(s)?void 0:s,defaultValueSource:s};n.push(...v(a)),this.d[a]=O,this.b.properties[a]=O}else{this.a.set(a,{value:o[a],source:s});const r=this.d[a];r&&(this.w(a,r),this.r(a,r))}this.m(n)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:n,source:o}of i)for(const s in n){const a=this.a.get(s),r=P.isString(o)?o:o?.id,m=P.isString(a?.source)?a?.source:a?.source?.id;if(r===m)if(l.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const C=this.d[s];C&&(this.w(s,C),this.r(s,C))}}this.u()}deltaConfiguration(i){let l=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,n){i.forEach(o=>{this.p(o,l,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(i,l){const n=o=>{if(o.properties)for(const s in o.properties){l.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,o.properties[s])}o.allOf?.forEach(s=>n(s))};for(const o of i){n(o);const s=this.c.indexOf(o);s!==-1&&this.c.splice(s,1)}}p(i,l=!0,n,o,s=3,a){s=P.isUndefinedOrNull(i.scope)?s:i.scope;const r=i.properties;if(r)for(const C in r){const M=r[C];if(l&&k(C,M)){delete r[C];continue}if(M.source=n,M.defaultDefaultValue=r[C].default,this.w(C,M),e.OVERRIDE_PROPERTY_REGEX.test(C)?M.scope=void 0:(M.scope=P.isUndefinedOrNull(M.scope)?s:M.scope,M.restricted=P.isUndefinedOrNull(M.restricted)?!!o?.includes(C):M.restricted),r[C].hasOwnProperty("included")&&!r[C].included){this.f[C]=r[C],delete r[C];continue}else this.d[C]=r[C],r[C].policy?.name&&this.e.set(r[C].policy.name,C);!r[C].deprecationMessage&&r[C].markdownDeprecationMessage&&(r[C].deprecationMessage=r[C].markdownDeprecationMessage),a.add(C)}const m=i.allOf;if(m)for(const C of m)this.p(C,l,n,o,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=n=>{const o=n.properties;if(o)for(const a in o)this.r(a,o[a]);n.allOf?.forEach(l)};l(i)}r(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,n={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,n),e.allSettings.properties[l]=n,e.applicationSettings.properties[l]=n,e.machineSettings.properties[l]=n,e.machineOverridableSettings.properties[l]=n,e.windowSettings.properties[l]=n,e.resourceSettings.properties[l]=n}}v(){const i={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,l){const n=this.a.get(i);let o=n?.value,s=n?.source;P.isUndefined(o)&&(o=l.defaultDefaultValue,s=void 0),P.isUndefined(o)&&(o=u(l.type)),l.default=o,l.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",w=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(L){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let l=w.exec(L);for(;l?.length;){const n=l[1].trim();n&&i.push(n),l=w.exec(L)}}return(0,E.distinct)(i)}e.overrideIdentifiersFromKey=v;function c(L){return L.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=c;function u(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new b;d.Registry.add(e.Extensions.Configuration,g);function k(L,i){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?D.localize(7,null,L):g.getConfigurationProperties()[L]!==void 0?D.localize(8,null,L):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?D.localize(9,null,L,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:D.localize(6,null)}e.validateProperty=k;function S(){const L=[],i=g.getConfigurationProperties();for(const l of Object.keys(i))L.push([l,i[l].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=S}),define(te[111],ie([0,1,25,3,43,2,38,44,11,7,18,67,48]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(l){return Object.isFrozen(l)?l:I.deepFreeze(l)}class w{constructor(n={},o=[],s=[],a){this.b=n,this.c=o,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof w)return o;const s=new v("");return s.parseRaw(o),s.configurationModel});this.f=n.reduce((o,s)=>s===o?s:o.merge(s),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,y.getConfigurationValue)(this.contents,n):this.contents}inspect(n,o){const s=this.rawConfiguration.getValue(n),a=o?this.rawConfiguration.getOverrideValue(n,o):void 0,r=o?this.rawConfiguration.override(o).getValue(n):s;return{value:s,override:a,merged:r}}getOverrideValue(n,o){const s=this.i(o);return s?n?(0,y.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const s of this.overrides)s.identifiers.includes(n)&&o.push(...s.keys);return E.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return E.distinct(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=I.deepClone(this.contents),s=I.deepClone(this.overrides),a=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const m of n)if(r.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.h(o,m.contents);for(const C of m.overrides){const[M]=s.filter(O=>E.equals(O.identifiers,C.identifiers));M?(this.h(M.contents,C.contents),M.keys.push(...C.keys),M.keys=E.distinct(M.keys)):s.push(I.deepClone(C))}for(const C of m.keys)a.indexOf(C)===-1&&a.push(C)}return new w(o,a,s,r.every(m=>m instanceof w)?void 0:r)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const s={};for(const a of E.distinct([...Object.keys(this.contents),...Object.keys(o)])){let r=this.contents[a];const m=o[a];m&&(typeof r=="object"&&typeof m=="object"?(r=I.deepClone(r),this.h(r,m)):r=m),s[a]=r}return new w(s,this.keys,this.overrides)}h(n,o){for(const s of Object.keys(o)){if(s in n&&d.isObject(n[s])&&d.isObject(o[s])){this.h(n[s],o[s]);continue}n[s]=I.deepClone(o[s])}}i(n){let o=null,s=null;const a=r=>{r&&(s?this.h(s,r):s=I.deepClone(r))};for(const r of this.overrides)E.equals(r.identifiers,[n])?o=r.contents:r.identifiers.includes(n)&&a(r.contents);return a(o),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,y.removeFromValueTree)(this.contents,n),p.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(s=>E.equals(s.identifiers,(0,p.overrideIdentifiersFromKey)(n))),1))}j(n,o,s){(0,y.addToValueTree)(this.contents,n,o,a=>console.error(a)),s=s||this.keys.indexOf(n)===-1,s&&this.keys.push(n),p.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,y.toValuesTree)(this.contents[n],a=>console.error(a))})}}e.ConfigurationModel=w;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!d.isUndefinedOrNull(n)){const s=this.g(n);this.parseRaw(s,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:s,keys:a,overrides:r,restricted:m,hasExcludedProperties:C}=this.h(n,o);this.b=new w(s,a,r,C?[n]:void 0),this.c=m||[]}g(n){let o={},s=null,a=[];const r=[],m=[];function C(O){Array.isArray(a)?a.push(O):s!==null&&(a[s]=O)}const M={onObjectBegin:()=>{const O={};C(O),r.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const O=[];C(O),r.push(a),a=O,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:C,onError:(O,B,J)=>{m.push({error:O,offset:B,length:J})}};if(n)try{P.visit(n,M),o=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return o}h(n,o){const s=b.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.i(n,s,!0,o);n=a.raw;const r=(0,y.toValuesTree)(n,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),m=Object.keys(n),C=this.j(n,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:r,keys:m,overrides:C,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(n,o,s,a){let r=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:r};const m={},C=[];for(const M in n)if(p.OVERRIDE_PROPERTY_REGEX.test(M)&&s){const O=this.i(n[M],o,!1,a);m[M]=O.raw,r=r||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=o[M],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(M),(B===void 0||a.scopes===void 0||a.scopes.includes(B))&&!(a.skipRestricted&&O?.restricted)?m[M]=n[M]:r=!0}return{raw:m,restricted:C,hasExcludedProperties:r}}j(n,o){const s=[];for(const a of Object.keys(n))if(p.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const m in n[a])r[m]=n[a][m];s.push({identifiers:(0,p.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,y.toValuesTree)(r,o)})}return s}}e.ConfigurationModelParser=v;class c extends D.Disposable{constructor(n,o,s,a){super(),this.f=n,this.g=o,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new w}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class u{constructor(n,o,s,a,r,m,C,M,O,B,J,G,X){this.a=n,this.b=o,this.c=s,this.overrideIdentifiers=a,this.d=r,this.f=m,this.g=C,this.h=M,this.i=O,this.j=B,this.k=J,this.l=G,this.m=X}get value(){return f(this.c)}n(n,o,s){const a=n.inspect(o,s);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(n,o,s,a,r=new w,m=new w,C=new R.ResourceMap,M=new w,O=new R.ResourceMap){this.c=n,this.d=o,this.f=s,this.g=a,this.h=r,this.i=m,this.j=C,this.l=M,this.m=O,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(n,o,s){return this.q(n,o,s).getValue(n)}updateValue(n,o,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new w,this.m.set(s.resource,a))):a=this.l,o===void 0?a.removeValue(n):a.setValue(n,o),s.resource||(this.a=null)}inspect(n,o,s){const a=this.q(n,o,s),r=this.u(o.resource,s),m=o.resource?this.m.get(o.resource)||this.l:this.l,C=new Set;for(const M of a.overrides)for(const O of M.identifiers)a.getOverrideValue(n,O)!==void 0&&C.add(O);return new u(n,o,a.getValue(n),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,r||void 0,m)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const s=[];if(!o){const{added:a,updated:r,removed:m}=L(this.c,n);o=[...a,...r,...m]}for(const a of o)for(const r of(0,p.overrideIdentifiersFromKey)(a)){const m=this.c.getKeysForOverrideIdentifier(r),C=n.getKeysForOverrideIdentifier(r),M=[...C.filter(O=>m.indexOf(O)===-1),...m.filter(O=>C.indexOf(O)===-1),...m.filter(O=>!I.equals(this.c.override(r).getValue(O),n.override(r).getValue(O)))];s.push([r,M])}return this.updateDefaultConfiguration(n),{keys:o,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:s,removed:a}=L(this.d,n),r=[...o,...s,...a];return r.length&&this.updatePolicyConfiguration(n),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:s,removed:a,overrides:r}=L(this.applicationConfiguration,n),m=[...o,...s,...a];return m.length&&this.updateApplicationConfiguration(n),{keys:m,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:s,removed:a,overrides:r}=L(this.localUserConfiguration,n),m=[...o,...s,...a];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:r}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:s,removed:a,overrides:r}=L(this.remoteUserConfiguration,n),m=[...o,...s,...a];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:r}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:s,removed:a,overrides:r}=L(this.workspaceConfiguration,n),m=[...o,...s,...a];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:r}}compareAndUpdateFolderConfiguration(n,o){const s=this.p.get(n),{added:a,updated:r,removed:m,overrides:C}=L(s,o),M=[...a,...r,...m];return(M.length||!s)&&this.updateFolderConfiguration(n,o),{keys:M,overrides:C}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:a,removed:r,overrides:m}=L(o,void 0);return{keys:[...s,...a,...r],overrides:m}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,s){let a=this.r(o,s);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}r({resource:n},o){let s=this.s();if(o&&n){const a=o.getFolder(n);a&&(s=this.t(a.uri)||s);const r=this.m.get(n);r&&(s=s.merge(r))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const s=this.s(),a=this.j.get(n);a?(o=s.merge(a),this.b.set(n,o)):o=s}return o}u(n,o){if(o&&n){const s=o.getFolder(n);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:s,overrides:a,keys:r}=this.j.get(o);return n.push([o,{contents:s,overrides:a,keys:r}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(s=>n.add(s))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this.i.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(a=>o.add(a))),[...o.values()]}static parse(n){const o=this.x(n.defaults),s=this.x(n.policy),a=this.x(n.application),r=this.x(n.user),m=this.x(n.workspace),C=n.folders.reduce((M,O)=>(M.set(h.URI.revive(O[0]),this.x(O[1])),M),new R.ResourceMap);return new g(o,s,a,r,new w,m,C,new w,new R.ResourceMap)}static x(n){return new w(n.contents,n.keys,n.overrides)}}e.Configuration=g;function k(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,o=new Map;for(const a of l)a.keys.forEach(r=>n.add(r)),a.overrides.forEach(([r,m])=>{const C=(0,R.getOrSet)(o,r,new Set);m.forEach(M=>C.add(M))});const s=[];return o.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=k;class S{constructor(n,o,s,a){this.change=n,this.f=o,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of n.keys)this.affectedKeys.add(r);for(const[,r]of n.overrides)for(const m of r)this.affectedKeys.add(m);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(n,o){const s=this.a+n,a=this.d.indexOf(s);if(a<0)return!1;const r=a+s.length;if(r>=this.d.length)return!1;const m=this.d.charCodeAt(r);if(m!==this.b&&m!==this.c)return!1;if(o){const C=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,M=this.g.getValue(n,o,this.h);return!I.equals(C,M)}return!0}}e.ConfigurationChangeEvent=S;function L(l,n){const{added:o,removed:s,updated:a}=i(n?.rawConfiguration,l?.rawConfiguration),r=[],m=l?.getAllOverrideIdentifiers()||[],C=n?.getAllOverrideIdentifiers()||[];if(n){const M=C.filter(O=>!m.includes(O));for(const O of M)r.push([O,n.getKeysForOverrideIdentifier(O)])}if(l){const M=m.filter(O=>!C.includes(O));for(const O of M)r.push([O,l.getKeysForOverrideIdentifier(O)])}if(n&&l){for(const M of m)if(C.includes(M)){const O=i({contents:l.getOverrideValue(void 0,M)||{},keys:l.getKeysForOverrideIdentifier(M)},{contents:n.getOverrideValue(void 0,M)||{},keys:n.getKeysForOverrideIdentifier(M)});r.push([M,[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:s,updated:a,overrides:r}}function i(l,n){const o=l?n?l.keys.filter(r=>n.keys.indexOf(r)===-1):[...l.keys]:[],s=n?l?n.keys.filter(r=>l.keys.indexOf(r)===-1):[...n.keys]:[],a=[];if(l&&n){for(const r of n.keys)if(l.keys.indexOf(r)!==-1){const m=(0,y.getConfigurationValue)(n.contents,r),C=(0,y.getConfigurationValue)(l.contents,r);I.equals(m,C)||a.push(r)}}return{added:o,removed:s,updated:a}}}),define(te[222],ie([0,1,25,3,2,44,11,111,67,5,39,48]),function(V,e,E,t,P,D,R,I,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,p.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new I.ConfigurationModel;const c=p.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const g=this.f();for(const k of c){const S=g[k],L=u[k];S!==void 0?this.b.addValue(k,S):L?this.b.addValue(k,L.default):this.b.removeValue(k)}}}e.DefaultConfiguration=b;class f{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let w=class extends P.Disposable{get configurationModel(){return this.b}constructor(c,u,g){super(),this.c=c,this.f=u,this.g=g,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},g=[],k=p.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const S of c){const L=k[S];if(!L){g.push(S);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}g.push(S),u[L.policy.name]={type:L.type}}}return(0,R.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),g}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=p.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),g=(0,E.coalesce)(c.map(k=>u.get(k)));this.j(g,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const g=p.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),k=[],S=this.b.isEmpty();for(const L of c){const i=g[L]?.policy?.name;if(i){const l=this.f.getPolicyValue(i);(S?l!==void 0:!(0,D.equals)(this.b.getValue(L),l))&&k.push([L,l])}else this.b.getValue(L)!==void 0&&k.push([L,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const L=this.b;this.b=new I.ConfigurationModel;for(const i of L.keys)this.b.setValue(i,L.getValue(i));for(const[i,l]of k)l===void 0?this.b.removeValue(i):this.b.setValue(i,l);u&&this.a.fire(this.b)}}};w=pe([ee(1,y.IPolicyService),ee(2,h.ILogService)],w),e.PolicyConfiguration=w}),define(te[223],ie([0,1,8,3,2,20,18,111,222,39]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends P.Disposable{constructor(b,f,w,v){super(),this.i=b,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=w instanceof h.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,w,v)),this.f=this.B(new I.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,f)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,f,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(b,f,new I.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(b,f){const w=typeof b=="string"?b:void 0,v=(0,R.isConfigurationOverrides)(b)?b:(0,R.isConfigurationOverrides)(f)?f:{};return this.a.getValue(w,v,void 0)}updateValue(b,f,w,v){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const f=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(w,f,2)}k(b,f){const w=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(b,f);this.m(v,w,7)}l(b){const f=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(b);this.m(w,f,7)}m(b,f,w){const v=new I.ConfigurationChangeEvent(b,{data:f},this.a);v.source=w,v.sourceConfig=this.n(w),this.h.fire(v)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(te[224],ie([0,1,13,6]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends E.ErrorNoTelemetry{static isNotAvailable(d){return d instanceof D&&d._code===P.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof D&&d._code===P.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof D&&d._code===P.NoResolverFound}static isHandled(d){return d instanceof D&&d.isHandled}constructor(d,h=P.Unknown,y){super(d),this._message=d,this._code=h,this._detail=y,this.isHandled=h===P.NotAvailable&&y===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function R(I){const d=I.indexOf("+");return d===-1?I:I.substring(0,d)}e.getRemoteAuthorityPrefix=R}),define(te[55],ie([0,1,15]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(h){return h.scheme===E.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=t;function P(h){if(!h)return;const y=h.indexOf("+");return y<0?h:h.substr(0,y)}e.getRemoteName=P;function D(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=D;function R(h){const{host:y,port:p}=d(h);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:p}}e.parseAuthorityWithPort=R;function I(h,y){let{host:p,port:b}=d(h);return typeof b>"u"&&(b=y),{host:p,port:b}}e.parseAuthorityWithOptionalPort=I;function d(h){const y=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const p=h.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const b=h.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:h,port:void 0}}}),define(te[90],ie([0,1,27,6,55]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=D;function R(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var d;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,c){if(typeof v>"u"||v===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof v=="string"||typeof c=="string"){const u=typeof v=="string"?v:v.value,g=typeof c=="string"?c:c.value;return E.equalsIgnoreCase(u,g)}return v.c===c.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=h;function y(w){return p(w)}e.isApplicationScopedExtension=y;function p(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function b(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function f(w,v){if(v){const c=`onResolveRemoteAuthority:${(0,P.getRemoteName)(v)}`;return w.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[225],ie([0,1,8,17,22,13,3,2,63,70,31,104,224,55]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var v;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function c(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(T){const W=new P.CancellationTokenSource;return setTimeout(()=>W.cancel(),T),W.token}function g(T,W){if(T.isCancellationRequested||W.isCancellationRequested)return P.CancellationToken.Cancelled;const j=new P.CancellationTokenSource;return T.onCancellationRequested(()=>j.cancel()),W.onCancellationRequested(()=>j.cancel()),j.token}class k{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new I.DisposableStore,this.promise=new Promise((j,K)=>{this.f=j,this.g=K}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function S(T,W){const j=new k(W);return j.registerDisposable(T.onControlMessage(K=>{const N=JSON.parse(K.toString()),q=z(N);q?j.reject(q):j.resolve(N)})),j.promise}function L(T,W,j,K,N,q,Z,oe,le){const be=new k(le),Ce=h.StopWatch.create(!1);return T.info(`Creating a socket (${oe})...`),d.mark(`code/willCreateSocket/${Z}`),W.connect(j,K,N,q,oe,(Oe,Le)=>{be.didTimeout?(d.mark(`code/didCreateSocketError/${Z}`),T.info(`Creating a socket (${oe}) finished after ${Ce.elapsed()} ms, but this is too late and has timed out already.`),Oe&&T.error(Oe),Le?.dispose()):Oe||!Le?(d.mark(`code/didCreateSocketError/${Z}`),T.info(`Creating a socket (${oe}) returned an error after ${Ce.elapsed()} ms.`),be.reject(Oe)):(d.mark(`code/didCreateSocketOK/${Z}`),T.info(`Creating a socket (${oe}) was successful after ${Ce.elapsed()} ms.`),be.resolve(Le))}),be.promise}function i(T,W){const j=new k(W);return T.then(K=>{j.didTimeout||j.resolve(K)},K=>{j.didTimeout||j.reject(K)}),j.promise}async function l(T,W,j,K){const N=$(T,W);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let q;try{q=await L(T.logService,T.socketFactory,T.host,T.port,(0,f.getRemoteServerRootPath)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,c(W),`renderer-${c(W)}-${T.reconnectionToken}`,K)}catch(Ce){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(Ce),Ce}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Z,oe;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(q,null),Z=T.reconnectionProtocol,oe=!1):(Z=new p.PersistentProtocol({socket:q,measureRoundTripTime:!0}),oe=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const le=await i(T.signService.createNewMessage((0,y.generateUuid)()),K),be={type:"auth",auth:T.connectionToken||"00000000000000000000",data:le.data};Z.sendControl(t.VSBuffer.fromString(JSON.stringify(be)));try{const Ce=await S(Z,g(K,u(1e4)));if(Ce.type!=="sign"||typeof Ce.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(T.logService.trace(`${N} 4/6. received SignRequest control message.`),!await i(T.signService.validate(le,Ce.signedData),K)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const Le=await i(T.signService.sign(Ce.data),K),we={type:"connectionType",commit:T.commit,signedData:Le,desiredConnectionType:W};return j&&(we.args=j),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(t.VSBuffer.fromString(JSON.stringify(we))),{protocol:Z,ownsProtocol:oe}}catch(Ce){throw Ce&&Ce.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(Ce)),Ce&&Ce.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(Ce)),oe&&U(Z),Ce}}async function n(T,W,j,K){const N=Date.now(),q=$(T,W),{protocol:Z,ownsProtocol:oe}=await l(T,W,j,K),le=new k(K);return le.registerDisposable(Z.onControlMessage(be=>{const Ce=JSON.parse(be.toString()),Oe=z(Ce);Oe?(T.logService.error(`${q} received error control message when negotiating connection. Error:`),T.logService.error(Oe),oe&&U(Z),le.reject(Oe)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${A(N)}!`),le.resolve({protocol:Z,firstMessage:Ce}))})),le.promise}async function o(T,W){const{protocol:j}=await n(T,1,void 0,W);return{protocol:j}}async function s(T,W,j){const{protocol:K,firstMessage:N}=await n(T,2,W,j),q=N&&N.debugPort;return{protocol:K,debugPort:q}}async function a(T,W,j){const K=Date.now(),N=$(T,3),{protocol:q}=await l(T,3,W,j);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${A(K)}!`),q}async function r(T,W,j){const{host:K,port:N,connectionToken:q}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,host:K,port:N,connectionToken:q,reconnectionToken:W,reconnectionProtocol:j,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function m(T,W,j){return M(T,async K=>{const{protocol:N}=await o(K,P.CancellationToken.None);return new H(T,W,j,K.reconnectionToken,N)})}e.connectRemoteAgentManagement=m;async function C(T,W){return M(T,async j=>{const{protocol:K,debugPort:N}=await s(j,W,P.CancellationToken.None);return new F(T,W,j.reconnectionToken,K,N)})}e.connectRemoteAgentExtensionHost=C;async function M(T,W){for(let K=1;;K++)try{const N=(0,y.generateUuid)(),q=await r(T,N,null);return await W(q)}catch(N){if(K<5)T.logService.error(`[remote-connection][attempt ${K}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(N);else throw T.logService.error(`[remote-connection][attempt ${K}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(N),ge.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(N)),N}}async function O(T,W,j){const K=await r(T,(0,y.generateUuid)(),null);return await a(K,{host:W,port:j},P.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function B(T){return(0,E.createCancelablePromise)(W=>new Promise((j,K)=>{const N=setTimeout(j,T*1e3);W.onCancellationRequested(()=>{clearTimeout(N),j()})}))}var J;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain",T[T.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(J=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class G{constructor(W,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=j,this.type=0}}e.ConnectionLostEvent=G;class X{constructor(W,j,K,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=j,this.durationSeconds=K,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=X;class re{constructor(W,j,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=j,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=re;class se{constructor(W,j,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=j,this.attempt=K,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(W,j){this.reconnectionToken=W,this.connectionHealth=j,this.type=5}}e.ConnectionHealthChangedEvent=ae;class fe{constructor(W,j,K,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=j,this.attempt=K,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends I.Disposable{static triggerPermanentFailure(W,j,K){this._permanentFailure=!0,this.f=W,this.g=j,this.h=K,this.i.forEach(N=>N.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(W=>W.r())}static debugPauseSocketWriting(){this.i.forEach(W=>W.v())}get k(){return this.c||ge._permanentFailure}constructor(W,j,K,N,q){super(),this.m=W,this.n=j,this.reconnectionToken=K,this.protocol=N,this.p=q,this.j=this.B(new R.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B(N.onSocketClose(Z=>{const oe=_(this.m,this.reconnectionToken,!0);Z?Z.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.n.logService.error(Z.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.n.logService.error(Z.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(N.onSocketTimeout(Z=>{const oe=_(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(N.onHighRoundTripTime(Z=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${Z.roundTripTime}ms (${Z.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(N.onDidChangeConnectionHealth(Z=>{this.j.fire(new ae(this.reconnectionToken,Z))})),ge.i.push(this),this.B((0,I.toDisposable)(()=>{const Z=ge.i.indexOf(this);Z>=0&&ge.i.splice(Z,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const W=_(this.m,this.reconnectionToken,!0);this.n.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let K=-1;do{K++;const N=K<j.length?j[K]:j[j.length-1];try{if(N>0){const Z=B(N);this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Z)),this.n.logService.info(`${W} waiting for ${N} seconds before reconnecting...`);try{await Z}catch{}}if(this.k){this.n.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1)),this.n.logService.info(`${W} resolving connection...`);const q=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${W} connecting to ${q.host}:${q.port}...`),await this.w(q,u(w)),this.n.logService.info(`${W} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(K>360){this.n.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this.n.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.n.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((0,D.isCancellationError)(q)){this.n.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if(q instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),K+1,b.RemoteAuthorityResolverError.isHandled(q));break}this.n.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}}while(!this.k)}t(W,j,K){this.p?ge.triggerPermanentFailure(W,j,K):this.u(W,j,K)}u(W,j,K){this.j.fire(new fe(this.reconnectionToken,W,j,K)),U(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class H extends ge{constructor(W,j,K,N,q){super(1,W,N,q,!0),this.client=this.B(new p.Client(q,{remoteAuthority:j,clientId:K},W.ipcLogger))}async w(W,j){await o(W,j)}}e.ManagementPersistentConnection=H;class F extends ge{constructor(W,j,K,N,q){super(2,W,K,N,!1),this.y=j,this.debugPort=q}async w(W,j){await s(W,this.y,j)}}e.ExtensionHostPersistentConnection=F;function U(T){try{T.acceptDisconnect();const W=T.getSocket();T.dispose(),W.dispose()}catch(W){(0,D.onUnexpectedError)(W)}}function z(T){if(T&&T.type==="error"){const W=new Error(`Connection error: ${T.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Q(T,W){for(;T.length<W;)T+=" ";return T}function ne(T,W){return`[remote-connection][${Q(c(T),13)}][${W.substr(0,5)}\u2026]`}function _(T,W,j){return`${ne(T,W)}[${j?"reconnect":"initial"}]`}function $(T,W){return`${_(W,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function A(T){return`${Date.now()-T} ms`}}),define(te[226],ie([0,1,81,86]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,D,R,I,d,h){const y=b=>h(b,void 0),p=E.createConnection({host:P,port:D},()=>{p.removeListener("error",y);const b=Buffer.alloc(16);for(let c=0;c<16;c++)b[c]=Math.round(Math.random()*256);const f=b.toString("base64"),w=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${D}${R}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];p.write(w.join(`\r
`)+`\r
\r
`);const v=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",v),h(void 0,new t.NodeSocket(p,d)))};p.on("data",v)});p.setNoDelay(!0),p.once("error",y)}}}),define(te[227],ie([0,1,26,46,41,185]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function I(f=!1){return(R===void 0||f)&&(R=d()),R}e.hasWSLFeatureInstalled=I;async function d(){const f=h();if(f===void 0)return!1;if(f>=22e3){const w=p();if(w)return new Promise(v=>{t.execFile(w,["--status"],c=>v(!c))})}else{const w=b();if(w)try{if((await P.promises.stat(w)).isFile())return!0}catch{}}return!1}function h(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function y(f){const w=process.env.SystemRoot;if(w){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(w,v?"Sysnative":"System32",f)}}function p(){return y("wsl.exe")}function b(){return y("lxss\\LxssManager.dll")}}),define(te[56],ie([0,1,17,169,67,6,48]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function I(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=I;function d(v){return v.res.statusCode===204}async function h(v){return d(v)?null:(await(0,E.streamToBuffer)(v.stream)).toString()}e.asText=h;async function y(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);return h(v)}e.asTextOrError=y;async function p(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);if(d(v))return null;const u=(await(0,E.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=p;function b(v){w(v)}e.updateProxyConfigurationsScope=b;let f;function w(v){const c=R.Registry.as(P.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:u?[u]:[]})}w(2)}),define(te[228],ie([0,1,17,22]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(I){this.a=I}listen(I,d){throw new Error("Invalid listen")}call(I,d,h,y=t.CancellationToken.None){switch(d){case"request":return this.a.request(h[0],y).then(async({res:p,stream:b})=>{const f=await(0,E.streamToBuffer)(b);return[{statusCode:p.statusCode,headers:p.headers},f]});case"resolveProxy":return this.a.resolveProxy(h[0])}throw new Error("Invalid call")}}e.RequestChannel=P;class D{constructor(I){this.a=I}async request(I,d){const[h,y]=await this.a.call("request",[I],d);return{res:h,stream:(0,E.bufferToStream)(y)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.RequestChannelClient=D}),define(te[229],ie([0,1,230,11]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(R,I){return R.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:R.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(R,I,d={}){const h=(0,E.parse)(R),y=d.proxyUrl||P(h,I);if(!y)return null;const p=(0,E.parse)(y);if(!/^https?:$/.test(p.protocol||""))return null;const b={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,t.isBoolean)(d.strictSSL)?d.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((f,w)=>{V(["http-proxy-agent"],f,w)}))(b):new(await new Promise((f,w)=>{V(["https-proxy-agent"],f,w)}))(b)}e.getProxyAgent=D}),define(te[112],ie([0,1,46,9,170,22,45,13,4,31,146,61,8,128]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let w;async function v(u,g,k,S){return k["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(S)&&!k["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(S)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=b.Promises.withAsyncBody(async(L,i)=>{const l=new D.CancellationTokenSource;let n=1e4;const o=u.getValue("application.shellEnvironmentResolutionTimeout");typeof o=="number"&&(n=(0,f.clamp)(o,1,120)*1e3);const s=setTimeout(()=>{l.dispose(!0),i(new Error((0,P.localize)(0,null)))},n);try{L(await c(g,l.token))}catch(a){!(0,I.isCancellationError)(a)&&!l.token.isCancellationRequested?i(new Error((0,P.localize)(1,null,(0,R.toErrorMessage)(a)))):L({})}finally{clearTimeout(s),l.dispose()}})),w)}e.getResolvedShellEnv=v;async function c(u,g){const k=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",S);const L=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(L+"({.*})"+L),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",l);const n=await(0,y.getSystemShell)(d.OS,l);return u.trace("getUnixShellEnvironment#shell",n),new Promise((o,s)=>{if(g.isCancellationRequested)return s(new I.CancellationError);const a=(0,t.basename)(n);let r,m;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(r=`& '${process.execPath}' ${C} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,m=["-Login","-Command"]):(r=`'${process.execPath}' ${C} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,a==="tcsh"||a==="csh"?m=["-ic"]:m=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),r);const M=(0,E.spawn)(n,[...m,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});g.onCancellationRequested(()=>(M.kill(),s(new I.CancellationError))),M.on("error",J=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(J)),s(J)});const O=[];M.stdout.on("data",J=>O.push(J));const B=[];M.stderr.on("data",J=>B.push(J)),M.on("close",(J,G)=>{const X=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",X);const re=Buffer.concat(B).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),J||G)return s(new Error((0,P.localize)(2,null,J,G)));const se=i.exec(X),ae=se?se[1]:"{}";try{const fe=JSON.parse(ae);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,S?fe.ELECTRON_NO_ATTACH_CONSOLE=S:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),o(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(fe)),s(fe)}})})}}),define(te[91],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[231],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((P,D)=>V(["vsda"],P,D))}async createNewMessage(P){try{const D=await this.c(),R=new D.validator;if(R){const I=String(E.a++);return this.b.set(I,R),{id:I,data:R.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,D){if(!P.id)return!0;const R=this.b.get(P.id);if(!R)return!1;this.b.delete(P.id);try{return R.validate(D)==="ok"}catch{return!1}}async sign(P){try{const D=await this.c(),R=new D.signer;if(R)return R.sign(P)}catch{}return P}}e.SignService=E,E.a=1}),define(te[34],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(te[21],ie([0,1,14,42,8,3,2,4,35,11,6,5,34,28]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var w;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let c=class kt extends R.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,k,S){super(),this.v=g,this.w=k,this.y=S,this.c=this.B(new D.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new D.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(kt.b),this.j&&this.w.removeItem(kt.b)}C(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",g);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!I.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",k),E.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit)"),S.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",g),E.app.removeListener("window-all-closed",k),E.app.quit()})})}D(g){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:g,join(S){k.push(S)}}),this.s=(async()=>{try{await P.Promises.settled(k)}catch(S){this.v.error(S)}try{await this.w.close()}catch(S){this.v.error(S)}})(),this.s}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(g){if(g<=this.k)return;let k=this.u.get(g);k||(k=new P.Barrier,this.u.set(g,k)),await k.wait()}registerWindow(g){const k=new R.DisposableStore;this.n++,k.add(g.onWillLoad(L=>this.g.fire({window:g,workspace:L.workspace,reason:L.reason})));const S=(0,h.assertIsDefined)(g.win);S.on("close",L=>{const i=g.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),L.preventDefault(),this.unload(g,1).then(l=>{if(l){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(g),g.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,k.dispose(),this.n===0&&(!I.isMacintosh||this.i)&&this.D(1)})}async reload(g,k){await this.unload(g,3)||g.reload(k)}unload(g,k){const S=this.t.get(g.id);if(S)return S;const L=this.F(g,k).finally(()=>{this.t.delete(g.id)});return this.t.set(g.id,L),L}async F(g,k){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const S=this.i?2:k,L=await this.I(g,S);return L?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(L)):(await this.J(g,S),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.r&&(this.r(g),this.r=void 0,this.p=void 0)}I(g,k){return new Promise(S=>{const L=this.m++,i=`vscode:ok${L}`,l=`vscode:cancel${L}`;t.validatedIpcMain.once(i,()=>{S(!1)}),t.validatedIpcMain.once(l,()=>{S(!0)}),g.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:l,reason:k})})}J(g,k){return new Promise(S=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>S()),g.send("vscode:onWillUnload",{replyChannel:i,reason:k})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.w.setItem(kt.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(g){this.y.args["enable-smoke-test-driver"]?this.v.info(g):this.v.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(g?.addArgs&&k.push(...g.addArgs),g?.removeArgs)for(const i of g.removeArgs){const l=k.indexOf(i);l>=0&&k.splice(l,1)}const S=()=>{try{if(I.isWindows){const i=(0,d.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:k})};E.app.once("quit",S),await this.quit(!0)&&E.app.removeListener("quit",S)}async kill(g){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,P.timeout)(1e3),(async()=>{for(const k of E.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let S;k.webContents&&!k.webContents.isDestroyed()?S=new Promise(L=>k.once("closed",L)):S=Promise.resolve(),k.destroy(),await S}})()]),E.app.exit(g)}};c.b="lifecycle.quitAndRestart",c=pe([ee(0,p.ILogService),ee(1,b.IStateMainService),ee(2,f.IEnvironmentMainService)],c),e.LifecycleMainService=c}),define(te[232],ie([0,1,4,3,2,6,21]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let I=class extends P.Disposable{constructor(y){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((p,b)=>{V(["native-keymap"],p,b)});this.c=d(y),E.isCI||y.onDidChangeKeyboardLayout(()=>{this.c=d(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};I=pe([ee(0,R.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function d(h){const y=h.getKeyMap(),p=h.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:p}}}),define(te[233],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(te[234],ie([0,1,8,17,11,33,16,5]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(p,b,f){this.f=p,this.g=b,this.h=f,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,b){const f=this.a[p];return(0,P.isUndefinedOrNull)(f)?b:f}setItem(p,b){this.setItems([{key:p,data:b}])}setItems(p){let b=!1;for(const{key:f,data:w}of p)this.a[f]!==w&&((0,P.isUndefinedOrNull)(w)?(0,P.isUndefined)(this.a[f])||(this.a[f]=void 0,b=!0):(this.a[f]=w,b=!0));b&&this.j()}removeItem(p){(0,P.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(p)),this.b=p}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=d;let h=class{constructor(p,b,f){this.a=new d(p.stateResource,b,f)}async init(){await this.a.init()}getItem(p,b){return this.a.getItem(p,b)}};h=pe([ee(0,D.IEnvironmentService),ee(1,I.ILogService),ee(2,R.IFileService)],h),e.StateService=h}),define(te[235],ie([0,1,234]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(D,R){this.a.setItem(D,R)}setItems(D){this.a.setItems(D)}removeItem(D){this.a.removeItem(D)}close(){return this.a.close()}}e.StateMainService=t}),define(te[92],ie([0,1,4,35,7,31]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(h){if(E.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function I(h,y,p,b,f,w,v,c,u,g){const k=Object.create(null);k["common.machineId"]=v,k.sessionID=(0,D.generateUuid)()+Date.now(),k.commitHash=f,k.version=w,k["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,E.PlatformToString)(E.platform),k["common.nodePlatform"]=t.platform,k["common.nodeArch"]=b,k["common.product"]=g||"desktop",c&&(k["common.msftInternal"]=c);let S=0;const L=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-L,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),E.isLinuxSnap&&(k["common.snap"]="true");const i=R(p);i&&(k["common.platformDetail"]=i);try{const l=await h.readFile(P.URI.file(u));k["common.source"]=l.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=I;function d(h){const y=t.env.USERDNSDOMAIN;if(!y)return!1;const p=y.toLowerCase();return h.some(b=>p===b)}e.verifyMicrosoftInternalDomain=d}),define(te[24],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[236],ie([0,1,26,8,43,15,9,4,7,84,23,103,87,16,19,24]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(i,l){const n=`${i}::${l.join(":")}`,o=c.get(n);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,r=new Map,m=2e4;function C(O,B,J,G){const X=B.substring(O.length+1);return t.Promises.withAsyncBody(async re=>{let se;try{se=await y.Promises.readdir(B,{withFileTypes:!0})}catch{re();return}if(G.count>=m){G.count+=se.length,G.maxReached=!0,re();return}let ae=se.length;if(ae===0){re();return}let fe=se;G.count+se.length>m&&(G.maxReached=!0,ae=m-G.count,fe=se.slice(0,ae)),G.count+=se.length;for(const ge of fe)if(ge.isDirectory()){if(J.includes(ge.name)||await C(O,(0,R.join)(B,ge.name),J,G),--ae===0){re();return}}else{const H=ge.name.lastIndexOf(".");if(H>=0){const F=ge.name.substring(H+1);F&&a.set(F,(a.get(F)??0)+1)}for(const F of s)F.relativePathPattern?.test(X)!==!1&&F.filePattern.test(ge.name)&&r.set(F.tag,(r.get(F.tag)??0)+1);if(--ae===0){re();return}}})}const M=t.Promises.withAsyncBody(async O=>{const B={count:0,maxReached:!1};await C(i,i,l,B);const J=await S(i);O({configFiles:g(r),fileTypes:g(a),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:J})});return c.set(n,M),M}e.collectWorkspaceStats=u;function g(i){return Array.from(i.entries(),([l,n])=>({name:l,count:n})).sort((l,n)=>n.count-l.count)}function k(){const i={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},l=E.cpus();return l&&l.length>0&&(i.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),i}e.getMachineInfo=k;async function S(i){try{const l=new Map,n=(0,R.join)(i,".vscode","launch.json"),o=await y.Promises.readFile(n),s=[],a=(0,P.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,P.getNodeType)(a)==="object"&&a.configurations)for(const r of a.configurations){const m=r.type;m&&(l.has(m)?l.set(m,l.get(m)+1):l.set(m,1))}return g(l)}catch{return[]}}e.collectLaunchConfigs=S;let L=class{constructor(l,n){this.c=l,this.d=n}f(l){const n=[];return n.push(`OS Version:       ${l.os}`),n.push(`CPUs:             ${l.cpus}`),n.push(`Memory (System):  ${l.memory}`),n.push(`VM:               ${l.vmHint}`),n.join(`
`)}g(l){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||n.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${l.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(l,n){return Promise.all([(0,p.listProcesses)(l.mainPID),this.k(l)]).then(async o=>{let[s,a]=o,r=this.m(l,s);return n.forEach(m=>{if((0,b.isRemoteDiagnosticError)(m))r+=`
${m.errorMessage}`,a+=`
${m.errorMessage}`;else if(r+=`

Remote: ${m.hostName}`,m.processes&&(r+=`
${this.m(l,m.processes)}`),m.workspaceMetadata){a+=`
|  Remote: ${m.hostName}`;for(const C of Object.keys(m.workspaceMetadata)){const M=m.workspaceMetadata[C];let O=`${M.fileCount} files`;M.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${C}): ${O}`,a+=this.h(M)}}}),{processInfo:r,workspaceInfo:a}})}async getSystemInfo(l,n){const{memory:o,vmHint:s,os:a,cpus:r}=k(),m={os:a,memory:o,cpus:r,vmHint:s,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:n};return I.isWindows||(m.load=`${E.loadavg().map(C=>Math.round(C)).join(", ")}`),I.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(l,n){const o=[];return(0,p.listProcesses)(l.mainPID).then(async s=>(o.push(""),o.push(this.g(l)),o.push(""),o.push(this.m(l,s)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(l))),n.forEach(a=>{if((0,b.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.f(a.machineInfo)),a.processes&&o.push(this.m(l,a.processes)),a.workspaceMetadata)for(const r of Object.keys(a.workspaceMetadata)){const m=a.workspaceMetadata[r];let C=`${m.fileCount} files`;m.maxFilesReached&&(C=`more than ${C}`),o.push(`Folder (${r}): ${C}`),o.push(this.h(m))}}),o.push(""),o.push(""),o.join(`
`)))}h(l){const n=[];let s=0;const a=(M,O)=>{const B=` ${M}(${O})`;s+B.length>60?(n.push(r),r="|                 ",s=r.length):s+=B.length,r+=B};let r="|      File types:";const m=10,C=l.fileTypes.length>m?m:l.fileTypes.length;for(let M=0;M<C;M++){const O=l.fileTypes[M];a(O.name,O.count)}if(n.push(r),l.configFiles.length>=0&&(r="|      Conf files:",s=0,l.configFiles.forEach(M=>{a(M.name,M.count)}),n.push(r)),l.launchConfigFiles.length>0){let M="|      Launch Configs:";l.launchConfigFiles.forEach(O=>{M+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(M)}return n.join(`
`)}j(l){const n=Math.max(...Object.keys(l).map(o=>o.length));return Object.keys(l).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${l[o]}`).join(`
                  `)}k(l){const n=[],o=[];return l.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const r=d.URI.revive(a);if(r.scheme===D.Schemas.file){const m=r.fsPath;o.push(u(m,["node_modules",".git"]).then(C=>{let M=`${C.fileCount} files`;C.maxFilesReached&&(M=`more than ${M}`),n.push(`|    Folder (${(0,R.basename)(m)}): ${M}`),n.push(this.h(C))}).catch(C=>{n.push(`|      Error: Unable to collect workspace stats for folder ${m} (${C.toString()})`)}))}else n.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(l,n){const o=new Map;l.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.n(l.mainPID,o,s,n,0),s.join(`
`)}n(l,n,o,s,a){const r=a===0;let m;r?m=s.pid===l?`${this.d.applicationName} main`:"remote agent":(m=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(m=`${m} (${n.get(s.pid)})`));const C=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(C/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(s.children)&&s.children.forEach(M=>this.n(l,n,o,M,a+1))}async getWorkspaceFileExtensions(l){const n=new Set;for(const{uri:o}of l.folders){const s=d.URI.revive(o);if(s.scheme!==D.Schemas.file)continue;const a=s.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(m=>n.add(m.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(l){for(const{uri:n}of l.folders){const o=d.URI.revive(n);if(o.scheme!==D.Schemas.file)continue;const s=o.fsPath;try{const a=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})}),a.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})}),a.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};L=pe([ee(0,v.ITelemetryService),ee(1,w.IProductService)],L),e.DiagnosticsService=L}),define(te[237],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(D){this.b=D}listen(D,R){throw new Error(`Event not found: ${R}`)}call(D,R,{eventName:I,data:d}){return this.b.forEach(h=>h.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(D){this.b=D}log(D,R){return this.b.call("log",{eventName:D,data:R}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[51],ie([0,1,44,11,3,18,55,92,24]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(r){this.value=r}}e.TelemetryTrustedValue=h;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,m){return Promise.resolve(void 0)}publicLog2(r,m){return this.publicLog(r,m)}publicLogError(r,m){return Promise.resolve(void 0)}publicLogError2(r,m){return this.publicLogError(r,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class p{async publicLog(r,m,C){}async publicLogError(r,m,C){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(a,r){return P.Event.debounce(r.onDidChangeConfiguration,(C,M)=>{const O=C?new Set([...C.affectedKeys,...M.affectedKeys]):M.affectedKeys;return{...M,affectedKeys:O}},1e3,!0)(C=>{C.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(C.source),configurationKeys:S(C.affectedKeys)})})}e.configurationTelemetry=b;function f(a,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!a.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function w(a,r){return!(r.isBuilt||r.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=w;function v(a){const r=a.getValue(d.TELEMETRY_SETTING_ID),m=a.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function c(a){const r={},m={},C={};k(a,C);for(let M in C){M=M.length>150?M.substr(M.length-149):M;const O=C[M];typeof O=="number"?m[M]=O:typeof O=="boolean"?m[M]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${O.length}`),r[M]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(r[M]=O)}return{properties:r,measurements:m}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(a){if(!a)return"none";const r=(0,R.getRemoteName)(a);return u.has(r)?r:"other"}e.cleanRemoteAuthority=g;function k(a,r,m=0,C){if(!!a)for(const M of Object.getOwnPropertyNames(a)){const O=a[M],B=C?C+M:M;Array.isArray(O)?r[B]=(0,E.safeStringify)(O):O instanceof Date?r[B]=O.toISOString():(0,t.isObject)(O)?m<2?k(O,r,m+1,B+"."):r[B]=(0,E.safeStringify)(O):r[B]=O}}function S(a){if(!a)return[];const r=[];return L(r,"",a),r}function L(a,r,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(C=>L(a,r?`${r}.${C}`:C,m[C])):a.push(r)}function i(a,r){const m=a.msftInternalDomains||[],C=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(m)||C}e.isInternalTelemetry=i;function l(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=l;function n(a,r){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let m=a;const C=[];for(const J of r)for(;;){const G=J.exec(a);if(!G)break;C.push([G.index,J.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let B=0;for(m="";;){const J=O.exec(a);if(!J)break;const G=C.some(([X,re])=>J.index<re&&X<O.lastIndex);!M.test(J[0])&&!G&&(m+=a.substring(B,J.index)+"<REDACTED: user-file-path>",B=O.lastIndex)}return B<a.length&&(m+=a.substr(B)),m}function o(a){if(!a)return a;const r=a.toLowerCase(),m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const C of m)if(C.regex.test(r))return`<REDACTED: ${C.label}>`;return a}function s(a,r){return(0,E.cloneAndChange)(a,m=>{if(m instanceof h)return m.value;if(typeof m=="string"){let C=m.replaceAll("%20"," ");C=n(C,r);for(const M of r)C=C.replace(M,"");return C=o(C),C}})}e.cleanData=s}),define(te[113],ie([0,1,27,195,90,4,7,13,35,51]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,E.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=y;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(o){const s=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new b(o.identifier,s,a)}static parse(o){const s=p.exec(o);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(o,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof b?y(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=b;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(n){const o=f.exec(n);return o&&o[1]?[c(o[1]),o[2]]:[c(n),void 0]}e.getIdAndVersion=w;function v(n,o){return`${n}.${o}`}e.getExtensionId=v;function c(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function u(n,o){return c(v(n,o))}e.getGalleryExtensionId=u;function g(n,o){const s=[],a=r=>{for(const m of s)if(m.some(C=>y(o(C),o(r))))return m;return null};for(const r of n){const m=a(r);m?m.push(r):s.push([r])}return s}e.groupByExtension=g;function k(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function S(n){return{id:new h.TelemetryTrustedValue(n.identifier.id),name:new h.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function L(n,o){const s=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const r=a.shift();if(r&&s.every(m=>!y(m.identifier,{id:r}))){const m=n.filter(C=>y(C.identifier,{id:r}));m.length===1&&(s.push(m[0]),a.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=L;async function i(n,o){if(!D.isLinux)return!1;let s;try{s=(await n.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function l(n,o){const s=await i(n,o),a=(0,t.getTargetPlatform)(s?"alpine":D.platform,d.arch);return o.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=l}),define(te[238],ie([0,1,192,51]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(D,R,I,d,h,y,p){const b={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${R.nameShort})`};if((0,t.supportsTelemetry)(R,I)&&(0,t.getTelemetryLevel)(d)===3){const f=await(0,E.getServiceMachineId)(I,h,y),{machineId:w}=await p.getTelemetryInfo();b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=w||f}return b}e.resolveMarketplaceHeaders=P}),define(te[239],ie([0,1,13,44,51]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function I(h,y,p){const b=await new Promise((u,g)=>{V(["@microsoft/1ds-core-js"],u,g)}),f=await new Promise((u,g)=>{V(["@microsoft/1ds-post-js"],u,g)}),w=new b.AppInsightsCore,v=new f.PostChannel,c={instrumentationKey:h,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(p){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:p};c.extensionConfig[v.identifier]=u}return w.initialize(c,[]),w.addTelemetryInitializer(u=>{y&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),w}class d{constructor(y,p,b,f,w){this.e=y,this.f=p,this.g=b,this.h=w,this.c=D,this.d=R,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(p=>{y(p)},p=>{(0,E.onUnexpectedError)(p),console.error(p)})}}log(y,p){if(!this.a)return;p=(0,t.mixin)(p,this.g),p=(0,P.validateTelemetryData)(p);const b=this.f+"/"+y;try{this.i(f=>{f.pluginVersionString=p?.properties.version??"Unknown",f.track({name:b,baseData:{name:b,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(te[114],ie([0,1,2,44,4,27,171,18,67,65,19,48,24,51]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(u,g,k){this.k=g,this.l=k,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(b.TELEMETRY_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,f.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const k=g.usage?3:g.error?2:0;u=Math.min(u,k)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,k=u["common.machineId"],S=u["common.firstSessionDate"],L=u["common.msftInternal"];return{sessionId:g,machineId:k,firstSessionDate:S,msftInternal:L}}dispose(){this.i.dispose()}n(u,g,k){return this.g<g?Promise.resolve(void 0):this.c.then(S=>{k=(0,t.mixin)(k,this.d),k=(0,f.cleanData)(k,this.j),k=(0,t.mixin)(k,S),this.b.forEach(L=>L.log(u,k))},S=>{console.error(S)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=pe([ee(1,I.IConfigurationService),ee(2,y.IProductService)],w),e.TelemetryService=w;function v(){const c=(0,R.localize)(0,null,h.default.nameLong),u=h.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=P.isWeb?"":(0,R.localize)(3,null),k=(0,R.localize)(4,null),S=(0,R.localize)(5,null),L=(0,R.localize)(6,null),i=(0,R.localize)(7,null),l=`
|       | ${k} | ${S} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,R.localize)(8,null);return`
${c} ${u} ${g}

&nbsp;

${i}
${l}

&nbsp;

${n}
`}p.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,R.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,R.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[240],ie([0,1,289,239]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends t.AbstractOneDataSystemAppender{constructor(R,I,d,h){const y={sendPOST:(p,b)=>{const f={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const w=E.request(p.urlString,f,v=>{v.on("data",function(c){b(v.statusCode??200,v.headers,c.toString())}),v.on("error",function(c){b(0,{})})});w.write(p.data),w.end()}catch{b(0,{})}}};super(R,I,d,h,y)}}e.OneDataSystemAppender=P}),define(te[241],ie([0,1,4,84,24]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(R){let I=R.getItem(P.machineIdKey);return(typeof I!="string"||E.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,t.getMachineId)()),I}e.resolveMachineId=D}),define(te[115],ie([0,1,24,241]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function P(D){const R=await(0,t.resolveMachineId)(D);return D.setItem(E.machineIdKey,R),R}e.resolveMachineId=P}),define(te[242],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST_DARK="hcDark",D.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(D){return D===E.HIGH_CONTRAST_DARK||D===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(D){return D===E.DARK||D===E.HIGH_CONTRAST_DARK}e.isDark=P}),define(te[243],ie([0,1,122,3,2,6,48,242]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var d;(function(c){function u(g){return g&&typeof g=="object"&&typeof g.id=="string"}c.isThemeColor=u})(d=e.ThemeColor||(e.ThemeColor={}));function h(c){return{id:c}}e.themeColorFromId=h;var y;(function(c){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||d.isThemeColor(o.color))}c.isThemeIcon=u;const g=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function k(o){const s=g.exec(o);if(!s)return;const[,a]=s;return{id:a}}c.fromString=k;function S(o){return{id:o}}c.fromId=S;function L(o,s){let a=o.id;const r=a.lastIndexOf("~");return r!==-1&&(a=a.substring(0,r)),s&&(a=`${a}~${s}`),{id:a}}c.modify=L;function i(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}c.getModifier=i;function l(o,s){return o.id===s.id&&o.color?.id===s.color?.id}c.isEqual=l;function n(o,s){return{id:o.id,color:s?h(s):void 0}}c.asThemeIcon=n,c.asClassNameArray=E.CSSIcon.asClassNameArray,c.asClassName=E.CSSIcon.asClassName,c.asCSSSelector=E.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function p(c){switch(c){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=p,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,P.toDisposable)(()=>{const g=this.a.indexOf(u);this.a.splice(g,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const f=new b;R.Registry.add(e.Extensions.ThemingContribution,f);function w(c){return f.onColorThemeChange(c)}e.registerThemingParticipant=w;class v extends P.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(g=>this.n(g)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,g){let k=this.h.getColor(u);return k&&g&&(k=g(k,this.h)),k?k.toString():null}}e.Themable=v}),define(te[68],ie([0,1,14,3,2,4,18,6,34]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const h="#FFFFFF",y="#1E1E1E",p="#000000",b="#FFFFFF",f="theme",w="themeBackground",v="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let c=class extends P.Disposable{constructor(g,k){super(),this.b=g,this.c=k,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(D.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?p:b;let k=this.b.getItem(w,null);if(!k)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":k=h;break;case"hc-black":k=p;break;case"hc-light":k=b;break;default:k=y}return D.isMacintosh&&k.toUpperCase()===y&&(k="#171717"),k}saveWindowSplash(g,k){this.b.setItems([{key:f,data:k.baseTheme},{key:w,data:k.colorInfo.background},{key:v,data:k}]),typeof g=="number"&&this.f(g,k)}f(g,k){for(const S of E.BrowserWindow.getAllWindows())if(S.id===g){S.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};c=pe([ee(0,d.IStateMainService),ee(1,R.IConfigurationService)],c),e.ThemeMainService=c}),define(te[116],ie([0,1,3,18,6,5]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var R;(function(v){v.Http="http",v.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=p;function b(v,c,u,g){if(u===1)return!1;if(u===2&&p(c)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(k?.length===4&&parseInt(k[1])>=18)return!1}return v<1024}e.isPortPrivileged=b;class f{constructor(c,u,g){this.remoteAddress=c,this.localAddress=u,this.b=g,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let w=class{constructor(c,u){this.i=c,this.j=u,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const g of u){const k=Array.from(g.values());for(const S of k){const L=await S.value;L&&c.push(L)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(g=>g?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,g,k,S){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:g,privacy:k,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(p(c)||y(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const g=this.q(c,u);if(g)return++g.refcount,g.value}openTunnel(c,u,g,k,S,L=!1,i,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${S}.`),!c)return;if(u||(u="localhost"),k||(k=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(c,u,g,k,S,L,i,l);return n?n.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(o);return(o.tunnelRemoteHost!==u||o.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const g=u.get(c.tunnelRemotePort);g&&(g.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,g))}}}}async n(c,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const k=g.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),k}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const g=this.d.get(c);if(g&&g.has(u)){const k=g.get(u);k.refcount=0,await this.n(c,u,k)}}o(c,u,g){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:g})}async p(c,u){const g=this.d.get(c);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(c))}q(c,u){const g=[c];y(c)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):p(c)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const k=g.map(S=>this.d.get(S));for(const S of k){const L=S?.get(u);if(L)return L}}canTunnel(c){return!!h(c)}s(c,u,g,k,S,L,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${k}.`);const l=g;this.h.add(l);const n=k===void 0?g:k,o={elevationRequired:S?this.isPortPrivileged(n):!1},s={remoteAddress:{host:u,port:g},localAddressPort:k,privacy:L,public:L?L!==I.Private:void 0,protocol:i},a=c.forwardPort(s,o);return a?(this.o(u,g,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),a}};w=pe([ee(0,D.ILogService),ee(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(te[244],ie([0,1,81,26,99,226,8,2,18,5,19,225,116,91,4]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(S,L,i,l,n){let o;for(let s=3;s&&(o?.dispose(),o=await new c(S,L,i,l,n).waitForReady(),!(n&&P.BROWSER_RESTRICTED_PORTS[n]||!P.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class c extends I.Disposable{constructor(L,i,l,n,o){super(),this.j=i,this.k=o,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=L,this.b=E.createServer(),this.c=new R.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const L=this.k??this.tunnelRemotePort,i=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let l=await(0,P.findFreePortFaster)(L,2,1e3,i),n=null;return this.b.listen(l,this.j),await this.c.wait(),n=this.b.address(),n||(l=0,this.b.listen(l,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(L){L.pause();const i=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,p.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=l.getSocket().socket,o=l.readEntireBuffer();l.dispose(),o.byteLength>0&&L.write(o.buffer),L.on("end",()=>{L.localAddress&&this.i.delete(L.localAddress),n.end()}),L.on("close",()=>n.end()),L.on("error",()=>{L.localAddress&&this.i.delete(L.localAddress),n.destroy()}),n.on("end",()=>L.end()),n.on("close",()=>L.end()),n.on("error",()=>{L.destroy()}),L.pipe(n),n.pipe(L),L.localAddress&&this.i.set(L.localAddress,()=>{L.end(),n.end()})}}let u=class extends b.AbstractTunnelService{constructor(L,i,l,n,o){super(i,o),this.t=L,this.u=l,this.v=n}isPortPrivileged(L){return(0,b.isPortPrivileged)(L,this.k,w.OS,t.release())}r(L,i,l,n,o,s,a,r){const m=this.q(i,l);if(m)return++m.refcount,m.value;if(this.e)return this.s(this.e,i,l,o,s,a,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${l} on local port ${o}.`);const C={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:L,signService:this.u,logService:this.i,ipcLogger:null},M=v(C,n,i,l,o);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,l,M),M}}};u=pe([ee(1,h.ILogService),ee(2,f.ISignService),ee(3,y.IProductService),ee(4,d.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(L,i,l,n){super(D.nodeSocketFactory,L,i,l,n)}};g=pe([ee(0,h.ILogService),ee(1,f.ISignService),ee(2,y.IProductService),ee(3,d.IConfigurationService)],g),e.TunnelService=g;let k=class extends I.Disposable{constructor(L,i,l,n){super(),this.b=L,this.c=i,this.f=l,this.g=n,this.a=new Map}async openTunnel(L,i,l,n,o,s,a,r,m){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${s}.`),!this.a.has(L)){const C=new g(this.b,this.f,this.c,this.g);this.B(C),this.a.set(L,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(L))})}return this.a.get(L).openTunnel(i,l,n,o,s,a,r,m)}};k=pe([ee(0,h.ILogService),ee(1,y.IProductService),ee(2,f.ISignService),ee(3,d.IConfigurationService)],k),e.SharedTunnelsService=k}),define(te[49],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(t=e.StateType||(e.StateType={}));var P;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(P=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,R)=>({type:"idle",updateType:D,error:R}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(te[245],ie([0,1,4,172,67,48]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(P.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[246],ie([0,1,3,49]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class P{constructor(I){this.a=I}listen(I,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,h){switch(d){case"checkForUpdates":return this.a.checkForUpdates(h);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(h)}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=P;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=D}),define(te[93],ie([0,1,8,22,3,18,28,21,5,19,56,49]),function(V,e,E,t,P,D,R,I,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(w,v,c){return`${c.updateUrl}/api/update/${w}/${v}/${c.commit}`}e.createUpdateURL=b;let f=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,c,u,g,k,S){this.f=v,this.g=c,this.h=u,this.i=g,this.j=k,this.k=S,this.b=p.State.Uninitialized,this.c=new P.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.l(),c=this.m(v);if(!c){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(c),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(p.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,D.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,E.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(v){}q(){return 1}r(){}};f=pe([ee(0,I.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,R.IEnvironmentMainService),ee(3,y.IRequestService),ee(4,d.ILogService),ee(5,h.IProductService)],f),e.AbstractUpdateService=f}),define(te[247],ie([0,1,14,54,3,2,18,28,21,5,19,56,24,49,93]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends w.AbstractUpdateService{get v(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"error",(u,g)=>g)}get w(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(u,g,k)=>({url:g,version:k,productVersion:k}))}get y(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(u,g,k,S)=>({releaseNotes:g,version:k,productVersion:k,date:S}))}constructor(u,g,k,S,L,i,l){super(u,g,S,L,i,l),this.z=k,this.u=new D.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(f.State.Idle(1,k))}s(u){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,w.createUpdateURL)(g,u,this.k);try{E.autoUpdater.setFeedURL({url:k})}catch(S){this.j.error("Failed to set update feed URL",S);return}return k}t(u){this.d(f.State.CheckingForUpdates(u)),E.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(f.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(f.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],v.prototype,"v",null),pe([t.memoize],v.prototype,"w",null),pe([t.memoize],v.prototype,"x",null),pe([t.memoize],v.prototype,"y",null),v=pe([ee(0,d.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,b.ITelemetryService),ee(3,I.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,h.ILogService),ee(6,y.IProductService)],v),e.DarwinUpdateService=v}),define(te[248],ie([0,1,46,41,8,3,9,28,21,5,24,49]),function(V,e,E,t,P,D,R,I,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,c,u){if(this.f=v,this.g=u,this.a=p.State.Uninitialized,this.b=new D.Emitter,this.onStateChange=this.b.event,c.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(v=60*60*1e3){return(0,P.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};b=pe([ee(0,d.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,h.ILogService)],b);let f=class extends b{constructor(v,c,u,g,k,S){super(u,g,k),this.o=v,this.p=c,this.q=S;const L=(0,t.watch)(R.dirname(this.o)),i=D.Event.fromNodeEventEmitter(L,"change",(s,a)=>a),l=D.Event.filter(i,s=>s==="current"),o=D.Event.debounce(l,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{o.dispose(),L.close()})}m(){this.d(p.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(p.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((u,g)=>(0,t.realpath)(`${R.dirname(this.o)}/current`,(k,S)=>k?g(k):u(S))),c=R.basename(v);return this.p!==c}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=pe([ee(2,d.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,h.ILogService),ee(5,y.ITelemetryService)],f),e.SnapUpdateService=f}),define(te[40],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(te[249],ie([0,1,40,193,16,20,129,3,2]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(b){this.uri=b,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let y=class{constructor(b){this.g=b,this.c=new d.DisposableStore,this.f=2**16;const f=new Map,w=v=>{let c=f.get(v.scheme);return c===void 0&&(c=b.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,c)),c};this.c.add(I.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new D.ExtUri(w),this.d=new R.SkipList((v,c)=>this.extUri.compare(v,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,D.normalizePath)(b));const f=this.d.get(b);return f?f.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new h(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((w,v)=>w[1].touch<v[1].touch?1:w[1].touch>v[1].touch?-1:0);h._clock=0,this.d.clear();const f=this.f*.5;for(let w=0;w<f;w++)this.d.set(b[w][0],b[w][1].touch())}};y=pe([ee(0,P.IFileService)],y),e.UriIdentityService=y,(0,t.registerSingleton)(E.IUriIdentityService,y,1)}),define(te[117],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(te[250],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(I){this.a=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,h){switch(d){case"handleURL":return this.a.handleURL(E.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=t;class P{constructor(I){this.a=I}handleURL(I,d){return this.a.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=P;class D{constructor(I){this.a=I}async routeCall(I,d,h,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(h){const p=E.URI.revive(h);if(p&&p.query){const b=/\bwindowId=(\d+)/.exec(p.query);if(b){const f=b[1],w=new RegExp(`window:${f}`),v=I.connections.find(c=>w.test(c.ctx));if(v)return v}}}return this.a.routeCall(I,d,h,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=D}),define(te[251],ie([0,1,8,2,7,19]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(h,y){const p=[...this.a.values()];return(0,E.first)(p.map(b=>()=>b.handleURL(h,y)),void 0,!1).then(b=>b||!1)}registerHandler(h){return this.a.add(h),(0,t.toDisposable)(()=>this.a.delete(h))}}e.AbstractURLService=R;let I=class extends R{constructor(h){super(),this.b=h}create(h){let{authority:y,path:p,query:b,fragment:f}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&p&&p.indexOf("/")!==0&&(p=`/${p}`),P.URI.from({scheme:this.b.urlProtocol,authority:y,path:p,query:b,fragment:f})}};I=pe([ee(0,D.IProductService)],I),e.NativeURLService=I}),define(te[252],ie([0,1,14,8,3,2,4,7]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class d{constructor(y,p,b,f,w,v){if(this.f=p,this.g=v,this.a=[],this.b=0,this.c=D.Disposable.None,this.d=new D.DisposableStore,v.trace("ElectronURLListener initialUrisToHandle:",y.map(g=>g.url)),this.a=y,R.isWindows){const g=f.isBuilt?[]:[`"${f.appRoot}"`];g.push("--open-url","--"),E.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,g)}const c=P.Event.map(P.Event.fromNodeEventEmitter(E.app,"open-url",(g,k)=>({event:g,url:k})),({event:g,url:k})=>(g.preventDefault(),k));this.d.add(c(g=>{const k=this.h(g);!k||this.f.open(k,{originalUrl:g})})),b.getWindows().filter(g=>g.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),P.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(y){try{return I.URI.parse(y)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const p of this.a)await this.f.open(p.uri,{originalUrl:p.url})?this.g.trace("ElectronURLListener#flush(): URL was handled",p.url):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",p.url),y.push(p));y.length!==0&&(this.a=y,this.c=(0,t.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=d}),define(te[253],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(te[254],ie([0,1,14,2,15,7]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends t.Disposable{constructor(){super();const d=this.b.bind(this);E.protocol.registerFileProtocol(P.Schemas.vscodeWebview,d)}b(d,h){try{const y=D.URI.parse(d.url),p=R.a.get(y.path);if(typeof p=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${p}`,f=P.FileAccess.asFileUri(b);return h({path:decodeURIComponent(f.fsPath),headers:{...P.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}e.WebviewProtocolProvider=R,R.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[76],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(y){return!!y.workspaceUri}e.isWorkspaceToOpen=t;function P(y){return!!y.folderUri}e.isFolderToOpen=P;function D(y){return!!y.fileUri}e.isFileToOpen=D;function R(y){const p=I(y),b=y.getValue("window.menuBarVisibility");return b==="default"||p==="native"&&b==="compact"||E.isMacintosh&&E.isNative?"classic":b}e.getMenuBarVisibility=R;function I(y){if(E.isWeb)return"custom";const p=y.getValue("window");if(p){if(E.isMacintosh&&p.nativeTabs===!0||E.isMacintosh&&p.nativeFullScreen===!1)return"native";const w=p.titleBarStyle;if(w==="native"||w==="custom")return w}return E.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(y){if(!E.isWindows||E.isWeb||I(y)==="native")return!1;const p=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof p=="boolean"?p:!0}e.useWindowControlsOverlay=d;function h(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=h}),define(te[118],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const P=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=P;var D;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var R;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(R=e.WindowError||(e.WindowError={}))}),define(te[30],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(P){P[P.CLI=0]="CLI",P[P.DOCK=1]="DOCK",P[P.MENU=2]="MENU",P[P.DIALOG=3]="DIALOG",P[P.DESKTOP=4]="DESKTOP",P[P.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[255],ie([0,1,14,22,3,71,2,31,74,108,5,19,30]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let w=class extends R.Disposable{constructor(c,u,g,k,S){super(),this.g=c,this.h=u,this.i=g,this.j=k,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const c=P.Event.fromNodeEventEmitter(E.app,"login",(u,g,k,S,L)=>({event:u,webContents:g,req:k,authInfo:S,callback:L}));this.B(c(this.m,this))}async m({event:c,authInfo:u,req:g,callback:k}){if(!u.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}c.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{S=await this.b}finally{this.b=void 0}}k(S?.username,S?.password)}async n(c){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(c);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(c){this.g.trace("auth#doResolveProxyCredentials - enter",c);const u=String((0,D.hash)({scheme:c.scheme,host:c.host,port:c.port}));let g,k;try{const l=await this.i.getPassword(this.a,u);if(l){const n=JSON.parse(await this.j.decrypt(l));g=n.username,k=n.password}}catch(l){this.g.error(l)}if(this.c!==f.StoredCredentialsUsed&&typeof g=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:g,password:k};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const L={authInfo:c,username:this.f?.username??g,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,L),this.c=f.LoginDialogShown;const i=await new Promise(l=>{const n=async(o,s,a)=>{if(s===L.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",n),a){const r={username:a.username,password:a.password};try{if(a.remember){const m=await this.j.encrypt(JSON.stringify(r));await this.i.setPassword(this.a,u,m)}else await this.i.deletePassword(this.a,u)}catch(m){this.g.error(m)}l({username:r.username,password:r.password})}else l(void 0)};S.win?.webContents.on("ipc-message",n)});return this.f=i,i}};w=pe([ee(0,y.ILogService),ee(1,b.IWindowsMainService),ee(2,d.ICredentialsMainService),ee(3,h.IEncryptionMainService),ee(4,p.IProductService)],w),e.ProxyAuthHandler=w}),define(te[256],ie([0,1,74,5,33,19,30,205]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let d=class extends I.BaseCredentialsMainService{constructor(y,p,b,f){super(y),this.j=p,this.k=b,this.l=f,this.i=w=>{this.l.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const y=await new Promise((p,b)=>{V(["keytar"],p,b)});return await y.findCredentials("test-keytar-loads"),this.f=y,this.f}};d=pe([ee(0,t.ILogService),ee(1,P.INativeEnvironmentService),ee(2,D.IProductService),ee(3,R.IWindowsMainService)],d),e.CredentialsNativeMainService=d}),define(te[257],ie([0,1,14,25,4,7,23,18,61,6,5,117,30]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,h.createDecorator)(e.ID);let f=class{constructor(v,c,u,g){this.a=v,this.b=c,this.c=u,this.d=g}async start(v,c){this.a.trace("Received data from other instance: ",v,c),P.isMacintosh&&E.app.focus({steal:!0});const u=this.e(v);if(u.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(g=k.ready())}g.then(()=>{for(const{uri:k,url:S}of u)this.c.open(k,{originalUrl:S})})}else return this.f(v,c)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(c=>{try{return{uri:D.URI.parse(c),url:c}}catch{return null}})):[]}async f(v,c){const u=(0,d.isLaunchedFromCli)(c)?0:4;let g=[];const k=v.wait&&v.waitMarkerFilePath?D.URI.file(v.waitMarkerFilePath):void 0,S=v.remote||void 0,L={context:u,cli:v,userEnv:c,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,L);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let i=!1;if(v["new-window"]||v["unity-launch"]||L.forceProfile||L.forceTempProfile)i=!0;else if(v["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!P.isMacintosh}if(i)g=await this.b.open({...L,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,L),g=[l]):g=await this.b.open({...L,forceEmpty:!0})}}else g=await this.b.open({...L,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(k&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,R.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};f=pe([ee(0,y.ILogService),ee(1,b.IWindowsMainService),ee(2,p.IURLService),ee(3,I.IConfigurationService)],f),e.LaunchMainService=f}),define(te[258],ie([0,1,14,2,3,5,259,8,15,100,30,83,24]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let f=class Bt extends t.Disposable{constructor(v,c,u){super(),this.n=v,this.p=c,this.r=u,this.b=String(++Bt.a),this.c=this.B(new P.Emitter),this.onStdout=this.c.event,this.f=this.B(new P.Emitter),this.onStderr=this.f.event,this.g=this.B(new P.Emitter),this.onMessage=this.g.event,this.h=this.B(new P.Emitter),this.onExit=this.h.event,this.i=this.B(new P.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(v,c){let u;switch(this.l?.correlationId?u=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`:u=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`,c){case p.default.Error:this.n.error(u);break;case p.default.Warning:this.n.warn(u);break;case p.default.Info:this.n.info(u);break}}t(v){if(!h.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",p.default.Error);return}const c=this.p.getWindowById(v.responseWindowId)?.win;if(!c||c.isDestroyed()||c.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error);return}return c}start(v){const c=this.t(v);if(!c)return;this.l=v;const u=`${this.l.type}-${this.b}`,g=d.FileAccess.asFileUri("bootstrap-fork.js").fsPath,k=[...this.l.args??[],`--type=${this.l.type}`],S=this.l.execArgv,L=this.l.allowLoadingUnsignedLibraries,i="pipe";let l=this.l.env;if(l){l={...l};for(const n of Object.keys(l))l[n]=String(l[n])}this.s("creating new...",p.default.Info),this.j=h.UtilityProcess.fork(g,k,{serviceName:u,env:l,execArgv:S,allowLoadingUnsignedLibraries:L,stdio:i}),this.u(this.j,this.l,u),this.v(this.j,this.l,c)}u(v,c,u){if(v.stdout){const g=new R.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stdout,"data")(k=>this.c.fire(typeof k=="string"?k:g.write(k))))}if(v.stderr){const g=new R.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stderr,"data")(k=>this.f.fire(typeof k=="string"?k:g.write(k))))}this.B(P.Event.fromNodeEventEmitter(v,"message")(g=>this.g.fire(g))),this.B(P.Event.fromNodeEventEmitter(v,"spawn")(()=>{this.k=v.pid,this.s("successfully created",p.default.Info)})),this.B(P.Event.fromNodeEventEmitter(v,"exit")(g=>{this.s(`received exit event with code ${g}`,p.default.Info),this.m=!0,this.h.fire({pid:this.k,code:g,signal:"unknown"})})),this.B(P.Event.fromNodeEventEmitter(E.app,"child-process-gone",(g,k)=>({event:g,details:k}))(({details:g})=>{g.type==="Utility"&&g.name===u&&(this.s(`crashed with code ${g.exitCode} and reason '${g.reason}'`,p.default.Error),this.r.publicLog2("utilityprocesscrash",{type:c.type,reason:g.reason,code:g.exitCode}),this.i.fire({pid:this.k,code:g.exitCode,reason:g.reason}))}))}v(v,c,u){const{port1:g,port2:k}=new E.MessageChannelMain;v.postMessage("null",[k]),u.webContents.postMessage(c.responseChannel,c.responseNonce,[g])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",p.default.Info);const v=process;return typeof v._debugProcess=="function"?(v._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",p.default.Warning);return}this.s("attempting to kill the process...",p.default.Info),this.j.kill()?this.s("successfully killed the process",p.default.Info):this.s("unable to kill the process",p.default.Warning)}async waitForExit(v){if(!this.j){this.s("no running process to wait for exit",p.default.Warning);return}this.m||(this.s("waiting to exit...",p.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.timeout)(v)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",p.default.Info),this.kill()))}};f.a=0,f=pe([ee(0,D.ILogService),ee(1,y.IWindowsMainService),ee(2,b.ITelemetryService)],f),e.UtilityProcess=f}),define(te[260],ie([0,1,13,2,3,5,21,70,46,259,8,15,44,4,35,100,258,30,24]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let k=class jt{constructor(i,l,n,o){this.d=i,this.f=n,this.g=o,this.c=!1,this.b=new Map,l.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}h(i){const l=this.b.get(i);if(!l)throw new Error("Unknown extension host!");return l}onDynamicStdout(i){return this.h(i).onStdout}onDynamicStderr(i){return this.h(i).onStderr}onDynamicMessage(i){return this.h(i).onMessage}onDynamicError(i){const l=this.h(i);return l instanceof c.UtilityProcess?P.Event.None:l.onError}onDynamicExit(i){return this.h(i).onExit}async canUseUtilityProcess(){return v.canUseUtilityProcess}async createExtensionHost(i){if(this.c)throw(0,E.canceled)();const l=String(++jt.a);let n;if(i){if(!v.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");n=new c.UtilityProcess(this.d,this.f,this.g)}else n=new S(l,this.d);return this.b.set(l,n),n.onExit(({pid:o,code:s,signal:a})=>{this.d.info(`Extension host with pid ${o} exited with code: ${s}, signal: ${a}.`),setTimeout(()=>{n.dispose(),this.b.delete(l)})}),{id:l}}async start(i,l){if(this.c)throw(0,E.canceled)();return this.h(i).start({...l,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:l.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:i})}async enableInspectPort(i){if(this.c)throw(0,E.canceled)();const l=this.b.get(i);return l?l.enableInspectPort():!1}async kill(i){if(this.c)throw(0,E.canceled)();const l=this.b.get(i);!l||l.kill()}async _killAllNow(){for(const[,i]of this.b)i.kill()}async _waitForAllExit(i){const l=[];for(const[,n]of this.b)l.push(n.waitForExit(i));return y.Promises.settled(l).then(()=>{})}};k.a=0,k=pe([ee(0,D.ILogService),ee(1,R.ILifecycleMainService),ee(2,u.IWindowsMainService),ee(3,g.ITelemetryService)],k),e.ExtensionHostStarter=k;let S=class extends t.Disposable{constructor(i,l){super(),this.id=i,this.c=l,this._onStdout=this.B(new P.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new P.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new P.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new P.Emitter),this.onError=this._onError.event,this._onExit=this.B(new P.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(i){f.isCI&&this.c.info("Calling fork to start extension host...");const l=I.StopWatch.create(!1);this.a=(0,d.fork)(p.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,w.cwd)()},i));const n=l.elapsed(),o=this.a.pid;this.c.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const s=new h.StringDecoder("utf-8");this.a.stdout?.on("data",r=>{const m=typeof r=="string"?r:s.write(r);this._onStdout.fire(m)});const a=new h.StringDecoder("utf-8");this.a.stderr?.on("data",r=>{const m=typeof r=="string"?r:a.write(r);this._onStderr.fire(m)}),this.a.on("message",r=>{this._onMessage.fire(r)}),this.a.on("error",r=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(r)})}),this.a.on("exit",(r,m)=>{this.b=!0,this._onExit.fire({pid:o,code:r,signal:m})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):f.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(i){if(!this.a)return;const l=this.a.pid;this.c.info(`Waiting for extension host with pid ${l} to exit.`),await Promise.race([P.Event.toPromise(this.onExit),(0,y.timeout)(i)]),this.b||(this.c.info(`Extension host with pid ${l} did not exit within ${i}ms.`),this.a.kill())}};S=pe([ee(1,D.ILogService)],S)}),define(te[261],ie([0,1,14,3,2,254,30]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends P.Disposable{constructor(h){super(),this.b=h,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(h,y){let p;if(typeof h.windowId=="number"){const{windowId:b}=h,f=this.b.getWindowById(b);if(!f?.win)throw new Error(`Invalid windowId: ${b}`);p=f.win.webContents}else{const{webContentsId:b}=h;if(p=E.webContents.fromId(b),!p)throw new Error(`Invalid webContentsId: ${b}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(y)}async findInFrame(h,y,p,b){const w=this.c(h,y);if(typeof w.findInFrame=="function"){w.findInFrame(p,{findNext:b.findNext,forward:b.forward});const v=(c,u)=>{u.finalUpdate&&(this.a.fire(u),w.removeListener("found-in-frame",v))};w.on("found-in-frame",v)}}async stopFindInFrame(h,y,p){const f=this.c(h,y);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(h,y){const p=this.b.getWindowById(h.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${h}`);const b=p.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===y);if(!b)throw new Error(`Unknown frame: ${y}`);return b}};I=pe([ee(0,R.IWindowsMainService)],I),e.WebviewMainService=I}),define(te[262],ie([0,1,8,3,2]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends P.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:h}){super(),this.a=this.B(new P.DisposableStore),t.Event.latch(t.Event.any(I,d))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>h()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=D}),define(te[29],ie([0,1,176,9,60,20,7,6,15]),function(V,e,E,t,P,D,R,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function h(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=h;function y(n){return typeof n?.id=="string"&&!h(n)&&!b(n)}e.isEmptyWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=n;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=p;function b(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=b;function f(n){const o=n;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const s=n;if(s?.configPath)return{id:s.id,configPath:R.URI.revive(s.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=f;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=v;function c(n){const o=n;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(o,s,a,r,m){this.h=o,this.j=a,this.k=r,this.l=m,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(o,s){this.raw=s,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,D.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function k(n){return new g({uri:n,index:0,name:(0,D.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(n,o){return D.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function L(n){let o;return R.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=L;function i(n,o){return!S(n,o)&&!L(n)}e.isSavedWorkspace=i;function l(n){return(typeof n=="string"?(0,t.extname)(n):(0,D.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(te[57],ie([0,1,14,8,71,36,2,79,4,11,23,153,6,5,29]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let v=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,g){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},g)}pickFolder(u,g){return this.e({...u,pickFolders:!0,title:(0,p.localize)(1,null)},g)}pickFile(u,g){return this.e({...u,pickFiles:!0,title:(0,p.localize)(2,null)},g)}pickWorkspace(u,g){const k=(0,p.localize)(3,null),S=(0,D.mnemonicButtonLabel)((0,p.localize)(4,null)),L=w.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:k,filters:L,buttonLabel:S},g)}async e(u,g){const k={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(k.properties=void 0,u.pickFiles&&u.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&k.properties.push("treatPackageAsDirectory");const S=await this.showOpenDialog(k,(0,h.withNullAsUndefined)(g||E.BrowserWindow.getFocusedWindow()));if(S&&S.filePaths&&S.filePaths.length>0)return S.filePaths}f(u){if(u){let g=this.b.get(u.id);return g||(g=new t.Queue,this.b.set(u.id,g)),g}else return this.c}showMessageBox(u,g){return this.f(g).queue(async()=>g?E.dialog.showMessageBox(g,u):E.dialog.showMessageBox(u))}async showSaveDialog(u,g){const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(g).queue(async()=>{let S;return g?S=await E.dialog.showSaveDialog(g,u):S=await E.dialog.showSaveDialog(u),S.filePath=this.g(S.filePath),S})}finally{(0,R.dispose)(k)}}g(u){return u&&d.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}h(u){return u.map(g=>this.g(g))}async showOpenDialog(u,g){u.defaultPath&&(await y.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(g).queue(async()=>{let S;return g?S=await E.dialog.showOpenDialog(g,u):S=await E.dialog.showOpenDialog(u),S.filePaths=this.h(S.filePaths),S})}finally{(0,R.dispose)(k)}}i(u,g){if(!g)return R.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let k=this.a.get(g.id);k||(k=new Set,this.a.set(g.id,k));const S=(0,P.hash)(u);if(!k.has(S))return this.d.trace("[DialogMainService]: new file dialog lock created",u),k.add(S),(0,R.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),k?.delete(S),k?.size===0&&this.a.delete(g.id)})}};v=pe([ee(0,f.ILogService)],v),e.DialogMainService=v}),define(te[263],ie([0,1,3,2,72,29]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends t.Disposable{constructor(d,h){super(),this.f=d,this.g=h,this.b=this.B(new E.Emitter),this.c=new Map,this.h(h.applicationStorage,this.b)}h(d,h){this.B(E.Event.debounce(d.onDidChangeStorage,(y,p)=>(y?y.push(p):y=[p],y),R.a)(y=>{y.length&&h.fire(this.i(y,d))}))}i(d,h){const y=new Map,p=new Set;return d.forEach(b=>{const f=h.get(b.key);typeof f=="string"?y.set(b.key,f):p.add(b.key)}),{changed:Array.from(y.entries()),deleted:Array.from(p.values())}}listen(d,h,y){switch(h){case"onDidChangeStorage":{const p=y.profile?(0,P.revive)(y.profile):void 0;if(!p)return this.b.event;let b=this.c.get(p.id);return b||(b=this.B(new E.Emitter),this.h(this.g.profileStorage(p),b),this.c.set(p.id,b)),b.event}}throw new Error(`Event not found: ${h}`)}async call(d,h,y){const p=y.profile?(0,P.revive)(y.profile):void 0,b=(0,D.reviveIdentifier)(y.workspace),f=await this.j(p,b);switch(h){case"getItems":return Array.from(f.items.entries());case"updateItems":{const w=y;if(w.insert)for(const[v,c]of w.insert)f.set(v,c);w.delete?.forEach(v=>f.delete(v));break}case"isUsed":{const w=y.payload;if(typeof w=="string")return this.g.isUsed(w)}default:throw new Error(`Call not found: ${h}`)}}async j(d,h){let y;h?y=this.g.workspaceStorage(h):d?y=this.g.profileStorage(d):y=this.g.applicationStorage;try{await y.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${h?"workspace":d?"profile":"application"} storage due to ${p}`)}return y}}e.StorageDatabaseChannel=R,R.a=100}),define(te[37],ie([0,1,71,3,2,20,7,173,33,16,6,5,29,38,40,8,31,27,11]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function k(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&R.URI.isUri(o.location)&&R.URI.isUri(o.globalStorageHome)&&R.URI.isUri(o.settingsResource)&&R.URI.isUri(o.keybindingsResource)&&R.URI.isUri(o.tasksResource)&&R.URI.isUri(o.snippetsHome)&&R.URI.isUri(o.extensionsResource))}e.isUserDataProfile=k,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function S(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:R.URI.revive(n.location).with({scheme:o}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:R.URI.revive(n.extensionsResource)?.with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=S;function L(n,o,s,a){return{id:n,name:o,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,D.joinPath)(s,"globalStorage"),settingsResource:(0,D.joinPath)(s,"settings.json"),keybindingsResource:(0,D.joinPath)(s,"keybindings.json"),tasksResource:(0,D.joinPath)(s,"tasks.json"),snippetsHome:(0,D.joinPath)(s,"snippets"),extensionsResource:(0,D.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=L;let i=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,s,a,r){super(),this.m=o,this.n=s,this.r=a,this.s=r,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const m of this.G()){if(!m.name||!(0,g.isString)(m.name)||!m.location){this.s.warn("Skipping the invalid stored profile",m.location||m.name);continue}o.push(L((0,D.basename)(m.location),m.name,m.location,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}))}const s=new f.ResourceMap,a=new Map,r=L((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...r,extensionsResource:this.L()??r.extensionsResource,isDefault:!0}),o.length){const m=this.I();if(m.workspaces)for(const[C,M]of Object.entries(m.workspaces)){const O=R.URI.parse(C),B=R.URI.parse(M),J=o.find(G=>this.r.extUri.isEqual(G.location,B));J&&s.set(O,J)}if(m.emptyWindows)for(const[C,M]of Object.entries(m.emptyWindows)){const O=R.URI.parse(M),B=o.find(J=>this.r.extUri.isEqual(J.location,O));B&&a.set(C,B)}}this.t={profiles:o,workspaces:s,emptyWindows:a}}return this.t}async createTransientProfile(o){const s="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let r=0;for(const C of this.profiles){const M=a.exec(C.name),O=M?parseInt(M[1]):0;r=O>r?O:r}const m=`${s} ${r+1}`;return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),m,{transient:!0},o)}async createNamedProfile(o,s,a){return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),o,s,a)}async createProfile(o,s,a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const m=await this.v(o,s,a);return r&&await this.setProfileForWorkspace(r,m),m}async v(o,s,a){if(!(0,g.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(s);return r||(r=(async()=>{try{const m=this.profiles.find(O=>O.name===s||O.id===o);if(m)return m;const C=L(o,s,(0,D.joinPath)(this.profilesHome,o),a);await this.n.createFolder(C.location);const M=[];return this.h.fire({profile:C,join(O){M.push(O)}}),await v.Promises.settled(M),this.z([C],[],[]),C}finally{this.k.delete(s)}})(),this.k.set(s,r)),r}async updateProfile(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(r=>r.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);return a=L(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(r=>r.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);const a=[];this.i.fire({profile:s,join(r){a.push(r)}});try{await Promise.allSettled(a)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(r=>r.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.D(o,a)}unsetWorkspace(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(o,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(o.map(s=>this.removeProfile(s)))}getProfileForWorkspace(o){const s=this.w(o);return R.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(o){return(0,b.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,b.isWorkspaceIdentifier)(o)?o.configPath:o.id}y(o){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,o.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,o.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,o.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,o.location)))}z(o,s,a){const r=[...this.profiles,...o],m=[];this.l.profiles=[];for(let C of r)C.isDefault||s.some(M=>C.id===M.id)||(C=a.find(M=>C.id===M.id)??C,C.isTransient?this.l.profiles.push(C):m.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.H(m),this.t=void 0,this.C(o,s,a)}C(o,s,a){this.g.fire({added:o,removed:s,updated:a,all:this.profiles})}D(o,s,a){a=s?.isTransient?!0:a,a||this.D(o,void 0,!0);const r=this.w(o),m=a?this.l:this.u;R.URI.isUri(r)?(m.workspaces.delete(r),s&&m.workspaces.set(r,s)):(m.emptyWindows.delete(r),s&&m.emptyWindows.set(r,s)),a||this.F()}F(){const o={};for(const[a,r]of this.u.workspaces.entries())o[a.toString()]=r.location.toString();const s={};for(const[a,r]of this.u.emptyWindows.entries())s[a.toString()]=r.location.toString();this.J({workspaces:o,emptyWindows:s}),this.t=void 0}G(){return[]}H(o){throw new Error("not implemented")}I(){return{}}J(o){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ee(0,d.IEnvironmentService),ee(1,h.IFileService),ee(2,w.IUriIdentityService),ee(3,p.ILogService)],i),e.UserDataProfilesService=i;class l extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(o){this.a=o}I(){return this.O}J(o){this.O=o}}e.InMemoryUserDataProfilesService=l}),define(te[77],ie([0,1,8,17,2,3,38,7,113,90,16,6,5,37,40,11,13,24]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(n,o){super(n),this.code=o}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let S=class extends P.Disposable{constructor(n,o,s,a,r,m){super(),this.h=n,this.i=o,this.j=s,this.k=a,this.l=r,this.m=m,this.a=this.B(new D.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new D.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new R.ResourceMap}scanProfileExtensions(n,o){return this.n(n,void 0,o)}async addExtensionsToProfile(n,o){const s=[],a=[];try{return await this.n(o,r=>{const m=[];for(const C of r)n.some(([M])=>(0,d.areSameExtensions)(M.identifier,C.identifier)&&M.manifest.version!==C.version)?s.push(C):m.push(C);for(const[C,M]of n)if(!m.some(O=>(0,d.areSameExtensions)(O.identifier,C.identifier)&&O.version===C.manifest.version)){const O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:M};a.push(O),m.push(O)}return a.length&&this.a.fire({extensions:a,profileLocation:o}),s.length&&this.c.fire({extensions:s,profileLocation:o}),m}),a.length&&this.b.fire({extensions:a,profileLocation:o}),s.length&&this.f.fire({extensions:s,profileLocation:o}),a}catch(r){throw a.length&&this.b.fire({extensions:a,error:r,profileLocation:o}),s.length&&this.f.fire({extensions:s,error:r,profileLocation:o}),r}}async removeExtensionFromProfile(n,o){const s=[];this.c.fire({extensions:s,profileLocation:o});try{await this.n(o,a=>{const r=[];for(const m of a)(0,d.areSameExtensions)(m.identifier,n.identifier)?s.push(m):r.push(m);return s.length&&this.c.fire({extensions:s,profileLocation:o}),r}),s.length&&this.f.fire({extensions:s,profileLocation:o})}catch(a){throw s.length&&this.f.fire({extensions:s,error:a,profileLocation:o}),a}}async n(n,o,s){return this.v(n).queue(async()=>{let a=[],r;try{const m=await this.i.readFile(n);r=JSON.parse(m.value.toString())}catch(m){if((0,y.toFileOperationResult)(m)!==1)throw m;if(this.k.extUri.isEqual(n,this.j.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&s?.bailOutWhenFileNotFound)throw new k((0,c.getErrorMessage)(m),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.p(n);let m=!1;for(const C of r){L(C)||this.p(n);let M;if((0,v.isString)(C.location))M=this.s(C.location);else{M=I.URI.revive(C.location);const O=this.r(M);O&&(m=!0,C.location=O)}a.push({identifier:C.identifier,location:M,version:C.version,metadata:C.metadata})}m&&await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(r)))}if(o){a=o(a);const m=a.map(C=>({identifier:C.identifier,version:C.version,location:this.r(C.location)??C.location.toJSON(),metadata:C.metadata}));await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(m)))}return a})}p(n){const o=new k(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:o.code}),o}r(n){return this.k.extUri.isEqualOrParent(n,this.h)?this.k.extUri.relativePath(this.h,n):void 0}s(n){return this.k.extUri.joinPath(this.h,n)}async u(){return this.t||(this.t=(async()=>{const n=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let o;try{o=(await this.i.readFile(n)).value.toString()}catch(a){if((0,y.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",n.toString());let s;try{const a=JSON.parse(o);Array.isArray(a)&&a.every(r=>L(r))?s=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(s)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",n.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,y.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",n.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(n)}catch(a){(0,y.toFileOperationResult)(a)!==1&&this.m.error(a)}return s})()),this.t}v(n){let o=this.g.get(n);return o||(o=new E.Queue,this.g.set(n,o)),o}};S=pe([ee(1,y.IFileService),ee(2,f.IUserDataProfilesService),ee(3,w.IUriIdentityService),ee(4,u.ITelemetryService),ee(5,b.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function L(l){return(0,v.isObject)(l)&&(0,h.isIExtensionIdentifier)(l.identifier)&&(i(l.location)||(0,v.isString)(l.location))&&l.version&&(0,v.isString)(l.version)}function i(l){return l?(0,v.isString)(l.path)&&(0,v.isString)(l.scheme):!1}}),define(te[119],ie([0,1,25,8,44,17,13,43,139,2,15,9,4,20,191,83,11,7,158,33,113,90,190,16,6,5,19,3,72,77,37,40,188,189]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(ge){function H(F,U){if(F===U)return!0;const z=Object.keys(F),Q=new Set;for(const ne of Object.keys(U))Q.add(ne);if(z.length!==Q.size)return!1;for(const ne of z){if(F[ne]!==U[ne])return!1;Q.delete(ne)}return Q.size===0}ge.equals=H})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let G=class extends h.Disposable{constructor(H,F,U,z,Q,ne,_,$,A,T,W,j){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=F,this.l=U,this.m=z,this.n=Q,this.p=ne,this.r=_,this.s=$,this.t=A,this.u=T,this.v=W,this.w=j,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,L.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,L.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(re,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,F,U){const[z,Q]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(F)]),ne=U?await this.scanExtensionsUnderDevelopment(H,[...z,...Q]):[];return this.F(z,Q,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const F=[];F.push(this.G(!!H.useCache,H.language)),F.push(this.H(H.language,!!H.checkControlFile));const[U,z]=await Promise.all(F);return this.D([...U,...z],0,H,!1)}async scanUserExtensions(H){const F=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const U=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(F,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,U),Q=H.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await Q.scanExtensions(z)}catch(_){if(_ instanceof m.ExtensionsProfileScanningError&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await Q.scanExtensions(z);else throw _}return ne=await this.D(ne,1,H,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const Q=await this.J(z,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(_=>(_.type=F.find($=>(0,S.areSameExtensions)($.identifier,_.identifier))?.type??_.type,this.k.validate(_,Q)))}))).flat();return this.D(U,"development",H,!0)}return[]}async scanExistingExtension(H,F,U){const z=await this.J(H,!1,F,!0,U.language,!0,void 0),Q=await this.k.scanExtension(z);return!Q||!U.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(H,F,U){const z=await this.J(H,!1,F,!0,U.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(z);return this.D(Q,F,U,!0)}async scanMetadata(H){const F=(0,f.joinPath)(H,"package.json"),U=(await this.r.readFile(F)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(H,F){const U=(0,f.joinPath)(H,"package.json"),z=(await this.r.readFile(U)).value.toString(),Q=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...F},await this.r.writeFile((0,f.joinPath)(H,"package.json"),D.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof m.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(F=>[F,F.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(F){(0,l.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(F))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,F,U,z){return U.includeAllVersions||(H=this.F(F===0?H:void 0,F===1?H:void 0,F==="development"?H:void 0,await this.getTargetPlatform(),z)),U.includeInvalid||(H=H.filter(Q=>Q.isValid)),H.sort((Q,ne)=>{const _=p.basename(Q.location.fsPath),$=p.basename(ne.location.fsPath);return _<$?-1:_>$?1:0})}F(H,F,U,z,Q){const ne=($,A,T)=>{if($.isValid&&!A.isValid)return!1;if($.isValid===A.isValid){if(Q&&w.gt($.manifest.version,A.manifest.version))return this.s.debug(`Skipping extension ${A.location.path} with lower version ${A.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(w.eq($.manifest.version,A.manifest.version)){if($.type===0)return this.s.debug(`Skipping extension ${A.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===z)return this.s.debug(`Skipping extension ${A.location.path} from different target platform ${A.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${$.location.path} with ${A.location.path}.`):this.s.debug(`Overwriting user extension ${$.location.path} with ${A.location.path}.`),!0},_=new Map;return H?.forEach($=>{const A=L.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);(!T||ne(T,$,!1))&&_.set(A,$)}),F?.forEach($=>{const A=L.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);if(!T&&H&&$.type===0){this.s.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!T||ne(T,$,!1))&&_.set(A,$)}),U?.forEach($=>{const A=L.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);(!T||ne(T,$,!0))&&_.set(A,$),_.set(A,$)}),[..._.values()]}async G(H,F){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,F,!0,void 0),Q=await(H&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(H,F){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const z=F?await this.I():{},Q=[],ne=u.URI.file(p.normalize(p.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $ of U){const A=z[$.name]||"marketplace";switch(A){case"disabled":break;case"marketplace":Q.push((0,f.joinPath)(ne,$.name));break;default:Q.push(u.URI.file(A));break}}const _=await Promise.all(Q.map(async $=>this.k.scanExtension(await this.J($,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",_.length),(0,E.coalesce)(_)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,F,U,z,Q,ne,_){const $=await this.f(Q??b.language),A=await this.L(H),T=F&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=T?await this.L(T):void 0;return new X(H,A,T,W,F,_,U,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,$)}async L(H){try{const F=await this.r.stat(H);if(typeof F.mtime=="number")return F.mtime}catch{}}};G=pe([ee(4,C.IUserDataProfilesService),ee(5,m.IExtensionsProfileScannerService),ee(6,l.IFileService),ee(7,o.ILogService),ee(8,k.IEnvironmentService),ee(9,s.IProductService),ee(10,M.IUriIdentityService),ee(11,n.IInstantiationService)],G),e.AbstractExtensionsScannerService=G;class X{constructor(H,F,U,z,Q,ne,_,$,A,T,W,j,K,N,q){this.location=H,this.mtime=F,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=z,this.profile=Q,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=$,this.validate=A,this.productVersion=T,this.productDate=W,this.productCommit=j,this.devMode=K,this.language=N,this.translations=q}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,F){return(0,f.isEqual)(H.location,F.location)&&H.mtime===F.mtime&&(0,f.isEqual)(H.applicationExtensionslocation,F.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&H.profile===F.profile&&P.equals(H.profileScanOptions,F.profileScanOptions)&&H.type===F.type&&H.excludeObsolete===F.excludeObsolete&&H.validate===F.validate&&H.productVersion===F.productVersion&&H.productDate===F.productDate&&H.productCommit===F.productCommit&&H.devMode===F.devMode&&H.language===F.language&&J.equals(H.translations,F.translations)}}e.ExtensionScannerInput=X;let re=class extends h.Disposable{constructor(H,F,U,z,Q){super(),this.f=H,this.g=F,this.h=U,this.i=z,this.j=Q}async scanExtensions(H){const F=H.profile?await this.l(H):await this.k(H);let U={};if(H.excludeObsolete&&H.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(z)}catch{}return(0,c.isEmptyObject)(U)?F:F.filter(z=>!U[S.ExtensionKey.create(z).toString()])}async k(H){const F=await this.i.resolve(H.location);if(!F.children?.length)return[];const U=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||H.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const Q=new X(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(U).sort((z,Q)=>z.location.path<Q.location.path?-1:1)}async l(H){let F=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const U=await this.m(H.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,H);F.push(...U)}return F}async m(H,F,U){const z=await this.g.scanProfileExtensions(H,U.profileScanOptions);if(!z.length)return[];const Q=await Promise.all(z.map(async ne=>{if(F(ne)){const _=new X(ne.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,f.joinPath)(H.location,"package.json"))){const F=await this.scanExtension(H);return F?[F]:[]}else return await this.scanExtensions(H)}catch(F){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,R.getErrorMessage)(F)),[]}}async scanExtension(H,F){try{let U=await this.scanExtensionManifest(H.location);if(U){U.publisher||(U.publisher=L.UNDEFINED_PUBLISHER),F=F??U.__metadata,delete U.__metadata;const z=(0,S.getGalleryExtensionId)(U.publisher,U.name),Q=F?.id?{id:z,uuid:F.id}:{id:z},ne=F?.isSystem?0:H.type,_=ne===0||!!F?.isBuiltin;B.ImplicitActivationEvents.updateManifest(U),U=await this.n(H.location,U,X.createNlsConfiguration(H));const $={type:ne,identifier:Q,manifest:U,location:H.location,isBuiltin:_,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(U){H.type!==0&&this.j.error(U)}return null}validate(H,F){let U=!0;const z=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,H.manifest,H.isBuiltin);for(const[Q,ne]of z)Q===v.default.Error&&(U=!1,this.j.error(this.t(F.location,ne)));return H.isValid=U,H.validations=z,H}async scanExtensionManifest(H){const F=(0,f.joinPath)(H,"package.json");let U;try{U=(await this.i.readFile(F)).value.toString()}catch(Q){return(0,l.toFileOperationResult)(Q)!==1&&this.j.error(this.t(H,(0,g.localize)(0,null,F.path,Q.message))),null}let z;try{z=JSON.parse(U)}catch{const ne=[];(0,I.parse)(U,ne);for(const _ of ne)this.j.error(this.t(H,(0,g.localize)(1,null,F.path,_.offset,_.length,(0,d.getParseErrorMessage)(_.error))));return null}return(0,I.getNodeType)(z)!=="object"?(this.j.error(this.t(H,(0,g.localize)(2,null,F.path))),null):z}async n(H,F,U){const z=await this.p(H,F,U);if(z)try{const Q=[],ne=await this.r(z.default,Q);if(Q.length>0)return Q.forEach($=>{this.j.error(this.t(H,(0,g.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)($.error))))}),F;if((0,I.getNodeType)(z)!=="object")return this.j.error(this.t(H,(0,g.localize)(4,null,z.default?.path))),F;const _=z.values||Object.create(null);return(0,O.localizeManifest)(F,_,ne)}catch{}return F}async p(H,F,U){const z=(0,f.joinPath)(H,"package.nls.json"),Q=(A,T)=>{T.forEach(W=>{this.j.error(this.t(H,(0,g.localize)(5,null,A?.path,(0,d.getParseErrorMessage)(W.error))))})},ne=A=>{this.j.error(this.t(H,(0,g.localize)(6,null,A?.path)))},_=`${F.publisher}.${F.name}`,$=U.translations[_];if($)try{const A=u.URI.file($),T=(await this.i.readFile(A)).value.toString(),W=[],j=(0,I.parse)(T,W);return W.length>0?(Q(A,W),{values:void 0,default:z}):(0,I.getNodeType)(j)!=="object"?(ne(A),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let T;try{T=await this.s(H,U)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const W=(await this.i.readFile(T.localized)).value.toString(),j=[],K=(0,I.parse)(W,j);return j.length>0?(Q(T.localized,j),{values:void 0,default:T.original}):(0,I.getNodeType)(K)!=="object"?(ne(T.localized),{values:void 0,default:T.original}):{values:K,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(H,F){if(H)try{const U=(await this.i.readFile(H)).value.toString();return(0,I.parse)(U,F)}catch{}}s(H,F){return new Promise((U,z)=>{const Q=ne=>{const _=(0,f.joinPath)(H,`package.nls.${ne}.json`);this.i.exists(_).then($=>{$&&U({localized:_,original:(0,f.joinPath)(H,"package.nls.json")});const A=ne.lastIndexOf("-");A===-1?U({localized:(0,f.joinPath)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,A),Q(ne))})};if(F.devMode||F.pseudo||!F.language)return U({localized:(0,f.joinPath)(H,"package.nls.json"),original:null});Q(F.language)})}t(H,F){return`[${H.path}]: ${F}`}};re=pe([ee(1,m.IExtensionsProfileScannerService),ee(2,M.IUriIdentityService),ee(3,l.IFileService),ee(4,o.ILogService)],re);let se=class extends re{constructor(H,F,U,z,Q,ne){super(F,U,z,Q,ne),this.y=H,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const F=await this.z();if(this.u=H,F&&F.input&&X.equals(F.input,this.u))return this.j.debug("Using cached extensions scan result",H.location.toString()),this.v.trigger(()=>this.D()),F.result.map(z=>(z.location=u.URI.revive(z.location),z));const U=await super.scanExtensions(H);return await this.C({input:H,result:U}),U}async z(){try{const H=await this.i.readFile(this.y),F=JSON.parse(H.value.toString());return{result:F.result,input:(0,r.revive)(F.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,R.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(H)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,R.getErrorMessage)(F))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const F=H.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(U,F))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};se=pe([ee(2,m.IExtensionsProfileScannerService),ee(3,M.IUriIdentityService),ee(4,l.IFileService),ee(5,o.ILogService)],se);function ae(ge,H){const F=(0,S.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:F,identifier:new L.ExtensionIdentifier(F),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:H,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ae;class fe extends G{constructor(H,F,U,z,Q,ne,_,$,A,T,W,j){super(H,F,(0,f.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(z,L.MANIFEST_CACHE_FOLDER),Q,ne,_,$,A,T,W,j),this.M=(async()=>{if(b.translationsConfigFile)try{const K=await this.r.readFile(u.URI.file(b.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=fe}),define(te[264],ie([0,1,5,37,40,24,77,16,33,7]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends R.AbstractExtensionsProfileScannerService{constructor(b,f,w,v,c,u){super(h.URI.file(b.extensionsPath),f,w,v,c,u)}};y=pe([ee(0,d.INativeEnvironmentService),ee(1,I.IFileService),ee(2,t.IUserDataProfilesService),ee(3,P.IUriIdentityService),ee(4,D.ITelemetryService),ee(5,E.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(te[265],ie([0,1,7,33,77,119,16,6,5,19,40,37]),function(V,e,E,t,P,D,R,I,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends D.NativeExtensionsScannerService{constructor(w,v,c,u,g,k,S,L){super(E.URI.file(g.builtinExtensionsPath),E.URI.file(g.extensionsPath),g.userHome,E.URI.file(g.userDataPath),w,v,c,u,g,k,S,L)}};b=pe([ee(0,p.IUserDataProfilesService),ee(1,P.IExtensionsProfileScannerService),ee(2,R.IFileService),ee(3,d.ILogService),ee(4,t.INativeEnvironmentService),ee(5,h.IProductService),ee(6,y.IUriIdentityService),ee(7,I.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(te[266],ie([0,1,14,2,15,9,4,60,7,31,42,33,5,37]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends t.Disposable{constructor(c,u,g){super(),this.c=c,this.f=g,this.a=I.TernarySearchTree.forPaths(!R.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(c.appRoot),this.addValidFileRoot(c.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(c.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:c}=E.session;c.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(u,g)=>this.i(u,g)),c.protocol.interceptFileProtocol(P.Schemas.file,(u,g)=>this.h(u,g)),this.B((0,t.toDisposable)(()=>{c.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),c.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(c){const u=(0,D.normalize)(c);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(c,u){const g=d.URI.parse(c.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${P.Schemas.file}: protocol (original URL: ${c.url})`),u({error:-3})}i(c,u){const g=this.j(c);let k;return this.c.crossOriginIsolated&&((0,D.basename)(g)==="workbench.html"||(0,D.basename)(g)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(c.url)),this.a.findSubstr(g)?u({path:g,headers:k}):this.b.has((0,D.extname)(g).toLowerCase())?u({path:g}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${c.url})`),u({error:-3}))}j(c){const u=d.URI.parse(c.url),g=P.FileAccess.uriToFileUri(u);return(0,D.normalize)(g.fsPath)}createIPCObjectUrl(){let c;const u=d.URI.from({scheme:"vscode",path:(0,h.generateUuid)()}),g=u.toString(),k=async()=>c;return y.validatedIpcMain.handle(g,k),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:u,update:S=>c=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),y.validatedIpcMain.removeHandler(g)}}}};w=pe([ee(0,p.INativeEnvironmentService),ee(1,f.IUserDataProfilesService),ee(2,b.ILogService)],w),e.ProtocolMainService=w}),define(te[267],ie([0,1,14,42,8,3,2,15,11,105,28,21,5,65,66,68,45,37,39,64]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends R.Disposable{constructor(i,l,n,o,s,a,r,m,C,M){super(),this.g=i,this.h=l,this.i=n,this.j=o,this.k=s,this.l=a,this.m=r,this.n=m,this.p=C,this.r=M,this.a=new P.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new D.Emitter),this.onDidError=D.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(i,l)=>this.t(i,l)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(i,l)=>this.u(i,l)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(i,l){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const n=await this.connect();if(i.sender.isDestroyed())return n.close();i.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[n])}u(i,l){this.l.trace("SharedProcess: onWorkerConnection",l);const n=new R.DisposableStore,o=a=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${a}')`,l),n.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",l))},s=E.BrowserWindow.fromId(l.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!l.reply.channel){o("unavailable");return}n.add(D.Event.filter(this.k.onWillLoadWindow,a=>a.window.win===s)(()=>o("load"))),n.add(D.Event.fromNodeEventEmitter(s,"closed")(()=>o("closed"))),s.webContents.postMessage(l.reply.channel,l.reply.nonce,i.ports)}v(){const i=this.b;!i||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(i.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{i.close()}catch{}this.b=void 0},0))}w(i,...l){if(!this.G()){this.l.warn(`Sending IPC message to channel '${i}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(i,...l)}catch(n){this.l.warn(`Error sending IPC message to channel '${i}' of shared process: ${(0,c.toErrorMessage)(n)}`)}}whenReady(){return this.y||(this.y=new Promise(i=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),i()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(i=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),i()}))})()),this.z}D(){const i=this.B(this.r.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),i.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),loggers:this.m.getLoggerResources(),product:f.default,policiesData:this.n.serialize()}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=i=>{this.l.trace("SharedProcess#close prevented"),i.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(i,l)=>this.f.fire({type:2,details:l})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(i,l,n)=>this.f.fire({type:3,details:{reason:n,exitCode:l}})))}async connect(){await this.C;const i=(0,d.assertIsDefined)(this.b);return(0,h.connect)(i)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const i=this.b;return i?!i.isDestroyed()&&!i.webContents.isDestroyed():!1}};S=pe([ee(2,y.IEnvironmentMainService),ee(3,u.IUserDataProfilesService),ee(4,p.ILifecycleMainService),ee(5,b.ILogService),ee(6,k.ILoggerMainService),ee(7,g.IPolicyService),ee(8,v.IThemeMainService),ee(9,w.IProtocolMainService)],S),e.SharedProcess=S}),define(te[94],ie([0,1,8,3,2,63,11,106,6,37]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function f(g){const k=g.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=f;class w extends P.Disposable{constructor(k={flushInterval:w.a}){super(),this.j=k,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,S){if(S===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:S,target:this.F(k)[S]})}r(k){this.f.fire({reason:k})}get(k,S,L){return this.L(S)?.get(k,L)}getBoolean(k,S,L){return this.L(S)?.getBoolean(k,L)}getNumber(k,S,L){return this.L(S)?.getNumber(k,L)}store(k,S,L,i){if((0,R.isUndefinedOrNull)(S)){this.remove(k,L);return}this.t(()=>{this.u(k,L,i),this.L(L)?.set(k,S)})}remove(k,S){this.t(()=>{this.u(k,S,void 0),this.L(S)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const L=[],i=this.F(k);for(const l of Object.keys(i))i[l]===S&&L.push(l);return L}u(k,S,L){const i=this.F(S);typeof L=="number"?i[k]!==L&&(i[k]=L,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[k]=="number"&&(delete i[k],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const S=this.L(k);return S?f(S):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=y.NONE){this.f.fire({reason:k});const S=this.L(-1),L=this.L(0),i=this.L(1);switch(k){case y.NONE:await E.Promises.settled([S?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await E.Promises.settled([S?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return u(k,S,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,S){return this.r(y.NONE),(0,h.isUserDataProfile)(k)?this.N(k,S):this.O(k,S)}H(k,S){return!(k.id===S.id||v(S)&&v(k))}I(k,S,L,i){this.t(()=>{if(i)for(const[l,n]of k)S.set(l,n);else{const l=new Set;for(const[n,o]of k)l.add(n),S.get(n)!==o&&this.n(L,n);for(const[n]of S.items)l.has(n)||this.n(L,n)}})}}e.AbstractStorageService=w,w.a=60*1e3;function v(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class c extends w{constructor(){super(),this.p=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=c;async function u(g,k,S,L,i,l){const n=B=>{try{return JSON.parse(B)}catch{return B}},o=new Map,s=new Map;g.forEach((B,J)=>{o.set(J,B),s.set(J,n(B))});const a=new Map,r=new Map;k.forEach((B,J)=>{a.set(J,B),r.set(J,n(B))});const m=new Map,C=new Map;S.forEach((B,J)=>{m.set(J,B),C.set(J,n(B))}),console.group(L!==i?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const M=[];if(o.forEach((B,J)=>{M.push({key:J,value:B})}),console.table(M),console.groupEnd(),console.log(s),L!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const B=[];a.forEach((J,G)=>{B.push({key:G,value:J})}),console.table(B),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${l})`);const O=[];m.forEach((B,J)=>{O.push({key:J,value:B})}),console.table(O),console.groupEnd(),console.log(C)}e.logStorage=u}),define(te[268],ie([0,1,25,8,3,2,9,70,7,23,106,150,5,94,24,29]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class c extends D.Disposable{get storage(){return this.f}constructor(l,n){super(),this.j=l,this.k=n,this.b=this.B(new P.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.Emitter),this.onDidCloseStorage=this.c.event,this.f=new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===y.StorageState.None)try{const l=await this.n();this.f.dispose(),this.f=l,this.B(l.onDidChangeStorage(o=>this.b.fire({key:o}))),await this.m(l);const n=l.getBoolean(f.IS_NEW_KEY);n===void 0?l.set(f.IS_NEW_KEY,!0):n&&l.set(f.IS_NEW_KEY,!1)}catch(l){this.j.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.i=y.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?l=>this.j.trace(l):void 0,logError:l=>this.j.error(l)}}m(l){return l.init()}get items(){return this.f.items}get(l,n){return this.f.get(l,n)}set(l,n){return this.f.set(l,n)}delete(l){return this.f.delete(l)}async close(){const l=new I.StopWatch(!1);await this.s(),l.stop(),l.elapsed()>c.a&&await this.r(l),this.c.fire()}async r(l){if(!!this.path)try{const n=(0,E.top)(Array.from(this.f.items.entries()).map(([s,a])=>({key:s,length:a.length})),(s,a)=>a.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),o=(await this.k.stat(d.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${o}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=y.StorageState.Closed,await this.f.close()}}c.a=2e3;class u extends c{get path(){if(!this.v.useInMemoryStorage)return(0,R.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(l,n,o,s){super(o,s),this.u=l,this.v=n}async n(){return new y.Storage(new p.SQLiteStorageDatabase(this.path??p.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class g extends u{constructor(l,n,o,s){super(l,n,o,s)}}e.ProfileStorageMain=g;class k extends u{constructor(l,n,o,s){super(n.defaultProfile,l,o,s)}async m(l){await super.m(l),this.z(l)}z(l){l.get(w.firstSessionDateStorageKey,void 0)===void 0&&l.set(w.firstSessionDateStorageKey,new Date().toUTCString());const o=l.get(w.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();l.set(w.lastSessionDateStorageKey,typeof o>"u"?null:o),l.set(w.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=k;class S extends c{get path(){if(!this.w.useInMemoryStorage)return(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(l,n,o,s,a){super(o,a),this.v=l,this.w=n,this.y=s}async n(){const{storageFilePath:l,wasCreated:n}=await this.C();return new y.Storage(new p.SQLiteStorageDatabase(l,{logging:this.l()}),{hint:this.w.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:n?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:p.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,R.join)(l,S.t);return await h.Promises.exists(l)?{storageFilePath:n,wasCreated:!1}:(await h.Promises.mkdir(l,{recursive:!0}),this.D(l),{storageFilePath:n,wasCreated:!0})}async D(l){let n;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const o=(0,R.join)(l,S.u);await h.Promises.exists(o)||await h.Promises.writeFile(o,JSON.stringify(n,void 0,2))}catch(o){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=S,S.t="state.vscdb",S.u="workspace.json";class L extends c{get path(){}async n(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=L}),define(te[269],ie([0,1,3,2,94]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class D extends t.Disposable{constructor(I,d,h){super(),this.b=I,this.c=d,this.f=h;const y=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new t.DisposableStore;return I.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,h)=>(d?d.push(h.key):d=[h.key],d),100)(d=>this.h(d))),I.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(d,h)=>{d||(d=new Map);let y=d.get(h.profile.id);return y||d.set(h.profile.id,y={profile:h.profile,keys:[],storage:h.storage}),y.keys.push(h.key),d},100)(d=>this.i(d))),I}h(I){const d=I.includes(P.TARGET_KEY)?[this.c.defaultProfile]:[],h=[];if(I=I.filter(y=>y!==P.TARGET_KEY),I.length){const y=(0,P.loadKeyTargets)(this.b.applicationStorage.storage);h.push({profile:this.c.defaultProfile,changes:I.map(p=>({key:p,scope:0,target:y[p]}))})}this.j(d,h)}i(I){const d=[],h=new Map;for(const[y,p]of I.entries()){p.keys.includes(P.TARGET_KEY)&&d.push(p.profile);const b=p.keys.filter(f=>f!==P.TARGET_KEY);if(b.length){const f=(0,P.loadKeyTargets)(p.storage.storage);h.set(y,{profile:p.profile,changes:b.map(w=>({key:w,scope:0,target:f[w]}))})}}this.j(d,[...h.values()])}j(I,d){(I.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:I})}listen(I,d,h){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(I,d){throw new Error(`Call not found: ${d}`)}}e.ProfileStorageChangesListenerChannel=D}),define(te[270],ie([0,1,72,7,33,16,5,233,40,37]),function(V,e,E,t,P,D,R,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let y=class extends h.UserDataProfilesService{constructor(f,w,v,c){super(w,v,f,c),this.a=w}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([ee(0,d.IUriIdentityService),ee(1,P.INativeEnvironmentService),ee(2,D.IFileService),ee(3,R.ILogService)],y),e.ServerUserDataProfilesService=y;let p=class Tt extends y{constructor(f,w,v,c,u){super(w,v,c,u),this.N=f}G(){return(0,E.revive)(this.N.getItem(Tt.b,[]))}I(){return(0,E.revive)(this.N.getItem(Tt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=pe([ee(0,I.IStateService),ee(1,d.IUriIdentityService),ee(2,P.INativeEnvironmentService),ee(3,D.IFileService),ee(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(te[52],ie([0,1,7,33,16,6,5,34,40,37,270]),function(V,e,E,t,P,D,R,I,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,D.refineServiceDecorator)(h.IUserDataProfilesService);let p=class ht extends y.UserDataProfilesService{constructor(f,w,v,c,u){super(f,w,v,c,u),this.R=f}setEnablement(f){super.setEnablement(f),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const f=[];for(const w of this.u.emptyWindows.keys())f.push({id:w});return f}H(f){f.length?this.R.setItem(ht.b,f):this.R.removeItem(ht.b)}J(f){f.emptyWindows||f.workspaces?this.R.setItem(ht.c,f):this.R.removeItem(ht.c)}I(){const f="workspaceAndProfileInfo",w=this.R.getItem(f,void 0);if(w){this.R.removeItem(f);const v=w.reduce((c,{workspace:u,profile:g})=>(c[E.URI.revive(u).toString()]=E.URI.revive(g).toString(),c),{});this.R.setItem(ht.c,{workspaces:v})}return super.I()}};p=pe([ee(0,I.IStateMainService),ee(1,d.IUriIdentityService),ee(2,t.INativeEnvironmentService),ee(3,P.IFileService),ee(4,R.ILogService)],p),e.UserDataProfilesMainService=p}),define(te[95],ie([0,1,7,50,3,2,33,16,6,21,5,94,268,37,52,40]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,d.createDecorator)("storageMainService");let c=class extends D.Disposable{constructor(k,S,L,i,l,n){super(),this.c=k,this.f=S,this.g=L,this.h=i,this.i=l,this.j=n,this.a=void 0,this.b=this.B(new P.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,S]of this.n)k.join(S.close());for(const[,S]of this.r)k.join(S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.n.get(k.profile.id);S&&k.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,p.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let S=this.n.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.p(k),this.n.set(k.id,S);const L=this.B(S.onDidChangeStorage(i=>this.b.fire({...i,storage:S,profile:k})));(0,t.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),L.dispose()})}return S}p(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let S=this.r.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.s(k),this.r.set(k.id,S),(0,t.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),S}s(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const S=E.URI.file(k);for(const L of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!L.path&&this.j.extUri.isEqualOrParent(E.URI.file(L.path),S))return!0;return!1}};c=pe([ee(0,y.ILogService),ee(1,R.IEnvironmentService),ee(2,w.IUserDataProfilesMainService),ee(3,h.ILifecycleMainService),ee(4,I.IFileService),ee(5,v.IUriIdentityService)],c),e.StorageMainService=c,e.IApplicationStorageMainService=(0,d.createDecorator)("applicationStorageMainService");let u=class extends p.AbstractStorageService{constructor(k,S){super(),this.p=k,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([ee(0,f.IUserDataProfilesService),ee(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(te[271],ie([0,1,2,21,52,29,8,30]),function(V,e,E,t,P,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let d=class extends E.Disposable{constructor(y,p,b){super(),this.a=p,this.b=b,this.B(y.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(y.onBeforeCloseWindow(f=>this.c(f))),this.B(new R.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(y){const p=this.f(y),b=this.a.getProfileForWorkspace(p);b&&((0,D.isEmptyWorkspaceIdentifier)(p)||b.isTransient)&&(this.a.unsetWorkspace(p,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,D.toWorkspaceIdentifier)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const p=this.b.getWindows().map(b=>this.f(b));for(const b of y)p.some(f=>f.id===b.id)||this.a.unsetWorkspace(b,!1)}};d=pe([ee(0,t.ILifecycleMainService),ee(1,P.IUserDataProfilesMainService),ee(2,I.IWindowsMainService)],d),e.UserDataProfilesHandler=d}),define(te[120],ie([0,1,20,7,29]),function(V,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function D(d,h,y){for(const b of d){const f=b.openedWorkspace;if((0,P.isWorkspaceIdentifier)(f)){const w=await y(f);if(w){if(w.folders.some(v=>E.extUriBiasedIgnorePathCase.isEqualOrParent(h,v.uri)))return b}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(h,f.configPath))return b}}const p=d.filter(b=>(0,P.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(h,b.openedWorkspace.uri));if(p.length)return p.sort((b,f)=>-(b.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function R(d,h){for(const y of d)if((0,P.isWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,h)||(0,P.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,h))return y}e.findWindowOnWorkspaceOrFolder=R;function I(d,h){const y=p=>h.some(b=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(b),t.URI.file(p)));for(const p of d)if(p.config?.extensionDevelopmentPath?.some(b=>y(b)))return p}e.findWindowOnExtensionDevelopmentPath=I}),define(te[272],ie([0,1,14,2,4,20,7,18,21,5,34,30,118,29]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class Ft extends t.Disposable{get state(){return this.b}constructor(S,L,i,l,n){super(),this.g=S,this.h=L,this.i=i,this.j=l,this.k=n,this.b=v(this.h.getItem(Ft.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,L={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!L.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(L.lastActiveWindow=this.r(n),L.lastActiveWindow.uiState.mode===3&&S.add(L.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(L.lastPluginDevelopmentHostWindow=this.r(i),L.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(L.lastPluginDevelopmentHostWindow.uiState.display)?P.isMacintosh&&!i.win?.isSimpleFullScreen()&&(L.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(L.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(L.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const o=this.r(n);return o.uiState.mode===3&&(S.has(o.uiState.display)?P.isMacintosh&&o.windowId!==L.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(o.uiState.mode=1):S.add(o.uiState.display)),o}));const l=u(L);this.h.setItem(Ft.a,l),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",l)}p(S){if(this.i.quitRequested)return;const L=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=L:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(i=>{const l=(0,f.isWorkspaceIdentifier)(S.openedWorkspace)&&i.workspace?.id===S.openedWorkspace.id,n=(0,f.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&i.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(i.folderUri,S.openedWorkspace.uri);(l||n)&&(i.uiState=L.uiState)}),this.g.getWindowCount()===1&&(this.c=L)}r(S){return{windowId:S.id,workspace:(0,f.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const L=this.s(S),i=this.k.getValue("window");if(L.mode===3){let l;L.hasDefaultState?l=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):l=!!(this.i.wasRestarted||i?.restoreFullscreen),l||(L.mode=1)}return L}s(S){const L=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(!!S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=S.workspace;if((0,f.isWorkspaceIdentifier)(a)){const m=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===a.id).map(C=>C.uiState);if(m.length)return m[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(a)){const m=this.state.openedWindows.filter(C=>C.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(C.folderUri,a.uri)).map(C=>C.uiState);if(m.length)return m[0]}else if(S.backupPath){const m=this.state.openedWindows.filter(C=>C.backupPath===S.backupPath).map(C=>C.uiState);if(m.length)return m[0]}const r=this.c||this.state.lastActiveWindow;if(!L&&r)return r.uiState}let i;const l=E.screen.getAllDisplays();if(l.length===1)i=l[0];else{if(P.isMacintosh){const a=E.screen.getCursorScreenPoint();i=E.screen.getDisplayNearestPoint(a)}!i&&L&&(i=E.screen.getDisplayMatching(L.getBounds())),i||(i=E.screen.getPrimaryDisplay()||l[0])}let n=(0,b.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const o=this.k.getValue("window");let s=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,s=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,s=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&L){const a=L.serializeWindowState();a.mode===3?n.mode=3:n=a,s=n.mode!==3&&o.newWindowDimensions==="offset"}}return s&&(n=this.t(n)),n.hasDefaultState=!0,n}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const L=this.g.getWindows().map(i=>i.getBounds());for(;L.some(i=>i.x===S.x||i.y===S.y);)S.x+=30,S.y+=30;return S}};w.a="windowsState",w=pe([ee(0,p.IWindowsMainService),ee(1,y.IStateMainService),ee(2,d.ILifecycleMainService),ee(3,h.ILogService),ee(4,I.IConfigurationService)],w),e.WindowsStateHandler=w;function v(k){const S={openedWindows:[]},L=k||{openedWindows:[]};return L.lastActiveWindow&&(S.lastActiveWindow=c(L.lastActiveWindow)),L.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=c(L.lastPluginDevelopmentHostWindow)),Array.isArray(L.openedWindows)&&(S.openedWindows=L.openedWindows.map(i=>c(i))),S}e.restoreWindowsState=v;function c(k){const S={uiState:k.uiState};return k.backupPath&&(S.backupPath=k.backupPath),k.remoteAuthority&&(S.remoteAuthority=k.remoteAuthority),k.folder&&(S.folderUri=R.URI.parse(k.folder)),k.workspaceIdentifier&&(S.workspace={id:k.workspaceIdentifier.id,configPath:R.URI.parse(k.workspaceIdentifier.configURIPath)}),S}function u(k){return{lastActiveWindow:k.lastActiveWindow&&g(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&g(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(S=>g(S))}}e.getWindowsStateStoreData=u;function g(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(te[96],ie([0,1,32,43,126,36,15,9,4,20,7,6,55,29]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function w(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function v(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=v;function c(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=c;function u(C){return g(C)||k(C)}e.isStoredWorkspaceFolder=u;function g(C){const M=C;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function k(C){const M=C;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function S(C,M,O,B,J){if(C.scheme!==B.scheme)return{name:O,uri:C.toString(!0)};let G=M?void 0:J.relativePath(B,C);if(G!==void 0)G.length===0?G=".":d.isWindows&&(G=L(G));else if(C.scheme===R.Schemas.file)G=C.fsPath,d.isWindows&&(G=L(G));else if(J.isEqualAuthority(C.authority,B.authority))G=C.path;else return{name:O,uri:C.toString(!0)};return{name:O,path:G}}e.getStoredWorkspaceFolder=S;function L(C){return C=(0,D.normalizeDriveLetter)(C),(0,E.isUNC)(C)||(C=(0,E.toSlashes)(C)),C}function i(C,M,O){const B=[],J=new Set,G=O.dirname(M);for(const X of C){let re;if(g(X))X.path&&(re=O.resolvePath(G,X.path));else if(k(X))try{re=y.URI.parse(X.uri),re.path[0]!==I.posix.sep&&(re=re.with({path:I.posix.sep+re.path}))}catch(se){console.warn(se)}if(re){const se=O.getComparisonKey(re);if(!J.has(se)){J.add(se);const ae=X.name||O.basenameOrAuthority(re);B.push(new f.WorkspaceFolder({uri:re,name:ae,index:B.length},X))}}}return B}e.toWorkspaceFolders=i;function l(C,M,O,B,J){const G=n(M,C),X=J.dirname(M),re=J.dirname(B),se=[];for(const H of G.folders){const F=g(H)?J.resolvePath(X,H.path):y.URI.parse(H.uri);let U;O?U=!1:U=!g(H)||(0,I.isAbsolute)(H.path),se.push(S(F,U,H.name,re,J))}const ae={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},fe=P.setProperty(C,["folders"],se,ae);let ge=P.applyEdits(C,fe);return(0,h.isEqualAuthority)(G.remoteAuthority,(0,b.getRemoteAuthority)(B))&&(ge=P.applyEdits(ge,P.removeProperty(ge,["remoteAuthority"],ae))),ge}e.rewriteWorkspaceFileForNewLocation=l;function n(C,M){const O=t.parse(M);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(B=>u(B));else throw new Error(`${C} looks like an invalid workspace file.`);return O}function o(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function s(C){return typeof C.folderUri=="string"}function a(C){return typeof C.fileUri=="string"}function r(C,M){const O={workspaces:[],files:[]};if(C){const B=function(G,X){for(let re=0;re<G.length;re++)try{X(G[re],re)}catch(se){M.warn(`Error restoring recent entry ${JSON.stringify(G[re])}: ${se.toString()}. Skip entry.`)}},J=C;Array.isArray(J.entries)&&B(J.entries,G=>{const X=G.label,re=G.remoteAuthority;o(G)?O.workspaces.push({label:X,remoteAuthority:re,workspace:{id:G.workspace.id,configPath:y.URI.parse(G.workspace.configPath)}}):s(G)?O.workspaces.push({label:X,remoteAuthority:re,folderUri:y.URI.parse(G.folderUri)}):a(G)&&O.files.push({label:X,remoteAuthority:re,fileUri:y.URI.parse(G.fileUri)})})}return O}e.restoreRecentlyOpened=r;function m(C){const M={entries:[]};for(const O of C.workspaces)v(O)?M.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):M.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of C.files)M.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return M}e.toStoreData=m}),define(te[97],ie([0,1,80,15,4,20]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(h){function y(){let p=h.scheme===t.Schemas.file?(0,D.originalFSPath)(h):h.toString();return P.isLinux||(p=p.toLowerCase()),(0,E.createHash)("md5").update(p).digest("hex")}return{id:y(),configPath:h}}e.getWorkspaceIdentifier=R;function I(h,y){function p(){if(h.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(h.toString()).digest("hex");if(!y)return;let f;return P.isLinux?f=y.ino:P.isMacintosh?f=y.birthtime.getTime():P.isWindows&&(typeof y.birthtimeMs=="number"?f=Math.floor(y.birthtimeMs):f=y.birthtime.getTime()),(0,E.createHash)("md5").update(h.fsPath).update(f?String(f):"").digest("hex")}const b=p();if(typeof b=="string")return{id:b,uri:h}}e.getSingleFolderWorkspaceIdentifier=I;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=d}),define(te[273],ie([0,1,80,32,15,9,4,20,23,180,18,28,34,16,5,179,29,97]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class Wt{constructor(S,L,i,l){this.j=S,this.k=L,this.l=i,this.m=l,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.extUriBiasedIgnorePathCase,this.i={isEqual:(n,o)=>(0,t.isEqual)(n,o,!R.isLinux)}}async initialize(){const S=this.m.getItem(Wt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,h.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,h.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.HotExitConfiguration.OFF}q(){return this.s()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,L){this.d.some(l=>S.workspace.id===l.workspace.id)||(this.d.push(S),this.C());const i=(0,D.join)(this.c,S.workspace.id);return L?this.t(i,L).then(()=>i):i}async t(S,L){if(await d.Promises.exists(S)&&await this.z(S),await d.Promises.exists(L))try{await d.Promises.rename(L,S)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(S){return this.e.some(L=>this.h.isEqual(S.folderUri,L.folderUri))||(this.e.push(S),this.C()),(0,D.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(L=>!!L.backupFolder&&this.i.isEqual(L.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,D.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const L=new Set,i=[];for(const l of S){const n=l.workspace;if(!(0,c.isWorkspaceIdentifier)(n))return[];if(!L.has(n.id)){L.add(n.id);const o=(0,D.join)(this.c,n.id);await this.B(o)?n.configPath.scheme!==P.Schemas.file||await d.Promises.exists(n.configPath.fsPath)?i.push(l):await this.z(o):await this.x(o)}}return i}async v(S){if(!Array.isArray(S))return[];const L=[],i=new Set;for(const l of S){const n=l.folderUri,o=this.h.getComparisonKey(n);if(!i.has(o)){i.add(o);const s=(0,D.join)(this.c,this.D(l));await this.B(s)?n.scheme!==P.Schemas.file||await d.Promises.exists(n.fsPath)?L.push(l):await this.z(s):await this.x(s)}}return L}async w(S){if(!Array.isArray(S))return[];const L=[],i=new Set;for(const l of S){const n=l.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const o=(0,D.join)(this.c,n);await this.B(o)?L.push(l):await this.x(o)}}return L}async x(S){try{await d.Promises.rm(S,d.RimRafMode.MOVE)}catch(L){this.l.error(`Backup: Could not delete stale backup: ${L.toString()}`)}}y(){let S=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(L=>!!L.backupFolder&&this.i.isEqual(L.backupFolder,S.id));)S=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const L=this.y(),i=(0,D.join)(this.c,L.backupFolder);try{await d.Promises.rename(S,i)}catch(l){return this.l.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.g.push(L),!0}async getDirtyWorkspaces(){const S=[];for(const L of this.d)await this.A(L)&&S.push(L);for(const L of this.e)await this.A(L)&&S.push(L);return S}A(S){let L;return(0,h.isEmptyWindowBackupInfo)(S)?L=(0,D.join)(this.c,S.backupFolder):(0,v.isFolderBackupInfo)(S)?L=(0,D.join)(this.c,this.D(S)):L=(0,D.join)(this.c,S.workspace.id),this.B(L)}async B(S){try{const L=await d.Promises.readdir(S);for(const i of L)try{if((await d.Promises.readdir((0,D.join)(S,i))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:L,remoteAuthority:i})=>{const l={id:L.id,configURIPath:L.configPath.toString()};return i&&(l.remoteAuthority=i),l}),folders:this.e.map(({folderUri:L,remoteAuthority:i})=>{const l={folderUri:L.toString()};return i&&(l.remoteAuthority=i),l}),emptyWindows:this.g.map(({backupFolder:L,remoteAuthority:i})=>{const l={backupFolder:L};return i&&(l.remoteAuthority=i),l})};this.m.setItem(Wt.a,S)}D(S){const L=S.folderUri;let i;return L.scheme===P.Schemas.file?i=R.isLinux?L.fsPath:L.fsPath.toLowerCase():i=L.toString().toLowerCase(),(0,E.createHash)("md5").update(i).digest("hex")}};g.a="backupWorkspaces",g=pe([ee(0,p.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,w.ILogService),ee(3,b.IStateMainService)],g),e.BackupMainService=g}),define(te[53],ie([0,1,14,3,43,36,2,15,9,20,11,23,178,62,57,28,6,5,19,52,120,29,96,97]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let n=class extends R.Disposable{constructor(s,a,r,m,C,M){super(),this.g=s,this.h=a,this.i=r,this.j=m,this.k=C,this.l=M,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await p.Promises.readdir(this.c.fsPath)).map(a=>(0,h.joinPath)(this.c,a,L.UNTITLED_WORKSPACE_NAME));for(const a of s){const r=(0,l.getWorkspaceIdentifier)(a),m=await this.resolveLocalWorkspace(a);m?this.f.push({workspace:r,remoteAuthority:m.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.m(s,a=>p.Promises.readFile(a,"utf8"))}m(s,a){if(!!this.n(s)&&s.scheme===I.Schemas.file)try{const r=a(s.fsPath);return r instanceof Promise?r.then(m=>this.p(s,m),m=>{}):this.p(s,r)}catch{return}}n(s){return(0,L.isUntitledWorkspace)(s,this.g)||(0,L.hasWorkspaceFileExtension)(s)}p(s,a){try{const r=this.r(s,a),m=(0,l.getWorkspaceIdentifier)(s);return{id:m.id,configPath:m.configPath,folders:(0,i.toWorkspaceFolders)(r.folders,m.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.h.warn(r.toString())}}r(s,a){const r=(0,P.parse)(a);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(m=>(0,i.isStoredWorkspaceFolder)(m));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(s,a){const{workspace:r,storedWorkspace:m}=this.s(s,a),C=r.configPath.fsPath;return await p.Promises.mkdir((0,d.dirname)(C),{recursive:!0}),await p.Promises.writeFile(C,JSON.stringify(m,null,"	")),this.f.push({workspace:r,remoteAuthority:a}),r}s(s=[],a){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),m=(0,h.joinPath)(this.c,r),C=(0,h.joinPath)(m,L.UNTITLED_WORKSPACE_NAME),M=[];for(const O of s)M.push((0,i.getStoredWorkspaceFolder)(O.uri,!0,O.name,m,h.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(C),storedWorkspace:{folders:M,remoteAuthority:a}}}async getWorkspaceIdentifier(s){return(0,l.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,L.isUntitledWorkspace)(s.configPath,this.g)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.t(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async t(s){const a=(0,h.originalFSPath)(s.configPath);try{await p.Promises.rm((0,d.dirname)(a));const r=(0,d.join)(this.g.workspaceStorageHome.fsPath,s.id);await p.Promises.exists(r)&&await p.Promises.writeFile((0,d.join)(r,"obsolete"),""),this.f=this.f.filter(m=>m.workspace.id!==s.id)}catch(r){this.h.warn(`Unable to delete untitled workspace ${a} (${r}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,a,r){if(!s||!s.win||!s.isReady||!await this.u(s,a,r))return;const C=await this.v(s,(0,l.getWorkspaceIdentifier)(r));if(!!C)return this.b.fire({window:s,workspace:C.workspace}),C}async u(s,a,r){if(!r)return!0;if((0,L.isWorkspaceIdentifier)(s.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,r))return!1;if((0,S.findWindowOnWorkspaceOrFolder)(a,r)){const m={title:this.l.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,h.basename)(r)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(m,(0,y.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(s,a){if(!s.config)return;s.focus();let r;return s.config.extensionDevelopmentPath||(s.config.backupPath?r=await this.j.registerWorkspaceBackup({workspace:a,remoteAuthority:s.remoteAuthority},s.config.backupPath):r=this.j.registerWorkspaceBackup({workspace:a,remoteAuthority:s.remoteAuthority})),(0,L.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=a,s.config.backupPath=r,{workspace:a,backupPath:r}}};n=pe([ee(0,v.IEnvironmentMainService),ee(1,u.ILogService),ee(2,k.IUserDataProfilesMainService),ee(3,f.IBackupMainService),ee(4,w.IDialogMainService),ee(5,g.IProductService)],n),e.WorkspacesManagementMainService=n}),define(te[121],ie([0,1,14,42,22,6,30,29,53,11,5]),function(V,e,E,t,P,D,R,I,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let p=class{constructor(f,w,v){this.a=f,this.b=w,this.c=v}async getRemoteDiagnostics(f){const w=this.a.getWindows();return(await Promise.all(w.map(async c=>{const u=c.remoteAuthority;if(!u)return;const g=`vscode:getDiagnosticInfoResponse${c.id}`,k={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(c):void 0};return new Promise(S=>{c.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:g,args:k}),t.validatedIpcMain.once(g,(L,i)=>{i||S({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),S(i)}),setTimeout(()=>{S({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(c=>!!c)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const w of E.BrowserWindow.getAllWindows()){const v=this.a.getWindowById(w.id);v?f.push(await this.d(v)):f.push(this.e(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(f){const w=await this.f(f),v=(0,h.assertIsDefined)(f.win);return this.e(v,w,f.remoteAuthority)}e(f,w=[],v){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:w,remoteAuthority:v}}async f(f){const w=[],v=f.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(v))w.push(v.uri);else if((0,I.isWorkspaceIdentifier)(v)){const c=await this.b.resolveLocalWorkspace(v.configPath);c&&c.folders.forEach(g=>{w.push(g.uri)})}return w}};p=pe([ee(0,R.IWindowsMainService),ee(1,d.IWorkspacesManagementMainService),ee(2,y.ILogService)],p),e.DiagnosticsMainService=p}),define(te[58],ie([0,1,46,14,26,144,54,3,36,2,15,9,4,7,102,84,23,99,168,57,28,6,21,5,19,68,30,29,53,17,227,220,34]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,L.createDecorator)("nativeHostMainService");let B=class extends h.Disposable{constructor(G,X,re,se,ae,fe,ge,H,F,U){super(),this.a=G,this.b=X,this.c=re,this.f=se,this.g=ae,this.h=fe,this.i=ge,this.j=H,this.k=F,this.l=U,this.onDidOpenWindow=I.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Q,y:ne})=>({windowId:z.id,x:Q,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new I.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Q,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),I.Event.fromNodeEventEmitter(t.screen,"display-added"),I.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(X=>({id:X.id,workspace:X.openedWorkspace??(0,a.toWorkspaceIdentifier)(X.backupPath,X.isExtensionDevelopmentHost),title:X.win?.getTitle()??"",filename:X.getRepresentedFilename(),dirty:X.isDocumentEdited()}))}async getWindowCount(G){return this.b.getWindowCount()}async getActiveWindowId(G){const X=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(X)return X.id}openWindow(G,X,re){return Array.isArray(X)?this.n(G,X,re):this.p(G,X)}async n(G,X,re=Object.create(null)){X.length>0&&await this.b.open({context:5,contextWindowId:G,urisToOpen:X,cli:this.g.args,forceNewWindow:re.forceNewWindow,forceReuseWindow:re.forceReuseWindow,preferNewWindow:re.preferNewWindow,diffMode:re.diffMode,mergeMode:re.mergeMode,addMode:re.addMode,gotoLineMode:re.gotoLineMode,noRecentEntry:re.noRecentEntry,waitMarkerFileURI:re.waitMarkerFileURI,remoteAuthority:re.remoteAuthority||void 0,forceProfile:re.forceProfile,forceTempProfile:re.forceTempProfile})}async p(G,X){await this.b.openEmptyWindow({context:5,contextWindowId:G},X)}async toggleFullScreen(G){this.w(G)?.toggleFullScreen()}async handleTitleDoubleClick(G){this.w(G)?.handleTitleDoubleClick()}async isMaximized(G){const X=this.w(G);return X?.win?X.win.isMaximized():!1}async maximizeWindow(G){const X=this.w(G);X?.win&&X.win.maximize()}async unmaximizeWindow(G){const X=this.w(G);X?.win&&X.win.unmaximize()}async minimizeWindow(G){const X=this.w(G);X?.win&&X.win.minimize()}async updateWindowControls(G,X){const re=this.w(G);re&&re.updateWindowControls(X)}async focusWindow(G,X){X&&typeof X.windowId=="number"&&(G=X.windowId),this.w(G)?.focus({force:X?.force??!1})}async setMinimumSize(G,X,re){const se=this.w(G);if(se?.win){const[ae,fe]=se.win.getSize(),[ge,H]=se.win.getMinimumSize(),[F,U]=[X??ge,re??H],[z,Q]=[Math.max(ae,F),Math.max(fe,U)];(ge!==F||H!==U)&&se.win.setMinimumSize(F,U),(ae!==z||fe!==Q)&&se.win.setSize(z,Q)}}async saveWindowSplash(G,X){this.j.saveWindowSplash(G,X)}async installShellCommand(G){const{source:X,target:re}=await this.r();try{const{symbolicLink:se}=await c.SymlinkSupport.stat(X);if(se&&!se.dangling){const ae=await(0,w.realpath)(X);if(re===ae)return}await c.Promises.unlink(X)}catch(se){if(se.code!=="ENOENT")throw se}try{await c.Promises.symlink(re,X)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ae}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,g.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${re}' '${X}'\\" with administrator privileges"`;await(0,D.promisify)(E.exec)(fe)}catch{throw new Error((0,g.localize)(3,null,X))}}}async uninstallShellCommand(G){const{source:X}=await this.r();try{await c.Promises.unlink(X)}catch(re){switch(re.code){case"EACCES":{const{response:se}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,g.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"rm '${X}'\\" with administrator privileges"`;await(0,D.promisify)(E.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,X))}break}case"ENOENT":break;default:throw re}}}async r(){const G=(0,p.resolve)(this.g.appRoot,"bin","code"),X=`/usr/local/bin/${this.i.applicationName}`;if(!await c.Promises.exists(G))throw new Error((0,g.localize)(8,null,G));return{source:X,target:G}}async showMessageBox(G,X){return this.c.showMessageBox(X,this.s(G))}async showSaveDialog(G,X){return this.c.showSaveDialog(X,this.s(G))}async showOpenDialog(G,X){return this.c.showOpenDialog(X,this.s(G))}s(G){const X=this.w(G);if(X?.win)return X.win}async pickFileFolderAndOpen(G,X){const re=await this.c.pickFileFolder(X);re&&await this.t(await Promise.all(re.map(async se=>await c.SymlinkSupport.existsDirectory(se)?{folderUri:f.URI.file(se)}:{fileUri:f.URI.file(se)})),X,G)}async pickFolderAndOpen(G,X){const re=await this.c.pickFolder(X);re&&await this.t(re.map(se=>({folderUri:f.URI.file(se)})),X,G)}async pickFileAndOpen(G,X){const re=await this.c.pickFile(X);re&&await this.t(re.map(se=>({fileUri:f.URI.file(se)})),X,G)}async pickWorkspaceAndOpen(G,X){const re=await this.c.pickWorkspace(X);re&&await this.t(re.map(se=>({workspaceUri:f.URI.file(se)})),X,G)}async t(G,X,re){await this.b.open({context:3,contextWindowId:re,cli:this.g.args,urisToOpen:G,forceNewWindow:X.forceNewWindow})}async showItemInFolder(G,X){t.shell.showItemInFolder(X)}async setRepresentedFilename(G,X){this.w(G)?.setRepresentedFilename(X)}async setDocumentEdited(G,X){this.w(G)?.setDocumentEdited(X)}async openExternal(G,X){return b.isLinuxSnap?this.u(X):t.shell.openExternal(X),!0}u(G){const X=process.env.GDK_PIXBUF_MODULE_FILE,re=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(G),process.env.GDK_PIXBUF_MODULE_FILE=X,process.env.GDK_PIXBUF_MODULEDIR=re}moveItemToTrash(G,X){return t.shell.trashItem(X)}async isAdmin(){let G;return b.isWindows?G=(await new Promise((X,re)=>{V(["native-is-elevated"],X,re)}))():G=process.getuid()===0,G}async writeElevated(G,X,re,se){const ae=await new Promise((fe,ge)=>{V(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const H=[`"${this.v}"`];se?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${X.fsPath}"`,`"${re.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:b.isMacintosh&&this.g.isBuilt?(0,p.join)((0,p.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(H.join(" "),F,(U,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),U?ge(U):fe(void 0)})})}get v(){return b.isWindows?this.g.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,p.join)(this.g.appRoot,"scripts","code-cli.bat"):b.isLinux?this.g.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,p.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.join)(this.g.appRoot,"bin","code"):(0,p.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return v.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,C.hasWSLFeatureInstalled)()}async killProcess(G,X,re){process.kill(X,re)}async readClipboardText(G,X){return t.clipboard.readText(X)}async writeClipboardText(G,X,re){return t.clipboard.writeText(X,re)}async readClipboardFindText(G){return t.clipboard.readFindText()}async writeClipboardFindText(G,X){return t.clipboard.writeFindText(X)}async writeClipboardBuffer(G,X,re,se){return t.clipboard.writeBuffer(X,Buffer.from(re.buffer),se)}async readClipboardBuffer(G,X){return m.VSBuffer.wrap(t.clipboard.readBuffer(X))}async hasClipboard(G,X,re){return t.clipboard.has(X,re)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(G,X){this.w(G)?.updateTouchBar(X)}async notifyReady(G){this.w(G)?.setReady()}async relaunch(G,X){return this.f.relaunch(X)}async reload(G,X){const re=this.w(G);if(re){if((0,a.isWorkspaceIdentifier)(re.openedWorkspace)){const se=re.openedWorkspace.configPath;if(se.scheme===y.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(re.id,{forceReuseWindow:!0})}return this.f.reload(re,X?.disableExtensions!==void 0?{_:[],"disable-extensions":X.disableExtensions}:void 0)}}async closeWindow(G){this.closeWindowById(G,G)}async closeWindowById(G,X){const re=this.w(X);if(re?.win)return re.win.close()}async quit(G){const X=this.b.getLastActiveWindow();X?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&X.win?X.win.close():this.f.quit()}async exit(G,X){await this.f.kill(X)}async resolveProxy(G,X){const se=this.w(G)?.win?.webContents?.session;if(se)return se.resolveProxy(X)}findFreePort(G,X,re,se,ae=1){return(0,u.findFreePort)(X,re,se,ae)}async openDevTools(G,X){const re=this.w(G);re?.win&&re.win.webContents.openDevTools(X)}async toggleDevTools(G){const X=this.w(G);X?.win&&X.win.webContents.toggleDevTools()}async sendInputEvent(G,X){const re=this.w(G);re?.win&&(X.type==="mouseDown"||X.type==="mouseUp")&&re.win.webContents.sendInputEvent(X)}async enableSandbox(G,X){X?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(G,X,re){const se=this.w(G);if(!se||!se.win)throw new Error;return await new M.WindowProfiler(se.win,X,this.h).inspect(re)}async windowsGetStringRegKey(G,X,re,se){if(!b.isWindows)return;const ae=await new Promise((fe,ge)=>{V(["@vscode/windows-registry"],fe,ge)});try{return ae.GetStringRegKey(X,re,se)}catch{return}}w(G){if(typeof G=="number")return this.b.getWindowById(G)}};pe([R.memoize],B.prototype,"v",null),B=pe([ee(1,s.IWindowsMainService),ee(2,k.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,S.IEnvironmentMainService),ee(5,l.ILogService),ee(6,n.IProductService),ee(7,o.IThemeMainService),ee(8,O.IStateMainService),ee(9,r.IWorkspacesManagementMainService)],B),e.NativeHostMainService=B}),define(te[274],ie([0,1,14,42,26,36,2,15,4,103,166,87,121,57,28,6,5,58,65,19,66,76,32,11,34]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");const o="issue.processExplorerWindowState";let s=class $t{constructor(m,C,M,O,B,J,G,X,re,se){this.g=m,this.h=C,this.i=M,this.j=O,this.k=B,this.l=J,this.m=G,this.n=X,this.o=re,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async m=>{const[C,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(C,M);this.r(m,"vscode:issueSystemInfoResponse",O)}),t.validatedIpcMain.on("vscode:listProcesses",async m=>{const C=[];try{C.push({name:(0,y.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,p.isRemoteDiagnosticError)(O)?C.push({name:O.hostName,rootProcess:O}):O.processes&&C.push({name:O.hostName,rootProcess:O.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.r(m,"vscode:listProcessesResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async m=>{const C={title:this.o.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const M=await this.l.showMessageBox(C,this.b);this.r(m,"vscode:issueReporterClipboardResponse",M.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async m=>{const C=await this.v();this.r(m,"vscode:issuePerformanceInfoResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const m={title:this.o.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(m,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(m,C)=>{const{id:M,from:O,args:B}=C;let J;switch(O){case"issueReporter":J=this.c;break;case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}J?.webContents.send("vscode:runAction",{id:M,from:O,args:B})}),t.validatedIpcMain.on("vscode:openExternal",(m,C)=>{this.m.openExternal(void 0,C)}),t.validatedIpcMain.on("vscode:closeIssueReporter",m=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",m=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async m=>{const C=await this.k.getMainDiagnostics();this.r(m,"vscode:windowsInfoResponse",C.windows)})}r(m,C,...M){m.sender.isDestroyed()||m.sender.send(C,...M)}async openReporter(m){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const C=new R.DisposableStore,M=C.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,M,{backgroundColor:m.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:m.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:m,disableExtensions:!!this.h.disableExtensions,os:{type:(0,P.type)(),arch:(0,P.arch)(),release:(0,P.release)()},product:g.default}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,C.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,C.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(m){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const C=new R.DisposableStore,M=C.add(this.n.createIPCObjectUrl()),O=this.p.getItem(o,void 0),B=a(O)?O:this.u(this.f,800,500),J=E.screen.getDisplayNearestPoint({x:B.x,y:B.y});B.width/=J.scaleFactor,B.height/=J.scaleFactor,this.d=this.t(B,M,{backgroundColor:m.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:m.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:m,product:g.default}),this.d.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,C.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,C.dispose())});const G=()=>{if(!this.d)return;const X=this.d.getSize(),re=this.d.getPosition();if(!X||!re)return;const se={width:X[0],height:X[1],x:re[0],y:re[1]};this.p.setItem(o,se)};this.d.on("moved",G),this.d.on("resized",G)}this.d&&this.s(this.d)}s(m){m.isMinimized()&&m.restore(),m.focus()}t(m,C,M,O){const B=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:m.width,height:m.height,minWidth:300,minHeight:200,x:m.x,y:m.y,title:M.title,backgroundColor:M.backgroundColor||$t.a,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,L.zoomLevelToZoomFactor)(M.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return B.setMenuBarVisibility(!1),B}async getSystemStatus(){const[m,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(m,C)}u(m,C,M){let O;const B=E.screen.getAllDisplays();if(B.length===1)O=B[0];else{if(d.isMacintosh){const X=E.screen.getCursorScreenPoint();O=E.screen.getDisplayNearestPoint(X)}!O&&m&&(O=E.screen.getDisplayMatching(m.getBounds())),O||(O=E.screen.getPrimaryDisplay()||B[0])}const J=O.bounds,G={width:C,height:M,x:J.x+J.width/2-C/2,y:J.y+J.height/2-M/2};return J.width>0&&J.height>0&&(G.x<J.x&&(G.x=J.x),G.y<J.y&&(G.y=J.y),G.x>J.x+J.width&&(G.x=J.x),G.y>J.y+J.height&&(G.y=J.y),G.width>J.width&&(G.width=J.width),G.height>J.height&&(G.height=J.height)),G}async v(){try{const[m,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(m,C)}catch(m){throw this.i.warn("issueService#getPerformanceInfo ",m.message),m}}async stopTracing(){if(!this.h.args.trace)return;const m=await E.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,y.localize)(9,null),detail:(0,y.localize)(10,null,m),buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(11,null))],defaultId:0,noLink:!0},(0,l.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,m)}};s.a="#1E1E1E",s=pe([ee(1,w.IEnvironmentMainService),ee(2,c.ILogService),ee(3,p.IDiagnosticsService),ee(4,b.IDiagnosticsMainService),ee(5,f.IDialogMainService),ee(6,u.INativeHostMainService),ee(7,S.IProtocolMainService),ee(8,k.IProductService),ee(9,n.IStateMainService)],s),e.IssueMainService=s;function a(r){return typeof r!="object"||r===null?!1:"x"in r&&"y"in r&&"width"in r&&"height"in r}}),define(te[275],ie([0,1,22,18,28,21,5,58,19,56,24,49,93]),function(V,e,E,t,P,D,R,I,d,h,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends b.AbstractUpdateService{constructor(v,c,u,g,k,S,L,i){super(v,c,g,k,S,i),this.e=u,this.u=L}s(v){return(0,b.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(p.State.CheckingForUpdates(v)),this.i.request({url:this.a},E.CancellationToken.None).then(h.asJson).then(c=>{!c||!c.url||!c.version||!c.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(p.State.Idle(1))):this.d(p.State.AvailableForDownload(c))}).then(void 0,c=>{this.j.error(c),this.e.publicLog2("update:notAvailable",{explicit:!!v});const u=v?c.message||c:void 0;this.d(p.State.Idle(1,u))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(p.State.Idle(1))}};f=pe([ee(0,D.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,y.ITelemetryService),ee(3,P.IEnvironmentMainService),ee(4,h.IRequestService),ee(5,R.ILogService),ee(6,I.INativeHostMainService),ee(7,d.IProductService)],f),e.LinuxUpdateService=f}),define(te[276],ie([0,1,46,41,26,8,22,54,9,7,130,23,18,28,16,21,5,58,19,56,24,49,93]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,r=1e3){for(;!a();)await(0,D.timeout)(r)}let n;function o(){return typeof n>"u"&&(n=t.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends i.AbstractUpdateService{get cachePath(){const r=d.join((0,P.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return p.Promises.mkdir(r,{recursive:!0}).then(()=>r)}constructor(r,m,C,M,O,B,J,G,X){super(r,m,M,O,B,X),this.u=C,this.v=J,this.w=G}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(r){let m="win32";return process.arch!=="ia32"&&(m+=`-${process.arch}`),o()===1?m+="-archive":this.k.target==="user"&&(m+="-user"),(0,i.createUpdateURL)(m,r,this.k)}t(r){!this.a||(this.d(L.State.CheckingForUpdates(r)),this.i.request({url:this.a},R.CancellationToken.None).then(k.asJson).then(m=>{const C=o();return!m||!m.url||!m.version||!m.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!r}),this.d(L.State.Idle(C)),Promise.resolve(null)):C===1?(this.d(L.State.AvailableForDownload(m)),Promise.resolve(null)):(this.d(L.State.Downloading(m)),this.B(m.version).then(()=>this.A(m.version).then(M=>p.Promises.exists(M).then(O=>{if(O)return Promise.resolve(M);const B=m.url,J=m.hash,G=`${M}.tmp`;return this.i.request({url:B},R.CancellationToken.None).then(X=>this.v.writeFile(h.URI.file(G),X.stream)).then(J?()=>(0,y.checksum)(G,m.hash):()=>{}).then(()=>p.Promises.rename(G,M)).then(()=>M)})).then(M=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},O&&m.supportsFastUpdate?this.k.target==="user"?this.p():this.d(L.State.Downloaded(m)):this.d(L.State.Ready(m))})))}).then(void 0,m=>{this.j.error(m),this.u.publicLog2("update:notAvailable",{explicit:!!r});const C=r?m.message||m:void 0;this.d(L.State.Idle(o(),C))}))}async o(r){r.update.url&&this.w.openExternal(void 0,r.update.url),this.d(L.State.Idle(o()))}async A(r){const m=await this.cachePath;return d.join(m,`CodeSetup-${this.k.quality}-${r}.exe`)}async B(r=null){const m=r?B=>!new RegExp(`${this.k.quality}-${r}\\.exe$`).test(B):()=>!0,C=await this.cachePath,O=(await p.Promises.readdir(C)).filter(m).map(async B=>{try{await p.Promises.unlink(d.join(C,B))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const r=this.state.update;this.d(L.State.Updating(r));const m=await this.cachePath;this.e.updateFilePath=d.join(m,`CodeSetup-${this.k.quality}-${r.version}.flag`),await p.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(L.State.Idle(o()))});const M=`${this.k.win32MutexName}-ready`,O=await new Promise((B,J)=>{V(["windows-mutex"],B,J)});l(()=>O.isActive(M)).then(()=>this.d(L.State.Ready(r)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(r){if(this.state.type!=="idle")return;const m=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!m};this.d(L.State.Downloading(C)),this.e={packagePath:r},m?this.k.target==="user"?this.p():this.d(L.State.Downloaded(C)):this.d(L.State.Ready(C))}};pe([I.memoize],s.prototype,"cachePath",null),s=pe([ee(0,v.ILifecycleMainService),ee(1,b.IConfigurationService),ee(2,S.ITelemetryService),ee(3,f.IEnvironmentMainService),ee(4,k.IRequestService),ee(5,c.ILogService),ee(6,w.IFileService),ee(7,u.INativeHostMainService),ee(8,g.IProductService)],s),e.Win32UpdateService=s}),define(te[277],ie([0,1,14,8,22,45,3,36,2,15,9,63,4,7,174,62,18,57,28,61,16,21,5,19,66,238,95,24,243,68,76,30,29,53,118,123,39,34,52,58,240,114,51,92,26,115,64]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O,B,J,G,X,re,se,ae,fe,ge,H,F,U,z,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function($){$[$.NONE=0]="NONE",$[$.NAVIGATING=1]="NAVIGATING",$[$.READY=2]="READY"})(ne||(ne={}));let _=class dt extends d.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const A=this.P.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&A?A:this.P.getProfileForWorkspace(this.config.workspace??(0,O.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(A,T,W,j,K,N,q,Z,oe,le,be,Ce,Oe,Le,we,ve,Ee,Ie,x,de,ue){super(),this.L=T,this.M=W,this.N=j,this.O=K,this.P=N,this.Q=q,this.R=Z,this.S=oe,this.U=le,this.W=be,this.X=Ce,this.Y=Oe,this.Z=Le,this.ab=we,this.bb=ve,this.db=Ee,this.eb=Ie,this.fb=x,this.gb=de,this.hb=ue,this.c=this.B(new R.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new R.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new R.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new R.Emitter),this.onDidClose=this.h.event,this.j=this.B(new R.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;{const[ye,De]=this.tb(A.state);this.r=ye,this.L.trace("window#ctor: using window state",ye);const Ue=this.r.mode===0||this.r.mode===3;typeof dt.b>"u"&&(dt.b=this.gb.getItem("window.experimental.useSandbox",!1));const Te=this.U.getValue("window");let He=!1;typeof Te?.experimental?.useSandbox=="boolean"?He=Te.experimental.useSandbox:this.db.quality==="stable"&&dt.b?He=!0:He=typeof this.db.quality=="string"&&this.db.quality!=="stable";const We={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,show:!Ue,title:this.db.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(Te?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...He?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?We.icon=(0,y.join)(this.N.appRoot,"resources/linux/code.png"):b.isWindows&&!this.N.isBuilt&&(We.icon=(0,y.join)(this.N.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.Ab()&&(We.fullscreenable=!1),b.isMacintosh&&(We.acceptFirstMouse=!0,Te?.clickThroughInactive===!1&&(We.acceptFirstMouse=!1));const qe=b.isMacintosh&&Te?.nativeTabs===!0;qe&&(We.tabbingIdentifier=this.db.nameShort);const Xe=(0,C.getTitleBarStyle)(this.U)==="custom";if(Xe&&(We.titleBarStyle="hidden",b.isMacintosh||(We.frame=!1),(0,C.useWindowControlsOverlay)(this.U))){const Ne=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),Ge=G.Color.fromHex(Ne).isDarker()?"#FFFFFF":"#000000";We.titleBarOverlay={height:29,color:Ne,symbolColor:Ge},this.z=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(We),(0,p.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,b.isMacintosh&&Xe&&this.l.setSheetOffset(22),Xe&&(b.isWindows&&(0,C.useWindowControlsOverlay)(this.U)||b.isMacintosh)){const Ne=this.gb.getItem(dt.a);Ne&&this.updateWindowControls({height:Ne})}b.isWindows&&Xe&&this.l.hookWindowMessage(278,()=>{const[Ge,Y]=this.l.getPosition(),ce=E.screen.getCursorScreenPoint(),he=ce.x-Ge,me=ce.y-Y;return(()=>!(he>30&&me>=0&&me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:he,y:me})),0}),(b.isMacintosh||b.isWindows)&&De&&(!qe||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Ne=>typeof Ne=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Ue&&((0,p.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb()}setRepresentedFilename(A){b.isMacintosh?this.l.setRepresentedFilename(A):this.v=A}getRepresentedFilename(){return b.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(A){b.isMacintosh&&this.l.setDocumentEdited(A),this.w=A}isDocumentEdited(){return b.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(A){b.isMacintosh&&A?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.C.push(A)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(A=>{function T(){W.dispose(),j.dispose(),A()}const W=this.onDidClose(()=>T()),j=this.onWillLoad(()=>T())})}jb(){this.l.on("unresponsive",()=>this.mb(1)),this.l.webContents.on("render-process-gone",(T,W)=>this.mb(2,W)),this.l.webContents.on("did-fail-load",(T,W,j)=>this.mb(3,{reason:j,exitCode:W})),this.l.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",T=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",T,this.l)}),this.l.on("unmaximize",T=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",T,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(T=>this.qb(T))),this.B(this.X.onDidDeleteUntitledWorkspace(T=>this.pb(T)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(T,W)=>{const j=await this.lb();W({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,j)})})}lb(){return this.kb||(this.kb=(0,o.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(A,T){switch(A){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:A,reason:T?.reason,code:T?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,w.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,w.localize)(2,null))],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,w.localize)(5,null):void 0},this.l);if(W.response!==1){const j=W.response===0;await this.ob(j,W.checkboxChecked)}}else if(A===2)if(b.isWindows&&T?.reason==="launch-failed"&&T.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(T);else{let W;T?W=(0,w.localize)(7,null,T.reason,T.exitCode??"<unknown>"):W=(0,w.localize)(6,null);const j=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[this.n?.workspace?(0,I.mnemonicButtonLabel)((0,w.localize)(8,null)):(0,I.mnemonicButtonLabel)((0,w.localize)(9,null)),(0,I.mnemonicButtonLabel)((0,w.localize)(10,null))],message:W,detail:this.n?.workspace?(0,w.localize)(11,null):(0,w.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,w.localize)(13,null):void 0},this.l),K=j.response===0;await this.ob(K,j.checkboxChecked)}break}}async nb(A){const T=[],W=(0,H.isInternalTelemetry)(this.db,this.U);if((0,H.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&T.push(new fe.OneDataSystemAppender(W,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:K}=this.N,N=await(0,z.resolveMachineId)(this.gb),q={appenders:T,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)(this.Q,(0,U.release)(),(0,U.hostname)(),process.arch,this.db.commit,this.db.version,N,W,K),piiPaths:(0,H.getPiiPathsFromEnvironment)(this.N)};await new ge.TelemetryService(q,this.U,this.db).publicLog2("windowadminerror",{reason:A.reason,code:A.exitCode})}(await this.ab.showMessageBox({title:this.db.nameLong,type:"error",buttons:[(0,I.mnemonicButtonLabel)((0,w.localize)(14,null)),(0,I.mnemonicButtonLabel)((0,w.localize)(15,null))],message:(0,w.localize)(16,null),detail:(0,w.localize)(17,null,this.db.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(T.map(K=>K.flush())),await this.ob(!1,!1)}async ob(A,T){const W=this.n?.workspace;if(T&&W)try{const j=this.S.workspaceStorage(W);await j.init(),j.delete("memento/workbench.parts.editor"),await j.close()}catch(j){this.L.error(j)}if(this.j.fire(),this.l?.destroy(),A&&this.n){let j,K;(0,O.isSingleFolderWorkspaceIdentifier)(W)?j={folderUri:W.uri}:(0,O.isWorkspaceIdentifier)(W)?j={workspaceUri:W.configPath}:K=!0;const[N]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:j?[j]:void 0,forceEmpty:K,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});N.focus()}}pb(A){this.n?.workspace?.id===A.id&&(this.n.workspace=void 0)}qb(A){const T=this.Bb();T!==this.s&&(this.s=T,this.Cb(T));let W=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||j!==this.G)){this.F=W,this.G=j;const K=W||"",N=j?`${j},<local>`:"<local>";this.L.trace(`Setting proxy to '${K}', bypassing '${N}'`),this.l.webContents.session.setProxy({proxyRules:K,proxyBypassRules:N,pacScript:""})}}addTabbedWindow(A){b.isMacintosh&&A.win&&this.l.addTabbedWindow(A.win)}load(A,T=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!T.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(A,T),this.ib===0?this.n=A:this.I=A,this.ib=1,this.l.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:A.workspace,reason:T.isReload?3:W?2:1})}rb(A,T){const W=(this.n??this.I)?.userEnv;if(W){const j=(0,k.isLaunchedFromCli)(W)&&!(0,k.isLaunchedFromCli)(A.userEnv),K=this.isExtensionDevelopmentHost;(j||K)&&(A.userEnv={...W,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(A["disable-extensions"]=T.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this.l.isMaximized(),A.partsSplash=this.W.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),A.perfMarks=(0,p.getMarks)(),this.H.update(A)}async reload(A){const T=Object.assign({},this.n);T.workspace=await this.sb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&A&&(T.verbose=A.verbose,T.debugId=A.debugId,T.extensionEnvironment=A.extensionEnvironment,T["inspect-extensions"]=A["inspect-extensions"],T["inspect-brk-extensions"]=A["inspect-brk-extensions"],T["extensions-dir"]=A["extensions-dir"]),T.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.O.serialize(),T.continueOn=this.N.continueOn,T.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},T.logLevel=this.L.getLevel(),T.loggers=this.M.getLoggerResources(this.id),this.load(T,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async sb(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const T=A.workspace.configPath;if(T.scheme===h.Schemas.file&&!await this.Q.exists(T))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const T=A.workspace.uri;if(T.scheme===h.Schemas.file&&!await this.Q.exists(T))return}return A.workspace}serializeWindowState(){if(!this.l)return(0,J.defaultWindowState)();if(this.isFullScreen){let W;try{W=E.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,J.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||j.width,height:this.r.height||j.height,x:this.r.x||0,y:this.r.y||0}}const A=Object.create(null);let T;if(!b.isMacintosh&&this.l.isMaximized()?T=0:T=1,T===0?A.mode=0:A.mode=1,T===1||T===0){let W;T===1?W=this.getBounds():W=this.l.getNormalBounds(),A.x=W.x,A.y=W.y,A.width=W.width,A.height=W.height}return A}updateWindowControls(A){if(A.height&&this.gb.setItem(dt.a,A.height),b.isWindows&&this.z)this.l.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(b.isMacintosh&&A.height!==void 0){const T=(A.height-15)/2;this.l.setTrafficLightPosition({x:T,y:T})}}tb(A){(0,p.mark)("code/willRestoreCodeWindowState");let T=!1;if(A)try{const W=E.screen.getAllDisplays();T=W.length>1,A=this.ub(A,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[A||(0,J.defaultWindowState)(),T]}ub(A,T){if(this.L.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const K=this.vb(T[0]);if(K){let N=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!K||(A.x<K.x&&(A.x=K.x),A.y<K.y&&(A.y=K.y))};this.L.trace("window#validateWindowState: 1 monitor working area",K),N(),A.width>K.width&&(A.width=K.width),A.height>K.height&&(A.height=K.height),A.x>K.x+K.width-128&&(A.x=K.x+K.width-A.width),A.y>K.y+K.height-128&&(A.y=K.y+K.height-A.height),N()}return A}if(A.display&&A.mode===3){const K=T.find(N=>N.id===A.display);if(K&&typeof K.bounds?.x=="number"&&typeof K.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,J.defaultWindowState)(3);return N.x=K.bounds.x,N.y=K.bounds.y,N}}let W,j;try{W=E.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),j=this.vb(W)}catch{}if(W&&j&&A.x+A.width>j.x&&A.y+A.height>j.y&&A.x<j.x+j.width&&A.y<j.y+j.height)return this.L.trace("window#validateWindowState: multi-monitor working area",j),A}vb(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,T]=this.l.getPosition(),[W,j]=this.l.getSize();return{x:A,y:T,width:W,height:j}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(A){this.Ab()?this.xb(A):this.zb(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(A){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(A)}yb(A){b.isMacintosh&&(this.t=A,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(A)}zb(A){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(A),this.l.webContents.focus()}Ab(){const A=this.U.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let A=(0,C.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}Cb(A,T=!0){b.isMacintosh||(A==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,w.localize)(18,null)),A==="hidden"?setTimeout(()=>{this.Db(A)}):this.Db(A))}Db(A){const T=this.isFullScreen;switch(A){case"classic":this.l.setMenuBarVisibility(!T),this.l.autoHideMenuBar=T;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(A,T,...W){this.isReady?this.send(A,...W):this.ready().then(()=>{T.isCancellationRequested||this.send(A,...W)})}send(A,...T){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this.l.webContents.send(A,...T)}catch(W){this.L.warn(`Error sending IPC message to channel '${A}' of window ${this.k}: ${(0,D.toErrorMessage)(W)}`)}}}updateTouchBar(A){!b.isMacintosh||this.D.forEach((T,W)=>{const j=A[W];T.segments=this.Gb(j)})}Eb(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const T=this.Fb();this.D.push(T)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Fb(A=[]){const T=this.Gb(A),W=new E.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:W.segments[j].id,from:"touchbar"})}});return W}Gb(A=[]){return A.map(W=>{let j;W.icon&&!r.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===h.Schemas.file&&(j=E.nativeImage.createFromPath(f.URI.revive(W.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let K;return typeof W.title=="string"?K=W.title:K=W.title.value,{id:W.id,label:j?void 0:K,icon:j}})}dispose(){super.dispose(),this.M.deregisterLoggerResources(this.id),this.l=null}};_.a="windowControlHeight",_.b=void 0,_=pe([ee(1,i.ILogService),ee(2,Q.ILoggerMainService),ee(3,g.IEnvironmentMainService),ee(4,X.IPolicyService),ee(5,se.IUserDataProfilesMainService),ee(6,S.IFileService),ee(7,s.IApplicationStorageMainService),ee(8,s.IStorageMainService),ee(9,c.IConfigurationService),ee(10,m.IThemeMainService),ee(11,B.IWorkspacesManagementMainService),ee(12,v.IBackupMainService),ee(13,a.ITelemetryService),ee(14,u.IDialogMainService),ee(15,L.ILifecycleMainService),ee(16,l.IProductService),ee(17,n.IProtocolMainService),ee(18,M.IWindowsMainService),ee(19,re.IStateMainService),ee(20,ae.INativeHostMainService)],_),e.CodeWindow=_}),define(te[78],ie([0,1,14,25,8,3,36,2,15,4,20,7,23,177,6,21,5,95,96,29,53,38]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let i=class rt extends I.Disposable{constructor(n,o,s,a){super(),this.f=n,this.g=o,this.h=s,this.j=a,this.c=this.B(new D.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new P.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let o=[],s=[];for(const r of n)if((0,g.isRecentWorkspace)(r))!this.g.isUntitledWorkspace(r.workspace)&&!this.r(o,r.workspace)&&o.push(r);else if((0,g.isRecentFolder)(r))this.s(o,r.folderUri)||o.push(r);else{const m=this.t(s,r.fileUri),C=r.fileUri.scheme===d.Schemas.file&&rt.y.indexOf((0,y.basename)(r.fileUri))>=0;!m&&!C&&(s.push(r),h.isWindows&&r.fileUri.scheme===d.Schemas.file&&E.app.addRecentDocument(r.fileUri.fsPath))}const a=await this.l({workspaces:o,files:s});o=a.workspaces,s=a.files,o.length>rt.a&&(o.length=rt.a),s.length>rt.a&&(s.length=rt.a),await this.n({workspaces:o,files:s}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const o=m=>{const C=this.p(m);for(const M of n)if(y.extUriBiasedIgnorePathCase.isEqual(M,C))return!1;return!0},s=await this.getRecentlyOpened(),a=s.workspaces.filter(o),r=s.files.filter(o);(a.length!==s.workspaces.length||r.length!==s.files.length)&&(await this.n({files:r,workspaces:a}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const o=new L.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r));if(n?.workspaces)for(const r of n.workspaces)o.set(this.p(r),r);const s=new L.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r));if(n?.files)for(const r of n.files)s.set(this.p(r),r);const a=await this.m();for(const r of a.workspaces){const m=o.get(this.p(r));m?m.label=m.label??r.label:o.set(this.p(r),r)}for(const r of a.files){const m=s.get(this.p(r));m?m.label=m.label??r.label:s.set(this.p(r),r)}return{workspaces:[...o.values()],files:[...s.values()]}}async m(){await this.j.whenReady;let n;const o=this.j.get(rt.b,-1);if(typeof o=="string")try{n=JSON.parse(o)}catch(s){this.f.error("Unexpected error parsing opened paths list",s)}return(0,g.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,g.toStoreData)(n)),-1,1)}p(n){return(0,g.isRecentFolder)(n)?n.folderUri:(0,g.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,o){return!!n.find(s=>(0,g.isRecentWorkspace)(s)&&s.workspace.id===o.id)}s(n,o){return!!n.find(s=>(0,g.isRecentFolder)(s)&&y.extUriBiasedIgnorePathCase.isEqual(s.folderUri,o))}t(n,o){return!!n.find(s=>y.extUriBiasedIgnorePathCase.isEqual(s.fileUri,o))}async C(){!h.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!h.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const r of E.app.getJumpListSettings().removedItems){const m=r.args;if(m){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);C&&o.push(p.URI.parse(C[2]))}}await this.removeRecentlyOpened(o);let s=!1;const a=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(r=>{const m=(0,g.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:C,description:M}=this.F(m,r.label);let O;return p.URI.isUri(m)?O=`--folder-uri "${m.toString()}"`:(s=!0,O=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:M.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&n.push({type:"custom",name:s?(0,f.localize)(2,null):(0,f.localize)(3,null),items:a})}n.push({type:"recent"});try{const o=E.app.setJumpList(n);o&&o!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.f.warn("updateWindowsJumpList#setJumpList",o)}}F(n,o){if(o)return{title:(0,R.splitName)(o).name,description:o};if(p.URI.isUri(n))return{title:(0,y.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(4,null),description:""};let s=(0,y.basename)(n.configPath);return s.endsWith(k.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,s),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,R.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!h.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),o=[];let s=0;for(let r=0;r<n.workspaces.length&&s<rt.u;r++){const m=this.p(n.workspaces[r]);if(m.scheme===d.Schemas.file){const C=(0,y.originalFSPath)(m);await b.Promises.exists(C)&&(o.push(C),s++)}}const a=[];for(let r=0;r<n.files.length&&s<rt.v;r++){const m=this.p(n.files[r]);if(m.scheme===d.Schemas.file){const C=(0,y.originalFSPath)(m);if(rt.y.includes((0,y.basename)(m))||o.includes(C))continue;await b.Promises.exists(C)&&(a.push(C),s++)}}a.reverse().forEach(r=>E.app.addRecentDocument(r)),o.reverse().forEach(r=>E.app.addRecentDocument(r))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ee(0,c.ILogService),ee(1,S.IWorkspacesManagementMainService),ee(2,v.ILifecycleMainService),ee(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[278],ie([0,1,14,8,22,36,4,7,167,18,28,21,5,216,58,19,34,24,49,76,30,78]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let l=class Ut{constructor(s,a,r,m,C,M,O,B,J,G,X){this.n=s,this.o=a,this.p=r,this.q=m,this.r=C,this.s=M,this.t=O,this.u=B,this.v=J,this.w=G,this.x=X,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.isMacintosh||(0,k.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const s=this.t.getItem(Ut.a);s&&(s.menus&&(this.k=s.menus),s.keybindings&&(this.l=s.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,O,B)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(M,O,B)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(M,O,B)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(M,O,B)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(M,O,B)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const s=this.x.twitterUrl;s&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(s,"openTwitterUrl"));const a=this.x.requestFeatureUrl;a&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(a,"openUserVoiceUrl"));const r=this.x.reportIssueUrl;r&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(r,"openReportIssues"));const m=this.x.licenseUrl;m&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.language){const M=m.indexOf("?")>0?"&":"?";this.Z(`${m}${M}lang=${R.language}`,"openLicenseUrl")}else this.Z(m,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&m&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(C,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(s=>this.F(s)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const s=this.o.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get C(){if(!R.isMacintosh)return!1;const s=this.o.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.k=s.menus,this.l=s.keybindings,this.t.setItem(Ut.a,s),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(s){!R.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.d=s.newCount===0,this.D())}G(){!R.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const s=E.Menu.getApplicationMenu();if(s&&this.j.push(s),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(R.isMacintosh?new E.Menu:null);return}const a=new E.Menu;let r;if(R.isMacintosh){const C=new E.Menu;r=new E.MenuItem({label:this.x.nameShort,submenu:C}),this.I(C),a.append(r)}if(R.isMacintosh&&!this.c){this.c=!0;const C=new E.Menu;C.append(new E.MenuItem({label:this.bb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(C)}if(this.K("File")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(1,null)),submenu:C});this.M(C,"File"),a.append(M)}if(this.K("Edit")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(2,null)),submenu:C});this.M(C,"Edit"),a.append(M)}if(this.K("Selection")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(3,null)),submenu:C});this.M(C,"Selection"),a.append(M)}if(this.K("View")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(4,null)),submenu:C});this.M(C,"View"),a.append(M)}if(this.K("Go")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(5,null)),submenu:C});this.M(C,"Go"),a.append(M)}if(this.K("Run")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(6,null)),submenu:C});this.M(C,"Run"),a.append(M)}if(this.K("Terminal")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(7,null)),submenu:C});this.M(C,"Terminal"),a.append(M)}let m;if(this.K("Window")){const C=new E.Menu;m=new E.MenuItem({label:this.bb(d.localize(8,null)),submenu:C,role:"window"}),this.S(C)}if(m&&a.append(m),this.K("Help")){const C=new E.Menu,M=new E.MenuItem({label:this.bb(d.localize(9,null)),submenu:C,role:"help"});this.M(C,"Help"),a.append(M)}a.items&&a.items.length>0?E.Menu.setApplicationMenu(a):E.Menu.setApplicationMenu(null),this.h.schedule()}I(s){const a=this.U(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),r=this.T();let m;if(this.K("Preferences")){const re=new E.Menu;this.M(re,"Preferences"),m=new E.MenuItem({label:this.bb(d.localize(11,null)),submenu:re})}const C=new E.Menu,M=new E.MenuItem({label:d.localize(12,null),role:"services",submenu:C}),O=new E.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),B=new E.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),J=new E.MenuItem({label:d.localize(15,null),role:"unhide"}),G=new E.MenuItem(this.Y("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(re,se,ae)=>{const fe=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||fe?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),X=[a];X.push(...r),m&&X.push(n(),m),X.push(n(),M,n(),O,B,J,n(),G),X.forEach(re=>s.append(re))}async J(s){if(this.p.getWindowCount()===0)return!0;const a=this.o.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.Q(s)){const r={title:this.x.nameLong,type:"question",buttons:[(0,D.mnemonicButtonLabel)(d.localize(17,null)),(0,D.mnemonicButtonLabel)(d.localize(18,null))],message:d.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:m}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,r);return m===0}return!0}K(s){if(!R.isMacintosh&&(0,k.getTitleBarStyle)(this.o)==="custom")return!1;switch(s){case"File":case"Help":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[s];case"Window":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[s]}}L(s,a){a.forEach(r=>{if((0,f.isMenubarMenuItemSeparator)(r))s.append(n());else if((0,f.isMenubarMenuItemSubmenu)(r)){const m=new E.Menu,C=new E.MenuItem({label:this.bb(r.label),submenu:m});this.L(m,r.submenu.items),s.append(C)}else(0,f.isMenubarMenuItemRecentAction)(r)?s.append(this.O(r)):(0,f.isMenubarMenuItemAction)(r)&&(r.id==="workbench.action.showAboutDialog"&&this.N(s),R.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[r.id]?s.append(new E.MenuItem(this.Y(r.id,{label:this.bb(r.label),click:this.m[r.id]}))):s.append(this.U(r.label,r.id,!1,r.checked)):s.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)):s.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)))})}M(s,a){this.k&&this.k[a]&&this.L(s,this.k[a].items)}N(s){const a=this.T();a.length&&(a.forEach(r=>s.append(r)),s.append(n()))}O(s){const a=I.URI.revive(s.uri),r=s.id,m=r==="openRecentFile"?{fileUri:a}:r==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new E.MenuItem(this.Y(r,{label:s.label,click:async(C,M,O)=>{const B=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[m],forceNewWindow:B,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([a])}},!1))}P(s){return!!(s&&(!R.isMacintosh&&(s.ctrlKey||s.shiftKey)||R.isMacintosh&&(s.metaKey||s.altKey)))}Q(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}R(s,a,r){const m={label:this.bb(s),role:r,enabled:!0};return new E.MenuItem(this.X(a,m))}S(s){const a=new E.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),r=new E.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),m=new E.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.U(d.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(n()),M.push(this.U(d.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,r,n(),C,...M,n(),m].forEach(O=>s.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(d.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(d.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(d.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(s,a,r,m){const C=this.bb(s),M=typeof a=="function"?a:(X,re,se)=>{const ae=X?X.userSettingsLabel:null;let fe=a;Array.isArray(a)&&(fe=this.P(se)?a[1]:a[0]),ae&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:fe})},O=typeof r=="boolean"?r:this.p.getWindowCount()>0,B=typeof m=="boolean"?m:!1,J={label:C,click:M,enabled:O};B&&(J.type="checkbox",J.checked=B);let G;return typeof a=="string"?G=a:Array.isArray(a)&&(G=a[0]),R.isMacintosh&&(G==="editor.action.clipboardCutAction"?J.role="cut":G==="editor.action.clipboardCopyAction"?J.role="copy":G==="editor.action.clipboardPasteAction"&&(J.role="paste"),G==="undo"?J.click=this.V(M,{inDevTools:X=>X.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):G==="redo"?J.click=this.V(M,{inDevTools:X=>X.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):G==="editor.action.selectAll"&&(J.click=this.V(M,{inDevTools:X=>X.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(G,J))}V(s,a){return(r,m,C)=>{const M=E.BrowserWindow.getFocusedWindow();if(!M)return a.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return a.inDevTools(M.webContents.devToolsWebContents);s(r,m||M,C)}}W(s){let a=E.BrowserWindow.getFocusedWindow();if(!a){const m=this.p.getLastActiveWindow();m?.isMinimized()&&(a=m.win)}const r=a?this.p.getWindowById(a.id):void 0;if(r){if(this.v.trace("menubar#runActionInRenderer",s),R.isMacintosh&&!this.q.isBuilt&&!r.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const m={id:s.commandId,from:"menu"};r.sendWhenReady("vscode:runAction",P.CancellationToken.None,m)}else{const m={userSettingsLabel:s.userSettingsLabel};r.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,m)}}else this.v.trace("menubar#runActionInRenderer: no active window found",s)}X(s,a){const r=typeof s=="string"?this.l[s]:void 0;if(r?.label){if(r.isNative!==!1)a.accelerator=r.label,a.userSettingsLabel=r.userSettingsLabel;else if(typeof a.label=="string"){const m=a.label.indexOf("[");m>=0?a.label=`${a.label.substr(0,m)} [${r.label}]`:a.label=`${a.label} [${r.label}]`}}else a.accelerator=void 0;return a}Y(s,a,r=!a.accelerator){r&&(a=this.X(s,a));const m=a.click;return a.click=(C,M,O)=>{this.ab(s),m?.(C,M,O)},a}Z(s,a){this.w.openExternal(void 0,s),this.ab(a)}ab(s){this.r.publicLog2("workbenchActionExecuted",{id:s,from:i})}bb(s){return(0,D.mnemonicMenuLabel)(s,!this.B)}};l.a="lastKnownMenubarData",l=pe([ee(0,g.IUpdateService),ee(1,h.IConfigurationService),ee(2,S.IWindowsMainService),ee(3,y.IEnvironmentMainService),ee(4,u.ITelemetryService),ee(5,L.IWorkspacesHistoryMainService),ee(6,c.IStateMainService),ee(7,p.ILifecycleMainService),ee(8,b.ILogService),ee(9,w.INativeHostMainService),ee(10,v.IProductService)],l),e.Menubar=l;function n(){return new E.MenuItem({type:"separator"})}}),define(te[279],ie([0,1,6,21,5,278]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let R=class{constructor(d,h,y){this.b=d,this.c=h,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(D.Menubar)}async updateMenubar(d,h){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(h,d)}};R=pe([ee(0,E.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,P.ILogService)],R),e.MenubarMainService=R}),define(te[280],ie([0,1,14,23,26,25,22,3,32,50,36,2,15,9,63,4,35,20,11,7,175,62,18,57,28,16,6,21,5,65,19,66,55,34,76,277,120,272,29,97,78,53,68,39,52,64]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O,B,J,G,X,re,se,ae,fe,ge,H,F,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Q($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function ne($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let _=class ft extends p.Disposable{constructor(A,T,W,j,K,N,q,Z,oe,le,be,Ce,Oe,Le,we,ve,Ee,Ie,x){super(),this.k=A,this.l=T,this.m=W,this.n=j,this.r=K,this.s=N,this.t=q,this.u=Z,this.v=oe,this.w=le,this.z=be,this.C=Ce,this.D=Oe,this.F=Le,this.G=we,this.H=ve,this.I=Ee,this.J=Ie,this.L=x,this.b=this.B(new I.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new I.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new I.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new I.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new re.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(A=>this.c.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const T=new p.DisposableStore;if(T.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>T.dispose())),A.config.extensionDevelopmentPath)for(const W of A.config.extensionDevelopmentPath)T.add(this.J.addValidFileRoot(W));A.config.extensionTestsPath&&T.add(this.J.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,T){const W=this.t.args,j=T?.remoteAuthority||void 0,K=!0,N=T?.forceReuseWindow,q=!N;return this.open({...A,cli:W,forceEmpty:K,forceNewWindow:q,forceReuseWindow:N,remoteAuthority:j})}openExistingWindow(A,T){A.focus(),this.N(T,[A])}async open(A){this.m.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const T=[],W=[],j=[],K=[],N=[];let q,Z=0;const oe=await this.U(A);this.m.trace("windowsManager#open pathsToOpen",oe);for(const Le of oe)ne(Le)?A.addMode?T.push(Le):W.push(Le):Q(Le)?j.push(Le):Le.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Le.remoteAuthority}),q.filesToOpenOrCreate.push(Le)):Le.backupPath?N.push({backupFolder:(0,f.basename)(Le.backupPath),remoteAuthority:Le.remoteAuthority}):Z++;A.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),A.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&A.waitMarkerFileURI&&(q.filesToWait={paths:(0,D.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(K.push(...this.D.getUntitledWorkspaces()),j.push(...K),N.push(...this.w.getEmptyWindowBackups())):N.length=0;const{windows:le,filesOpenedInWindow:be}=await this.O(A,j,W,N,Z,q,T);if(this.m.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${W.length}, emptyToRestore: ${N.length}, emptyToOpen: ${Z})`),le.length>1)if(be)be.focus();else{const Le=this.j.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let we=!0,ve=!0;if(Le){const Ee=le.filter(Ie=>this.j.state.lastActiveWindow&&Ie.backupPath===this.j.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),we=!1,ve=!1)}if(we)for(let Ee=le.length-1;Ee>=0;Ee--){const Ie=le[Ee];if(!(Ie.openedWorkspace&&K.some(x=>Ie.openedWorkspace&&x.workspace.id===Ie.openedWorkspace.id)||Ie.backupPath&&N.some(x=>Ie.backupPath&&x.backupFolder===(0,f.basename)(Ie.backupPath)))){Ie.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const Ce=q&&q.filesToDiff.length>0,Oe=q&&q.filesToMerge.length>0;if(!le.some(Le=>Le.isExtensionDevelopmentHost)&&!Ce&&!Oe&&!A.noRecentEntry){const Le=[];for(const we of oe)Q(we)&&!we.transient?Le.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):ne(we)?Le.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&Le.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.C.addRecentlyOpened(Le)}return this.N(A,le),le}N(A,T){const W=A.waitMarkerFileURI;A.context===0&&W&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async O(A,T,W,j,K,N,q){const Z=[];let oe;function le(Ee,Ie){Z.push(Ee),Ie&&(oe=Ee,N=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:Ce}=this.gb(A);if(!A.initialStartup&&q.length>0){const Ee=q[0].remoteAuthority,Ie=this.lb(Ee);Ie&&le(this.Q(Ie,q.map(x=>x.workspace.uri)))}const Oe=W.length+T.length+j.length;if(N&&Oe===0){const Ee=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],Ie=this.getWindows().filter(de=>N&&(0,u.isEqualAuthority)(de.remoteAuthority,N.remoteAuthority));let x;Ee?.fileUri&&!Ce&&((A.context===4||A.context===0||A.context===1)&&(x=await(0,X.findWindowOnFile)(Ie,Ee.fileUri,async de=>de.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(de.configPath):void 0)),x||(x=this.mb(Ie))),x?(0,se.isWorkspaceIdentifier)(x.openedWorkspace)?T.push({workspace:x.openedWorkspace,remoteAuthority:x.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(x.openedWorkspace)?W.push({workspace:x.openedWorkspace,remoteAuthority:x.remoteAuthority}):le(this.P(A,x,N),!0):le(await this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Le=(0,D.distinct)(T,Ee=>Ee.workspace.id);if(Le.length>0){const Ee=(0,D.coalesce)(Le.map(Ie=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ie.workspace.configPath)));if(Ee.length>0){const Ie=Ee[0],x=(0,u.isEqualAuthority)(N?.remoteAuthority,Ie.remoteAuthority)?N:void 0;le(this.P(A,Ie,x),!!x),be=!0}for(const Ie of Le){if(Ee.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Ie.workspace.id))continue;const x=Ie.remoteAuthority,de=(0,u.isEqualAuthority)(N?.remoteAuthority,x)?N:void 0;le(await this.S(A,Ie,be,de),!!de),be=!0}}const we=(0,D.distinct)(W,Ee=>u.extUriBiasedIgnorePathCase.getComparisonKey(Ee.workspace.uri));if(we.length>0){const Ee=(0,D.coalesce)(we.map(Ie=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ie.workspace.uri)));if(Ee.length>0){const Ie=Ee[0],x=(0,u.isEqualAuthority)(N?.remoteAuthority,Ie.remoteAuthority)?N:void 0;le(this.P(A,Ie,x),!!x),be=!0}for(const Ie of we){if(Ee.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Ie.workspace.uri)))continue;const x=Ie.remoteAuthority,de=(0,u.isEqualAuthority)(N?.remoteAuthority,x)?N:void 0;le(await this.S(A,Ie,be,de),!!de),be=!0}}const ve=(0,D.distinct)(j,Ee=>Ee.backupFolder);if(ve.length>0)for(const Ee of ve){const Ie=Ee.remoteAuthority,x=(0,u.isEqualAuthority)(N?.remoteAuthority,Ie)?N:void 0;le(await this.R(A,!0,Ie,x,Ee),!!x),be=!0}if(Z.length===0||N){N&&!K&&K++;const Ee=N?N.remoteAuthority:A.remoteAuthority;for(let Ie=0;Ie<K;Ie++)le(await this.R(A,be,Ee,N),!!N),be=!0}return{windows:(0,D.distinct)(Z),filesOpenedInWindow:oe}}P(A,T,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),T.focus();const j={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",R.CancellationToken.None,j),T}Q(A,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),A.focus();const W={foldersToAdd:T};return A.sendWhenReady("vscode:addFolders",R.CancellationToken.None,W),A}R(A,T,W,j,K){this.m.trace("windowsManager#doOpenEmpty",{restore:!!K,remoteAuthority:W,filesToOpen:j,forceNewWindow:T});let N;return!T&&typeof A.contextWindowId=="number"&&(N=this.getWindowById(A.contextWindowId)),this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W,forceNewWindow:T,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:j,windowToUse:N,emptyWindowBackupInfo:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}S(A,T,W,j,K){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:j}),!W&&!K&&typeof A.contextWindowId=="number"&&(K=this.getWindowById(A.contextWindowId)),this.hb({workspace:T.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:j,windowToUse:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async U(A){let T,W=!1,j=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(T=await this.W(A),W=!0):A.forceEmpty?T=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(T=await this.X(A.cli),T.length===0&&T.push(Object.create(null)),W=!0):(T=await this.Z(),T.length===0&&T.push(Object.create(null)),j=!0),!A.addMode&&W){const K=T.filter(N=>ne(N));if(K.length>1){const N=K[0].remoteAuthority;if(K.every(q=>(0,u.isEqualAuthority)(q.remoteAuthority,N))){const q=await this.D.createUntitledWorkspace(K.map(Z=>({uri:Z.workspace.uri})));T.push({workspace:q,remoteAuthority:N}),T=T.filter(Z=>!ne(Z))}}}if(A.initialStartup&&!j&&this.z.getValue("window")?.restoreWindows==="preserve"){const K=await this.Z();T.unshift(...K.filter(N=>Q(N)||ne(N)||N.backupPath))}return T}async W(A){const T={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},W=await Promise.all((0,D.coalesce)(A.urisToOpen||[]).map(async j=>{const K=await this.bb(j,T);if(K)return K.label=j.label,K;const N=this.db(j),q={title:this.I.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,S.localize)(0,null))],defaultId:0,message:N.scheme===b.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:N.scheme===b.Schemas.file?(0,S.localize)(3,null,(0,y.getPathLabel)(N,{os:v.OS,tildify:this.t})):(0,S.localize)(4,null,N.toString(!0)),noLink:!0};this.G.showMessageBox(q,(0,g.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,D.coalesce)(W)}async X(A){const T=[],W={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},j=A["folder-uri"];if(j){const q=await Promise.all(j.map(Z=>{const oe=this.Y(Z);if(!!oe)return this.bb({folderUri:oe},W)}));T.push(...(0,D.coalesce)(q))}const K=A["file-uri"];if(K){const q=await Promise.all(K.map(Z=>{const oe=this.Y(Z);if(!!oe)return this.bb((0,se.hasWorkspaceFileExtension)(Z)?{workspaceUri:oe}:{fileUri:oe},W)}));T.push(...(0,D.coalesce)(q))}const N=await Promise.all(A._.map(q=>W.remoteAuthority?this.fb(q,W):this.eb(q,W)));return T.push(...(0,D.coalesce)(N)),T}Y(A){try{const T=k.URI.parse(A);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${A}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${A}, ${T.message}`)}}async Z(){const A=this.ab();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];A!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const W=await Promise.all(T.map(async j=>{if(j.workspace){const K=await this.bb({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(K))return K}else if(j.folderUri){const K=await this.bb({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(ne(K))return K}else if(A!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,D.coalesce)(W)}}}ab(){let A;return this.v.wasRestarted?A="all":(A=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async bb(A,T=Object.create(null)){const W=this.db(A);return W.scheme===b.Schemas.file?((0,J.isFileToOpen)(A)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.eb(W.fsPath,T)):this.cb(A,T)}cb(A,T){let W=this.db(A);const j=(0,O.getRemoteAuthority)(W)||T.remoteAuthority;if(W=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(W)),(0,J.isFileToOpen)(A)){if(T.gotoLineMode){const{path:K,line:N,column:q}=(0,d.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:K}),options:{selection:N?{startLineNumber:N,startColumn:q||1}:void 0},remoteAuthority:j}}return{fileUri:W,remoteAuthority:j}}else if((0,J.isWorkspaceToOpen)(A))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:j};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:j}}db(A){return(0,J.isWorkspaceToOpen)(A)?A.workspaceUri:(0,J.isFolderToOpen)(A)?A.folderUri:A.fileUri}async eb(A,T){let W,j;T.gotoLineMode&&({path:A,line:W,column:j}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,f.normalize)(A),(0,c.cwd)());try{const K=await t.Promises.stat(A);if(K.isFile()){if(!T.forceOpenWorkspaceAsFile){const N=await this.D.resolveLocalWorkspace(k.URI.file(A));if(N)return N.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:o.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:k.URI.file(A),type:o.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:j||1}:void 0}}}else{if(K.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(k.URI.file(A),K),type:o.FileType.Directory,exists:!0};if(!v.isWindows&&A==="/dev/null")return{fileUri:k.URI.file(A),type:o.FileType.File,exists:!0}}}catch{const N=k.URI.file(A);if(this.C.removeRecentlyOpened([N]),T.ignoreFileNotFound)return{fileUri:N,type:o.FileType.File,exists:!1}}}fb(A,T){const W=A.charCodeAt(0),j=T.remoteAuthority;let K,N;T.gotoLineMode&&({path:A,line:K,column:N}=(0,d.parseLineAndColumnAware)(A)),W!==47&&((0,d.isWindowsDriveLetter)(W)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const q=k.URI.from({scheme:b.Schemas.vscodeRemote,authority:j,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return T.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:K?{startLineNumber:K,startColumn:N||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(q),remoteAuthority:j};if(T.gotoLineMode||f.posix.basename(A).indexOf(".")!==-1)return{fileUri:q,options:{selection:K?{startLineNumber:K,startColumn:N||1}:void 0},remoteAuthority:j}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:j}}gb(A){const T=this.z.getValue("window"),W=T?.openFoldersInNewWindow||"default",j=T?.openFilesInNewWindow||"off";let K=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(W==="on"||W==="off")&&(K=W==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(v.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(N=j==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(A,T){const W=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(W)return this.v.reload(W,T.cli),W.focus(),[W];let j=T.cli["folder-uri"]||[],K=T.cli["file-uri"]||[],N=T.cli._;if(!N.length&&!j.length&&!K.length&&!T.cli.extensionTestsPath){const oe=this.j.state.lastPluginDevelopmentHostWindow,le=oe?.workspace??oe?.folderUri;le&&(k.URI.isUri(le)?le.scheme===b.Schemas.file?N=[le.fsPath]:j=[le.toString()]:le.configPath.scheme===b.Schemas.file?N=[(0,u.originalFSPath)(le.configPath)]:K=[le.configPath.toString()])}let q=T.remoteAuthority;for(const oe of A)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=k.URI.parse(oe),be=(0,O.getRemoteAuthority)(le);be&&(q?(0,u.isEqualAuthority)(be,q)||this.m.error("more than one extension development path authority"):q=be)}N=N.filter(oe=>{const le=k.URI.file(oe);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),q)}),j=j.filter(oe=>{const le=this.Y(oe);return le&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),q):!1}),K=K.filter(oe=>{const le=this.Y(oe);return le&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),q):!1}),T.cli._=N,T.cli["folder-uri"]=j,T.cli["file-uri"]=K;const Z={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!N.length&&!j.length&&!K.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:q,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(Z)}async hb(A){const T=this.z.getValue("window");let W;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(W=A.windowToUse||this.getLastActiveWindow(),W&&W.focus());const j={...this.t.args,...A.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,f.join)(this.t.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:this.u.defaultProfile},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.l,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),loggers:this.n.getLoggerResources(),logsPath:this.t.logsPath,product:m.default,isInitialStartup:A.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,P.release)(),hostname:(0,P.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(W){const K=W.config;!j.extensionDevelopmentPath&&K?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=K.extensionDevelopmentPath,j.extensionDevelopmentKind=K.extensionDevelopmentKind,j["enable-proposed-api"]=K["enable-proposed-api"],j.verbose=K.verbose,j["inspect-extensions"]=K["inspect-extensions"],j["inspect-brk-extensions"]=K["inspect-brk-extensions"],j.debugId=K.debugId,j.extensionEnvironment=K.extensionEnvironment,j["extensions-dir"]=K["extensions-dir"],j["disable-extensions"]=K["disable-extensions"]),j.loggers=K?.loggers??j.loggers}else{const K=this.j.getNewWindowState(j);(0,w.mark)("code/willCreateCodeWindow");const N=W=this.F.createInstance(G.CodeWindow,{state:K,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(N),ft.a.push(N),this.b.fire(N),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,h.once)(N.onDidSignalReady)(()=>this.c.fire(N)),(0,h.once)(N.onDidClose)(()=>this.kb(N)),(0,h.once)(N.onDidDestroy)(()=>this.f.fire(N)),N.onDidTriggerSystemContextMenu(({x:Z,y:oe})=>this.h.fire({window:N,x:Z,y:oe}));const q=(0,g.assertIsDefined)(N.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.v.reload(N)),this.v.registerWindow(N)}return j.windowId=W.id,W.isReady?this.v.unload(W,4).then(async K=>{K||await this.ib(W,j,A)}):await this.ib(W,j,A),W}async ib(A,T,W){if(T.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const j=T.workspace??(0,se.toWorkspaceIdentifier)(T.backupPath,!1),K=this.jb(W,j),N=K instanceof Promise?await K:K;T.profiles.profile=N,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(j,N)}A.load(T)}jb(A,T){return A.forceProfile?this.u.profiles.find(W=>W.name===A.forceProfile)??this.u.createNamedProfile(A.forceProfile):A.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??this.u.defaultProfile}kb(A){const T=ft.a.indexOf(A);ft.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=E.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(A){return this.mb(this.getWindows().filter(T=>(0,u.isEqualAuthority)(T.remoteAuthority,A)))}mb(A){const T=Math.max.apply(Math,A.map(W=>W.lastFocusTime));return A.find(W=>W.lastFocusTime===T)}sendToFocused(A,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,R.CancellationToken.None,...T)}sendToAll(A,T,W){for(const j of this.getWindows())W&&W.indexOf(j.id)>=0||j.sendWhenReady(A,R.CancellationToken.None,T)}getWindows(){return ft.a}getWindowCount(){return ft.a.length}getWindowById(A){const T=this.getWindows().filter(W=>W.id===A);return(0,D.firstOrDefault)(T)}getWindowByWebContents(A){const T=E.BrowserWindow.fromWebContents(A);if(!!T)return this.getWindowById(T.id)}};_.a=[],_=pe([ee(2,r.ILogService),ee(3,z.ILoggerMainService),ee(4,B.IStateMainService),ee(5,F.IPolicyService),ee(6,n.IEnvironmentMainService),ee(7,U.IUserDataProfilesMainService),ee(8,a.ILifecycleMainService),ee(9,L.IBackupMainService),ee(10,i.IConfigurationService),ee(11,fe.IWorkspacesHistoryMainService),ee(12,ge.IWorkspacesManagementMainService),ee(13,s.IInstantiationService),ee(14,l.IDialogMainService),ee(15,o.IFileService),ee(16,C.IProductService),ee(17,M.IProtocolMainService),ee(18,H.IThemeMainService)],_),e.WindowsMainService=_}),define(te[281],ie([0,1,62,30,78,53]),function(V,e,E,t,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=class{constructor(d,h,y,p){this.a=d,this.b=h,this.c=y,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,h){const y=this.b.getWindowById(d);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),h)}createUntitledWorkspace(d,h,y){return this.a.createUntitledWorkspace(h,y)}deleteUntitledWorkspace(d,h){return this.a.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(d,h){return this.a.getWorkspaceIdentifier(h)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,h){return this.c.addRecentlyOpened(h)}removeRecentlyOpened(d,h){return this.c.removeRecentlyOpened(h)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};R=pe([ee(0,D.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,P.IWorkspacesHistoryMainService),ee(3,E.IBackupMainService)],R),e.WorkspacesMainService=R}),define(te[282],ie([0,1,14,42,26,17,45,13,32,50,43,36,2,15,9,4,11,7,31,134,47,148,105,255,151,62,273,18,74,183,87,121,57,108,206,28,61,112,196,219,197,260,109,198,199,16,210,89,73,6,88,274,232,257,21,5,212,279,58,19,55,267,91,34,263,95,92,24,237,114,51,49,246,247,275,248,276,117,250,251,252,253,261,30,280,262,29,96,78,281,53,256,39,218,52,228,56,77,119,265,271,269,8,115,264,213,64]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O,B,J,G,X,re,se,ae,fe,ge,H,F,U,z,Q,ne,_,$,A,T,W,j,K,N,q,Z,oe,le,be,Ce,Oe,Le,we,ve,Ee,Ie,x,de,ue,ye,De,Ue,Te,He,We,qe,Xe,Ne,Ge,Y,ce,he,me,Se,Ae,ze,it,_e,Ve,tt,nt,ct,ot,zt,qt,Ht,Vt,Gt,Kt,Jt,Ct,Xt,Yt,Qt,Zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Dt=class extends b.Disposable{constructor(Pe,Re,Me,ke,Fe,Be,xe,et,je,Ke,Je){super(),this.c=Pe,this.f=Re,this.g=Me,this.h=ke,this.i=Fe,this.j=Be,this.k=xe,this.l=et,this.m=je,this.n=Ke,this.p=Je,this.r(),this.s()}r(){const Pe=je=>je?.startsWith(`${f.Schemas.vscodeWebview}://`),Re=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((je,Ke,Je,Ze)=>Pe(Ze.requestingUrl)?Je(Re.has(Ke)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((je,Ke,Je,Ze)=>Pe(Ze.requestingUrl)?Re.has(Ke):!1);const Me=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ke=je=>{for(let Ke=je;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Fe=je=>je.resourceType==="xhr"||ke(je.frame),Be=je=>{const Ke=je.frame;if(!Ke||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ke.processId===Ze.webContents.mainFrame.processId)return!0;return!1},xe=(je,Ke)=>{if(je.path!=="/index.html")return!0;const Je=Ke.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((je,Ke)=>{const Je=u.URI.parse(je.url);return Je.scheme===f.Schemas.vscodeWebview&&!xe(Je,je)?(this.h.error("Blocked vscode-webview request",je.url),Ke({cancel:!0})):Je.scheme===f.Schemas.vscodeFileResource&&!Be(je)?(this.h.error("Blocked vscode-file request",je.url),Ke({cancel:!0})):Je.path.endsWith(".svg")&&!Me.has(Je.scheme)?Ke({cancel:!Fe(je)}):Ke({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((je,Ke)=>{const Je=je.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(je.url);if(st.path.endsWith(".svg")&&Me.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ze.some(at=>at.toLowerCase().includes("image/svg")))return Ke({cancel:!Fe(je)})}return Ke({cancel:!1})});const et=E.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome"))}s(){(0,I.setUnexpectedErrorHandler)(Me=>this.u(Me)),process.on("uncaughtException",Me=>(0,I.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,I.onUnexpectedError)(Me)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Me,ke)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",ke)}),E.app.on("activate",async(Me,ke)=>{this.h.trace("app#activate"),ke||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Me,ke)=>{ke.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),ke.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Pe=[],Re;E.app.on("open-file",(Me,ke)=>{this.h.trace("app#open-file: ",ke),Me.preventDefault(),Pe.push((0,Ae.hasWorkspaceFileExtension)(ke)?{workspaceUri:u.URI.file(ke)}:{fileUri:u.URI.file(ke)}),Re!==void 0&&(clearTimeout(Re),Re=void 0),Re=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Re=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const ke=this.a?.getWindowByWebContents(Me.sender);let Fe,Be;return ke?.config?(Fe=ke.config,Be={...process.env,...ke.config.userEnv}):(Fe=this.i.args,Be=process.env),this.J(Fe,Be,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,ke,Fe)=>{const Be=this.t([ke]);if(!Be||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,D.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...ke)=>{const Fe=this.t(ke);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}t(Pe){let Re;for(const Me of Pe)typeof Me=="string"&&(typeof Re!="string"?Re=Me:Re=(0,w.join)(Re,Me));if(!(typeof Re!="string"||!(0,w.isAbsolute)(Re)||!(0,d.isEqualOrParent)(Re,this.i.cachedLanguagesPath,!v.isLinux)))return u.URI.file(Re)}u(Pe){if(Pe){const Re={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Re))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;v.isWindows&&Pe&&E.app.setAppUserModelId(Pe);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(je){this.h.error(je)}const Re=new L.Server;this.j.onWillShutdown(je=>{je.reason===2&&Re.dispose()}),this.h.trace("Resolving machine identifier...");const Me=await(0,Xt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:ke,sharedProcessReady:Fe,sharedProcessClient:Be}=this.w(Me),xe=await this.y(Me,ke,Fe);this.v(xe),xe.invokeFunction(je=>this.z(je,Re,Be)),await xe.invokeFunction(je=>this.C(je,Re)),xe.invokeFunction(je=>this.G(je,ke)),this.B(new Ct.RunOnceScheduler(()=>{this.B((0,Ct.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe){this.B(Pe.createInstance(l.ProxyAuthHandler)),this.B(Pe.createInstance(Kt.UserDataProfilesHandler))}w(Pe){const Re=this.B(this.g.createInstance(Ce.SharedProcess,Pe,this.f)),Me=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Re.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),ke=(async()=>(await Re.whenReady(),Me))();return{sharedProcess:Re,sharedProcessReady:ke,sharedProcessClient:Me}}async y(Pe,Re,Me){const ke=new A.ServiceCollection;switch(process.platform){case"win32":ke.set(ye.IUpdateService,new _.SyncDescriptor(We.Win32UpdateService));break;case"linux":v.isLinuxSnap?ke.set(ye.IUpdateService,new _.SyncDescriptor(He.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(ye.IUpdateService,new _.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":ke.set(ye.IUpdateService,new _.SyncDescriptor(Ue.DarwinUpdateService));break}ke.set(he.IWindowsMainService,new _.SyncDescriptor(me.WindowsMainService,[Pe,this.f],!1));const Fe=new O.DialogMainService(this.h);ke.set(O.IDialogMainService,Fe),ke.set(j.ILaunchMainService,new _.SyncDescriptor(j.LaunchMainService,void 0,!1)),ke.set(M.IDiagnosticsMainService,new _.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),ke.set(C.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(Me.then(et=>et.getChannel("diagnostics"))))),ke.set(T.IIssueMainService,new _.SyncDescriptor(T.IssueMainService,[this.f])),ke.set(B.IEncryptionMainService,new _.SyncDescriptor(J.EncryptionMainService,[Pe])),ke.set(W.IKeyboardLayoutMainService,new _.SyncDescriptor(W.KeyboardLayoutMainService)),ke.set(oe.INativeHostMainService,new _.SyncDescriptor(oe.NativeHostMainService,[Re],!1)),ke.set(r.ICredentialsMainService,new _.SyncDescriptor(tt.CredentialsNativeMainService)),ke.set(Y.IWebviewManagerService,new _.SyncDescriptor(ce.WebviewMainService)),ke.set(Z.IMenubarMainService,new _.SyncDescriptor(Z.MenubarMainService)),ke.set(se.IExtensionUrlTrustService,new _.SyncDescriptor(ae.ExtensionUrlTrustService)),ke.set(fe.IExtensionHostStarter,new _.SyncDescriptor(ge.ExtensionHostStarter)),ke.set(ve.IStorageMainService,new _.SyncDescriptor(ve.StorageMainService)),ke.set(ve.IApplicationStorageMainService,new _.SyncDescriptor(ve.ApplicationStorageMainService)),v.isWindows?ke.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):v.isMacintosh?ke.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):v.isLinux&&ke.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const Be=new s.BackupMainService(this.i,this.k,this.h,this.l);ke.set(o.IBackupMainService,Be);const xe=new Ve.WorkspacesManagementMainService(this.i,this.h,this.p,Be,Fe,this.n);if(ke.set(Ve.IWorkspacesManagementMainService,xe),ke.set(ze.IWorkspacesService,new _.SyncDescriptor(_e.WorkspacesMainService,void 0,!1)),ke.set(it.IWorkspacesHistoryMainService,new _.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),ke.set(qe.IURLService,new _.SyncDescriptor(Ne.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.n,this.i)){const et=(0,ue.isInternalTelemetry)(this.n,this.k),je=(0,S.getDelayedChannel)(Me.then(at=>at.getChannel("telemetryAppender"))),Ke=new x.TelemetryAppenderClient(je),Je=(0,Ee.resolveCommonProperties)(this.m,(0,P.release)(),(0,P.hostname)(),process.arch,this.n.commit,this.n.version,Pe,et,this.i.installSourcePath),Ze=(0,ue.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ke],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};ke.set(Ie.ITelemetryService,new _.SyncDescriptor(de.TelemetryService,[st],!1))}else ke.set(Ie.ITelemetryService,ue.NullTelemetryService);return ke.set(Ht.IExtensionsProfileScannerService,new _.SyncDescriptor(Yt.ExtensionsProfileScannerService,void 0,!0)),ke.set(Vt.IExtensionsScannerService,new _.SyncDescriptor(Gt.ExtensionsScannerService,void 0,!0)),await Ct.Promises.settled([Be.initialize(),xe.initialize()]),this.g.createChild(ke)}z(Pe,Re,Me){const ke=S.ProxyChannel.fromService(Pe.get(j.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",ke);const Fe=S.ProxyChannel.fromService(Pe.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const Be=new ct.PolicyChannel(Pe.get(nt.IPolicyService));Re.registerChannel("policy",Be),Me.then(Ye=>Ye.registerChannel("policy",Be));const xe=this.m.getProvider(f.Schemas.file);(0,c.assertType)(xe instanceof ne.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(xe,this.h,this.i);Re.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Me.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const je=S.ProxyChannel.fromService(Pe.get(ot.IUserDataProfilesMainService));Re.registerChannel("userDataProfiles",je),Me.then(Ye=>Ye.registerChannel("userDataProfiles",je));const Ke=new zt.RequestChannel(Pe.get(qt.IRequestService));Me.then(Ye=>Ye.registerChannel("request",Ke));const Je=new De.UpdateChannel(Pe.get(ye.IUpdateService));Re.registerChannel("update",Je);const Ze=S.ProxyChannel.fromService(Pe.get(T.IIssueMainService));Re.registerChannel("issue",Ze);const st=S.ProxyChannel.fromService(Pe.get(B.IEncryptionMainService));Re.registerChannel("encryption",st);const at=S.ProxyChannel.fromService(Pe.get(r.ICredentialsMainService));Re.registerChannel("credentials",at);const Rt=S.ProxyChannel.fromService(Pe.get(Oe.ISignService));Re.registerChannel("sign",Rt);const Lt=S.ProxyChannel.fromService(Pe.get(W.IKeyboardLayoutMainService));Re.registerChannel("keyboardLayout",Lt),this.b=Pe.get(oe.INativeHostMainService);const bt=S.ProxyChannel.fromService(this.b);Re.registerChannel("nativeHost",bt),Me.then(Ye=>Ye.registerChannel("nativeHost",bt));const Qe=S.ProxyChannel.fromService(Pe.get(ze.IWorkspacesService));Re.registerChannel("workspaces",Qe);const yt=S.ProxyChannel.fromService(Pe.get(Z.IMenubarMainService));Re.registerChannel("menubar",yt);const gt=S.ProxyChannel.fromService(Pe.get(qe.IURLService));Re.registerChannel("url",gt);const St=S.ProxyChannel.fromService(Pe.get(se.IExtensionUrlTrustService));Re.registerChannel("extensionUrlTrust",St);const Mt=S.ProxyChannel.fromService(Pe.get(Y.IWebviewManagerService));Re.registerChannel("webview",Mt);const Et=this.B(new we.StorageDatabaseChannel(this.h,Pe.get(ve.IStorageMainService)));Re.registerChannel("storage",Et),Me.then(Ye=>Ye.registerChannel("storage",Et));const mt=this.B(new Jt.ProfileStorageChangesListenerChannel(Pe.get(ve.IStorageMainService),Pe.get(ot.IUserDataProfilesMainService),this.h));Me.then(Ye=>Ye.registerChannel("profileStorageListener",mt));const wt=S.ProxyChannel.fromService(Pe.get(H.IExternalTerminalMainService));Re.registerChannel("externalTerminal",wt);const pt=new q.LogLevelChannel(Pe.get(N.ILogService),Pe.get(N.ILoggerService));Re.registerChannel("logLevel",pt),Me.then(Ye=>Ye.registerChannel("logLevel",pt));const lt=new Qt.LoggerChannel(Pe.get(Zt.ILoggerMainService));Re.registerChannel("logger",lt),Me.then(Ye=>Ye.registerChannel("logger",lt));const vt=new m.ElectronExtensionHostDebugBroadcastChannel(Pe.get(he.IWindowsMainService));Re.registerChannel("extensionhostdebugservice",vt);const $e=S.ProxyChannel.fromService(Pe.get(fe.IExtensionHostStarter));Re.registerChannel(fe.ipcExtensionHostStarterChannelName,$e)}async C(Pe,Re){const Me=this.a=Pe.get(he.IWindowsMainService),ke=Pe.get(qe.IURLService),Fe=Pe.get(oe.INativeHostMainService),Be=this.h;this.j.phase=2;const xe=this.i.args["open-url"]?this.i.args._urls||[]:[];xe.length&&Be.trace("app#openFirstWindow() protocol links from command line:",xe);const et=global.getOpenUrls()||[];et.length&&Be.trace("app#openFirstWindow() protocol links from macOS 'open-url' event:",et);const je=[],Ke=[...xe,...et].map($e=>{try{return{uri:u.URI.parse($e),url:$e}}catch{Be.trace("app#openFirstWindow() protocol link failed to parse:",$e);return}}).filter($e=>{if(!$e)return!1;if(this.D($e.uri))return Be.trace("app#openFirstWindow() protocol link was blocked:",$e.uri.toString(!0)),!1;const Ye=this.F($e.uri);return Ye?(Be.trace("app#openFirstWindow() protocol link will be handled as window to open:",$e.uri.toString(!0),Ye),je.push(Ye),!1):(Be.trace("app#openFirstWindow() protocol link will be passed to active window for handling:",$e.uri.toString(!0)),!0)}),Je=this,Ze=this.i,st=this.n;ke.registerHandler({async handleURL($e,Ye){if(Be.trace("app#handleURL():",$e.toString(!0),Ye),$e.scheme===st.urlProtocol&&$e.path==="workspace"&&($e=$e.with({authority:"file",path:u.URI.parse($e.query).path,query:""})),Je.D($e))return Be.trace("app#handleURL() protocol link was blocked:",$e.toString(!0)),!0;let It=!1;const ut=new URLSearchParams($e.query);ut.get("windowId")==="_blank"?(Be.trace("app#handleURL() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",$e.toString(!0)),ut.delete("windowId"),$e=$e.with({query:ut.toString()}),It=!0):v.isMacintosh&&Me.getWindowCount()===0&&(Be.trace("app#handleURL() running on macOS with no window open, setting shouldOpenInNewWindow=true:",$e.toString(!0)),It=!0);const Nt=ut.get("continueOn");Nt!==null&&(Be.trace("app#handleURL() found 'continueOn' as parameter:",$e.toString(!0)),ut.delete("continueOn"),$e=$e.with({query:ut.toString()}),Ze.continueOn=Nt??void 0);const At=Je.F($e);if(At){Be.trace("app#handleURL() opening protocol link as window:",At,$e.toString(!0));const[Ot]=await Me.open({context:5,cli:{...Ze.args},urisToOpen:[At],forceNewWindow:It,gotoLineMode:!0});return Ot.focus(),!0}if(It){Be.trace("app#handleURL() opening empty window and passing in protocol link:",$e.toString(!0));const[Ot]=await Me.open({context:5,cli:{...Ze.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,be.getRemoteAuthority)($e)});return await Ot.ready(),ke.open($e,Ye)}return!1}});const at=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),Rt=new S.StaticRouter($e=>at.getActiveClientId().then(Ye=>$e===Ye)),Lt=new Xe.URLHandlerRouter(Rt),bt=Re.getChannel("urlHandler",Lt);ke.registerHandler(new Xe.URLHandlerChannelClient(bt)),this.B(new Ge.ElectronURLListener(Ke,ke,Me,this.i,this.n,this.h));const Qe=this.i.args,yt=global.macOpenFiles,gt=(0,X.isLaunchedFromCli)(process.env)?0:4,St=Qe._.length,Mt=!!Qe["folder-uri"],Et=!!Qe["file-uri"],mt=Qe["skip-add-to-recently-opened"]===!0,wt=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,pt=Qe.remote||void 0,lt=Qe.profile,vt=Qe["profile-temp"];if(je.length>0)return Me.open({context:gt,cli:Qe,urisToOpen:je,gotoLineMode:!0,initialStartup:!0});if(!St&&!Mt&&!Et){if(Qe["new-window"]||lt||vt)return Me.open({context:gt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:wt,initialStartup:!0,remoteAuthority:pt,forceProfile:lt,forceTempProfile:vt});if(yt.length)return Me.open({context:1,cli:Qe,urisToOpen:yt.map($e=>(0,Ae.hasWorkspaceFileExtension)($e)?{workspaceUri:u.URI.file($e)}:{fileUri:u.URI.file($e)}),noRecentEntry:mt,waitMarkerFileURI:wt,initialStartup:!0})}return Me.open({context:gt,cli:Qe,forceNewWindow:Qe["new-window"]||!St&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:mt,waitMarkerFileURI:wt,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:pt,forceProfile:lt,forceTempProfile:vt})}D(Pe){return!!(Pe.authority===f.Schemas.file&&v.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,p.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,p.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,p.getPathLabel)(Pe,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Pe){if(!!Pe.path){if(Pe.authority===f.Schemas.file){const Re=u.URI.file(Pe.fsPath);return(0,Ae.hasWorkspaceFileExtension)(Re)?{workspaceUri:Re}:{fileUri:Re}}else if(Pe.authority===f.Schemas.vscodeRemote){const Re=Pe.path.indexOf(w.posix.sep,1);if(Re!==-1){const Me=Pe.path.substring(1,Re),ke=Pe.path.substring(Re),Fe=u.URI.from({scheme:f.Schemas.vscodeRemote,authority:Me,path:ke,query:Pe.query,fragment:Pe.fragment});return(0,Ae.hasWorkspaceFileExtension)(ke)?{workspaceUri:Fe}:/:[\d]+$/.test(ke)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Pe,Re){const Me=Pe.get(Ie.ITelemetryService),ke=Pe.get(ye.IUpdateService);this.j.phase=3,this.I(Me,Re),this.H(),E.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Fe,Be)=>{Be({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(ke instanceof We.Win32UpdateService||ke instanceof Te.LinuxUpdateService||ke instanceof Ue.DarwinUpdateService)&&ke.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Pe=this.n.win32MutexName;if(v.isWindows&&Pe)try{const Re=await new Promise((ke,Fe)=>{V(["windows-mutex"],ke,Fe)}),Me=new Re.Mutex(Pe);(0,h.once)(this.j.onWillShutdown)(()=>Me.release())}catch(Re){this.h.error(Re)}}I(Pe,Re){let Me=!1;(0,h.once)(this.j.onWillShutdown)(()=>Me=!0),this.B(Re.onDidError(({type:ke,details:Fe})=>{let Be;switch(ke){case 1:Be="SharedProcess: detected unresponsive window";break;case 2:Be=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:Be=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Be)),Pe.publicLog2("sharedprocesserror",{type:ke,reason:Fe?.reason,code:Fe?.exitCode,visible:Re.isVisible(),shuttingdown:Me})}))}async J(Pe,Re,Me){try{return await(0,re.getResolvedShellEnv)(this.k,this.h,Pe,Re)}catch(ke){const Fe=(0,R.toErrorMessage)(ke);Me?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Re=(await this.m.readFile(this.i.argvResource)).value.toString(),Me=JSON.parse((0,y.stripComments)(Re)),Fe=(0,ue.getTelemetryLevel)(this.k)>=1;if(Me["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],xe=Re.substring(0,Re.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,D.VSBuffer.fromString(xe))}else{const Be=Re.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);Be!==Re&&await this.m.writeFile(this.i.argvResource,D.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};Dt=pe([ee(2,$.IInstantiationService),ee(3,N.ILogService),ee(4,G.IEnvironmentMainService),ee(5,K.ILifecycleMainService),ee(6,a.IConfigurationService),ee(7,Le.IStateMainService),ee(8,z.IFileService),ee(9,le.IProductService),ee(10,ot.IUserDataProfilesMainService)],Dt),e.CodeApplication=Dt}),define(te[283],ie([0,1,39,8,290,2,5]),function(V,e,E,t,P,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends E.AbstractPolicyService{constructor(h,y){super(),this.j=h,this.k=y,this.a=new t.Throttler,this.b=this.B(new D.MutableDisposable)}async i(h){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.a.queue(()=>new Promise((y,p)=>{try{this.b.value=(0,P.createWatcher)(this.k,h,b=>{this.m(b),y()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),p(b)}}))}m(h){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const y in h){const p=h[y];p===void 0?this.g.delete(y):this.g.set(y,p)}this.h.fire(Object.keys(h))}};I=pe([ee(0,R.ILogService)],I),e.NativePolicyService=I}),define(te[284],ie([0,1,230,8,17,13,2,11,18,33,112,5,229,291]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends R.Disposable{constructor(c,u,g){super(),this.h=c,this.i=u,this.j=g,this.k(),this.B(c.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const c=this.h.getValue("http");this.a=c?.proxy,this.b=!!c?.proxyStrictSSL,this.f=c?.proxyAuthorization}async request(c,u){this.j.trace("RequestService#request (node) - begin",c.url);const{a:g,b:k}=this;let S;try{S=await(0,y.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(l){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",l))}const L={...process.env,...S},i=c.agent?c.agent:await(0,b.getProxyAgent)(c.url||"",L,{proxyUrl:g,strictSSL:k});c.agent=i,c.strictSSL=k,this.f&&(c.headers={...c.headers||{},"Proxy-Authorization":this.f});try{const l=await this.m(c,u);return this.j.trace("RequestService#request (node) - success",c.url),l}catch(l){throw this.j.trace("RequestService#request (node) - error",c.url,l),l}}async l(c){return((0,E.parse)(c.url).protocol==="https:"?await new Promise((k,S)=>{V(["https"],k,S)}):await new Promise((k,S)=>{V(["http"],k,S)})).request}m(c,u){return t.Promises.withAsyncBody(async(g,k)=>{const S=(0,E.parse)(c.url),L=c.getRawRequest?c.getRawRequest(c):await this.l(c),i={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,I.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(i.auth=c.user+":"+c.password);const l=L(i,n=>{const o=(0,I.isNumber)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this.m({...c,url:n.headers.location,followRedirects:o-1},u).then(g,k);else{let s=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,f.createGunzip)())),g({res:n,stream:(0,P.streamToBufferReadableStream)(s)})}});l.on("error",k),c.timeout&&l.setTimeout(c.timeout),c.isChromiumNetwork&&l.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&l.write(c.data),l.end(),u.onCancellationRequested(()=>{l.abort(),k(new D.CancellationError)})})}async resolveProxy(c){}};w=pe([ee(0,d.IConfigurationService),ee(1,h.INativeEnvironmentService),ee(2,p.ILogService)],w),e.RequestService=w}),define(te[285],ie([0,1,14,284]),function(V,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function P(R){return E.net.request}class D extends t.RequestService{request(I,d){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},d)}}e.RequestMainService=D}),define(te[292],ie([0,1,14,41,7,25,8,45,13,32,50,36,15,9,63,4,35,27,23,47,86,282,10,18,223,236,28,61,187,16,208,89,73,204,88,21,211,5,65,19,66,266,116,244,56,285,91,231,34,235,51,68,52,39,283,217,2,40,249,37,64,245]),function(V,e,E,t,P,D,R,I,d,h,y,p,b,f,w,v,c,u,g,k,S,L,i,l,n,o,s,a,r,m,C,M,O,B,J,G,X,re,se,ae,fe,ge,H,F,U,z,Q,ne,_,$,A,T,W,j,K,N,q,Z,oe,le,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ce{main(){try{this.a()}catch(we){console.error(we.message),E.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(De=>console.error(De));const[we,ve,Ee,Ie,x,de,ue,ye]=this.b();try{try{await this.d(Ee,ye,Ie,x,ue)}catch(De){throw this.f(Ee,ue.nameLong,De),De}await we.invokeFunction(async De=>{const Ue=De.get(re.ILogService),Te=De.get(G.ILifecycleMainService),He=De.get(m.IFileService),We=De.get(re.ILoggerService),qe=await this.e(Ue,Ee,Te,we,ue,!0);return g.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Xe=>{Ue.warn(`Error writing main lockfile: ${Xe.stack}`)}),de.logger=We.createLogger(P.URI.file((0,f.join)(Ee.logsPath,"main.log")),{name:"main"}),(0,y.once)(Te.onWillShutdown)(Xe=>{He.dispose(),Ie.dispose(),Xe.join(g.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),we.createInstance(L.CodeApplication,qe,ve).startup()})}catch(De){we.invokeFunction(this.i,De)}}b(){const we=new J.ServiceCollection,ve=new q.DisposableStore;process.once("exit",()=>ve.dispose());const Ee={_serviceBrand:void 0,...se.default};we.set(ae.IProductService,Ee);const Ie=new s.EnvironmentMainService(this.j(),Ee),x=this.c(Ie);we.set(s.IEnvironmentMainService,Ie);const de=new X.BufferLogService,ue=ve.add(new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(Ie)),de]));we.set(re.ILogService,ue);const ye=new C.FileService(ue);we.set(m.IFileService,ye);const De=new M.DiskFileSystemProvider(ue);ye.registerProvider(b.Schemas.file,De);const Ue=new oe.UriIdentityService(ye);we.set(Z.IUriIdentityService,Ue),we.set(be.ILoggerMainService,new be.LoggerMainService(ue));const Te=new $.StateMainService(Ie,ue,ye);we.set(_.IStateMainService,Te);const He=new W.UserDataProfilesMainService(Te,Ue,Ie,ye,ue);we.set(W.IUserDataProfilesMainService,He);const We=v.isWindows&&Ee.win32RegValueName?ve.add(new K.NativePolicyService(ue,Ee.win32RegValueName)):Ie.policyFile?ve.add(new N.FilePolicyService(Ie.policyFile,ye,ue)):new j.NullPolicyService;we.set(j.IPolicyService,We);const qe=new n.ConfigurationService(He.defaultProfile.settingsResource,ye,We,ue);return we.set(l.IConfigurationService,qe),we.set(G.ILifecycleMainService,new O.SyncDescriptor(G.LifecycleMainService,void 0,!1)),we.set(U.IRequestService,new O.SyncDescriptor(z.RequestMainService,void 0,!0)),we.set(T.IThemeMainService,new O.SyncDescriptor(T.ThemeMainService)),we.set(Q.ISignService,new O.SyncDescriptor(ne.SignService,void 0,!1)),we.set(H.ITunnelService,new O.SyncDescriptor(F.TunnelService)),we.set(fe.IProtocolMainService,new ge.ProtocolMainService(Ie,He,ue)),[new B.InstantiationService(we,!0),x,Ie,qe,Te,de,Ee,He]}c(we){const ve={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const Ie=process.env[Ee];typeof Ie=="string"&&(ve[Ee]=Ie)}),Object.assign(process.env,ve),ve}async d(we,ve,Ee,Ie,x){await R.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsPath,ve.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(de=>de?g.Promises.mkdir(de,{recursive:!0}):void 0)),Ie.init(),Ee.initialize()]),ve.setEnablement(x.quality!=="stable"||Ee.getValue(le.PROFILES_ENABLEMENT_CONFIG))}async e(we,ve,Ee,Ie,x,de){let ue;try{(0,w.mark)("code/willStartMainServer"),ue=await(0,S.serve)(ve.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,y.once)(Ee.onWillShutdown)(()=>ue.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.f(ve,x.nameLong,ye),ye;let De;try{De=await(0,S.connect)(ve.mainIPCHandle,"main")}catch(We){if(!de||v.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.g((0,i.localize)(0,null,x.nameShort),(0,i.localize)(1,null),x.nameLong),We;try{(0,t.unlinkSync)(ve.mainIPCHandle)}catch(qe){throw we.warn("Could not delete obsolete instance handle",qe),qe}return this.e(we,ve,Ee,Ie,x,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const We=`Running extension tests from the command line is currently only supported if no other instance of ${x.nameShort} is running.`;throw we.error(We),De.dispose(),new Error(We)}let Ue;!ve.args.wait&&!ve.args.status&&(Ue=setTimeout(()=>{this.g((0,i.localize)(2,null,x.nameShort),(0,i.localize)(3,null),x.nameLong)},1e4));const Te=k.ProxyChannel.toService(De.getChannel("launch"),{disableMarshalling:!0}),He=k.ProxyChannel.toService(De.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return Ie.invokeFunction(async()=>{const We=new o.DiagnosticsService(A.NullTelemetryService,x),qe=await He.getMainDiagnostics(),Xe=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ne=await We.getDiagnostics(qe,Xe);throw console.log(Ne),new d.ExpectedError});throw v.isWindows&&await this.h(Te,we),we.trace("Sending env to running instance..."),await Te.start(ve.args,process.env),De.dispose(),Ue&&clearTimeout(Ue),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw we.warn(`Warning: The --status argument can only be used if ${x.nameShort} is already running. Please run it again after {0} has started.`),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ue}f(we,ve,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const Ie=(0,D.coalesce)([we.userDataPath,we.extensionsPath,S.XDG_RUNTIME_DIR]).map(x=>(0,p.getPathLabel)(P.URI.file(x),{os:v.OS,tildify:we}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,I.toErrorMessage)(Ee),Ie.join(`
`)),ve)}}g(we,ve,Ee){E.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,p.mnemonicButtonLabel)((0,i.localize)(6,null))],message:we,detail:ve,defaultId:0,noLink:!0})}async h(we,ve){if(v.isWindows){const Ee=await we.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((Ie,x)=>{V(["windows-foreground-love"],Ie,x)})).allowSetForegroundWindow(Ee)}catch(Ie){ve.error(Ie)}}}i(we,ve){const Ee=we.get(re.ILogService),Ie=we.get(G.ILifecycleMainService);let x=0;ve&&(ve.isExpected?ve.message&&Ee.trace(ve.message):(x=1,ve.stack?Ee.error(ve.stack):Ee.error(`Startup error: ${ve.toString()}`))),Ie.kill(x)}j(){const we=this.k((0,a.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const ve=(0,r.createWaitMarkerFileSync)(we.verbose);ve&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",ve),we.waitMarkerFilePath=ve)}return we}k(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const ve=this.l(we._,we.goto);we._=ve}return we}l(we,ve){const Ee=(0,c.cwd)(),Ie=we.map(ue=>{let ye=String(ue),De;ve&&(De=(0,h.parseLineAndColumnAware)(ye),ye=De.path),ye&&(ye=this.m(Ee,ye));const Ue=(0,h.sanitizeFilePath)(ye,Ee),Te=(0,f.basename)(Ue);return Te&&!(0,h.isValidBasename)(Te)?null:ve&&De?(De.path=Ue,this.n(De)):Ue}),x=v.isWindows||v.isMacintosh,de=(0,D.distinct)(Ie,ue=>ue&&x?ue.toLowerCase():ue||"");return(0,D.coalesce)(de)}m(we,ve){return v.isWindows&&(ve=(0,u.rtrim)(ve,'"')),ve=(0,u.trim)((0,u.trim)(ve," "),"	"),v.isWindows&&(ve=(0,f.resolve)(we,ve),ve=(0,u.rtrim)(ve,".")),ve}n(we){const ve=[we.path];return typeof we.line=="number"&&ve.push(String(we.line)),typeof we.column=="number"&&ve.push(String(we.column)),ve.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/243854703b7fa371abb752ec0df7817a615a308b/core/vs/code/electron-main/main.js.map
