/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],T=0,O=x.length;T<O;T++)e[T]=Z[x[T]];return e};define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(y,f,l)=>{let b=null,g=null;if(typeof l.value=="function"?(b="value",g=l.value):typeof l.get=="function"&&(b="get",g=l.get),!g)throw new Error("not supported");l[b]=N(g,f)}}function O(N,y,f){let l=null,b=null;if(typeof f.value=="function"?(l="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",b=f.get),!b)throw new Error("not supported");const g=`$memoize$${y}`;f[l]=function(...m){return this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,m)}),this[g]}}e.memoize=O;function R(N,y,f){return T((l,b)=>{const g=`$debounce$${b}`,m=`$debounce$result$${b}`;return function(...k){this[m]||(this[m]=f?f():void 0),clearTimeout(this[g]),y&&(this[m]=y(this[m],...k),k=[this[m]]),this[g]=setTimeout(()=>{l.apply(this,k),this[m]=f?f():void 0},N)}})}e.debounce=R;function D(N,y,f){return T((l,b)=>{const g=`$throttle$timer$${b}`,m=`$throttle$result$${b}`,k=`$throttle$lastRun$${b}`,v=`$throttle$pending$${b}`;return function(...L){if(this[m]||(this[m]=f?f():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),y&&(this[m]=y(this[m],...L)),this[v])return;const h=this[k]+N;h<=Date.now()?(this[k]=Date.now(),l.apply(this,[this[m]]),this[m]=f?f():void 0):(this[v]=!0,this[g]=setTimeout(()=>{this[v]=!1,this[k]=Date.now(),l.apply(this,[this[m]]),this[m]=f?f():void 0},h-Date.now()))}})}e.throttle=D}),define(Z[70],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function R(f,l="Unreachable"){throw new Error(l)}e.assertNever=R;function D(f){if(!f)throw new T.BugIndicatingError("Assertion Failed")}e.assert=D;function N(f){if(!f()){debugger;f(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function y(f,l){let b=0;for(;b<f.length-1;){const g=f[b],m=f[b+1];if(!l(g,m))return!1;b++}return!0}e.checkAdjacentItems=y}),define(Z[50],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function N(t,a=!1){let i=0;const n=t.length;let r="",s=0,o=16,u=0;function S(ne){let ae=0,fe=0;for(;ae<ne;){const re=t.charCodeAt(i);if(re>=48&&re<=57)fe=fe*16+re-48;else if(re>=65&&re<=70)fe=fe*16+re-65+10;else if(re>=97&&re<=102)fe=fe*16+re-97+10;else break;i++,ae++}return ae<ne&&(fe=-1),fe}function M(ne){i=ne,r="",s=0,o=16,u=0}function U(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return u=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else u=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),u=2;break}const fe=t.charCodeAt(i);if(fe===34){ne+=t.substring(ae,i),i++;break}if(fe===92){if(ne+=t.substring(ae,i),i++,i>=n){u=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const me=S(4);me>=0?ne+=String.fromCharCode(me):u=4;break}default:u=5}ae=i;continue}if(fe>=0&&fe<=31)if(f(fe)){ne+=t.substring(ae,i),u=2;break}else u=6;i++}return ne}function X(){if(r="",u=0,s=i,i>=n)return s=n,o=17;let ne=t.charCodeAt(i);if(y(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(y(ne));return o=15}if(f(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(ne){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=Y(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!f(t.charCodeAt(i));)i++;return r=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let re=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,re=!0;break}i++}return re||(i++,u=1),r=t.substring(ae,i),o=13}return r+=String.fromCharCode(ne),i++,o=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!l(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),o=11;default:for(;i<n&&ee(ne);)i++,ne=t.charCodeAt(i);if(s!==i){switch(r=t.substring(s,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(ne),i++,o=16}}function ee(ne){if(y(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:M,getPosition:()=>i,scan:a?ie:X,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>u}}e.createScanner=N;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function g(t,a){const i=[],n=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(S,M,U,Y){s.value=S,s.offset=M,s.length=U,s.type=Y,s.colonOffset=void 0,r=s}try{w(t,{onObjectBegin:(S,M)=>{if(a<=S)throw n;r=void 0,o=a>S,i.push("")},onObjectProperty:(S,M,U)=>{if(a<M||(u(S,M,U,"property"),i[i.length-1]=S,a<=M+U))throw n},onObjectEnd:(S,M)=>{if(a<=S)throw n;r=void 0,i.pop()},onArrayBegin:(S,M)=>{if(a<=S)throw n;r=void 0,i.push(0)},onArrayEnd:(S,M)=>{if(a<=S)throw n;r=void 0,i.pop()},onLiteralValue:(S,M,U)=>{if(a<M||(u(S,M,U,E(S)),a<=M+U))throw n},onSeparator:(S,M,U)=>{if(a<=M)throw n;if(S===":"&&r&&r.type==="property")r.colonOffset=M,o=!1,r=void 0;else if(S===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:r,isAtPropertyKey:o,matches:S=>{let M=0;for(let U=0;M<S.length&&U<i.length;U++)if(S[M]===i[U]||S[M]==="*")M++;else if(S[M]!=="**")return!1;return M===S.length}}}e.getLocation=g;function m(t,a=[],i=D.DEFAULT){let n=null,r=[];const s=[];function o(S){Array.isArray(r)?r.push(S):n!==null&&(r[n]=S)}return w(t,{onObjectBegin:()=>{const S={};o(S),s.push(r),r=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const S=[];o(S),s.push(r),r=S,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:o,onError:(S,M,U)=>{a.push({error:S,offset:M,length:U})}},i),r[0]}e.parse=m;function k(t,a=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function s(S){return n.children.push(S),S}w(t,{onObjectBegin:S=>{n=s({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,M,U)=>{n=s({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:M,length:U,parent:n})},onObjectEnd:(S,M)=>{n.length=S+M-n.offset,n=n.parent,r(S+M)},onArrayBegin:(S,M)=>{n=s({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,M)=>{n.length=S+M-n.offset,n=n.parent,r(S+M)},onLiteralValue:(S,M,U)=>{s({type:E(S),offset:M,length:U,parent:n,value:S}),r(M+U)},onSeparator:(S,M,U)=>{n.type==="property"&&(S===":"?n.colonOffset=M:S===","&&r(M))},onError:(S,M,U)=>{a.push({error:S,offset:M,length:U})}},i);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=k;function v(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=v;function L(t){if(!t.parent||!t.parent.children)return[];const a=L(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=L;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=h(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function c(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=c;function p(t,a,i=!1){if(c(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const s=p(n[r],a,i);if(s)return s}return t}}e.findNodeAtOffset=p;function w(t,a,i=D.DEFAULT){const n=N(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(q){return q?K=>q(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(a.onObjectBegin),u=s(a.onObjectProperty),S=r(a.onObjectEnd),M=r(a.onArrayBegin),U=r(a.onArrayEnd),Y=s(a.onLiteralValue),X=s(a.onSeparator),ee=r(a.onComment),ie=s(a.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:ne||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:ne?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,K=[],I=[]){if(ie(q),K.length+I.length>0){let P=n.getToken();for(;P!==17;){if(K.indexOf(P)!==-1){fe();break}else if(I.indexOf(P)!==-1)break;P=fe()}}}function me(q){const K=n.getTokenValue();return q?Y(K):u(K),fe(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function j(){return n.getToken()!==10?(re(3,[],[2,5]),!1):(me(!1),n.getToken()===6?(X(":"),fe(),W()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function C(){o(),fe();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===2&&ae)break}else q&&re(6,[],[]);j()||re(4,[],[2,5]),q=!0}return S(),n.getToken()!==2?re(7,[2],[]):fe(),!0}function V(){M(),fe();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===4&&ae)break}else q&&re(6,[],[]);W()||re(4,[],[4,5]),q=!0}return U(),n.getToken()!==4?re(8,[4],[]):fe(),!0}function W(){switch(n.getToken()){case 3:return V();case 1:return C();case 10:return me(!0);default:return B()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(re(4,[],[]),!1):W()?(n.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=w;function d(t,a){const i=N(t),n=[];let r,s=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:s!==o&&n.push(t.substring(s,o)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),s=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=d;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(y,f,l){return Math.min(Math.max(y,f),l)}e.clamp=T;function O(y,f){return(f+y%f)%f}e.rot=O;class R{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=R;class D{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class N{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function x(R){const D=[];typeof R=="number"&&D.push("code/timeOrigin",R);function N(f){D.push(f,Date.now())}function y(){const f=[];for(let l=0;l<D.length;l+=2)f.push({name:D[l],startTime:D[l+1]});return f}return{mark:N,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))D.push({name:N.name,startTime:Math.round(R+N.startTime)});return D}};if(typeof process=="object"){const R=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:x)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function T(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return x[O].call(R.exports,R,R.exports,T),R.l=!0,R.exports}return T.m=x,T.c=e,T.d=function(O,R,D){T.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:D})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,R){if(1&R&&(O=T(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var N in O)T.d(D,N,function(y){return O[y]}.bind(null,N));return D},T.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(R,"a",R),R},T.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},T.p="",T(T.s=0)}([function(x,e,T){(function(O){var R;e=x.exports=I,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],f=e.src=[],l=0,b=l++;f[b]="0|[1-9]\\d*";var g=l++;f[g]="[0-9]+";var m=l++;f[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=l++;f[k]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var v=l++;f[v]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var L=l++;f[L]="(?:"+f[b]+"|"+f[m]+")";var h=l++;f[h]="(?:"+f[g]+"|"+f[m]+")";var c=l++;f[c]="(?:-("+f[L]+"(?:\\."+f[L]+")*))";var p=l++;f[p]="(?:-?("+f[h]+"(?:\\."+f[h]+")*))";var w=l++;f[w]="[0-9A-Za-z-]+";var d=l++;f[d]="(?:\\+("+f[w]+"(?:\\."+f[w]+")*))";var E=l++,t="v?"+f[k]+f[c]+"?"+f[d]+"?";f[E]="^"+t+"$";var a="[v=\\s]*"+f[v]+f[p]+"?"+f[d]+"?",i=l++;f[i]="^"+a+"$";var n=l++;f[n]="((?:<|>)?=?)";var r=l++;f[r]=f[g]+"|x|X|\\*";var s=l++;f[s]=f[b]+"|x|X|\\*";var o=l++;f[o]="[v=\\s]*("+f[s]+")(?:\\.("+f[s]+")(?:\\.("+f[s]+")(?:"+f[c]+")?"+f[d]+"?)?)?";var u=l++;f[u]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[p]+")?"+f[d]+"?)?)?";var S=l++;f[S]="^"+f[n]+"\\s*"+f[o]+"$";var M=l++;f[M]="^"+f[n]+"\\s*"+f[u]+"$";var U=l++;f[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=l++;f[Y]="(?:~>?)";var X=l++;f[X]="(\\s*)"+f[Y]+"\\s+",y[X]=new RegExp(f[X],"g");var ee=l++;f[ee]="^"+f[Y]+f[o]+"$";var ie=l++;f[ie]="^"+f[Y]+f[u]+"$";var ne=l++;f[ne]="(?:\\^)";var ae=l++;f[ae]="(\\s*)"+f[ne]+"\\s+",y[ae]=new RegExp(f[ae],"g");var fe=l++;f[fe]="^"+f[ne]+f[o]+"$";var re=l++;f[re]="^"+f[ne]+f[u]+"$";var me=l++;f[me]="^"+f[n]+"\\s*("+a+")$|^$";var B=l++;f[B]="^"+f[n]+"\\s*("+t+")$|^$";var j=l++;f[j]="(\\s*)"+f[n]+"\\s*("+a+"|"+f[o]+")",y[j]=new RegExp(f[j],"g");var C=l++;f[C]="^\\s*("+f[o]+")\\s+-\\s+("+f[o]+")\\s*$";var V=l++;f[V]="^\\s*("+f[u]+")\\s+-\\s+("+f[u]+")\\s*$";var W=l++;f[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)R(q,f[q]),y[q]||(y[q]=new RegExp(f[q]));function K(z,H){if(z instanceof I)return z;if(typeof z!="string"||z.length>D||!(H?y[i]:y[E]).test(z))return null;try{return new I(z,H)}catch{return null}}function I(z,H){if(z instanceof I){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof I))return new I(z,H);R("SemVer",z,H),this.loose=H;var J=z.trim().match(H?y[i]:y[E]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<N)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=K,e.valid=function(z,H){var J=K(z,H);return J?J.version:null},e.clean=function(z,H){var J=K(z.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=I,I.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},I.prototype.toString=function(){return this.version},I.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof I||(z=new I(z,this.loose)),this.compareMain(z)||this.comparePre(z)},I.prototype.compareMain=function(z){return z instanceof I||(z=new I(z,this.loose)),A(this.major,z.major)||A(this.minor,z.minor)||A(this.patch,z.patch)},I.prototype.comparePre=function(z){if(z instanceof I||(z=new I(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],he=z.prerelease[H];if(R("prerelease compare",H,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return A(J,he)}while(++H)},I.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new I(z,J).inc(H,he).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var J=K(z),he=K(H);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=A;var P=/^[0-9]+$/;function A(z,H){var J=P.test(z),he=P.test(H);return J&&he&&(z=+z,H=+H),J&&!he?-1:he&&!J?1:z<H?-1:z>H?1:0}function F(z,H,J){return new I(z,J).compare(new I(H,J))}function $(z,H,J){return F(z,H,J)>0}function G(z,H,J){return F(z,H,J)<0}function te(z,H,J){return F(z,H,J)===0}function oe(z,H,J){return F(z,H,J)!==0}function ge(z,H,J){return F(z,H,J)>=0}function ve(z,H,J){return F(z,H,J)<=0}function le(z,H,J,he){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z!==J;break;case"":case"=":case"==":pe=te(z,J,he);break;case"!=":pe=oe(z,J,he);break;case">":pe=$(z,J,he);break;case">=":pe=ge(z,J,he);break;case"<":pe=G(z,J,he);break;case"<=":pe=ve(z,J,he);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ce(z,H){if(z instanceof ce){if(z.loose===H)return z;z=z.value}if(!(this instanceof ce))return new ce(z,H);R("comparator",z,H),this.loose=H,this.parse(z),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,H){return A(H,z)},e.major=function(z,H){return new I(z,H).major},e.minor=function(z,H){return new I(z,H).minor},e.patch=function(z,H){return new I(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,J){return F(H,z,J)},e.sort=function(z,H){return z.sort(function(J,he){return e.compare(J,he,H)})},e.rsort=function(z,H){return z.sort(function(J,he){return e.rcompare(J,he,H)})},e.gt=$,e.lt=G,e.eq=te,e.neq=oe,e.gte=ge,e.lte=ve,e.cmp=le,e.Comparator=ce;var we={};function se(z,H){if(z instanceof se)return z.loose===H?z:new se(z.raw,H);if(z instanceof ce)return new se(z.value,H);if(!(this instanceof se))return new se(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ue(z){return!z||z.toLowerCase()==="x"||z==="*"}function be(z,H,J,he,pe,Oe,Se,Le,Ie,De,Fe,Re,Te){return((H=ue(J)?"":ue(he)?">="+J+".0.0":ue(pe)?">="+J+"."+he+".0":">="+H)+" "+(Le=ue(Ie)?"":ue(De)?"<"+(+Ie+1)+".0.0":ue(Fe)?"<"+Ie+"."+(+De+1)+".0":Re?"<="+Ie+"."+De+"."+Fe+"-"+Re:"<="+Le)).trim()}function je(z,H){for(var J=0;J<z.length;J++)if(!z[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<z.length;J++)if(R(z[J].semver),z[J].semver!==we&&z[J].semver.prerelease.length>0){var he=z[J].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function Ce(z,H,J){try{H=new se(H,J)}catch{return!1}return H.test(z)}function Ne(z,H,J,he){var pe,Oe,Se,Le,Ie;switch(z=new I(z,he),H=new se(H,he),J){case">":pe=$,Oe=ve,Se=G,Le=">",Ie=">=";break;case"<":pe=G,Oe=ge,Se=$,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(z,H,he))return!1;for(var De=0;De<H.set.length;++De){var Fe=H.set[De],Re=null,Te=null;if(Fe.forEach(function(Me){Me.semver===we&&(Me=new ce(">=0.0.0")),Re=Re||Me,Te=Te||Me,pe(Me.semver,Re.semver,he)?Re=Me:Se(Me.semver,Te.semver,he)&&(Te=Me)}),Re.operator===Le||Re.operator===Ie||(!Te.operator||Te.operator===Le)&&Oe(z,Te.semver)||Te.operator===Ie&&Se(z,Te.semver))return!1}return!0}ce.prototype.parse=function(z){var H=this.loose?y[me]:y[B],J=z.match(H);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new I(J[2],this.loose):this.semver=we},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===we||(typeof z=="string"&&(z=new I(z,this.loose)),le(z,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(z,H){if(!(z instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(z.value,H),Ce(this.value,J,H);if(z.operator==="")return J=new se(this.value,H),Ce(z.semver,J,H);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=le(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ie=le(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||pe||Oe&&Se||Le||Ie},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),R("range",z,H);var J=H?y[V]:y[C];z=z.replace(J,be),R("hyphen replace",z),z=z.replace(y[j],"$1$2$3"),R("comparator trim",z,y[j]),z=(z=(z=z.replace(y[X],"$1~")).replace(y[ae],"$1^")).split(/\s+/).join(" ");var he=H?y[me]:y[B],pe=z.split(" ").map(function(Oe){return function(Se,Le){return R("comp",Se),Se=function(Ie,De){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Te){R("caret",Re,Te);var Me=Te?y[re]:y[fe];return Re.replace(Me,function(Ue,Ee,ye,Pe,ke){var Ae;return R("caret",Re,Ue,Ee,ye,Pe,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Pe)?Ae=Ee==="0"?">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+".0 <"+(+Ee+1)+".0.0":ke?(R("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Pe+ke+" <"+Ee+"."+ye+"."+(+Pe+1):">="+Ee+"."+ye+"."+Pe+ke+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Pe+ke+" <"+(+Ee+1)+".0.0"):(R("no pr"),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+ye+"."+(+Pe+1):">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Pe+" <"+(+Ee+1)+".0.0"),R("caret return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,De){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Te){var Me=Te?y[ie]:y[ee];return Re.replace(Me,function(Ue,Ee,ye,Pe,ke){var Ae;return R("tilde",Re,Ue,Ee,ye,Pe,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Pe)?Ae=">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":ke?(R("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+Ee+"."+ye+"."+Pe+ke+" <"+Ee+"."+(+ye+1)+".0"):Ae=">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+(+ye+1)+".0",R("tilde return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,De){return R("replaceXRanges",Ie,De),Ie.split(/\s+/).map(function(Fe){return function(Re,Te){Re=Re.trim();var Me=Te?y[M]:y[S];return Re.replace(Me,function(Ue,Ee,ye,Pe,ke,Ae){R("xRange",Re,Ue,Ee,ye,Pe,ke,Ae);var We=ue(ye),ze=We||ue(Pe),Be=ze||ue(ke);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Pe=0),Be&&(ke=0),Ee===">"?(Ee=">=",ze?(ye=+ye+1,Pe=0,ke=0):Be&&(Pe=+Pe+1,ke=0)):Ee==="<="&&(Ee="<",ze?ye=+ye+1:Pe=+Pe+1),Ue=Ee+ye+"."+Pe+"."+ke):ze?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Be&&(Ue=">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0"),R("xRange return",Ue),Ue})}(Fe,De)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,De){return R("replaceStars",Ie,De),Ie.trim().replace(y[W],"")}(Se,Le),R("stars",Se),Se}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new ce(Oe,H)})},se.prototype.intersects=function(z,H){if(!(z instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return z.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new se(z,H).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},se.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new I(z,this.loose));for(var H=0;H<this.set.length;H++)if(je(this.set[H],z))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(z,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return z.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==-1||(pe=new I(he=Se,J)))}),he},e.minSatisfying=function(z,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return z.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==1||(pe=new I(he=Se,J)))}),he},e.validRange=function(z,H){try{return new se(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,J){return Ne(z,H,"<",J)},e.gtr=function(z,H,J){return Ne(z,H,">",J)},e.outside=Ne,e.prerelease=function(z,H){var J=K(z,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(z,H,J){return z=new se(z,J),H=new se(H,J),z.intersects(H)},e.coerce=function(z){if(z instanceof I)return z;if(typeof z!="string")return null;var H=z.match(y[U]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function(x,e){var T,O,R=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function y(h){if(T===setTimeout)return setTimeout(h,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(h,0);try{return T(h,0)}catch{try{return T.call(null,h,0)}catch{return T.call(this,h,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch{T=D}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var f,l=[],b=!1,g=-1;function m(){b&&f&&(b=!1,f.length?l=f.concat(l):g=-1,l.length&&k())}function k(){if(!b){var h=y(m);b=!0;for(var c=l.length;c;){for(f=l,l=[];++g<c;)f&&f[g].run();g=-1,c=l.length}f=null,b=!1,function(p){if(O===clearTimeout)return clearTimeout(p);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(p);try{O(p)}catch{try{return O.call(null,p)}catch{return O.call(this,p)}}}(h)}}function v(h,c){this.fun=h,this.array=c}function L(){}R.nextTick=function(h){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];l.push(new v(h,c)),l.length!==1||b||y(k)},v.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=L,R.addListener=L,R.once=L,R.off=L,R.removeListener=L,R.removeAllListeners=L,R.emit=L,R.prependListener=L,R.prependOnceListener=L,R.listeners=function(h){return[]},R.binding=function(h){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(h){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(y,f,l){this.level=y,this.key=f,this.value=l,this.forward=[]}}const R=void 0;class D{constructor(y,f=2**16){this.comparator=y,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new O(this.c,R,R)}get size(){return this.f}clear(){this.e=new O(this.c,R,R)}has(y){return Boolean(D.g(this,y,this.comparator))}get(y){return D.g(this,y,this.comparator)?.value}set(y,f){return D.h(this,y,f,this.comparator)&&(this.f+=1),this}delete(y){const f=D.k(this,y,this.comparator);return f&&(this.f-=1),f}forEach(y,f){let l=this.e.forward[0];for(;l;)y.call(f,l.value,l.key,this),l=l.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this.e.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this.e.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this.e.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",f=this.e.forward[0];for(;f;)y+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return y}static g(y,f,l){let b=y.e;for(let g=y.d-1;g>=0;g--)for(;b.forward[g]&&l(b.forward[g].key,f)<0;)b=b.forward[g];if(b=b.forward[0],b&&l(b.key,f)===0)return b}static h(y,f,l,b){const g=[];let m=y.e;for(let k=y.d-1;k>=0;k--){for(;m.forward[k]&&b(m.forward[k].key,f)<0;)m=m.forward[k];g[k]=m}if(m=m.forward[0],m&&b(m.key,f)===0)return m.value=l,!1;{const k=D.j(y);if(k>y.d){for(let v=y.d;v<k;v++)g[v]=y.e;y.d=k}m=new O(k,f,l);for(let v=0;v<k;v++)m.forward[v]=g[v].forward[v],g[v].forward[v]=m;return!0}}static j(y,f=.5){let l=1;for(;Math.random()<f&&l<y.c;)l+=1;return l}static k(y,f,l){const b=[];let g=y.e;for(let m=y.d-1;m>=0;m--){for(;g.forward[m]&&l(g.forward[m].key,f)<0;)g=g.forward[m];b[m]=g}if(g=g.forward[0],!g||l(g.key,f)!==0)return!1;for(let m=0;m<y.d&&b[m].forward[m]===g;m++)b[m].forward[m]=g.forward[m];for(;y.d>0&&y.e.forward[y.d-1]===R;)y.d-=1;return!0}}e.SkipList=D}),define(Z[43],Q([0,1,6,2]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const E=d;return E?typeof E.read=="function":!1}e.isReadable=R;function D(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function N(d){const E=d;return E?D(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=N;function y(d,E){return new f(d,E)}e.newWriteableStream=y;class f{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,T.onUnexpectedError)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let a;switch(E){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(d,E){const t=[];let a;for(;(a=d.read())!==null;)t.push(a);return E(t)}e.consumeReadable=l;function b(d,E,t){const a=[];let i;for(;(i=d.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?E(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return d.read()}}}e.peekReadable=b;function g(d,E){return new Promise((t,a)=>{const i=[];m(d,{onData:n=>{E&&i.push(n)},onError:n=>{E?a(n):t(void 0)},onEnd:()=>{t(E?E(i):void 0)}})})}e.consumeStream=g;function m(d,E){let t=!1;return d.on("error",a=>{t||E.onError(a)}),d.on("end",()=>{t||E.onEnd()}),d.on("data",a=>{t||E.onData(a)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=m;function k(d,E){return new Promise((t,a)=>{const i=new O.DisposableStore,n=[],r=u=>{if(n.push(u),n.length>E)return i.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},s=u=>a(u),o=()=>t({stream:d,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>d.removeListener("error",s))),d.on("error",s),i.add((0,O.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),i.add((0,O.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=k;function v(d,E){const t=y(E);return t.end(d),t}e.toStream=v;function L(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=L;function h(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.toReadable=h;function c(d,E,t){const a=y(t);return m(d,{onData:i=>a.write(E.data(i)),onError:i=>a.error(E.error?E.error(i):i),onEnd:()=>a.end()}),a}e.transform=c;function p(d,E,t){let a=!1;return{read:()=>{const i=E.read();return a?i:(a=!0,i!==null?t([d,i]):d)}}}e.prefixedReadable=p;function w(d,E,t){let a=!1;const i=y(t);return m(E,{onData:n=>a?i.write(n):(a=!0,i.write(t([d,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(d)),i.end()}}),i}e.prefixedStream=w}),define(Z[15],Q([0,1,43]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let R,D;class N{static alloc(u){return O?new N(Buffer.allocUnsafe(u)):new N(new Uint8Array(u))}static wrap(u){return O&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new N(u)}static fromString(u,S){return!(S?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(u)):(R||(R=new TextEncoder),new N(R.encode(u)))}static fromByteArray(u){const S=N.alloc(u.length);for(let M=0,U=u.length;M<U;M++)S.buffer[M]=u[M];return S}static concat(u,S){if(typeof S>"u"){S=0;for(let Y=0,X=u.length;Y<X;Y++)S+=u[Y].byteLength}const M=N.alloc(S);let U=0;for(let Y=0,X=u.length;Y<X;Y++){const ee=u[Y];M.set(ee,U),U+=ee.byteLength}return M}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=N.alloc(this.byteLength);return u.set(this),u}toString(){return O?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(u,S){return new N(this.buffer.subarray(u,S))}set(u,S){if(u instanceof N)this.buffer.set(u.buffer,S);else if(u instanceof Uint8Array)this.buffer.set(u,S);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),S);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return l(this.buffer,u)}writeUInt32BE(u,S){b(this.buffer,u,S)}readUInt32LE(u){return g(this.buffer,u)}writeUInt32LE(u,S){m(this.buffer,u,S)}readUInt8(u){return k(this.buffer,u)}writeUInt8(u,S){v(this.buffer,u,S)}}e.VSBuffer=N;function y(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=y;function f(o,u,S){o[S+0]=u&255,u=u>>>8,o[S+1]=u&255}e.writeUInt16LE=f;function l(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=l;function b(o,u,S){o[S+3]=u,u=u>>>8,o[S+2]=u,u=u>>>8,o[S+1]=u,u=u>>>8,o[S]=u}e.writeUInt32BE=b;function g(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=g;function m(o,u,S){o[S+0]=u&255,u=u>>>8,o[S+1]=u&255,u=u>>>8,o[S+2]=u&255,u=u>>>8,o[S+3]=u&255}e.writeUInt32LE=m;function k(o,u){return o[u]}e.readUInt8=k;function v(o,u,S){o[S]=u}e.writeUInt8=v;function L(o){return T.consumeReadable(o,u=>N.concat(u))}e.readableToBuffer=L;function h(o){return T.toReadable(o)}e.bufferToReadable=h;function c(o){return T.consumeStream(o,u=>N.concat(u))}e.streamToBuffer=c;async function p(o){return o.ended?N.concat(o.buffer):N.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=p;function w(o){return T.toStream(o,u=>N.concat(u))}e.bufferToStream=w;function d(o){return T.transform(o,{data:u=>typeof u=="string"?N.fromString(u):N.wrap(u)},u=>N.concat(u))}e.streamToBufferReadableStream=d;function E(o){return T.newWriteableStream(u=>N.concat(u),o)}e.newWriteableBufferStream=E;function t(o,u){return T.prefixedReadable(o,u,S=>N.concat(S))}e.prefixedBufferReadable=t;function a(o,u){return T.prefixedStream(o,u,S=>N.concat(S))}e.prefixedBufferStream=a;function i(o){let u=0,S=0,M=0;const U=new Uint8Array(Math.floor(o.length/4*3)),Y=ee=>{switch(S){case 3:U[M++]=u|ee,S=0;break;case 2:U[M++]=u|ee>>>2,u=ee<<6,S=3;break;case 1:U[M++]=u|ee>>>4,u=ee<<4,S=2;break;default:u=ee<<2,S=1}};for(let ee=0;ee<o.length;ee++){const ie=o.charCodeAt(ee);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[ee]}`)}}const X=M;for(;S>0;)Y(0);return N.wrap(U).slice(0,X)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:o},u=!0,S=!1){const M=S?r:n;let U="";const Y=o.byteLength%3;let X=0;for(;X<o.byteLength-Y;X+=3){const ee=o[X+0],ie=o[X+1],ne=o[X+2];U+=M[ee>>>2],U+=M[(ee<<4|ie>>>4)&63],U+=M[(ie<<2|ne>>>6)&63],U+=M[ne&63]}if(Y===1){const ee=o[X+0];U+=M[ee>>>2],U+=M[ee<<4&63],u&&(U+="==")}else if(Y===2){const ee=o[X+0],ie=o[X+1];U+=M[ee>>>2],U+=M[(ee<<4|ie>>>4)&63],U+=M[ie<<2&63],u&&(U+="=")}return U}e.encodeBase64=s}),define(Z[30],Q([0,1,4]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,d])=>{p[w]=d&&typeof d=="object"?O(d):d}),p}e.deepClone=O;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const d in w)if(D.call(w,d)){const E=w[d];typeof E=="object"&&!Object.isFrozen(E)&&!(0,T.isTypedArray)(E)&&p.push(E)}}return c}e.deepFreeze=R;const D=Object.prototype.hasOwnProperty;function N(c,p){return y(c,p,new Set)}e.cloneAndChange=N;function y(c,p,w){if((0,T.isUndefinedOrNull)(c))return c;const d=p(c);if(typeof d<"u")return d;if(Array.isArray(c)){const E=[];for(const t of c)E.push(y(t,p,w));return E}if((0,T.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const E={};for(const t in c)D.call(c,t)&&(E[t]=y(c[t],p,w));return w.delete(c),E}return c}function f(c,p,w=!0){return(0,T.isObject)(c)?((0,T.isObject)(p)&&Object.keys(p).forEach(d=>{d in c?w&&((0,T.isObject)(c[d])&&(0,T.isObject)(p[d])?f(c[d],p[d],w):c[d]=p[d]):c[d]=p[d]}),c):p}e.mixin=f;function l(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let w,d;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(w=0;w<c.length;w++)if(!l(c[w],p[w]))return!1}else{const E=[];for(d in c)E.push(d);E.sort();const t=[];for(d in p)t.push(d);if(t.sort(),!l(E,t))return!1;for(w=0;w<E.length;w++)if(!l(c[E[w]],p[E[w]]))return!1}return!0}e.equals=l;function b(c){const p=new Set;return JSON.stringify(c,(w,d)=>{if((0,T.isObject)(d)||Array.isArray(d)){if(p.has(d))return"[Circular]";p.add(d)}return d})}e.safeStringify=b;function g(c,p){const w=Object.create(null);return!c||!p||Object.keys(p).forEach(E=>{const t=c[E],a=p[E];l(t,a)||(w[E]=a)}),w}e.distinct=g;function m(c,p){const w=p.toLowerCase(),d=Object.keys(c).find(E=>E.toLowerCase()===w);return d?c[d]:c[p]}e.getCaseInsensitive=m;function k(c,p){const w=Object.create(null);for(const[d,E]of Object.entries(c))p(d,E)&&(w[d]=E);return w}e.filter=k;function v(c){let p=[],w=Object.getPrototypeOf(c);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=v;function L(c){const p=[];for(const w of v(c))typeof c[w]=="function"&&p.push(w);return p}e.getAllMethodNames=L;function h(c,p){const w=E=>function(){const t=Array.prototype.slice.call(arguments,0);return p(E,t)},d={};for(const E of c)d[E]=w(E);return d}e.createProxyObject=h}),define(Z[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return T.test(R)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let f=0;f<y.length;f++)y[f]=Math.floor(Math.random()*256);return y};const D=new Uint8Array(16),N=[];for(let y=0;y<256;y++)N.push(y.toString(16).padStart(2,"0"));return function(){R(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let f=0,l="";return l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l+="-",l+=N[D[f++]],l+=N[D[f++]],l+="-",l+=N[D[f++]],l+=N[D[f++]],l+="-",l+=N[D[f++]],l+=N[D[f++]],l+="-",l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l+=N[D[f++]],l}}()}),define(Z[73],Q([0,1,33]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const y=N.replace(/\-/g,":").toLowerCase();return!O.has(y)}function D(){const N=(0,T.networkInterfaces)();for(const y in N){const f=N[y];if(f){for(const{mac:l}of f)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[74],Q([7,8]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,R=O*60,D=R*24,N=D*7,y=D*30,f=D*365;function l(g,m,k,v){typeof g!="number"&&(g=g.getTime());const L=Math.round((new Date().getTime()-g)/1e3);if(L<-30)return(0,T.localize)(0,null,l(new Date().getTime()+L*1e3,!1));if(!v&&L<30)return(0,T.localize)(1,null);let h;return L<O?(h=L,m?h===1?k?(0,T.localize)(2,null,h):(0,T.localize)(3,null,h):k?(0,T.localize)(4,null,h):(0,T.localize)(5,null,h):h===1?k?(0,T.localize)(6,null,h):(0,T.localize)(7,null,h):k?(0,T.localize)(8,null,h):(0,T.localize)(9,null,h)):L<R?(h=Math.floor(L/O),m?h===1?k?(0,T.localize)(10,null,h):(0,T.localize)(11,null,h):k?(0,T.localize)(12,null,h):(0,T.localize)(13,null,h):h===1?k?(0,T.localize)(14,null,h):(0,T.localize)(15,null,h):k?(0,T.localize)(16,null,h):(0,T.localize)(17,null,h)):L<D?(h=Math.floor(L/R),m?h===1?k?(0,T.localize)(18,null,h):(0,T.localize)(19,null,h):k?(0,T.localize)(20,null,h):(0,T.localize)(21,null,h):h===1?k?(0,T.localize)(22,null,h):(0,T.localize)(23,null,h):k?(0,T.localize)(24,null,h):(0,T.localize)(25,null,h)):L<N?(h=Math.floor(L/D),m?h===1?(0,T.localize)(26,null,h):(0,T.localize)(27,null,h):h===1?(0,T.localize)(28,null,h):(0,T.localize)(29,null,h)):L<y?(h=Math.floor(L/N),m?h===1?k?(0,T.localize)(30,null,h):(0,T.localize)(31,null,h):k?(0,T.localize)(32,null,h):(0,T.localize)(33,null,h):h===1?k?(0,T.localize)(34,null,h):(0,T.localize)(35,null,h):k?(0,T.localize)(36,null,h):(0,T.localize)(37,null,h)):L<f?(h=Math.floor(L/y),m?h===1?k?(0,T.localize)(38,null,h):(0,T.localize)(39,null,h):k?(0,T.localize)(40,null,h):(0,T.localize)(41,null,h):h===1?k?(0,T.localize)(42,null,h):(0,T.localize)(43,null,h):k?(0,T.localize)(44,null,h):(0,T.localize)(45,null,h)):(h=Math.floor(L/f),m?h===1?k?(0,T.localize)(46,null,h):(0,T.localize)(47,null,h):k?(0,T.localize)(48,null,h):(0,T.localize)(49,null,h):h===1?k?(0,T.localize)(50,null,h):(0,T.localize)(51,null,h):k?(0,T.localize)(52,null,h):(0,T.localize)(53,null,h))}e.fromNow=l;function b(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Z[76],Q([7,8]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,4,76]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(g,m){return m&&(g.stack||g.stacktrace)?R.localize(0,null,y(g),N(g.stack)||N(g.stacktrace)):y(g)}function N(g){return Array.isArray(g)?g.join(`
`):g}function y(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?R.localize(1,null,g.message):g.message||R.localize(2,null)}function f(g=null,m=!1){if(!g)return R.localize(3,null);if(Array.isArray(g)){const k=T.coalesce(g),v=f(k[0],m);return k.length>1?R.localize(4,null,v,k.length):v}if(O.isString(g))return g;if(g.detail){const k=g.detail;if(k.error)return D(k.error,m);if(k.exception)return D(k.exception,m)}return g.stack?D(g,m):g.message?g.message:R.localize(5,null)}e.toErrorMessage=f;function l(g){const m=g;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=l;function b(g,m){let k;return typeof g=="string"?k=new Error(g):k=g,k.actions=m,k}e.createErrorWithActions=b}),define(Z[77],Q([7,8]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(R){switch(R){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Z[51],Q([0,1,12]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(y,...f){const l=f.reduce((m,k)=>(m[k]=!0,m),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(m=>!l[m]).forEach(m=>{for(let k=0;k<b.length;k++)if(m.search(b[k])!==-1){delete y[m];break}})}e.sanitizeProcessEnvironment=D;function N(y){!y||(delete y.DEBUG,T.isMacintosh&&delete y.DYLD_LIBRARY_PATH,T.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Z[52],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return R(c,0)}e.hash=O;function R(c,p){switch(typeof c){case"object":return c===null?D(349,p):Array.isArray(c)?f(c,p):l(c,p);case"string":return y(c,p);case"boolean":return N(c,p);case"number":return D(c,p);case"undefined":return D(937,p);default:return D(617,p)}}e.doHash=R;function D(c,p){return(p<<5)-p+c|0}e.numberHash=D;function N(c,p){return D(c?433:863,p)}function y(c,p){p=D(149417,p);for(let w=0,d=c.length;w<d;w++)p=D(c.charCodeAt(w),p);return p}e.stringHash=y;function f(c,p){return p=D(104579,p),c.reduce((w,d)=>R(d,w),p)}function l(c,p){return p=D(181387,p),Object.keys(c).sort().reduce((w,d)=>(w=y(d,w),R(c[d],w)),p)}class b{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.Hasher=b;var g;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function m(c,p,w=32){const d=w-p,E=~((1<<d)-1);return(c<<p|(E&c)>>>d)>>>0}function k(c,p=0,w=c.byteLength,d=0){for(let E=0;E<w;E++)c[p+E]=d}function v(c,p,w="0"){for(;c.length<p;)c=w+c;return c}function L(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),p/4)}e.toHexString=L;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const w=p.length;if(w===0)return;const d=this.p;let E=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=p.charCodeAt(0),i=0);;){let n=a;if(T.isHighSurrogate(a))if(i+1<w){const r=p.charCodeAt(i+1);T.isLowSurrogate(r)?(i++,n=T.computeCodePoint(a,r)):n=65533}else{t=a;break}else T.isLowSurrogate(a)&&(n=65533);if(E=this.w(d,E,n),i++,i<w)a=p.charCodeAt(i);else break}this.r=E,this.u=t}w(p,w,d){return d<128?p[w++]=d:d<2048?(p[w++]=192|(d&1984)>>>6,p[w++]=128|(d&63)>>>0):d<65536?(p[w++]=224|(d&61440)>>>12,p[w++]=128|(d&4032)>>>6,p[w++]=128|(d&63)>>>0):(p[w++]=240|(d&1835008)>>>18,p[w++]=128|(d&258048)>>>12,p[w++]=128|(d&4032)>>>6,p[w++]=128|(d&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=h.g,w=this.q;for(let o=0;o<64;o+=4)p.setUint32(o,w.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)p.setUint32(o,m(p.getUint32(o-12,!1)^p.getUint32(o-32,!1)^p.getUint32(o-56,!1)^p.getUint32(o-64,!1),1),!1);let d=this.h,E=this.l,t=this.m,a=this.n,i=this.o,n,r,s;for(let o=0;o<80;o++)o<20?(n=E&t|~E&a,r=1518500249):o<40?(n=E^t^a,r=1859775393):o<60?(n=E&t|E&a|t&a,r=2400959708):(n=E^t^a,r=3395469782),s=m(d,5)+n+i+r+p.getUint32(o*4,!1)&4294967295,i=a,a=t,t=m(E,30),E=d,d=s;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=h,h.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const D="error",N="warning",y="warn",f="info",l="ignore";function b(m){return m?T.equalsIgnoreCase(D,m)?R.Error:T.equalsIgnoreCase(N,m)||T.equalsIgnoreCase(y,m)?R.Warning:T.equalsIgnoreCase(f,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function g(m){switch(m){case R.Error:return D;case R.Warning:return N;case R.Info:return f;default:return l}}R.toString=g}(O||(O={})),e.default=O}),define(Z[79],Q([0,1,11]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=O;function R(l){const b=[];let g;try{const m=JSON.parse(l.arguments),k=m[m.length-1];k&&k.__$stack&&(m.pop(),g=k.__$stack),b.push(...m)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:g}}e.parse=R;function D(l){if(typeof l!="string")return D(R(l).stack);const b=l;if(b){const g=N(b),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(m&&m.length===4)return{uri:T.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=D;function N(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function y(l,b){const{args:g,stack:m}=R(l),k=typeof g[0]=="string"&&g.length===1;let v=N(m);v&&(v=`(${v.trim()})`);let L=[];if(typeof g[0]=="string"?v&&k?L=[`%c[${b}] %c${g[0]} %c${v}`,f("blue"),f(""),f("grey")]:L=[`%c[${b}] %c${g[0]}`,f("blue"),f(""),...g.slice(1)]:L=[`%c[${b}]%`,f("blue"),...g],v&&!k&&L.push(v),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,L)}e.log=y;function f(l){return`color: ${l}`}}),define(Z[44],Q([0,1,15,32,11]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(l){return JSON.stringify(l,y)}e.stringify=D;function N(l){let b=JSON.parse(l);return b=f(b),b}e.parse=N;function y(l,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,O.regExpFlags)(b)}:b}function f(l,b=0){if(!l||b>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return R.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof T.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let g=0;g<l.length;++g)l[g]=f(l[g],b+1);else for(const g in l)Object.hasOwnProperty.call(l,g)&&(l[g]=f(l[g],b+1))}return l}e.revive=f}),define(Z[80],Q([0,1,33,6,54,31,73]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,g=0;const m=(0,T.networkInterfaces)();for(const k in m){const v=m[k];if(v)for(const{mac:L,internal:h}of v)h||(g+=1,this.c(L.toUpperCase())&&(b+=1))}this.b=g>0?b/g:0}return this.b}};let y;async function f(){return y||(y=(async()=>await l()||D.generateUuid())()),y}e.getMachineId=f;async function l(){try{const b=await new Promise((m,k)=>{x(["crypto"],m,k)}),g=(0,N.getMac)();return b.createHash("sha256").update(g,"utf8").digest("hex")}catch(b){O.onUnexpectedError(b);return}}}),define(Z[81],Q([0,1,33,14,20]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,N=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var f;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class g{constructor(E,t,a){this.exePath=E,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:d=!1}={}){return d?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function k({useAlternateBitness:d=!1,findPreview:E=!1}={}){const t=m({useAlternateBitness:d});if(!t)return null;const a=O.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const o of await R.Promises.readdir(a)){let u=-1;if(E){const M=o.indexOf("-");if(M<0)continue;const U=o.substring(0,M);if(!D.test(U)||o.substring(M+1)!=="preview")continue;u=parseInt(U,10)}else{if(!D.test(o))continue;u=parseInt(o,10)}if(u<=i)continue;const S=O.join(a,o,"pwsh.exe");!await R.SymlinkSupport.existsFile(S)||(n=S,i=u)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",s=E?" Preview":"";return new g(n,`PowerShell${s}${r}`,!0)}async function v({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const E=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=d?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(E))if(t.test(i)){const n=O.join(E,i,"pwsh.exe");return new g(n,a)}return null}function L(){const d=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new g(d,".NET Core PowerShell Global Tool")}function h(){const d=O.join(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(d,"Windows PowerShell",!0)}async function*c(){let d=await k();d&&(yield d),d=await k({useAlternateBitness:!0}),d&&(yield d),d=await v(),d&&(yield d),d=L(),d&&(yield d),d=await k({findPreview:!0}),d&&(yield d),d=await v({findPreview:!0}),d&&(yield d),d=await k({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=h(),d&&(yield d)}async function*p(){for await(const d of c())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=p;async function w(){for await(const d of p())return d;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Z[55],Q([0,1,14,12,35,51,4,20]),function(x,e,T,O,R,D,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function f(g=R.env){return g.comspec||"cmd.exe"}e.getWindowsShell=f;function l(g){let m=[],k=!1;const v=function(L){if(k){m.push(L);return}(!g.send(L,c=>{if(c&&console.error(c),k=!1,m.length>0){const p=m.slice(0);m=[],p.forEach(w=>v(w))}})||O.isWindows)&&(k=!0)};return{send:v}}e.createQueuedSender=l;var b;(function(g){async function m(k,v,L){if(T.isAbsolute(k))return k;if(v===void 0&&(v=R.cwd()),T.dirname(k)!=="."||(L===void 0&&N.isString(R.env.PATH)&&(L=R.env.PATH.split(T.delimiter)),L===void 0||L.length===0))return T.join(v,k);async function c(p){if(await y.Promises.exists(p)){let w;try{w=await y.Promises.stat(p)}catch(d){d.message.startsWith("EACCES")&&(w=await y.Promises.lstat(p))}return w?!w.isDirectory():!1}return!1}for(const p of L){let w;if(T.isAbsolute(p)?w=T.join(p,k):w=T.join(v,p,k),await c(w))return w;let d=w+".com";if(await c(d)||(d=w+".exe",await c(d)))return d}return T.join(v,k)}g.findExecutable=m})(b=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(g,m){return g===1?O.isWindows?b():D.getWindowsShell(m):f(g,m)}e.getSystemShell=N;let y=null;function f(g,m){if(O.isLinux&&g===2||O.isMacintosh&&g===3)return"/bin/bash";if(!y){let k;if(O.isWindows)k="/bin/bash";else{if(k=m.SHELL,!k)try{k=(0,T.userInfo)().shell}catch{}k||(k="sh"),k==="/bin/false"&&(k="/bin/bash")}y=k}return y}let l=null;async function b(){return l||(l=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),l}});var de=this&&this.__decorate||function(x,e,T,O){var R=arguments.length,D=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,T,O);else for(var y=x.length-1;y>=0;y--)(N=x[y])&&(D=(R<3?N(D):R>3?N(e,T,D):N(e,T))||D);return R>3&&D&&Object.defineProperty(e,T,D),D};define(Z[56],Q([0,1,19,5,15,22,49,6,3,2,44,32,4]),function(x,e,T,O,R,D,N,y,f,l,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(k||(k={}));function v(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var L;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(L||(L={}));function h(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(c||(c={}));function p(j){let C=0;for(let V=0;;V+=7){const W=j.read(1);if(C|=(W.buffer[0]&127)<<V,!(W.buffer[0]&128))return C}}const w=i(0);function d(j,C){if(C===0){j.write(w);return}let V=0;for(let q=C;q!==0;q=q>>>7)V++;const W=R.VSBuffer.alloc(V);for(let q=0;C!==0;q++)W.buffer[q]=C&127,C=C>>>7,C>0&&(W.buffer[q]|=128);j.write(W)}class E{constructor(C){this.b=C,this.a=0}read(C){const V=this.b.slice(this.a,this.a+C);return this.a+=V.byteLength,V}}e.BufferReader=E;class t{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(C){this.a.push(C)}}e.BufferWriter=t;var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(a||(a={}));function i(j){const C=R.VSBuffer.alloc(1);return C.writeUInt8(j,0),C}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function s(j,C){if(typeof C>"u")j.write(n.Undefined);else if(typeof C=="string"){const V=R.VSBuffer.fromString(C);j.write(n.String),d(j,V.byteLength),j.write(V)}else if(r&&Buffer.isBuffer(C)){const V=R.VSBuffer.wrap(C);j.write(n.Buffer),d(j,V.byteLength),j.write(V)}else if(C instanceof R.VSBuffer)j.write(n.VSBuffer),d(j,C.byteLength),j.write(C);else if(Array.isArray(C)){j.write(n.Array),d(j,C.length);for(const V of C)s(j,V)}else if(typeof C=="number"&&(C|0)===C)j.write(n.Uint),d(j,C);else{const V=R.VSBuffer.fromString(JSON.stringify(C));j.write(n.Object),d(j,V.byteLength),j.write(V)}}e.serialize=s;function o(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(p(j)).toString();case a.Buffer:return j.read(p(j)).buffer;case a.VSBuffer:return j.read(p(j));case a.Array:{const V=p(j),W=[];for(let q=0;q<V;q++)W.push(o(j));return W}case a.Object:return JSON.parse(j.read(p(j)).toString());case a.Int:return p(j)}}e.deserialize=o;class u{constructor(C,V,W=null,q=1e3){this.h=C,this.j=V,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(C,V){this.b.set(C,V),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const V=this.o([C.type]);this.k?.logOutgoing(V,0,1,h(C.type));return}case 201:case 202:case 204:case 203:{const V=this.o([C.type,C.id],C.data);this.k?.logOutgoing(V,C.id,1,h(C.type),C.data);return}}}o(C,V=void 0){const W=new t;return s(W,C),s(W,V),this.p(W.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const V=new E(C),W=o(V),q=o(V),K=W[0];switch(K){case 100:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(K)}: ${W[2]}.${W[3]}`,q),this.s({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(K)}: ${W[2]}.${W[3]}`,q),this.t({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(K)}`),this.u({type:K,id:W[1]});case 103:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(K)}`),this.u({type:K,id:W[1]})}}s(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const W=new D.CancellationTokenSource;let q;try{q=V.call(this.j,C.name,C.arg,W.token)}catch(P){q=Promise.reject(P)}const K=C.id;q.then(P=>{this.m({id:K,data:P,type:201}),this.d.delete(C.id)},P=>{P instanceof Error?this.m({id:K,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:K,data:P,type:203}),this.d.delete(C.id)});const I=(0,l.toDisposable)(()=>W.cancel());this.d.set(C.id,I)}t(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const W=C.id,K=V.listen(this.j,C.name,C.arg)(I=>this.m({id:W,data:I,type:204}));this.d.set(C.id,K)}u(C){const V=this.d.get(C.id);V&&(V.dispose(),this.d.delete(C.id))}v(C){let V=this.g.get(C.channelName);V||(V=[],this.g.set(C.channelName,V));const W=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:C,timeoutTimer:W})}w(C){const V=this.g.get(C);if(V){for(const W of V)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var S;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(C,V=null){this.l=C,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=V}getChannel(C){const V=this;return{call(W,q,K){return V.a?Promise.reject(new y.CancellationError):V.m(C,W,q,K)},listen(W,q){return V.a?f.Event.None:V.o(C,W,q)}}}m(C,V,W,q=D.CancellationToken.None){const K=this.g++,P={id:K,type:100,channelName:C,name:V,arg:W};if(q.isCancellationRequested)return Promise.reject(new y.CancellationError);let A;return new Promise(($,G)=>{if(q.isCancellationRequested)return G(new y.CancellationError);const te=()=>{const le=ce=>{switch(ce.type){case 201:this.f.delete(K),$(ce.data);break;case 202:{this.f.delete(K);const we=new Error(ce.data.message);we.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,we.name=ce.data.name,G(we);break}case 203:this.f.delete(K),G(ce.data);break}};this.f.set(K,le),this.p(P)};let oe=null;this.b===c.Idle?te():(oe=(0,O.createCancelablePromise)(le=>this.u()),oe.then(()=>{oe=null,te()}));const ge=()=>{oe?(oe.cancel(),oe=null):this.p({id:K,type:101}),G(new y.CancellationError)},ve=q.onCancellationRequested(ge);A=(0,l.combinedDisposable)((0,l.toDisposable)(ge),ve),this.d.add(A)}).finally(()=>{this.d.delete(A)})}o(C,V,W){const q=this.g++,I={id:q,type:102,channelName:C,name:V,arg:W};let P=null;const A=new f.Emitter({onWillAddFirstListener:()=>{P=(0,O.createCancelablePromise)($=>this.u()),P.then(()=>{P=null,this.d.add(A),this.p(I)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(A),this.p({id:q,type:103}))}}),F=$=>A.fire($.data);return this.f.set(q,F),A.event}p(C){switch(C.type){case 100:case 102:{const V=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(V,C.id,0,`${v(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const V=this.q([C.type,C.id]);this.j?.logOutgoing(V,C.id,0,v(C.type));return}}}q(C,V=void 0){const W=new t;return s(W,C),s(W,V),this.r(W.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const V=new E(C),W=o(V),q=o(V),K=W[0];switch(K){case 200:return this.j?.logIncoming(C.byteLength,0,0,h(K)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,W[1],0,h(K),q),this.t({type:W[0],id:W[1],data:q})}}t(C){if(C.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}de([N.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class U{get connections(){const C=[];return this.f.forEach(V=>C.push(V)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,C(({protocol:V,onDidClientDisconnect:W})=>{f.Event.once(V.onMessage)(K=>{const I=new E(K),P=o(I),A=new u(V,P),F=new M(V);this.a.forEach((G,te)=>A.registerChannel(te,G));const $={channelServer:A,channelClient:F,ctx:P};this.f.add($),this.g.fire($),W(()=>{A.dispose(),F.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(C,V){const W=this;return{call(q,K,I){let P;if((0,m.isFunction)(V)){const F=(0,T.getRandomElement)(W.connections.filter(V));P=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(W.onDidAddConnection,V))}else P=V.routeCall(W,q,K);const A=P.then(F=>F.channelClient.getChannel(C));return X(A).call(q,K,I)},listen(q,K){if((0,m.isFunction)(V))return W.j(C,V,q,K);const I=V.routeEvent(W,q,K).then(P=>P.channelClient.getChannel(C));return X(I).listen(q,K)}}}j(C,V,W,q){const K=this;let I=new l.DisposableStore;const P=new f.Emitter({onWillAddFirstListener:()=>{I=new l.DisposableStore;const A=new f.EventMultiplexer,F=new Map,$=te=>{const ge=te.channelClient.getChannel(C).listen(W,q),ve=A.add(ge);F.set(te,ve)},G=te=>{const oe=F.get(te);!oe||(oe.dispose(),F.delete(te))};K.connections.filter(V).forEach($),f.Event.filter(K.onDidAddConnection,V)($,void 0,I),K.onDidRemoveConnection(G,void 0,I),A.event(P.fire,P,I),I.add(A)},onDidRemoveLastListener:()=>{I.dispose()}});return P.event}registerChannel(C,V){this.a.set(C,V),this.f.forEach(W=>{W.channelServer.registerChannel(C,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=U;class Y{constructor(C,V,W=null){const q=new t;s(q,V),C.send(q.buffer),this.a=new M(C,W),this.d=new u(C,V,W)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,V){this.d.registerChannel(C,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function X(j){return{call(C,V,W){return j.then(q=>q.call(C,V,W))},listen(C,V){const W=new f.Relay;return j.then(q=>W.input=q.listen(C,V)),W.event}}}e.getDelayedChannel=X;function ee(j){let C=!1;return{call(V,W,q){return C?j.call(V,W,q):(0,O.timeout)(0).then(()=>C=!0).then(()=>j.call(V,W,q))},listen(V,W){if(C)return j.listen(V,W);const q=new f.Relay;return(0,O.timeout)(0).then(()=>C=!0).then(()=>q.input=j.listen(V,W)),q.event}}}e.getNextTickChannel=ee;class ie{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const V of C.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await f.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.StaticRouter=ie;var ne;(function(j){function C(K,I){const P=K,A=I&&I.disableMarshalling,F=new Map;for(const $ in P)W($)&&F.set($,f.Event.buffer(P[$],!0));return new class{listen($,G,te){const oe=F.get(G);if(oe)return oe;if(q(G)){const ge=P[G];if(typeof ge=="function")return ge.call(P,te)}throw new Error(`Event not found: ${G}`)}call($,G,te){const oe=P[G];if(typeof oe=="function"){if(!A&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,b.revive)(te[ge]);return oe.apply(P,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=C;function V(K,I){const P=I&&I.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return I?.properties?.has(F)?I.properties.get(F):q(F)?function($){return K.listen(F,$)}:W(F)?K.listen(F):async function(...$){let G;I&&!(0,m.isUndefinedOrNull)(I.context)?G=[I.context,...$]:G=$;const te=await K.call(F,G);return P?te:(0,b.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=V;function W(K){return K[0]==="o"&&K[1]==="n"&&g.isUpperAsciiLetter(K.charCodeAt(2))}function q(K){return/^onDynamic/.test(K)&&g.isUpperAsciiLetter(K.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const C=j.toString();if(C!=="[object Object]")return C}return j}function re(j){return Array.isArray(j)?j.map(fe):fe(j)}function me(j,C,V,W,q,K,I){I=re(I);const P=ae[q],A=P[W%P.length];let F=[`%c[${j}]%c[${String(C).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(K)?(F=F.concat(I),F.push(")")):F.push(I),console.log.apply(console,F)}class B{constructor(C,V){this.d=C,this.f=V,this.a=0,this.b=0}logOutgoing(C,V,W,q,K){this.b+=C,me(this.d,this.b,C,V,W,q,K)}logIncoming(C,V,W,q,K){this.a+=C,me(this.f,this.a,C,V,W,q,K)}}e.IPCLogger=B}),define(Z[83],Q([0,1,57,5,15,22,79,6,3,2,30,55,51,56]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends k.ChannelServer{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=v;class L{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const w=p&&p.timeout?p.timeout:6e4;this.b=new O.Delayer(w),this.d=null,this.f=null}getChannel(c){const p=this;return{call(w,d,E){return p.k(c,w,d,E)},listen(w,d){return p.l(c,w,d)}}}k(c,p,w,d=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(y.canceled());this.b.cancel();const E=this.n(c),t=(0,O.createCancelablePromise)(n=>E.call(p,w,n)),a=d.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,p,w){if(!this.b)return f.Event.None;this.b.cancel();let d;const E=new f.Emitter({onWillAddFirstListener:()=>{d=this.n(c).listen(p,w)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,m.removeDangerousEnvVariables)(p.env),this.d=(0,T.fork)(this.i,c,p);const w=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.isRemoteConsoleLog)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}w.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const E=this.j.useQueue?(0,g.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&E.send(r.buffer.toString("base64")),a=w.event,i={send:t,onMessage:a};this.f=new k.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,s)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,l.dispose)(o)),this.c.clear(),r!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+s),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:s})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=L}),define(Z[84],Q([0,1,5,3,2,4]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function y(g){const m=g;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var f;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class l extends R.Disposable{constructor(m,k=Object.create(null)){super(),this.m=m,this.n=k,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new T.ThrottledDelayer(l.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((k,v)=>this.s(v,k)),m.deleted?.forEach(k=>this.s(k,void 0))}s(m,k){if(this.c===f.Closed)return;let v=!1;(0,D.isUndefinedOrNull)(k)?v=this.f.delete(m):this.f.get(m)!==k&&(this.f.set(m,k),v=!0),v&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,k){const v=this.f.get(m);return(0,D.isUndefinedOrNull)(v)?k:v}getBoolean(m,k){const v=this.get(m);return(0,D.isUndefinedOrNull)(v)?k:v==="true"}getNumber(m,k){const v=this.get(m);return(0,D.isUndefinedOrNull)(v)?k:parseInt(v,10)}async set(m,k){if(this.c===f.Closed)return;if((0,D.isUndefinedOrNull)(k))return this.delete(m);const v=String(k);if(this.f.get(m)!==v)return this.f.set(m,v),this.j.set(m,v),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===f.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=l,l.a=100;class b{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((k,v)=>this.a.set(v,k)),m.delete?.forEach(k=>this.a.delete(k))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[85],Q([7,8]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([7,8]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([7,8]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([7,8]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([7,8]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([7,8]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([7,8]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([7,8]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([7,8]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([7,8]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,49,16,14,35,18,11]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,D.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return f.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(f.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=N.env.VSCODE_PORTABLE;return v?f.URI.file((0,D.join)(v,"argv.json")):(0,y.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,D.resolve)(v):(0,D.normalize)((0,D.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?f.URI.file((0,D.resolve)(v)):f.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,D.resolve)(v);const L=N.env.VSCODE_EXTENSIONS;if(L)return L;const h=N.env.VSCODE_PORTABLE;return h?(0,D.join)(h,"extensions"):(0,y.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(L=>/^[^:/?#]+?:\/\//.test(L)?f.URI.parse(L):f.URI.file((0,D.normalize)(L)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,D.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const L of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(L);h&&h[1]&&h[2]&&v.push([h[1],h[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,y.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=N.env.VSCODE_PORTABLE;return v?f.URI.file((0,D.join)(v,"policy.json")):(0,y.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,L,h){this.a=v,this.b=L,this.c=h,this.editSessionId=this.args.editSessionId}}de([O.memoize],l.prototype,"appRoot",null),de([O.memoize],l.prototype,"userHome",null),de([O.memoize],l.prototype,"userDataPath",null),de([O.memoize],l.prototype,"appSettingsHome",null),de([O.memoize],l.prototype,"tmpDir",null),de([O.memoize],l.prototype,"cacheHome",null),de([O.memoize],l.prototype,"stateResource",null),de([O.memoize],l.prototype,"userRoamingDataHome",null),de([O.memoize],l.prototype,"userDataSyncHome",null),de([O.memoize],l.prototype,"userDataSyncLogResource",null),de([O.memoize],l.prototype,"editSessionsLogResource",null),de([O.memoize],l.prototype,"sync",null),de([O.memoize],l.prototype,"machineSettingsResource",null),de([O.memoize],l.prototype,"workspaceStorageHome",null),de([O.memoize],l.prototype,"localHistoryHome",null),de([O.memoize],l.prototype,"keyboardLayoutResource",null),de([O.memoize],l.prototype,"argvResource",null),de([O.memoize],l.prototype,"isExtensionDevelopment",null),de([O.memoize],l.prototype,"untitledWorkspacesHome",null),de([O.memoize],l.prototype,"installSourcePath",null),de([O.memoize],l.prototype,"builtinExtensionsPath",null),de([O.memoize],l.prototype,"extensionsPath",null),de([O.memoize],l.prototype,"extensionDevelopmentLocationURI",null),de([O.memoize],l.prototype,"extensionDevelopmentKind",null),de([O.memoize],l.prototype,"extensionTestsLocationURI",null),de([O.memoize],l.prototype,"debugExtensionHost",null),de([O.memoize],l.prototype,"logLevel",null),de([O.memoize],l.prototype,"extensionLogLevel",null),de([O.memoize],l.prototype,"serviceMachineIdResource",null),de([O.memoize],l.prototype,"telemetryLogResource",null),de([O.memoize],l.prototype,"disableWorkspaceTrust",null),de([O.memoize],l.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=l;function b(k,v){return m(k["inspect-extensions"],k["inspect-brk-extensions"],5870,v,k.debugId,k.extensionEnvironment)}e.parseExtensionHostPort=b;function g(k,v){return m(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,v,k.extensionEnvironment)}e.parsePtyHostPort=g;function m(k,v,L,h,c,p){const d=Number(v||k)||(h?null:L),E=d?Boolean(!!v):!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:d,break:E,debugId:c,env:t}}}),function(){"use strict";function x(e,T,O){function R(N,y){const f=D(N,y),l=[f];return e.isAbsolute(f)||l.unshift(O),e.resolve(...l)}function D(N,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,y);const b=N["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(g,"AppData","Roaming")}break;case"darwin":l=e.join(T.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,y)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[105],Q([156,33,35]),function(e,T,O){return x(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=x(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends O.AbstractNativeEnvironmentService{constructor(y,f){super(y,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,R.getUserDataPath)(y,f.nameShort)},f)}}e.NativeEnvironmentService=D}),define(Z[107],Q([0,1,4,90]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(N,y,f){try{D(N,y,f)}catch(l){console.error(l?.message??l)}return N}e.localizeManifest=R;function D(N,y,f){const l=(b,g,m)=>{const k=b[g];if((0,T.isString)(k)){const v=k,L=v.length;if(L>1&&v[0]==="%"&&v[L-1]==="%"){const h=v.substr(1,L-2);let c=y[h];c===void 0&&f&&(c=f[h]);const p=typeof c=="string"?c:c?.message,w=f?.[h],d=typeof w=="string"?w:w?.message;if(!p){d||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,h)}`);return}if(m&&(g==="title"||g==="category")&&d&&d!==p){const E={value:p,original:d};b[g]=E}else b[g]=p}}else if((0,T.isObject)(k))for(const v in k)k.hasOwnProperty(v)&&(v==="commands"?l(k,v,!0):l(k,v,m));else if(Array.isArray(k))for(let v=0;v<k.length;v++)l(k,v,m)};for(const b in N)N.hasOwnProperty(b)&&l(N,b)}}),define(Z[108],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(D,N){this.a.set(D,N)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const N in D.contributes){const y=this.a.get(N);if(!y)continue;const f=D.contributes[N],l=Array.isArray(f)?f:[f];try{y(l,D.activationEvents)}catch(b){(0,T.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Z[45],Q([0,1,18,53,94,41]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function f(c){return c=c.trim(),c==="*"||N.test(c)}e.isValidVersionStr=f;function l(c){if(!f(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(N);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=l;function b(c){if(!c)return null;const p=c.majorBase,w=c.majorMustEqual,d=c.minorBase;let E=c.minorMustEqual;const t=c.patchBase;let a=c.patchMustEqual;c.hasCaret&&(p===0||(E=!1),a=!1);let i=0;if(c.preRelease){const n=y.exec(c.preRelease);if(n){const[,r,s,o]=n;i=Date.UTC(Number(r),Number(s)-1,Number(o))}}return{majorBase:p,majorMustEqual:w,minorBase:d,minorMustEqual:E,patchBase:t,patchMustEqual:a,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function g(c,p,w){let d;typeof c=="string"?d=b(l(c)):d=c;let E;p instanceof Date?E=p.getTime():typeof p=="string"&&(E=new Date(p).getTime());let t;if(typeof w=="string"?t=b(l(w)):t=w,!d||!t)return!1;const a=d.majorBase,i=d.minorBase,n=d.patchBase;let r=t.majorBase,s=t.minorBase,o=t.patchBase;const u=t.notBefore;let S=t.majorMustEqual,M=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>s?!0:i<s||E&&E<u?!1:n>=o:(a===1&&r===0&&(!S||!M||!U)&&(r=1,s=0,o=0,S=!0,M=!1,U=!1),a<r?!1:a>r?!S:i<s?!1:i>s?!M:n<o?!1:n>o?!U:!(E&&E<u))}e.isValidVersion=g;function m(c,p,w,d,E){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof d.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!d.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!h(d.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!h(d.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const n=(0,T.joinPath)(w,d.main);(0,T.isEqualOrParent)(n,w)||t.push([O.default.Warning,R.localize(10,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,R.localize(11,null,"activationEvents","main")]),t}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([O.default.Error,R.localize(12,null,"browser")]),t;{const n=(0,T.joinPath)(w,d.browser);(0,T.isEqualOrParent)(n,w)||t.push([O.default.Warning,R.localize(13,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,R.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(d.version))return t.push([O.default.Error,R.localize(15,null)]),t;const a=[];if(!k(c,p,d,E,a))for(const n of a)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=m;function k(c,p,w,d,E){return d||typeof w.main>"u"&&typeof w.browser>"u"?!0:L(c,p,w.engines.vscode,E)}e.isValidExtensionVersion=k;function v(c,p,w){return c==="*"||L(p,w,c)}e.isEngineValid=v;function L(c,p,w,d=[]){const E=b(l(w));if(!E)return d.push(R.localize(16,null,w)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(R.localize(17,null,w)),!1}else if(!E.majorMustEqual)return d.push(R.localize(18,null,w)),!1;return g(c,p,E)?!0:(d.push(R.localize(19,null,c,w)),!1)}function h(c){if(!Array.isArray(c))return!1;for(let p=0,w=c.length;p<w;p++)if(typeof c[p]!="string")return!1;return!0}}),define(Z[109],Q([0,1,15,31]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(D,N,y){let f=y&&y.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const b=(await N.readFile(D.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(b)?b:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await N.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch{}}return y?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=R}),define(Z[46],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(R,D=[],N=!1){this.ctor=R,this.staticArguments=D,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Z[110],Q([0,1,46]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var R;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function D(y,f,l){f instanceof T.SyncDescriptor||(f=new T.SyncDescriptor(f,[],Boolean(l))),O.push([y,f])}e.registerSingleton=D;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(D,N){this.key=D,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const N of this.a.values())N.outgoing.size===0&&D.push(N);return D}insertEdge(D,N){const y=this.lookupOrInsertNode(D),f=this.lookupOrInsertNode(N);y.outgoing.set(f.key,f),f.incoming.set(y.key,y)}removeNode(D){const N=this.b(D);this.a.delete(N);for(const y of this.a.values())y.outgoing.delete(N),y.incoming.delete(N)}lookupOrInsertNode(D){const N=this.b(D);let y=this.a.get(N);return y||(y=new T(N,D),this.a.set(N,y)),y}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[N,y]of this.a)D.push(`${N}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,N]of this.a){const y=new Set([D]),f=this.c(N,y);if(f)return f}}c(D,N){for(const[y,f]of D.outgoing){if(N.has(y))return[...N,y].join(" -> ");N.add(y);const l=this.c(f,N);if(l)return l;N.delete(y)}}}e.Graph=O}),define(Z[23],Q([0,1,4,11,9]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=D;function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var y;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function l(c,p){const w=Object.create(null);for(const d in c)b(w,d,c[d],p);return w}e.toValuesTree=l;function b(c,p,w,d){const E=p.split("."),t=E.pop();let a=c;for(let i=0;i<E.length;i++){const n=E[i];let r=a[n];switch(typeof r){case"undefined":r=a[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${p} as ${E.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[t]=w}catch{d(`Ignoring ${p} as ${E.join(".")} is ${JSON.stringify(a)}`)}else d(`Ignoring ${p} as ${E.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=b;function g(c,p){const w=p.split(".");m(c,w)}e.removeFromValueTree=g;function m(c,p){const w=p.shift();if(p.length===0){delete c[w];return}if(Object.keys(c).indexOf(w)!==-1){const d=c[w];typeof d=="object"&&!Array.isArray(d)&&(m(d,p),Object.keys(d).length===0&&delete c[w])}}function k(c,p,w){function d(a,i){let n=a;for(const r of i){if(typeof n!="object"||n===null)return;n=n[r]}return n}const E=p.split("."),t=d(c,E);return typeof t>"u"?w:t}e.getConfigurationValue=k;function v(c,p,w){Object.keys(p).forEach(d=>{d!=="__proto__"&&(d in c?T.isObject(c[d])&&T.isObject(p[d])?v(c[d],p[d],w):w&&(c[d]=p[d]):c[d]=p[d])})}e.merge=v;function L(c,p,w){const d=c.inspect(p),E=c.inspect(w);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:d.defaultValue}e.getMigratedSettingValue=L;function h(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(Z[58],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Z[17],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[24],Q([0,1,88,9]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function D(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function N(c,p){switch(c){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function y(c,p){return p==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function f(c,p,w){return y(p,w)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===w?!0:l(w).includes(c)}e.isTargetPlatformCompatible=f;function l(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function b(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=b;var g;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(g=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var k;(function(c){c.Install="install",c.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var L;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((D,N)=>x(["node-vsce-sign"],async y=>D(y),N))),this.a}async verify(D,N){let y;try{y=await this.b()}catch{return!1}return y.verify(D,N)}}e.ExtensionSignatureVerificationService=O}),define(Z[60],Q([0,1,15,6,96,13]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(b,g,m,k,v,L){let h;try{await y(b,g,m,k,v,L)}catch(c){h=c}finally{h&&v.errorTransformer&&(h=v.errorTransformer(h)),typeof h<"u"&&m.error(h),m.end()}}e.readFileIntoStream=N;async function y(b,g,m,k,v,L){f(L);const h=await b.open(g,{create:!1});try{f(L);let c=0,p=0,w=v&&typeof v.length=="number"?v.length:void 0,d=T.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),E=v&&typeof v.position=="number"?v.position:0,t=0;do p=await b.read(h,E,d.buffer,t,d.byteLength-t),E+=p,t+=p,c+=p,typeof w=="number"&&(w-=p),t===d.byteLength&&(await m.write(k(d)),d=T.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),t=0);while(p>0&&(typeof w!="number"||w>0)&&f(L)&&l(c,v));if(t>0){let a=t;typeof w=="number"&&(a=Math.min(t,w)),m.write(k(d.slice(0,a)))}}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await b.close(h)}}function f(b){if(b.isCancellationRequested)throw(0,O.canceled)();return!0}function l(b,g){if(g?.limits){if(typeof g.limits.memory=="number"&&b>g.limits.memory)throw(0,D.createFileSystemProviderError)((0,R.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&b>g.limits.size)throw(0,D.createFileSystemProviderError)((0,R.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,3,157,2,12,158]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(l){const b=this.i(l),g=b.filter(k=>{const v=this.c.get(k.path);return v?!(0,O.patternsEquals)(v.request.excludes,k.excludes)||!(0,O.patternsEquals)(v.request.includes,k.includes):!0}),m=Array.from(this.c.values()).filter(({request:k})=>!b.find(v=>v.path===k.path&&(0,O.patternsEquals)(v.excludes,k.excludes)&&(0,O.patternsEquals)(v.includes,k.includes))).map(({request:k})=>k.path);g.length&&this.j(`Request to start watching: ${g.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const k of m)this.h(k);for(const k of g)this.g(k)}g(l){const b=new N.NodeJSFileWatcherLibrary(l,m=>this.a.fire(m),m=>this.b.fire(m),this.f),g={request:l,instance:b};this.c.set(l.path,g)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const b=this.c.get(l);b&&(this.c.delete(l),b.instance.dispose())}i(l){const b=new Map;for(const g of l){const m=D.isLinux?g.path:g.path.toLowerCase();b.set(m,g)}return Array.from(b.values())}async setVerboseLogging(l){this.f=l;for(const[,b]of this.c)b.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=y}),define(Z[113],Q([0,1,61,112]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends T.AbstractNonRecursiveWatcherClient{constructor(N,y,f){super(N,y,f),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends D.AbstractUniversalWatcherClient{constructor(f,l,b){super(f,l,b),this.m()}l(f){const l=f.add(new R.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:b,signal:g})=>this.n(`terminated by itself with code ${b}, signal: ${g}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...R){this.a=new Map;for(const[D,N]of R)this.set(D,N)}set(R,D){const N=this.a.get(R);return this.a.set(R,D),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=T}),define(Z[115],Q([0,1,5,6,2,46,111,9,62,159]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class g extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class m{constructor(h=new f.ServiceCollection,c=!1,p,w=b){this.f=h,this.g=c,this.h=p,this.i=w,this.o=new Set,this.f.set(y.IInstantiationService,this),this._globalGraph=w?p?._globalGraph??new N.Graph(d=>d):void 0}createChild(h){return new m(h,this.g,this,this.i)}invokeFunction(h,...c){const p=v.traceInvocation(this.i,h);let w=!1;try{return h({get:E=>{if(w)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(E,p);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...c)}finally{w=!0,p.stop()}}createInstance(h,...c){let p,w;return h instanceof D.SyncDescriptor?(p=v.traceCreation(this.i,h.ctor),w=this.j(h.ctor,h.staticArguments.concat(c),p)):(p=v.traceCreation(this.i,h),w=this.j(h,c,p)),p.stop(),w}j(h,c=[],p){const w=y._util.getServiceDependencies(h).sort((t,a)=>t.index-a.index),d=[];for(const t of w){const a=this.m(t.id,p);a||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(a)}const E=w.length>0?w[0].index:c.length;if(c.length!==E){console.trace(`[createInstance] First service dependency of ${h.name} at position ${E+1} conflicts with ${c.length} static arguments`);const t=E-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,E)}return Reflect.construct(h,c.concat(d))}k(h,c){if(this.f.get(h)instanceof D.SyncDescriptor)this.f.set(h,c);else if(this.h)this.h.k(h,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const c=this.f.get(h);return!c&&this.h?this.h.l(h):c}m(h,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const p=this.l(h);return p instanceof D.SyncDescriptor?this.q(h,p,c.branch(h,!0)):(c.branch(h,!1),p)}q(h,c,p){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,c,p)}finally{this.o.delete(h)}}r(h,c,p){const w=new N.Graph(t=>t.id.toString());let d=0;const E=[{id:h,desc:c,_trace:p}];for(;E.length;){const t=E.pop();if(w.lookupOrInsertNode(t),d++>1e3)throw new g(w);for(const a of y._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof D.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};w.insertEdge(t,n),E.push(n)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new g(w);break}for(const{data:a}of t){if(this.l(a.id)instanceof D.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}w.removeNode(a)}}return this.l(h)}s(h,c,p=[],w,d){if(this.f.get(h)instanceof D.SyncDescriptor)return this.t(h,c,p,w,d);if(this.h)return this.h.s(h,c,p,w,d);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(h,c,p=[],w,d){if(w){const E=new m(void 0,this.g,this,this.i);E.c=String(h);const t=new Map,a=new T.IdleValue(()=>{const i=E.j(c,p,d);for(const[n,r]of t){const s=i[n];if(typeof s=="function")for(const o of r)s.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new l.LinkedList,t.set(n,o)),(S,M,U)=>{const Y=o.push([S,M,U]);return(0,R.toDisposable)(Y)}}if(n in i)return i[n];const r=a.value;let s=r[n];return typeof s!="function"||(s=s.bind(r),i[n]=s),s},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return c.prototype}})}else return this.j(c,p,d)}u(h,c){if(c&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=m;var k;(function(L){L[L.None=0]="None",L[L.Creation=1]="Creation",L[L.Invocation=2]="Invocation",L[L.Branch=3]="Branch"})(k||(k={}));class v{static traceInvocation(h,c){return h?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(h,c){return h?new v(1,c.name):v.c}constructor(h,c){this.type=h,this.name=c,this.g=Date.now(),this.h=[]}branch(h,c){const p=new v(3,h.toString());return this.h.push([h,c,p]),p}stop(){const h=Date.now()-this.g;v.f+=h;let c=!1;function p(d,E){const t=[],a=new Array(d+1).join("	");for(const[i,n,r]of E.h)if(n&&r){c=!0,t.push(`${a}CREATES -> ${i}`);const s=p(d+1,r);s&&t.push(s)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(h>2||c)&&v.all.add(w.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0});var _=this&&this.__param||function(x,e){return function(T,O){e(T,O,x)}};define(Z[63],Q([0,1,22,2,12,98,24,9]),function(x,e,T,O,R,D,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(b){return b.tags.find(g=>g.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,y.createDecorator)("languagePackService");let l=class extends O.Disposable{constructor(g){super(),this.c=g}async getAvailableLanguages(){const g=new T.CancellationTokenSource;setTimeout(()=>g.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},g.token)}catch{return[]}const v=m.firstPage.filter(L=>L.properties.localizedLanguages?.length&&L.tags.some(h=>h.startsWith("lp-"))).map(L=>{const h=L.properties.localizedLanguages?.[0],c=f(L);return{...this.f(c,h,L),extensionId:L.identifier.id,galleryExtension:L}});return v.push({...this.f("en","English"),extensionId:"default"}),v}f(g,m,k){const v=m??g;let L;if(v!==g&&(L=`(${g})`),g.toLowerCase()===R.language.toLowerCase()&&(L??="",L+=(0,D.localize)(0,null)),k?.installCount){L??="";const h=k.installCount;let c;h>1e6?c=`${Math.floor(h/1e5)/10}M`:h>1e3?c=`${Math.floor(h/1e3)}K`:c=String(h),L+=` $(cloud-download) ${c}`}return{id:g,label:v,description:L}}};l=de([_(0,N.IExtensionGalleryService)],l),e.LanguagePackBaseService=l}),define(Z[10],Q([0,1,34,3,2,36,12,9]),function(x,e,T,O,R,D,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function f(){return new Date().toISOString()}var l;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function b(r,s,o){switch(s){case l.Trace:r.trace(o);break;case l.Debug:r.debug(o);break;case l.Info:r.info(o);break;case l.Warning:r.warn(o);break;case l.Error:r.error(o);break;case l.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=b;function g(r){let s="";for(let o=0;o<r.length;o++){let u=r[o];if(typeof u=="object")try{u=JSON.stringify(u)}catch{}s+=(o>0?" ":"")+u}return s}e.format=g;class m extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==l.Off&&this.b<=s}}e.AbstractLogger=m;class k extends m{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...o){this.f(l.Trace)&&this.g(l.Trace,g([s,...o]))}debug(s,...o){this.f(l.Debug)&&this.g(l.Debug,g([s,...o]))}info(s,...o){this.f(l.Info)&&this.g(l.Info,g([s,...o]))}warn(s,...o){this.f(l.Warning)&&this.g(l.Warning,g([s,...o]))}error(s,...o){if(this.f(l.Error))if(s instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=s.stack,this.g(l.Error,g(u))}else this.g(l.Error,g([s,...o]))}flush(){}}e.AbstractMessageLogger=k;class v extends m{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!N.isWindows}trace(s,...o){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,s,...o):console.log(`[main ${f()}]`,s,...o))}debug(s,...o){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,s,...o):console.log(`[main ${f()}]`,s,...o))}info(s,...o){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,s,...o):console.log(`[main ${f()}]`,s,...o))}warn(s,...o){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,s,...o):console.warn(`[main ${f()}]`,s,...o))}error(s,...o){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,s,...o):console.error(`[main ${f()}]`,s,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class L extends m{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...o){this.f(l.Trace)&&console.log("%cTRACE","color: #888",s,...o)}debug(s,...o){this.f(l.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...o)}info(s,...o){this.f(l.Info)&&console.log("%c INFO","color: #33f",s,...o)}warn(s,...o){this.f(l.Warning)&&console.log("%c WARN","color: #993",s,...o)}error(s,...o){this.f(l.Error)&&console.log("%c  ERR","color: #f33",s,...o)}dispose(){}flush(){}}e.ConsoleLogger=L;class h extends m{constructor(s,o=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(o)}trace(s,...o){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(s),...o])}debug(s,...o){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(s),...o])}info(s,...o){this.f(l.Info)&&this.g.log(l.Info,[this.h(s),...o])}warn(s,...o){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(s),...o])}error(s,...o){this.f(l.Error)&&this.g.log(l.Error,[this.h(s),...o])}h(s){return typeof s=="string"?s:(0,T.toErrorMessage)(s,this.f(l.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class c extends m{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const o of this.g)o.setLevel(s);super.setLevel(s)}trace(s,...o){for(const u of this.g)u.trace(s,...o)}debug(s,...o){for(const u of this.g)u.debug(s,...o)}info(s,...o){for(const u of this.g)u.info(s,...o)}warn(s,...o){for(const u of this.g)u.warn(s,...o)}error(s,...o){for(const u of this.g)u.error(s,...o)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=c;class p extends R.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...o){this.b.trace(s,...o)}debug(s,...o){this.b.debug(s,...o)}info(s,...o){this.b.info(s,...o)}warn(s,...o){this.b.warn(s,...o)}error(s,...o){this.b.error(s,...o)}flush(){this.b.flush()}}e.LogService=p;class w extends R.Disposable{constructor(s,o,u){if(super(),this.h=s,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new O.Emitter),this.onDidChangeLoggerResources=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeLogLevel=this.g.event,this.B(o(S=>this.j(S))),u)for(const S of u)this.c.set(S.resource,S)}getLogger(s){return this.b.get(s)}createLogger(s,o,u){let S=this.b.get(s);return S||(u=o?.always?l.Trace:u,S=this.k(s,u??this.getLogLevel(s)??this.h,o),this.b.set(s,S),this.registerLoggerResource({resource:s,logLevel:u,name:o?.name})),S}setLogLevel(s,o){const u=this.c.get(s);u&&o!==u.logLevel&&(u.logLevel=o===this.h?void 0:o,this.b.get(s)?.setLevel(o),this.c.set(u.resource,u),this.g.fire(u))}j(s){this.h=s;for(const[o,u]of this.b.entries())this.c.get(o)?.logLevel===void 0&&u.setLevel(this.h)}getLogLevel(s){return this.c.get(s)?.logLevel}registerLoggerResource(s){this.c.get(s.resource)||(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLoggerResource(s){const o=this.c.get(s);o&&(this.c.delete(s),this.f.fire({added:[],removed:[o]}))}getLoggerResources(){return this.c.values()}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=w;class d{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(s){}getLevel(){return l.Info}trace(s,...o){}debug(s,...o){}info(s,...o){}warn(s,...o){}error(s,...o){}critical(s,...o){}dispose(){}flush(){}}e.NullLogger=d;class E extends d{}e.NullLogService=E;class t extends w{constructor(){super(l.Info,O.Event.None)}k(s,o,u){return new d}}e.NullLoggerService=t;function a(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const s=n(r.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function i(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=i;function n(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=n}),define(Z[116],Q([0,1,19,5,6,3,2,14,61,10]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends N.Disposable{constructor(m,k){super(),this.a=m,this.b=k,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(m,k){return k.recursive||this.b?.watcher?.forceUniversal?this.l(m,k):this.u(m,k)}l(m,k){const v={path:this.C(m),excludes:k.excludes,includes:k.includes,recursive:k.recursive},L=(0,T.insert)(this.j,v);return this.m(),(0,N.toDisposable)(()=>{L(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,R.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(k=>this.c.fire((0,f.toFileChanges)(k)),k=>this.z(k),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const k of this.j)(0,f.isRecursiveWatchRequest)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const k of this.j)(0,f.isRecursiveWatchRequest)(k)&&m.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,k){const v={path:this.C(m),excludes:k.excludes,includes:k.includes,recursive:!1},L=(0,T.insert)(this.s,v);return this.v(),(0,N.toDisposable)(()=>{L(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,R.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,f.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,y.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Z[117],Q([0,1,19,5,15,22,3,52,64,2,54,16,118,18,43,95,13,60,10,6]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends l.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new h.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,k.isAbsolutePath)(t))throw new h.FileOperationError((0,L.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new w.ErrorNoTelemetry;throw i.message=(0,L.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a)||(0,h.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,h.toFileSystemProviderErrorCode)(i)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,L.localize)(2,null,this.nb(t)),1):(0,h.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),r=a?.resolveTo,s=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,u=await i.stat(t);let S;return this.p(i,t,u,void 0,!!o,(M,U)=>(S||(S=b.TernarySearchTree.forUris(()=>!n),S.set(t,!0),r&&S.fill(!0,r)),S.get(M.resource)||S.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?U===1:!1))}async p(t,a,i,n,r,s){const{providerExtUri:o}=this.N(t),u={resource:a,name:o.basename(a),isFile:(i.type&h.FileType.File)!==0,isDirectory:(i.type&h.FileType.Directory)!==0,isSymbolicLink:(i.type&h.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&h.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,h.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(u.isDirectory&&s(u,n)){try{const S=await t.readdir(a),M=await O.Promises.settled(S.map(async([U,Y])=>{try{const X=o.joinPath(a,U),ee=r?await t.stat(X):{type:Y};return await this.p(t,X,ee,S.length,r,s)}catch(X){return this.b.trace(X),null}}));u.children=(0,T.coalesce)(M)}catch(S){this.b.trace(S),u.children=[]}return u}return u}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new h.FileOperationError((0,L.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=R.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new h.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let o;if((0,h.hasReadWriteCapability)(n)&&!(a instanceof R.VSBuffer))if((0,v.isReadableStream)(a)){const u=await(0,v.peekStream)(a,3);u.ended?o=R.VSBuffer.concat(u.buffer):o=u}else o=(0,v.peekReadable)(a,u=>R.VSBuffer.concat(u),3);else o=a;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&o instanceof R.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof R.VSBuffer?(0,R.bufferToReadable)(o):o),this.m.fire(new h.FileOperationEvent(t,4))}catch(s){throw new h.FileOperationError((0,L.localize)(4,null,this.nb(t),(0,h.ensureFileSystemProviderError)(s).toString()),(0,h.toFileOperationResult)(s),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,L.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,L.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==h.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,h.etag)({mtime:i.mtime,size:r.size}))throw new h.FileOperationError((0,L.localize)(7,null),3,i);return r}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((r,s)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,a,i,n);r(o)}catch(o){s(o)}})})}async u(t,a,i,n){const r=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const r=new D.CancellationTokenSource(n),s=this.F(a,i).then(u=>u,u=>{throw r.cancel(),u});let o;try{return typeof i?.etag=="string"&&i.etag!==h.ETAG_DISABLED&&await s,i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)||!((0,h.hasOpenReadWriteCloseCapability)(t)||(0,h.hasFileReadStreamCapability)(t))||(0,h.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,a,i):(0,h.hasFileReadStreamCapability)(t)?o=this.z(t,a,r.token,i):o=this.C(t,a,r.token,i),{...await s,value:o}}catch(u){throw o&&await(0,v.consumeStream)(o),this.w(u,a,i)}}w(t,a,i){const n=(0,L.localize)(8,null,this.nb(a),(0,h.ensureFileSystemProviderError)(t).toString());return t instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new h.FileOperationError(n,(0,h.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,v.transform)(r,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>this.w(s,a,n)},s=>R.VSBuffer.concat(s))}C(t,a,i,n=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,c.readFileIntoStream)(t,a,r,s=>s,{...n,bufferSize:this.a,errorTransformer:s=>this.w(s,a,n)},i),r}D(t,a,i){const n=(0,v.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(a,r.byteLength,i),n.end(R.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new h.FileOperationError((0,L.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==h.ETAG_DISABLED&&a.etag===i.etag)throw new h.NotModifiedSinceFileOperationError((0,L.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&a>i.limits.size&&(n=7),typeof n=="number")throw new h.TooLargeFileOperationError((0,L.localize)(11,null,this.nb(t)),n,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),s=this.lb(await this.l(a),a);await this.M(r,t,s,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),s=await this.I(n,t,r,a,"move",!!i),o=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,s==="move"?2:3,o)),o}async copy(t,a,i){const n=await this.k(t),r=this.lb(await this.l(a),a),s=await this.I(n,t,r,a,"copy",!!i),o=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,s==="copy"?3:2,o)),o}async I(t,a,i,n,r,s){if(a.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:u}=await this.M(t,a,i,n,r,s);if(o&&!u&&s&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,h.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:s});else{const S=await this.resolve(a);S.isDirectory?await this.L(t,S,i,n):await this.J(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:s}),r):(await this.I(t,a,i,n,"copy",s),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async r=>{const s=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,s):this.J(t,r.resource,i,s)}))}async M(t,a,i,n,r,s){let o=!1;if(t===i){const{providerExtUri:S,isPathCaseSensitive:M}=this.N(t);if(M||(o=S.isEqual(a,n)),o&&r==="copy")throw new Error((0,L.localize)(12,null,this.nb(a),this.nb(n)));if(!o&&S.isEqualOrParent(n,a))throw new Error((0,L.localize)(13,null,this.nb(a),this.nb(n)))}const u=await this.exists(n);if(u&&!o){if(!s)throw new h.FileOperationError((0,L.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(a,n))throw new Error((0,L.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:u,isSameResourceWithDifferentPathCase:o}}N(t){const a=this.O(t);return{providerExtUri:a?k.extUri:k.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(((await t.stat(a)).type&h.FileType.Directory)===0)throw new Error((0,L.localize)(16,null,this.nb(a)));break}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(s){if((0,h.toFileSystemProviderErrorCode)(s)!==h.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,L.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new h.FileOperationError((0,L.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,L.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,r=!!a?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new h.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,h.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,h.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,l.toDisposable)(()=>r())),(async()=>{try{const s=await this.W(t,a);n?(0,l.dispose)(s):r=()=>(0,l.dispose)(s)}catch(s){this.b.error(s)}})(),i}async W(t,a){const i=await this.j(t),n=(0,y.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.U.set(n,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await t.close(r)}})}async Z(t,a,i){let n=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=R.VSBuffer.concat(i.buffer);await this.bb(t,a,s,s.byteLength,n,0),n+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((s,o)=>{(0,v.listenStream)(r,{onData:async u=>{r.pause();try{await this.bb(t,a,u,u.byteLength,n,0)}catch(S){return o(S)}n+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>o(u),onEnd:()=>s()})})}async ab(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,a,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,a,i,n,r,s){let o=0;for(;o<n;)o+=await t.write(a,r+o,i.buffer,s+o,n-o)}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let r;n instanceof R.VSBuffer?r=n:(0,v.isReadableStream)(n)?r=await(0,R.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?r=await(0,R.bufferedStreamToBuffer)(n):r=(0,R.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let r,s;try{r=await t.open(a,{create:!1}),s=await i.open(n,{create:!0,unlock:!1});const o=R.VSBuffer.alloc(this.a);let u=0,S=0,M=0;do M=await t.read(r,u,o.buffer,S,o.byteLength-S),await this.bb(i,s,o,M,u,S),u+=M,S+=M,S===o.byteLength&&(S=0);while(M>0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const s=await t.readFile(a);await this.bb(i,r,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async kb(t,a,i,n){const r=await(0,R.streamToBuffer)(this.C(t,a,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new h.FileOperationError((0,L.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,L.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===g.Schemas.file?t.fsPath:t.toString(!0)}};d=de([_(0,p.ILogService)],d),e.FileService=d}),define(Z[119],Q([0,1,120,160,5,36,15,3,161,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(a){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(a)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=y.Event.None,this.H=new D.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,g.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await v.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await v.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async s=>{try{let o;s.isSymbolicLink()?o=(await this.stat((0,m.joinPath)(i,s.name))).type:o=this.G(s),r.push([s.name,o])}catch(o){this.a.trace(o)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=h.FileType.Unknown:i.isFile()?r=h.FileType.File:i.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const s=new R.Barrier;return this.H.set(i,s),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===s&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const s=this.C(i);return await v.Promises.readFile(s)}catch(s){throw this.Y(s)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const s=(0,k.newWriteableStream)(o=>N.VSBuffer.concat(o.map(u=>N.VSBuffer.wrap(u))).buffer);return(0,c.readFileIntoStream)(this,i,s,o=>o.buffer,{...n,bufferSize:256*1024},r),s}async writeFile(i,n,r){let s;try{const o=this.C(i);if(!r.create||!r.overwrite){if(await v.Promises.exists(o)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,L.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,L.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof s=="number"&&await this.close(s)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let s;(0,h.isFileOpenForWriteOptions)(n)&&(s=await this.I(i));let o;try{if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await v.SymlinkSupport.stat(r);S.mode&128||await v.Promises.chmod(r,S.mode|128)}catch(S){this.a.trace(S)}let u;if((0,h.isFileOpenForWriteOptions)(n)){if(g.isWindows)try{await v.Promises.truncate(r,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}u||(u="w")}else u="r";o=await v.Promises.open(r,u)}catch(u){throw s?.dispose(),(0,h.isFileOpenForWriteOptions)(n)?await this.Z(i,u):this.Y(u)}if(this.L.set(o,0),(0,h.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),s){const u=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,s),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),u.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await v.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await v.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,s,o){const u=this.P(i,n);let S=null;try{S=(await v.Promises.read(i,r,s,o,u)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,u,S)}return S}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const s=this.L.get(i);typeof s=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,s+r):this.L.delete(i)))}async write(i,n,r,s,o){return(0,R.retry)(()=>this.R(i,n,r,s,o),100,3)}async R(i,n,r,s,o){const u=this.P(i,n);let S=null;try{S=(await v.Promises.write(i,r,s,o,u)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,u,S)}return S}async mkdir(i){try{await v.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await v.Promises.rm(r,v.RimRafMode.MOVE):await v.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const s=this.C(i),o=this.C(n);if(s!==o)try{await this.S(i,n,"move",r.overwrite),await v.Promises.move(s,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,L.localize)(2,null,(0,b.basename)(s),(0,b.basename)((0,b.dirname)(o)),u.toString()))),this.Y(u)}}async copy(i,n,r){const s=this.C(i),o=this.C(n);if(s!==o)try{await this.S(i,n,"copy",r.overwrite),await v.Promises.copy(s,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,L.localize)(3,null,(0,b.basename)(s),(0,b.basename)((0,b.dirname)(o)),u.toString()))),this.Y(u)}}async S(i,n,r,s){const o=this.C(i),u=this.C(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,f.isEqual)(o,u,!0)),S&&r==="copy")throw(0,h.createFileSystemProviderError)((0,L.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!S&&await v.Promises.exists(u)){if(!s)throw(0,h.createFileSystemProviderError)((0,L.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const s=this.C(i),o=this.C(n),u=!!(this.capabilities&1024);if((0,f.isEqual)(s,o,!u))return;const S=new l.DisposableStore;try{const[M,U]=await Promise.all([this.I(i),this.I(n)]);S.add(M),S.add(U),r&&await v.Promises.mkdir((0,b.dirname)(o),{recursive:!0}),await v.Promises.copyFile(s,o)}catch(M){if(M.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(M)}finally{S.dispose()}}p(i,n,r){return new d.UniversalWatcherClient(s=>i(s),s=>n(s),r)}y(i,n,r){return new E.NodeJSWatcherClient(s=>i(s),s=>n(s),r)}Y(i){if(i instanceof h.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await v.SymlinkSupport.stat(this.C(i));s.mode&128||(r=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[121],Q([0,1,13,10]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function D(l,b,g,m,k){try{const v=await new Promise((h,c)=>{x(["spdlog"],h,c)});v.setFlushOn(R.Trace);const L=await v.createAsyncRotatingLogger(l,b,g,m);return k?L.clearFormatters():L.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),L}catch(v){console.error(v)}return null}function N(l,b,g){switch(b){case O.LogLevel.Trace:l.trace(g);break;case O.LogLevel.Debug:l.debug(g);break;case O.LogLevel.Info:l.info(g);break;case O.LogLevel.Warning:l.warn(g);break;case O.LogLevel.Error:l.error(g);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function y(l,b){switch(b){case O.LogLevel.Trace:l.setLevel(R.Trace);break;case O.LogLevel.Debug:l.setLevel(R.Debug);break;case O.LogLevel.Info:l.setLevel(R.Info);break;case O.LogLevel.Warning:l.setLevel(R.Warning);break;case O.LogLevel.Error:l.setLevel(R.Error);break;case O.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class f extends O.AbstractMessageLogger{constructor(b,g,m,k,v){super(),this.k=[],this.setLevel(v),this.l=this.n(b,g,m,k),this.B(this.onDidChangeLogLevel(L=>{this.m&&y(this.m,L)}))}async n(b,g,m,k){const v=m?6:1,L=30/v*T.ByteSize.MB,h=await D(b,g,L,v,k);if(h){this.m=h,y(this.m,this.getLevel());for(const{level:c,message:p}of this.k)N(this.m,c,p);this.k=[]}}g(b,g){this.m?N(this.m,b,g):this.getLevel()<=b&&this.k.push({level:b,message:g})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(Z[38],Q([0,1,3,64,2,9]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class N extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const b=Object.keys(this.f).length;return this.f={...l,...this.f},b!==Object.keys(this.f).length&&await this.i(l),O.Iterable.reduce(this.g.entries(),(g,[m,k])=>({...g,[m]:k}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(l,[b,g])=>({...l,[b]:{definition:g,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=N;class y{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(Z[122],Q([0,1,5,3,64,4,13,10,38]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(g,m){const k=[];for(const v of new Set(R.Iterable.concat(g.keys(),m.keys())))g.get(v)!==m.get(v)&&k.push(v);return k}let b=class extends f.AbstractPolicyService{constructor(m,k,v){super(),this.j=m,this.k=k,this.l=v,this.c=this.B(new T.ThrottledDelayer(500));const L=O.Event.filter(k.onDidFilesChange,h=>h.affects(m));this.B(k.watch(m)),this.B(L(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const k=await this.k.readFile(this.j),v=JSON.parse(k.value.toString());if(!(0,D.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const L of Object.keys(v))this.f[L]&&m.set(L,v[L])}catch(k){k.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",k)}return m}async p(){const m=await this.n(),k=l(this.g,m);this.g=m,k.length>0&&this.h.fire(k)}};b=de([_(1,N.IFileService),_(2,y.ILogService)],b),e.FilePolicyService=b}),define(Z[28],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(N,y){T.ok(O.isString(N)),T.ok(O.isObject(y)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,y)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new R}),define(Z[123],Q([0,1,3,37]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class D{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[R(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const N=new D;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Z[42],Q([0,1,19,3,4,86,23,123,37]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const g=f.Registry.as(y.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const s in n)if(a.add(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o=this.a.get(s),u=o?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[s]))u.set(Y,r);const S={...o?.value||{},...n[s]};this.a.set(s,{source:r,value:S,valuesSources:u});const M=(0,N.getLanguageTagSettingPlainKey)(s),U={type:"object",default:S,description:D.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:R.isString(r)?void 0:r,defaultValueSource:r};i.push(...L(s)),this.d[s]=U,this.b.properties[s]=U}else{this.a.set(s,{value:n[s],source:r});const o=this.d[s];o&&(this.w(s,o),this.r(s,o))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const s=this.a.get(r),o=R.isString(n)?n:n?.id,u=R.isString(s?.source)?s?.source:s?.source?.id;if(o===u)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const S=this.d[r];S&&(this.w(r,S),this.r(r,S))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const s=this.d[r];s?.policy?.name&&this.e.delete(s.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,i,n,r=3,s){r=R.isUndefinedOrNull(t.scope)?r:t.scope;const o=t.properties;if(o)for(const S in o){const M=o[S];if(a&&w(S,M)){delete o[S];continue}if(M.source=i,M.defaultDefaultValue=o[S].default,this.w(S,M),e.OVERRIDE_PROPERTY_REGEX.test(S)?M.scope=void 0:(M.scope=R.isUndefinedOrNull(M.scope)?r:M.scope,M.restricted=R.isUndefinedOrNull(M.restricted)?!!n?.includes(S):M.restricted),o[S].hasOwnProperty("included")&&!o[S].included){this.f[S]=o[S],delete o[S];continue}else this.d[S]=o[S],o[S].policy?.name&&this.e.set(o[S].policy.name,S);!o[S].deprecationMessage&&o[S].markdownDeprecationMessage&&(o[S].deprecationMessage=o[S].markdownDeprecationMessage),s.add(S)}const u=t.allOf;if(u)for(const S of u)this.p(S,a,i,n,r,s)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const s in n)this.r(s,n[s]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,r=i?.source;R.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),R.isUndefined(n)&&(n=c(a.type)),a.default=n,a.defaultValueSource=r}}const k="\\[([^\\]]+)\\]",v=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function L(E){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let a=v.exec(E);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=v.exec(E)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=L;function h(E){return E.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=h;function c(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const p=new m;f.Registry.add(e.Extensions.Configuration,p);function w(E,t){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?D.localize(7,null,E):p.getConfigurationProperties()[E]!==void 0?D.localize(8,null,E):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,E,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=w;function d(){const E=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))E.push([a,t[a].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(Z[65],Q([0,1,19,3,50,2,36,30,4,11,23,42,37]),function(x,e,T,O,R,D,N,y,f,l,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(a){return Object.isFrozen(a)?a:y.deepFreeze(a)}class v{constructor(i={},n=[],r=[],s){this.b=i,this.c=n,this.d=r,this.raw=s,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof v)return n;const r=new L("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),s=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:s,merged:o}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,b.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return T.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=y.deepClone(this.contents),r=y.deepClone(this.overrides),s=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const u of i)if(o.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(n,u.contents);for(const S of u.overrides){const[M]=r.filter(U=>T.equals(U.identifiers,S.identifiers));M?(this.h(M.contents,S.contents),M.keys.push(...S.keys),M.keys=T.distinct(M.keys)):r.push(y.deepClone(S))}for(const S of u.keys)s.indexOf(S)===-1&&s.push(S)}return new v(n,s,r,o.every(u=>u instanceof v)?void 0:o)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const s of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[s];const u=n[s];u&&(typeof o=="object"&&typeof u=="object"?(o=y.deepClone(o),this.h(o,u)):o=u),r[s]=o}return new v(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&f.isObject(i[r])&&f.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=y.deepClone(n[r])}}i(i){let n=null,r=null;const s=o=>{o&&(r?this.h(r,o):r=y.deepClone(o))};for(const o of this.overrides)T.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&s(o.contents);return s(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.removeFromValueTree)(this.contents,i),g.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,g.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,b.addToValueTree)(this.contents,i,n,s=>console.error(s)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),g.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,g.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],s=>console.error(s))})}}e.ConfigurationModel=v;class L{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!f.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:s,overrides:o,restricted:u,hasExcludedProperties:S}=this.h(i,n);this.b=new v(r,s,o,S?[i]:void 0),this.c=u||[]}g(i){let n={},r=null,s=[];const o=[],u=[];function S(U){Array.isArray(s)?s.push(U):r!==null&&(s[r]=U)}const M={onObjectBegin:()=>{const U={};S(U),o.push(s),s=U,r=null},onObjectProperty:U=>{r=U},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const U=[];S(U),o.push(s),s=U,r=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:S,onError:(U,Y,X)=>{u.push({error:U,offset:Y,length:X})}};if(i)try{R.visit(i,M),n=s[0]||{}}catch(U){console.error(`Error while parsing settings file ${this.f}: ${U}`),this.d=[U]}return n}h(i,n){const r=m.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),s=this.i(i,r,!0,n);i=s.raw;const o=(0,b.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),u=Object.keys(i),S=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:o,keys:u,overrides:S,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}i(i,n,r,s){let o=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const u={},S=[];for(const M in i)if(g.OVERRIDE_PROPERTY_REGEX.test(M)&&r){const U=this.i(i[M],n,!1,s);u[M]=U.raw,o=o||U.hasExcludedProperties,S.push(...U.restricted)}else{const U=n[M],Y=U?typeof U.scope<"u"?U.scope:3:void 0;U?.restricted&&S.push(M),(Y===void 0||s.scopes===void 0||s.scopes.includes(Y))&&!(s.skipRestricted&&U?.restricted)?u[M]=i[M]:o=!0}return{raw:u,restricted:S,hasExcludedProperties:o}}j(i,n){const r=[];for(const s of Object.keys(i))if(g.OVERRIDE_PROPERTY_REGEX.test(s)){const o={};for(const u in i[s])o[u]=i[s][u];r.push({identifiers:(0,g.overrideIdentifiersFromKey)(s),keys:Object.keys(o),contents:(0,b.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=L;class h extends D.Disposable{constructor(i,n,r,s){super(),this.f=i,this.g=n,this.h=s,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new L(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class c{constructor(i,n,r,s,o,u,S,M,U,Y,X,ee,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=s,this.d=o,this.f=u,this.g=S,this.h=M,this.i=U,this.j=Y,this.k=X,this.l=ee,this.m=ie}get value(){return k(this.c)}n(i,n,r){const s=i.inspect(n,r);return{get value(){return k(s.value)},get override(){return k(s.override)},get merged(){return k(s.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(i,n,r,s,o=new v,u=new v,S=new N.ResourceMap,M=new v,U=new N.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=s,this.h=o,this.i=u,this.j=S,this.l=M,this.m=U,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let s;r.resource?(s=this.m.get(r.resource),s||(s=new v,this.m.set(r.resource,s))):s=this.l,n===void 0?s.removeValue(i):s.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const s=this.q(i,n,r),o=this.u(n.resource,r),u=n.resource?this.m.get(n.resource)||this.l:this.l,S=new Set;for(const M of s.overrides)for(const U of M.identifiers)s.getOverrideValue(i,U)!==void 0&&S.add(U);return new c(i,n,s.getValue(i),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,o||void 0,u)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:s,updated:o,removed:u}=E(this.c,i);n=[...s,...o,...u]}for(const s of n)for(const o of(0,g.overrideIdentifiersFromKey)(s)){const u=this.c.getKeysForOverrideIdentifier(o),S=i.getKeysForOverrideIdentifier(o),M=[...S.filter(U=>u.indexOf(U)===-1),...u.filter(U=>S.indexOf(U)===-1),...u.filter(U=>!y.equals(this.c.override(o).getValue(U),i.override(o).getValue(U)))];r.push([o,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:s}=E(this.d,i),o=[...n,...r,...s];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:s,overrides:o}=E(this.applicationConfiguration,i),u=[...n,...r,...s];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:s,overrides:o}=E(this.localUserConfiguration,i),u=[...n,...r,...s];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:s,overrides:o}=E(this.remoteUserConfiguration,i),u=[...n,...r,...s];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:s,overrides:o}=E(this.workspaceConfiguration,i),u=[...n,...r,...s];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:s,updated:o,removed:u,overrides:S}=E(r,n),M=[...s,...o,...u];return(M.length||!r)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:S}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:o,overrides:u}=E(n,void 0);return{keys:[...r,...s,...o],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let s=this.r(n,r);return n.overrideIdentifier&&(s=s.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(s=s.merge(this.d)),s}r({resource:i},n){let r=this.s();if(n&&i){const s=n.getFolder(i);s&&(r=this.t(s.uri)||r);const o=this.m.get(i);o&&(r=r.merge(o))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),s=this.j.get(i);s?(n=r.merge(s),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:s,keys:o}=this.j.get(n);return i.push([n,{contents:r,overrides:s,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),s=this.x(i.application),o=this.x(i.user),u=this.x(i.workspace),S=i.folders.reduce((M,U)=>(M.set(l.URI.revive(U[0]),this.x(U[1])),M),new N.ResourceMap);return new p(n,r,s,o,new v,u,S,new v,new N.ResourceMap)}static x(i){return new v(i.contents,i.keys,i.overrides)}}e.Configuration=p;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const s of a)s.keys.forEach(o=>i.add(o)),s.overrides.forEach(([o,u])=>{const S=(0,N.getOrSet)(n,o,new Set);u.forEach(M=>S.add(M))});const r=[];return n.forEach((s,o)=>r.push([o,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=w;class d{constructor(i,n,r,s){this.change=i,this.f=n,this.g=r,this.h=s,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const u of o)this.affectedKeys.add(u);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,s=this.d.indexOf(r);if(s<0)return!1;const o=s+r.length;if(o>=this.d.length)return!1;const u=this.d.charCodeAt(o);if(u!==this.b&&u!==this.c)return!1;if(n){const S=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,M=this.g.getValue(i,n,this.h);return!y.equals(S,M)}return!0}}e.ConfigurationChangeEvent=d;function E(a,i){const{added:n,removed:r,updated:s}=t(i?.rawConfiguration,a?.rawConfiguration),o=[],u=a?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const M=S.filter(U=>!u.includes(U));for(const U of M)o.push([U,i.getKeysForOverrideIdentifier(U)])}if(a){const M=u.filter(U=>!S.includes(U));for(const U of M)o.push([U,a.getKeysForOverrideIdentifier(U)])}if(i&&a){for(const M of u)if(S.includes(M)){const U=t({contents:a.getOverrideValue(void 0,M)||{},keys:a.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});o.push([M,[...U.added,...U.removed,...U.updated]])}}return{added:n,removed:r,updated:s,overrides:o}}function t(a,i){const n=a?i?a.keys.filter(o=>i.keys.indexOf(o)===-1):[...a.keys]:[],r=i?a?i.keys.filter(o=>a.keys.indexOf(o)===-1):[...i.keys]:[],s=[];if(a&&i){for(const o of i.keys)if(a.keys.indexOf(o)!==-1){const u=(0,b.getConfigurationValue)(i.contents,o),S=(0,b.getConfigurationValue)(a.contents,o);y.equals(u,S)||s.push(o)}}return{added:n,removed:r,updated:s}}}),define(Z[124],Q([0,1,19,3,2,30,4,65,42,10,38,37]),function(x,e,T,O,R,D,N,y,f,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new y.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(g.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:c})=>this.c(Array.from(h),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(h,c){this.h(h,g.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:h})}f(){return{}}g(){this.b=new y.ConfigurationModel;const h=g.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(h),h)}h(h,c){const p=this.f();for(const w of h){const d=p[w],E=c[w];d!==void 0?this.b.addValue(w,d):E?this.b.addValue(w,E.default):this.b.removeValue(w)}}}e.DefaultConfiguration=m;class k{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new y.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=k;let v=class extends R.Disposable{get configurationModel(){return this.b}constructor(h,c,p){super(),this.c=h,this.f=c,this.g=p,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new y.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.i(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.j(await this.h(h),!0))),this.b}async h(h){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",h);const c={},p=[],w=g.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const d of h){const E=w[d];if(!E){p.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}p.push(d),c[E.policy.name]={type:E.type}}}return(0,N.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),p}i(h){this.g.trace("PolicyConfiguration#onDidChangePolicies",h);const c=g.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),p=(0,T.coalesce)(h.map(w=>c.get(w)));this.j(p,!0)}j(h,c){this.g.trace("PolicyConfiguration#update",h);const p=g.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),w=[],d=this.b.isEmpty();for(const E of h){const t=p[E]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(d?a!==void 0:!(0,D.equals)(this.b.getValue(E),a))&&w.push([E,a])}else this.b.getValue(E)!==void 0&&w.push([E,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const E=this.b;this.b=new y.ConfigurationModel;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,a]of w)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);c&&this.a.fire(this.b)}}};v=de([_(1,b.IPolicyService),_(2,l.ILogService)],v),e.PolicyConfiguration=v}),define(Z[125],Q([0,1,5,3,2,18,23,65,124,38]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends R.Disposable{constructor(m,k,v,L){super(),this.i=m,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=v instanceof l.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,v,L)),this.f=this.B(new y.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,k)),this.a=new y.Configuration(this.b.configurationModel,this.c.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:c})=>this.k(h,c))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,k,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.Configuration(m,k,new y.ConfigurationModel,v)}getConfigurationData(){return this.a.toData()}getValue(m,k){const v=typeof m=="string"?m:void 0,L=(0,N.isConfigurationOverrides)(m)?m:(0,N.isConfigurationOverrides)(k)?k:{};return this.a.getValue(v,L,void 0)}updateValue(m,k,v,L){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const k=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(v,k,2)}k(m,k){const v=this.a.toData(),L=this.a.compareAndUpdateDefaultConfiguration(m,k);this.m(L,v,7)}l(m){const k=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(m);this.m(v,k,7)}m(m,k,v){const L=new y.ConfigurationChangeEvent(m,{data:k},this.a);L.source=v,L.sourceConfig=this.n(v),this.h.fire(L)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Z[66],Q([0,1,16]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(l){return l.scheme===T.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=O;function R(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.getRemoteName=R;function D(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=D;function N(l){const{host:b,port:g}=f(l);if(typeof g>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:g}}e.parseAuthorityWithPort=N;function y(l,b){let{host:g,port:m}=f(l);return typeof m>"u"&&(m=b),{host:g,port:m}}e.parseAuthorityWithOptionalPort=y;function f(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const g=l.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const m=l.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:l,port:void 0}}}),define(Z[29],Q([0,1,32,9,66]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=D;function N(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var f;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(f=e.TargetPlatform||(e.TargetPlatform={}));class l{constructor(L){this.value=L,this.c=L.toLowerCase()}static equals(L,h){if(typeof L>"u"||L===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof L=="string"||typeof h=="string"){const c=typeof L=="string"?L:L.value,p=typeof h=="string"?h:h.value;return T.equalsIgnoreCase(c,p)}return L.c===h.c}static toKey(L){return typeof L=="string"?L.toLowerCase():L.c}}e.ExtensionIdentifier=l;function b(v){return g(v)}e.isApplicationScopedExtension=b;function g(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function k(v,L){if(L){const h=`onResolveRemoteAuthority:${(0,R.getRemoteName)(L)}`;return v.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[126],Q([0,1,2,14,20,29]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(f,l){super(),this.b=f,this.a=(0,O.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(l.onDidInstallExtensions(b=>this.c(b))),this.B(l.onDidUninstallExtension(b=>this.f(b)))}c(f){f.some(l=>!!l.local)&&this.invalidate()}f(f){f.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Z[47],Q([0,1,15,99,42,9,37]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function y(L){return L.res.statusCode&&L.res.statusCode>=200&&L.res.statusCode<300||L.res.statusCode===1223}e.isSuccess=y;function f(L){return L.res.statusCode===204}async function l(L){return f(L)?null:(await(0,T.streamToBuffer)(L.stream)).toString()}e.asText=l;async function b(L){if(!y(L))throw new Error("Server returned "+L.res.statusCode);return l(L)}e.asTextOrError=b;async function g(L){if(!y(L))throw new Error("Server returned "+L.res.statusCode);if(f(L))return null;const c=(await(0,T.streamToBuffer)(L.stream)).toString();try{return JSON.parse(c)}catch(p){throw p.message+=`:
`+c,p}}e.asJson=g;function m(L){v(L)}e.updateProxyConfigurationsScope=m;let k;function v(L){const h=N.Registry.as(R.Extensions.Configuration),c=k;k={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:L,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[k],remove:c?[c]:[]})}v(2)}),define(Z[127],Q([0,1,22,16,13,47]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(f,l){this.a=f,this.b=l}async download(f,l,b=T.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.b.copy(f,l);return}const g={type:"GET",url:f.toString(!0)},m=await this.a.request(g,b);if(m.res.statusCode===200)await this.b.writeFile(l,m.stream);else{const k=await(0,D.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${k}`)}}};N=de([_(0,D.IRequestService),_(1,R.IFileService)],N),e.DownloadService=N}),define(Z[128],Q([0,1,129,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(N,y){return N.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:N.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function D(N,y,f={}){const l=(0,T.parse)(N),b=f.proxyUrl||R(l,y);if(!b)return null;const g=(0,T.parse)(b);if(!/^https?:$/.test(g.protocol||""))return null;const m={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((k,v)=>{x(["http-proxy-agent"],k,v)}))(m):new(await new Promise((k,v)=>{x(["https-proxy-agent"],k,v)}))(m)}e.getProxyAgent=D}),define(Z[130],Q([0,1,57,14,100,22,34,6,12,31,82,162,5,71]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let v;async function L(c,p,w,d){return w["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(d)&&!w["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(d)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=m.Promises.withAsyncBody(async(E,t)=>{const a=new D.CancellationTokenSource;let i=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,k.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{E(await h(p,a.token))}catch(s){!(0,y.isCancellationError)(s)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.toErrorMessage)(s)))):E({})}finally{clearTimeout(r),a.dispose()}})),v)}e.getResolvedShellEnv=L;async function h(c,p){const w=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",w);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",d);const E=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",a);const i=await(0,b.getSystemShell)(f.OS,a);return c.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(p.isCancellationRequested)return r(new y.CancellationError);const s=(0,O.basename)(i);let o,u;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(o=`& '${process.execPath}' ${S} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,u=["-Login","-Command"]):(o=`'${process.execPath}' ${S} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,s==="tcsh"||s==="csh"?u=["-ic"]:u=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),o);const M=(0,T.spawn)(i,[...u,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(M.kill(),r(new y.CancellationError))),M.on("error",X=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),r(X)});const U=[];M.stdout.on("data",X=>U.push(X));const Y=[];M.stderr.on("data",X=>Y.push(X)),M.on("close",(X,ee)=>{const ie=Buffer.concat(U).toString("utf8");c.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&c.trace("getUnixShellEnvironment#stderr",ne),X||ee)return r(new Error((0,R.localize)(2,null,X,ee)));const ae=t.exec(ie),fe=ae?ae[1]:"{}";try{const re=JSON.parse(fe);w?re.ELECTRON_RUN_AS_NODE=w:delete re.ELECTRON_RUN_AS_NODE,d?re.ELECTRON_NO_ATTACH_CONSOLE=d:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",re),n(re)}catch(re){c.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(re)),r(re)}})})}}),define(Z[67],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Z[131],Q([0,1,5,15,4,17,13,10]),function(x,e,T,O,R,D,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(g,m,k){this.f=g,this.g=m,this.h=k,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.g.error(g)}}getItem(g,m){const k=this.a[g];return(0,R.isUndefinedOrNull)(k)?m:k}setItem(g,m){this.setItems([{key:g,data:m}])}setItems(g){let m=!1;for(const{key:k,data:v}of g)this.a[k]!==v&&((0,R.isUndefinedOrNull)(v)?(0,R.isUndefined)(this.a[k])||(this.a[k]=void 0,m=!0):(this.a[k]=v,m=!0));m&&this.j()}removeItem(g){(0,R.isUndefined)(this.a[g])||(this.a[g]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(g)),this.b=g}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=f;let l=class{constructor(g,m,k){this.a=new f(g.stateResource,m,k)}async init(){await this.a.init()}getItem(g,m){return this.a.getItem(g,m)}};l=de([_(0,D.IEnvironmentService),_(1,y.ILogService),_(2,N.IFileService)],l),e.StateService=l}),define(Z[68],Q([0,1,12,35,11,31]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(l){if(T.platform===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}async function y(l,b,g,m,k,v,L,h,c,p){const w=Object.create(null);w["common.machineId"]=L,w.sessionID=(0,D.generateUuid)()+Date.now(),w.commitHash=k,w.version=v,w["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,T.PlatformToString)(T.platform),w["common.nodePlatform"]=O.platform,w["common.nodeArch"]=m,w["common.product"]=p||"desktop",h&&(w["common.msftInternal"]=h);let d=0;const E=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),T.isLinuxSnap&&(w["common.snap"]="true");const t=N(g);t&&(w["common.platformDetail"]=t);try{const a=await l.readFile(R.URI.file(c));w["common.source"]=a.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=y;function f(l){const b=O.env.USERDNSDOMAIN;if(!b)return!1;const g=b.toLowerCase();return l.some(m=>g===m)}e.verifyMicrosoftInternalDomain=f}),define(Z[25],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,30,4,3,23,66,68,25]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(o){this.value=o}}e.TelemetryTrustedValue=l;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class g{async publicLog(o,u,S){}async publicLogError(o,u,S){}}e.NullEndpointTelemetryService=g,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,o){return R.Event.debounce(o.onDidChangeConfiguration,(S,M)=>{const U=S?new Set([...S.affectedKeys,...M.affectedKeys]):M.affectedKeys;return{...M,affectedKeys:U}},1e3,!0)(S=>{S.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(S.source),configurationKeys:d(S.affectedKeys)})})}e.configurationTelemetry=m;function k(s,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!s.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=k;function v(s,o){return!(o.isBuilt||o.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=v;function L(s){const o=s.getValue(f.TELEMETRY_SETTING_ID),u=s.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=L;function h(s){const o={},u={},S={};w(s,S);for(let M in S){M=M.length>150?M.substr(M.length-149):M;const U=S[M];typeof U=="number"?u[M]=U:typeof U=="boolean"?u[M]=U?1:0:typeof U=="string"?(U.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${U.length}`),o[M]=U.substring(0,8191)):typeof U<"u"&&U!==null&&(o[M]=U)}return{properties:o,measurements:u}}e.validateTelemetryData=h;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(s){if(!s)return"none";const o=(0,N.getRemoteName)(s);return c.has(o)?o:"other"}e.cleanRemoteAuthority=p;function w(s,o,u=0,S){if(!!s)for(const M of Object.getOwnPropertyNames(s)){const U=s[M],Y=S?S+M:M;Array.isArray(U)?o[Y]=(0,T.safeStringify)(U):U instanceof Date?o[Y]=U.toISOString():(0,O.isObject)(U)?u<2?w(U,o,u+1,Y+"."):o[Y]=(0,T.safeStringify)(U):o[Y]=U}}function d(s){if(!s)return[];const o=[];return E(o,"",s),o}function E(s,o,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(S=>E(s,o?`${o}.${S}`:S,u[S])):s.push(o)}function t(s,o){const u=s.msftInternalDomains||[],S=o.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(u)||S}e.isInternalTelemetry=t;function a(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(s,o){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let u=s;const S=[];for(const X of o)for(;;){const ee=X.exec(s);if(!ee)break;S.push([ee.index,X.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,U=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(u="";;){const X=U.exec(s);if(!X)break;const ee=S.some(([ie,ne])=>X.index<ne&&ie<U.lastIndex);!M.test(X[0])&&!ee&&(u+=s.substring(Y,X.index)+"<REDACTED: user-file-path>",Y=U.lastIndex)}return Y<s.length&&(u+=s.substr(Y)),u}function n(s){if(!s)return s;const o=s.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of u)if(S.regex.test(o))return`<REDACTED: ${S.label}>`;return s}function r(s,o){return(0,T.cloneAndChange)(s,u=>{if(u instanceof l)return u.value;if(typeof u=="string"){let S=u.replaceAll("%20"," ");S=i(S,o);for(const M of o)S=S.replace(M,"");return S=n(S),S}})}e.cleanData=r}),define(Z[26],Q([0,1,32,24,29,12,11,6,35,39]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,T.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=b;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,r,s)}static parse(n){const r=g.exec(n);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(i){const n=k.exec(i);return n&&n[1]?[h(n[1]),n[2]]:[h(i),void 0]}e.getIdAndVersion=v;function L(i,n){return`${i}.${n}`}e.getExtensionId=L;function h(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function c(i,n){return h(L(i,n))}e.getGalleryExtensionId=c;function p(i,n){const r=[],s=o=>{for(const u of r)if(u.some(S=>b(n(S),n(o))))return u;return null};for(const o of i){const u=s(o);u?u.push(o):r.push([o])}return r}e.groupByExtension=p;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function d(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(i,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const o=s.shift();if(o&&r.every(u=>!b(u.identifier,{id:o}))){const u=i.filter(S=>b(S.identifier,{id:o}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=E;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function a(i,n){const r=await t(i,n),s=(0,O.getTargetPlatform)(r?"alpine":D.platform,f.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=a}),define(Z[132],Q([0,1,22,6,16,18,41,11,89,24,26,29]),function(x,e,T,O,R,D,N,y,f,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=h=>(0,f.localize)(0,null,h),k=(0,f.localize)(1,null,"ms-dotnettools.csharp");function v(h,c){return c?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}let L=class{constructor(c,p){this.a=c,this.b=p}get d(){}async listExtensions(c,p,w,d=console){let E=await this.a.getInstalled(1,w);const t=g.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(p&&p!==""){if(t.indexOf(p.toLowerCase())<0){d.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}E=E.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){d.log("Possible Categories: "),t.forEach(i=>{d.log(i)});return}this.d&&d.log((0,f.localize)(2,null,this.d)),E=E.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let a;for(const i of E)a!==i.identifier.id&&(a=i.identifier.id,d.log(v(i.manifest,c)))}async installExtensions(c,p,w,d,E=console){const t=[],a=[];c.length&&E.log(this.d?(0,f.localize)(3,null,this.d):(0,f.localize)(4,null));const i=await this.a.getInstalled(1,w.profileLocation),n=(u,S)=>{const M=i.find(U=>(0,b.areSameExtensions)(U.identifier,{id:u}));if(M){if(!d&&(!S||S==="prerelease"&&M.preRelease))return E.log((0,f.localize)(5,null,u,M.manifest.version,u)),!1;if(S&&M.manifest.version===S)return E.log((0,f.localize)(6,null,`${u}@${S}`)),!1}return!0},r=(u,S,M)=>{o.push({id:u,version:S!=="prerelease"?S:void 0,installOptions:{...w,isBuiltin:M,installPreReleaseVersion:S==="prerelease"||w.installPreReleaseVersion}})},s=[],o=[];for(const u of c)if(u instanceof y.URI)s.push(u);else{const[S,M]=(0,b.getIdAndVersion)(u);n(S,M)&&r(S,M,!1)}for(const u of p){const[S,M]=(0,b.getIdAndVersion)(u);n(S,M)&&r(S,M,!0)}if(s.length&&await Promise.all(s.map(async u=>{try{const S=await this.f(u,{...w,isBuiltin:!1},d,E);S&&a.push(S)}catch(S){E.error(S.message||S.stack||S),t.push(u.toString())}})),o.length){const u=await this.g(o);await Promise.all(o.map(async S=>{const M=u.get(S.id.toLowerCase());if(M)try{const U=await this.h(S,M,i,d,E);U&&a.push(U)}catch(U){E.error(U.message||U.stack||U),t.push(S.id)}else E.error(`${m(S.version?`${S.id}@${S.version}`:S.id)}
${k}`),t.push(S.id)}))}if(t.length)throw new Error((0,f.localize)(7,null,t.join(", ")))}async f(c,p,w,d){const E=await this.a.getManifest(c);if(!E)throw new Error("Invalid vsix");if(await this.k(E,w,p.profileLocation,d))try{return await this.a.install(c,p),d.log((0,f.localize)(8,null,(0,D.basename)(c))),E}catch(a){if((0,O.isCancellationError)(a))return d.log((0,f.localize)(9,null,(0,D.basename)(c))),null;throw a}return null}async g(c){const p=new Map,w=c.some(E=>E.installOptions.installPreReleaseVersion),d=await this.b.getExtensions(c.map(E=>({...E,preRelease:w})),T.CancellationToken.None);for(const E of d)p.set(E.identifier.id.toLowerCase(),E);return p}async h({id:c,version:p,installOptions:w},d,E,t,a){const i=await this.b.getManifest(d,T.CancellationToken.None);if(i&&!this.j(i,a))return null;const n=E.find(r=>(0,b.areSameExtensions)(r.identifier,d.identifier));if(n){if(d.version===n.manifest.version)return a.log((0,f.localize)(10,null,p?`${c}@${p}`:c)),null;a.log((0,f.localize)(11,null,c,d.version))}try{w.isBuiltin?a.log(p?(0,f.localize)(12,null,c,p):(0,f.localize)(13,null,c)):a.log(p?(0,f.localize)(14,null,c,p):(0,f.localize)(15,null,c));const r=await this.a.installFromGallery(d,{...w,installGivenVersion:!!p});return a.log((0,f.localize)(16,null,c,r.manifest.version)),i}catch(r){if((0,O.isCancellationError)(r))return a.log((0,f.localize)(17,null,c)),null;throw r}}j(c,p){return!0}async k(c,p,w,d){const E={id:(0,b.getGalleryExtensionId)(c.publisher,c.name)},a=(await this.a.getInstalled(1,w)).find(i=>(0,b.areSameExtensions)(E,i.identifier)&&(0,N.gt)(i.manifest.version,c.version));return a&&!p?(d.log((0,f.localize)(18,null,a.identifier.id,a.manifest.version,c.version)),!1):this.j(c,d)}async uninstallExtensions(c,p,w,d=console){const E=async a=>{if(a instanceof y.URI){const i=await this.a.getManifest(a);return v(i)}return a},t=[];for(const a of c){const i=await E(a),r=(await this.a.getInstalled(void 0,w)).filter(s=>(0,b.areSameExtensions)(s.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${k}`);if(r.some(s=>s.type===0)){d.log((0,f.localize)(19,null,i));return}if(!p&&r.some(s=>s.isBuiltin)){d.log((0,f.localize)(20,null,i));return}d.log((0,f.localize)(21,null,i));for(const s of r)await this.a.uninstall(s,{profileLocation:w}),t.push(s);this.d?d.log((0,f.localize)(22,null,i,this.d)):d.log((0,f.localize)(23,null,i))}}async locateExtension(c,p=console){const w=await this.a.getInstalled();c.forEach(d=>{w.forEach(E=>{if(E.identifier.id===d&&E.location.scheme===R.Schemas.file){p.log(E.location.fsPath);return}})})}l(c){return this.d?(0,f.localize)(24,null,c,this.d):(0,f.localize)(25,null,c)}};L=de([_(0,l.IExtensionManagementService),_(1,l.IExtensionGalleryService)],L),e.ExtensionManagementCLI=L}),define(Z[133],Q([0,1,5,6,2,16,12,18,41,4,31,20,23,17,24,26,59,13,10,28]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Ve extends R.Disposable{constructor(t,a,i,n,r,s,o){super(),this.h=a,this.i=i,this.j=n,this.k=r,this.l=s,this.m=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,a){await this.g;const i=(0,y.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,r=>this.i.download(t,r,a))}catch(r){throw new v.ExtensionManagementError(r.message,v.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const r=await this.r(t);try{await this.l.verify(i.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(s){const o=s.code;if(o==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(i),new v.ExtensionManagementError(o,v.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,l.isBoolean)(a)?a:this.k.quality!=="stable"}async r(t){await this.g;const a=(0,y.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${Ve.c}`);return await this.t(t,a,i=>this.i.downloadSignatureArchive(t,i)),a}async t(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==D.Schemas.file){await i(a);return}const n=(0,y.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.m.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async u(t,a,i){try{await g.Promises.rename(t.fsPath,a.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.u(t,a,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const o of t.children)if(o.name.endsWith(Ve.c))n.push(o.resource);else{const u=L.ExtensionKey.parse(o.name);u&&i.push([u,o])}const r=(0,L.groupByExtension)(i,([o])=>o),s=[];for(const o of r)o.sort((u,S)=>f.rcompare(u[0].version,S[0].version)),a.push(...o.slice(1).map(u=>u[1].resource)),s.push(o[0][1]);s.sort((o,u)=>o.mtime-u.mtime),a.push(...s.slice(0,Math.max(0,s.length-this.f)).map(o=>o.resource)),a.push(...n),await T.Promises.settled(a.map(o=>(this.m.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(t){this.m.error(t)}}w(t){return this.f?L.ExtensionKey.create(t).toString().toLowerCase():(0,b.generateUuid)()}};d.c=".sigzip",d=de([_(0,k.INativeEnvironmentService),_(1,c.IFileService),_(2,v.IExtensionGalleryService),_(3,m.IConfigurationService),_(4,w.IProductService),_(5,h.IExtensionSignatureVerificationService),_(6,p.ILogService)],d),e.ExtensionsDownloader=d}),define(Z[134],Q([0,1,3,2,36,26,29]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class y extends O.Disposable{constructor(l,b,g,m,k,v,L){super(),this.f=l,this.g=b,this.h=g,this.i=m,this.j=k,this.k=v,this.l=L,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,h=>L.error(h))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added,l.removed))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l,b){try{await Promise.all(b.map(g=>(this.c.deleteAndDispose(g.id),this.z(g.extensionsResource)))),l.length&&await Promise.all(l.map(g=>(this.c.set(g.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(g.extensionsResource)),this.k.watch(g.extensionsResource))),this.y(g.extensionsResource))))}catch(g){throw this.l.error(g),g}}async r(l){for(const b of l.extensions)this.D(this.G(b.identifier,b.version),l.profileLocation)}async s(l){for(const b of l.extensions){const g=this.G(b.identifier,b.version);l.error?this.F(g,l.profileLocation):this.D(g,l.profileLocation)}}async t(l){for(const b of l.extensions)this.F(this.G(b.identifier,b.version),l.profileLocation)}async u(l){let b=!1;for(const g of l.extensions){const m=this.G(g.identifier,g.version);l.error?this.D(m,l.profileLocation):(this.F(m,l.profileLocation),b=b||!this.b.has(m))}b&&await this.C()}v(l){for(const b of this.h.profiles)l.contains(b.extensionsResource,0,1)&&this.w(b.extensionsResource)}async w(l){const b=[],g=[],m=await this.i.scanProfileExtensions(l),k=new Set,v=new Set;for(const[L,h]of this.b)h.has(l)&&v.add(L);for(const L of m){const h=this.G(L.identifier,L.version);k.add(h),v.has(h)||(b.push(L.identifier),this.D(h,l))}for(const L of v)if(!k.has(L)){const h=this.H(L);h&&(g.push(h.identifier),this.F(L,l))}(b.length||g.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:l}:void 0,removed:g.length?{extensions:g,profileLocation:l}:void 0})}async y(l){const b=await this.i.scanProfileExtensions(l);for(const g of b)this.D(this.G(g.identifier,g.version),l)}async z(l){for(const b of[...this.b.keys()])this.F(b,l);await this.C()}async C(){const b=(await this.f.getAllUserInstalled()).filter(g=>g.installedTimestamp&&!this.b.has(this.G(g.identifier,g.manifest.version)));b.length&&await this.f.markAsUninstalled(...b)}D(l,b){let g=this.b.get(l);g||this.b.set(l,g=new R.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),g.add(b)}F(l,b){const g=this.b.get(l);g&&g.delete(b),g?.size||this.b.delete(l)}G(l,b){return`${N.ExtensionIdentifier.toKey(l.id)}@${b}`}H(l){const[b,g]=(0,D.getIdAndVersion)(l);return g?{identifier:{id:b},version:g}:void 0}}e.ExtensionsWatcher=y}),define(Z[135],Q([0,1,109,39]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(D,N,y,f,l,b,g){const m={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,y)&&(0,O.getTelemetryLevel)(f)===3){const k=await(0,T.getServiceMachineId)(y,l,b),{machineId:v}=await g.getTelemetryInfo();m["X-Market-User-Id"]=k,m["VSCode-SessionId"]=v||k}return m}e.resolveMarketplaceHeaders=R}),define(Z[136],Q([0,1,163,19,5,2,16,14,20,17,24,26,10,63,12,11]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends k.LanguagePackBaseService{constructor(d,E,t,a){super(t),this.h=d,this.i=a,this.g=this.B(new c(E,a)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(d){const t=(await this.g.getLanguagePacks())[v.Language.value()];if(!t){this.i.warn(`No language pack found for ${v.Language.value()}`);return}const a=t.translations[d];return a?L.URI.file(a):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),E=Object.keys(d).map(t=>{const a=d[t];return{...this.f(t,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return E.push({...this.f("en","English"),extensionId:"default"}),E.sort((t,a)=>t.label.localeCompare(a.label)),E}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const E=await this.g.getLanguagePacks();Object.keys(E).some(t=>E[t]&&E[t].extensions.some(a=>(0,g.areSameExtensions)(a.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(E);return!(0,O.equals)(Object.keys(d),Object.keys(t))}};h=de([_(0,b.IExtensionManagementService),_(1,l.INativeEnvironmentService),_(2,b.IExtensionGalleryService),_(3,m.ILogService)],h),e.NativeLanguagePackService=h;let c=class extends D.Disposable{constructor(d,E){super(),this.i=E,this.c={},this.f=(0,y.join)(d.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(E=>{Object.keys(E).forEach(t=>delete E[t]),this.j(E,...d)}).then(()=>this.c)}j(d,...E){for(const t of E)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(d,t);Object.keys(d).forEach(t=>this.l(d[t]))}k(d,E){const t=E.identifier,a=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const i of a)if(E.location.scheme===N.Schemas.file&&p(i)){let n=d[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=n);const r=n.extensions.filter(s=>(0,g.areSameExtensions)(s.extensionIdentifier,t))[0];r?r.version=E.manifest.version:n.extensions.push({extensionIdentifier:t,version:E.manifest.version});for(const s of i.translations)n.translations[s.id]=(0,y.join)(E.location.fsPath,s.path)}}l(d){if(d){const E=(0,T.createHash)("md5");for(const t of d.extensions)E.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);d.hash=E.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let E=null;return f.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(E=d(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const a=JSON.stringify(this.c);return this.i.debug("Writing language packs",a),f.Promises.writeFile(this.f,a)}).then(()=>E,t=>this.i.error(t))})}};c=de([_(0,l.INativeEnvironmentService),_(1,m.ILogService)],c);function p(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const d of w.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Z[137],Q([0,1,6,30,39]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function y(l,b,g){const m=await new Promise((c,p)=>{x(["@microsoft/1ds-core-js"],c,p)}),k=await new Promise((c,p)=>{x(["@microsoft/1ds-post-js"],c,p)}),v=new m.AppInsightsCore,L=new k.PostChannel,h={instrumentationKey:l,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[L]]};if(g){h.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[L.identifier]=c}return v.initialize(h,[]),v.addTelemetryInitializer(c=>{b&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),v}class f{constructor(b,g,m,k,v){this.e=b,this.f=g,this.g=m,this.h=v,this.c=D,this.d=N,this.g||(this.g={}),typeof k=="function"?this.a=k():this.a=k,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=y(this.a,this.e,this.h)),this.b.then(g=>{b(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(b,g){if(!this.a)return;g=(0,O.mixin)(g,this.g),g=(0,R.validateTelemetryData)(g);const m=this.f+"/"+b;try{this.i(k=>{k.pluginVersionString=g?.properties.version??"Unknown",k.track({name:m,baseData:{name:m,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(Z[138],Q([0,1,2,30,12,32,101,23,42,139,28,37,25,39]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(c,p,w){this.k=p,this.l=w,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=c.appenders,this.c=c.commonProperties||Promise.resolve({}),this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(m.TELEMETRY_SETTING_ID)||d.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||d.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,k.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const w=p.usage?3:p.error?2:0;c=Math.min(c,w)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const c=await this.c,p=c.sessionID,w=c["common.machineId"],d=c["common.firstSessionDate"],E=c["common.msftInternal"];return{sessionId:p,machineId:w,firstSessionDate:d,msftInternal:E}}dispose(){this.i.dispose()}n(c,p,w){return this.g<p?Promise.resolve(void 0):this.c.then(d=>{w=(0,O.mixin)(w,this.d),w=(0,k.cleanData)(w,this.j),w=(0,O.mixin)(w,d),this.b.forEach(E=>E.log(c,w))},d=>{console.error(d)})}publicLog(c,p){return this.n(c,3,p)}publicLog2(c,p){return this.publicLog(c,p)}publicLogError(c,p){return this.h?this.n(c,2,p):Promise.resolve(void 0)}publicLogError2(c,p){return this.publicLogError(c,p)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=de([_(1,y.IConfigurationService),_(2,b.IProductService)],v),e.TelemetryService=v;function L(){const h=(0,N.localize)(0,null,l.default.nameLong),c=l.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.isWeb?"":(0,N.localize)(3,null),w=(0,N.localize)(4,null),d=(0,N.localize)(5,null),E=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${w} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${h} ${c} ${p}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}g.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:L(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,N.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,N.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[140],Q([0,1,164,137]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends O.AbstractOneDataSystemAppender{constructor(N,y,f,l){const b={sendPOST:(g,m)=>{const k={method:"POST",headers:{...g.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(g.data)}};try{const v=T.request(g.urlString,k,L=>{L.on("data",function(h){m(L.statusCode??200,L.headers,h.toString())}),L.on("error",function(h){m(0,{})})});v.write(g.data),v.end()}catch{m(0,{})}}};super(N,y,f,l,b)}}e.OneDataSystemAppender=R}),define(Z[141],Q([0,1,14,20]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function R(D,N){const y=Object.create(null),f=(b,g)=>{const m=JSON.parse(b);y[g]=m};if(N){const b=[],g=await O.Promises.readdir(N);for(const k of g)try{(await O.Promises.stat((0,T.join)(N,k))).isDirectory()&&b.push(k)}catch{}const m=[];for(const k of b)(await O.Promises.readdir((0,T.join)(N,k))).filter(L=>L==="telemetry.json").length===1&&m.push(k);for(const k of m){const v=(await O.Promises.readFile((0,T.join)(N,k,"telemetry.json"))).toString();f(v,k)}}let l=(await O.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return f(l,"vscode-core"),l=(await O.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),f(l,"vscode-extensions"),JSON.stringify(y,null,4)}e.buildTelemetryMessage=R}),define(Z[142],Q([0,1,12,80,25]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(N){let y=N.getItem(R.machineIdKey);return(typeof y!="string"||T.isMacintosh&&y==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(y=await(0,O.getMachineId)()),y}e.resolveMachineId=D}),define(Z[27],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Z[143],Q([0,1,27,110,13,18,72,3,2]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(m){this.uri=m,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let b=class{constructor(m){this.g=m,this.c=new f.DisposableStore,this.f=2**16;const k=new Map,v=L=>{let h=k.get(L.scheme);return h===void 0&&(h=m.hasProvider(L)&&!this.g.hasCapability(L,1024),k.set(L.scheme,h)),h};this.c.add(y.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(L=>{k.delete(L.scheme)})),this.extUri=new D.ExtUri(v),this.d=new N.SkipList((L,h)=>this.extUri.compare(L,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,D.normalizePath)(m));const k=this.d.get(m);return k?k.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new l(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((v,L)=>v[1].touch<L[1].touch?1:v[1].touch>L[1].touch?-1:0);l._clock=0,this.d.clear();const k=this.f*.5;for(let v=0;v<k;v++)this.d.set(m[v][0],m[v][1].touch())}};b=de([_(0,R.IFileService)],b),e.UriIdentityService=b,(0,O.registerSingleton)(T.IUriIdentityService,b,1)}),define(Z[144],Q([0,1,103,14,54,18,11,9,16]),function(x,e,T,O,R,D,N,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function g(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=g;function m(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function k(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=k;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function L(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=L;function h(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class c{constructor(n,r,s,o,u){this.h=n,this.j=s,this.k=o,this.l=u,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function w(i){return new p({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function E(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=E;function t(i,n){return!d(i,n)&&!E(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,O.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(Z[21],Q([0,1,52,3,2,18,11,102,17,13,9,10,144,36,27,5,31,32,4]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function d(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=d;function E(i,n,r,s){return{id:i,name:n,location:r,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=E;let t=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,s,o){super(),this.m=n,this.n=r,this.r=s,this.s=o,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new k.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,p.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}n.push(E((0,D.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const r=new k.ResourceMap,s=new Map,o=E((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,y.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...o,extensionsResource:this.L()??o.extensionsResource,isDefault:!0}),n.length){const u=this.I();if(u.workspaces)for(const[S,M]of Object.entries(u.workspaces)){const U=N.URI.parse(S),Y=N.URI.parse(M),X=n.find(ee=>this.r.extUri.isEqual(ee.location,Y));X&&r.set(U,X)}if(u.emptyWindows)for(const[S,M]of Object.entries(u.emptyWindows)){const U=N.URI.parse(M),Y=n.find(X=>this.r.extUri.isEqual(X.location,U));Y&&s.set(S,Y)}}this.t={profiles:n,workspaces:r,emptyWindows:s}}return this.t}async createTransientProfile(n){const r="Temp",s=new RegExp(`${(0,c.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const S of this.profiles){const M=s.exec(S.name),U=M?parseInt(M[1]):0;o=U>o?U:o}const u=`${r} ${o+1}`;return this.createProfile((0,T.hash)((0,h.generateUuid)()).toString(16),u,{transient:!0},n)}async createNamedProfile(n,r,s){return this.createProfile((0,T.hash)((0,h.generateUuid)()).toString(16),n,r,s)}async createProfile(n,r,s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(n,r,s);return o&&await this.setProfileForWorkspace(o,u),u}async v(n,r,s){if(!(0,p.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const u=this.profiles.find(U=>U.name===r||U.id===n);if(u)return u;const S=E(n,r,(0,D.joinPath)(this.profilesHome,n),s);await this.n.createFolder(S.location);const M=[];return this.h.fire({profile:S,join(U){M.push(U)}}),await L.Promises.settled(M),this.z([S],[],[]),S}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);return s=E(s.id,r.name??s.name,s.location,{shortName:r.shortName??s.shortName,transient:r.transient??s.isTransient,useDefaultFlags:r.useDefaultFlags??s.useDefaultFlags}),this.z([],[],[s]),s}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this.i.fire({profile:r,join(o){s.push(o)}});try{await Promise.allSettled(s)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(o=>o.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,s)}unsetWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.r.extUri.isEqual(s.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,s){const o=[...this.profiles,...n],u=[];this.l.profiles=[];for(let S of o)S.isDefault||r.some(M=>S.id===M.id)||(S=s.find(M=>S.id===M.id)??S,S.isTransient?this.l.profiles.push(S):u.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.H(u),this.t=void 0,this.C(n,r,s)}C(n,r,s){this.g.fire({added:n,removed:r,updated:s,all:this.profiles})}D(n,r,s){s=r?.isTransient?!0:s,s||this.D(n,void 0,!0);const o=this.w(n),u=s?this.l:this.u;N.URI.isUri(o)?(u.workspaces.delete(o),r&&u.workspaces.set(o,r)):(u.emptyWindows.delete(o),r&&u.emptyWindows.set(o,r)),s||this.F()}F(){const n={};for(const[s,o]of this.u.workspaces.entries())n[s.toString()]=o.location.toString();const r={};for(const[s,o]of this.u.emptyWindows.entries())r[s.toString()]=o.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=de([_(0,f.IEnvironmentService),_(1,l.IFileService),_(2,v.IUriIdentityService),_(3,g.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=a}),define(Z[145],Q([0,1,19,5,22,6,3,2,12,11,87,24,26,29,10,28,25,21]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var p;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(p=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let w=class extends y.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,s,o,u){super(),this.t=n,this.u=r,this.v=s,this.w=o,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,y.toDisposable)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.k.forEach(S=>S.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,g.isTargetPlatformCompatible)(s,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new g.ExtensionManagementError(b.localize(0,null),g.ExtensionManagementErrorCode.Internal);const s=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(s.manifest,s.extension,r)}catch(s){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(n),error:s}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(s),E(s)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,s){const o={...s,installOnlyNewlyAddedFromExtensionPack:l.URI.isUri(r)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,k.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},u=ee=>`${m.ExtensionKey.create(ee).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!l.URI.isUri(r)){const ee=this.j.get(u(r));if(ee){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await ee.task.waitUntilTaskIsFinished();return ie}}const S=[],M=[],U=[],Y=this.Q(n,r,o);l.URI.isUri(r)||this.j.set(u(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:o.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),S.push({task:Y,manifest:n});let X=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ae,manifest:fe}of(0,T.distinct)(ie,({gallery:re})=>re.identifier.id)){X=X||!!fe.extensionDependencies?.some(B=>(0,m.areSameExtensions)({id:B},Y.identifier));const re=u(ae),me=this.j.get(re);if(me){if(this.C(Y,me.task)){const B=me.task.identifier;this.v.info("Waiting for already requested installing extension",B.id,Y.identifier.id),me.waitingTasks.push(Y),M.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,j=>j.some(C=>(0,m.areSameExtensions)(C.identifier,B)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!j.find(V=>(0,m.areSameExtensions)(V.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ne.some(({identifier:B})=>(0,m.areSameExtensions)(B,ae.identifier))){const B=this.Q(fe,ae,{...o,donotIncludePackAndDependencies:!0});this.j.set(re,{task:B,waitingTasks:[Y]}),this.l.fire({identifier:B.identifier,source:ae,profileLocation:o.profileLocation}),this.v.info("Installing extension:",B.identifier.id,Y.identifier.id),S.push({task:B,manifest:fe})}}}catch(ie){if(l.URI.isUri(Y.source))(0,T.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,T.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const ee=S.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;ee.size;){let ie;const ne=[...ee.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>ee.has(fe.toLowerCase())));ne.length?ie=ee.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!X)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...ee.values()]),await this.D(ie.map(async({task:ae})=>{const fe=new Date().getTime();try{const{local:re}=await ae.run();if(await this.D(this.s.map(me=>me.postInstall(re,ae.source,o,R.CancellationToken.None))),!l.URI.isUri(ae.source)){const me=ae.operation===3,B=me?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,me?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:B}),f.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}U.push({local:re,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw l.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:re}),this.v.error("Error while installing the extension:",ae.identifier.id),re}finally{ee.delete(ae.identifier.id.toLowerCase())}}))}return M.length&&await this.D(M),U.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(U),U.filter(({identifier:ie})=>(0,m.areSameExtensions)(ie,Y.identifier))[0].local}catch(ee){if(S.forEach(({task:ie})=>ie.cancel()),U.length)try{const ie=await Promise.allSettled(U.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:fe}=U[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",fe.id):this.v.warn("Rollback: Error while uninstalling extension",fe.id,(0,D.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ie),U.map(({identifier:ne})=>ne.id))}throw this.m.fire(S.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:o.context,profileLocation:o.profileLocation}))),ee}finally{for(const{task:ee}of S)ee.source&&!l.URI.isUri(ee.source)&&this.j.delete(u(ee.source))}}C(n,r){for(const[,{task:s,waitingTasks:o}]of this.j.entries())if(s===n&&(o.includes(r)||o.some(u=>this.C(u,r)))||s===r&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const r=[],s=[],o=await Promise.allSettled(n);for(const u of o)u.status==="fulfilled"?r.push(u.value):s.push(u.reason);if(s.length)throw d(s);return r}async F(n,r,s,o,u){if(!this.t.isEnabled())return[];const S=await this.getInstalled(void 0,u),M=[],U=[],Y=async(X,ee)=>{M.push(X);const ie=ee.extensionDependencies||[],ne=[...ie];if(ee.extensionPack){const ae=s?S.find(fe=>(0,m.areSameExtensions)(fe.identifier,X)):void 0;for(const fe of ee.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(re=>(0,m.areSameExtensions)({id:re},{id:fe}))||ne.every(re=>!(0,m.areSameExtensions)({id:re},{id:fe}))&&ne.push(fe)}if(ne.length){const ae=ne.filter(fe=>M.every(re=>!(0,m.areSameExtensions)(re,{id:fe})));if(ae.length){const fe=await this.t.getExtensions(ae.map(re=>({id:re,preRelease:o})),R.CancellationToken.None);for(const re of fe){if(M.find(j=>(0,m.areSameExtensions)(j,re.identifier)))continue;const me=ie.some(j=>(0,m.areSameExtensions)({id:j},re.identifier));let B;try{B=await this.G(re,!1,o)}catch(j){if(j instanceof g.ExtensionManagementError&&j.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw j}U.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(n,r),U}async G(n,r,s){if((await this.getExtensionsControlManifest()).malicious.some(M=>(0,m.areSameExtensions)(n.identifier,M)))throw new g.ExtensionManagementError(b.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const M=await this.getTargetPlatform();throw new g.ExtensionManagementError(b.localize(2,null,n.identifier.id,this.w.nameLong,(0,g.TargetPlatformToString)(M)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(n,r,s);if(u){if(s&&!r&&n.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(b.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],R.CancellationToken.None))[0]?new g.ExtensionManagementError(b.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(b.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),g.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const S=await this.t.getManifest(u,R.CancellationToken.None);if(S===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(S.version!==u.version)throw new g.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:S}}async H(n,r,s){const o=await this.getTargetPlatform();let u=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(u=(await this.t.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:o,compatible:!0},R.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(n,s,o)&&(u=n),u||(r?u=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},R.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(n,s,o)),u}async I(n,r){const s={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},o=X=>`${X.id.toLowerCase()}${s.versionOnly?`-${n.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,u=this.k.get(o(n.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),u.waitUntilTaskIsFinished();const S=X=>{const ee=this.R(X,s);return this.k.set(o(ee.extension.identifier),ee),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:s.profileLocation,applicationScoped:X.isApplicationScoped}),ee},M=(X,ee)=>{ee?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,s.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,ee.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(X),error:ee}),this.p.fire({identifier:X.identifier,error:ee?.code,profileLocation:s.profileLocation,applicationScoped:X.isApplicationScoped})},U=[],Y=[];try{U.push(S(n));const X=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ee=this.M(n,X);for(const ie of ee)this.k.has(o(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):U.push(S(ie))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(U.map(ee=>ee.extension),X,n),await this.D(U.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(ie=>ie.postUninstall(ee.extension,s,R.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}M(ee.extension)}catch(ie){const ne=ie instanceof g.ExtensionManagementError?ie:new g.ExtensionManagementError((0,D.getErrorMessage)(ie),g.ExtensionManagementErrorCode.Internal);throw M(ee.extension,ne),ne}finally{Y.push(ee)}}))}catch(X){const ee=X instanceof g.ExtensionManagementError?X:new g.ExtensionManagementError((0,D.getErrorMessage)(X),g.ExtensionManagementErrorCode.Internal);for(const ie of U){try{ie.cancel()}catch{}Y.includes(ie)||M(ie.extension,ee)}throw ee}finally{for(const X of U)this.k.delete(o(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}J(n,r,s){for(const o of n){const u=this.N(o,r);if(u.length){const S=u.filter(M=>!n.some(U=>(0,m.areSameExtensions)(U.identifier,M.identifier)));if(S.length)throw new Error(this.L(o,S,s))}}}L(n,r,s){return s===n?r.length===1?b.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const u=r.filter(M=>!M.isBuiltin&&o.some(U=>(0,m.areSameExtensions)({id:U},M.identifier))),S=[];for(const M of u)S.push(...this.M(M,r,s));return[...u,...S]}return[]}N(n,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(o=>(0,m.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};w=de([_(0,g.IExtensionGalleryService),_(1,h.ITelemetryService),_(2,v.ILogService),_(3,L.IProductService),_(4,c.IUserDataProfilesService)],w),e.AbstractExtensionManagementService=w;function d(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=d;function E(i){if(i instanceof g.ExtensionManagementError)return i;const n=new g.ExtensionManagementError(i.message,g.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:s,duration:o,error:u,durationSinceUpdate:S}){let M,U;u&&(u instanceof g.ExtensionManagementError?(M=u.code,u.code===g.ExtensionManagementErrorCode.Signature&&(U=u.message)):M=g.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:s,success:!u,duration:o,errorcode:M,errorcodeDetail:U,durationSinceUpdate:S})}e.reportTelemetry=t;class a{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((r,s)=>{const o=n.onCancellationRequested(()=>{o.dispose(),s(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(Z[40],Q([0,1,5,15,2,3,36,11,26,29,13,9,10,21,27,4,6,25]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class w extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=w,e.IExtensionsProfileScannerService=(0,g.createDecorator)("IExtensionsProfileScannerService");let d=class extends R.Disposable{constructor(i,n,r,s,o,u){super(),this.h=i,this.i=n,this.j=r,this.k=s,this.l=o,this.m=u,this.a=this.B(new D.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new D.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],s=[];try{return await this.n(n,o=>{const u=[];for(const S of o)i.some(([M])=>(0,f.areSameExtensions)(M.identifier,S.identifier)&&M.manifest.version!==S.version)?r.push(S):u.push(S);for(const[S,M]of i)if(!u.some(U=>(0,f.areSameExtensions)(U.identifier,S.identifier)&&U.version===S.manifest.version)){const U={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:M};s.push(U),u.push(U)}return s.length&&this.a.fire({extensions:s,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),u}),s.length&&this.b.fire({extensions:s,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),s}catch(o){throw s.length&&this.b.fire({extensions:s,error:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:o,profileLocation:n}),o}}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,s=>{const o=[];for(const u of s)(0,f.areSameExtensions)(u.identifier,i.identifier)?r.push(u):o.push(u);return r.length&&this.c.fire({extensions:r,profileLocation:n}),o}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(s){throw r.length&&this.f.fire({extensions:r,error:s,profileLocation:n}),s}}async n(i,n,r){return this.v(i).queue(async()=>{let s=[],o;try{const u=await this.i.readFile(i);o=JSON.parse(u.value.toString())}catch(u){if((0,b.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(o=await this.u()),!o&&r?.bailOutWhenFileNotFound)throw new w((0,h.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.p(i);let u=!1;for(const S of o){E(S)||this.p(i);let M;if((0,L.isString)(S.location))M=this.s(S.location);else{M=y.URI.revive(S.location);const U=this.r(M);U&&(u=!0,S.location=U)}s.push({identifier:S.identifier,location:M,version:S.version,metadata:S.metadata})}u&&await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(o)))}if(n){s=n(s);const u=s.map(S=>({identifier:S.identifier,version:S.version,location:this.r(S.location)??S.location.toJSON(),metadata:S.metadata}));await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(u)))}return s})}p(i){const n=new w(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(s){if((0,b.toFileOperationResult)(s)===1)return;throw s}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const s=JSON.parse(n);Array.isArray(s)&&s.every(o=>E(o))?r=s:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.m.error(s)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(s){if((0,b.toFileOperationResult)(s)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw s}try{await this.i.del(i)}catch(s){(0,b.toFileOperationResult)(s)!==1&&this.m.error(s)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new T.Queue,this.g.set(i,n)),n}};d=de([_(1,b.IFileService),_(2,k.IUserDataProfilesService),_(3,v.IUriIdentityService),_(4,c.ITelemetryService),_(5,m.ILogService)],d),e.AbstractExtensionsProfileScannerService=d;function E(a){return(0,L.isObject)(a)&&(0,l.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,L.isString)(a.location))&&a.version&&(0,L.isString)(a.version)}function t(a){return a?(0,L.isString)(a.path)&&(0,L.isString)(a.scheme):!1}}),define(Z[48],Q([0,1,19,5,30,15,6,50,78,2,16,14,12,18,41,53,4,11,91,17,26,29,45,13,9,10,28,3,44,40,21,27,107,108]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w,d,E,t,a,i,n,r,s,o,u,S,M,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(me){function B(j,C){if(j===C)return!0;const V=Object.keys(j),W=new Set;for(const q of Object.keys(C))W.add(q);if(V.length!==W.size)return!1;for(const q of V){if(j[q]!==C[q])return!1;W.delete(q)}return W.size===0}me.equals=B})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends l.Disposable{constructor(B,j,C,V,W,q,K,I,P,A,F,$){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=C,this.m=V,this.n=W,this.p=q,this.r=K,this.s=I,this.t=P,this.u=A,this.v=F,this.w=$,this.g=this.B(new s.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,k.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,E.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,E.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,d.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,C){const[V,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=C?await this.scanExtensionsUnderDevelopment(B,[...V,...W]):[];return this.F(V,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[C,V]=await Promise.all(j);return this.D([...C,...V],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const C=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,C),W=B.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions(V)}catch(K){if(K instanceof u.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions(V);else throw K}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const C=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===b.Schemas.file).map(async V=>{const W=await this.J(V,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(K=>(K.type=j.find(I=>(0,d.areSameExtensions)(I.identifier,K.identifier))?.type??K.type,this.k.validate(K,W)))}))).flat();return this.D(C,"development",B,!0)}return[]}async scanExistingExtension(B,j,C){const V=await this.J(B,!1,j,!0,C.language,!0,void 0),W=await this.k.scanExtension(V);return!W||!C.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,C){const V=await this.J(B,!1,j,!0,C.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(V);return this.D(W,j,C,!0)}async scanMetadata(B){const j=(0,k.joinPath)(B,"package.json"),C=(await this.r.readFile(j)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(B,j){const C=(0,k.joinPath)(B,"package.json"),V=(await this.r.readFile(C)).value.toString(),W=JSON.parse(V);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,k.joinPath)(B,"package.json"),D.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof u.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,a.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,C,V){return C.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),V)),C.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const K=g.basename(W.location.fsPath),I=g.basename(q.location.fsPath);return K<I?-1:K>I?1:0})}F(B,j,C,V,W){const q=(I,P,A)=>{if(I.isValid&&!P.isValid)return!1;if(I.isValid===P.isValid){if(W&&v.gt(I.manifest.version,P.manifest.version))return this.s.debug(`Skipping extension ${P.location.path} with lower version ${P.manifest.version} in favour of ${I.location.path} with version ${I.manifest.version}`),!1;if(v.eq(I.manifest.version,P.manifest.version)){if(I.type===0)return this.s.debug(`Skipping extension ${P.location.path} in favour of system extension ${I.location.path} with same version`),!1;if(I.targetPlatform===V)return this.s.debug(`Skipping extension ${P.location.path} from different target platform ${P.targetPlatform}`),!1}}return A?this.s.warn(`Overwriting user extension ${I.location.path} with ${P.location.path}.`):this.s.debug(`Overwriting user extension ${I.location.path} with ${P.location.path}.`),!0},K=new Map;return B?.forEach(I=>{const P=E.ExtensionIdentifier.toKey(I.identifier.id),A=K.get(P);(!A||q(A,I,!1))&&K.set(P,I)}),j?.forEach(I=>{const P=E.ExtensionIdentifier.toKey(I.identifier.id),A=K.get(P);if(!A&&B&&I.type===0){this.s.debug(`Skipping obsolete system extension ${I.location.path}.`);return}(!A||q(A,I,!1))&&K.set(P,I)}),C?.forEach(I=>{const P=E.ExtensionIdentifier.toKey(I.identifier.id),A=K.get(P);(!A||q(A,I,!0))&&K.set(P,I),K.set(P,I)}),[...K.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const C=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!C.devMode?this.i:this.k).scanExtensions(C);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const C=this.t.isBuilt?[]:this.u.builtInExtensions;if(!C?.length)return[];this.s.trace("Started scanning dev system extensions");const V=j?await this.I():{},W=[],q=c.URI.file(g.normalize(g.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const I of C){const P=V[I.name]||"marketplace";switch(P){case"disabled":break;case"marketplace":W.push((0,k.joinPath)(q,I.name));break;default:W.push(c.URI.file(P));break}}const K=await Promise.all(W.map(async I=>this.k.scanExtension(await this.J(I,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",K.length),(0,T.coalesce)(K)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,C,V,W,q,K){const I=await this.f(W??m.language),P=await this.L(B),A=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=A?await this.L(A):void 0;return new ie(B,P,A,F,j,K,C,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,I)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ee=de([_(4,S.IUserDataProfilesService),_(5,u.IExtensionsProfileScannerService),_(6,a.IFileService),_(7,n.ILogService),_(8,w.IEnvironmentService),_(9,r.IProductService),_(10,M.IUriIdentityService),_(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class ie{constructor(B,j,C,V,W,q,K,I,P,A,F,$,G,te,oe){this.location=B,this.mtime=j,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=q,this.type=K,this.excludeObsolete=I,this.validate=P,this.productVersion=A,this.productDate=F,this.productCommit=$,this.devMode=G,this.language=te,this.translations=oe}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,k.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,k.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&R.equals(B.profileScanOptions,j.profileScanOptions)&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&X.equals(B.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends l.Disposable{constructor(B,j,C,V,W){super(),this.f=B,this.g=j,this.h=C,this.i=V,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let C={};if(B.excludeObsolete&&B.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();C=JSON.parse(V)}catch{}return(0,h.isEmptyObject)(C)?j:j.filter(V=>!C[d.ExtensionKey.create(V).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const C=await Promise.all(j.children.map(async V=>{if(!V.isDirectory||B.type===1&&(0,k.basename)(V.resource).indexOf(".")===0)return null;const W=new ie(V.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,T.coalesce)(C).sort((V,W)=>V.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(V=>!V.metadata?.isApplicationScoped);const C=await this.m(B.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,B);j.push(...C)}return j}async m(B,j,C){const V=await this.g.scanProfileExtensions(B,C.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async q=>{if(j(q)){const K=new ie(q.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(K,q.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,k.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let C=await this.scanExtensionManifest(B.location);if(C){C.publisher||(C.publisher=E.UNDEFINED_PUBLISHER),j=j??C.__metadata,delete C.__metadata;const V=(0,d.getGalleryExtensionId)(C.publisher,C.name),W=j?.id?{id:V,uuid:j.id}:{id:V},q=j?.isSystem?0:B.type,K=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(C),C=await this.n(B.location,C,ie.createNlsConfiguration(B));const I={type:q,identifier:W,manifest:C,location:B.location,isBuiltin:K,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(I,B):I}}catch(C){B.type!==0&&this.j.error(C)}return null}validate(B,j){let C=!0;const V=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of V)W===L.default.Error&&(C=!1,this.j.error(this.t(j.location,q)));return B.isValid=C,B.validations=V,B}async scanExtensionManifest(B){const j=(0,k.joinPath)(B,"package.json");let C;try{C=(await this.i.readFile(j)).value.toString()}catch(W){return(0,a.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,p.localize)(0,null,j.path,W.message))),null}let V;try{V=JSON.parse(C)}catch{const q=[];(0,y.parse)(C,q);for(const K of q)this.j.error(this.t(B,(0,p.localize)(1,null,j.path,K.offset,K.length,(0,f.getParseErrorMessage)(K.error))));return null}return(0,y.getNodeType)(V)!=="object"?(this.j.error(this.t(B,(0,p.localize)(2,null,j.path))),null):V}async n(B,j,C){const V=await this.p(B,j,C);if(V)try{const W=[],q=await this.r(V.default,W);if(W.length>0)return W.forEach(I=>{this.j.error(this.t(B,(0,p.localize)(3,null,V.default?.path,(0,f.getParseErrorMessage)(I.error))))}),j;if((0,y.getNodeType)(V)!=="object")return this.j.error(this.t(B,(0,p.localize)(4,null,V.default?.path))),j;const K=V.values||Object.create(null);return(0,U.localizeManifest)(j,K,q)}catch{}return j}async p(B,j,C){const V=(0,k.joinPath)(B,"package.nls.json"),W=(P,A)=>{A.forEach(F=>{this.j.error(this.t(B,(0,p.localize)(5,null,P?.path,(0,f.getParseErrorMessage)(F.error))))})},q=P=>{this.j.error(this.t(B,(0,p.localize)(6,null,P?.path)))},K=`${j.publisher}.${j.name}`,I=C.translations[K];if(I)try{const P=c.URI.file(I),A=(await this.i.readFile(P)).value.toString(),F=[],$=(0,y.parse)(A,F);return F.length>0?(W(P,F),{values:void 0,default:V}):(0,y.getNodeType)($)!=="object"?(q(P),{values:void 0,default:V}):{values:$.contents?$.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let A;try{A=await this.s(B,C)}catch{return}if(!A.localized)return{values:void 0,default:A.original};try{const F=(await this.i.readFile(A.localized)).value.toString(),$=[],G=(0,y.parse)(F,$);return $.length>0?(W(A.localized,$),{values:void 0,default:A.original}):(0,y.getNodeType)(G)!=="object"?(q(A.localized),{values:void 0,default:A.original}):{values:G,default:A.original}}catch{return{values:void 0,default:A.original}}}}async r(B,j){if(B)try{const C=(await this.i.readFile(B)).value.toString();return(0,y.parse)(C,j)}catch{}}s(B,j){return new Promise((C,V)=>{const W=q=>{const K=(0,k.joinPath)(B,`package.nls.${q}.json`);this.i.exists(K).then(I=>{I&&C({localized:K,original:(0,k.joinPath)(B,"package.nls.json")});const P=q.lastIndexOf("-");P===-1?C({localized:(0,k.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,P),W(q))})};if(j.devMode||j.pseudo||!j.language)return C({localized:(0,k.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ne=de([_(1,u.IExtensionsProfileScannerService),_(2,M.IUriIdentityService),_(3,a.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(B,j,C,V,W,q){super(j,C,V,W,q),this.y=B,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new s.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",B.location.toString()),this.v.trigger(()=>this.D()),j.result.map(V=>(V.location=c.URI.revive(V.location),V));const C=await super.scanExtensions(B);return await this.C({input:B,result:C}),C}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,o.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(C,j))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ae=de([_(2,u.IExtensionsProfileScannerService),_(3,M.IUriIdentityService),_(4,a.IFileService),_(5,n.ILogService)],ae);function fe(me,B){const j=(0,d.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:j,identifier:new E.ExtensionIdentifier(j),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:B,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=fe;class re extends ee{constructor(B,j,C,V,W,q,K,I,P,A,F,$){super(B,j,(0,k.joinPath)(C,".vscode-oss-dev","extensions","control.json"),(0,k.joinPath)(V,E.MANIFEST_CACHE_FOLDER),W,q,K,I,P,A,F,$),this.M=(async()=>{if(m.translationsConfigFile)try{const G=await this.r.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=re}),define(Z[146],Q([0,1,57,5,34,3,2,16,14,20,10,21]),function(x,e,T,O,R,D,N,y,f,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends N.Disposable{constructor(v,L){super(),this.b=v,this.f=L,this.a=new O.Limiter(5)}async postUninstall(v){const L=this.g(v,"uninstall");return L&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(L.script,"uninstall",L.args,!0,v).then(()=>this.f.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),h=>this.f.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${h}`)))),l.Promises.rm(this.j(v)).then(void 0,h=>this.f.error("Error while removing extension storage path",h))}g(v,L){const h=`vscode:${L}`;if(v.location.scheme===y.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[h]=="string"){const c=v.manifest.scripts[h].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${h} should be a node script`),null):{script:(0,f.join)(v.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(v,L,h,c,p){return new Promise((w,d)=>{const E=this.i(v,L,h,p);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?d(i):w(void 0)};E.on("error",i=>{a((0,R.toErrorMessage)(i)||"Unknown")}),E.on("exit",(i,n)=>{a(i?`post-${L} process exited with code ${i}`:void 0)}),c&&(t=setTimeout(()=>{t=null,E.kill(),d("timed out")},5e3))})}i(v,L,h,c){const p={silent:!0,execArgv:void 0},w=(0,T.fork)(v,[`--type=extension-post-${L}`,...h],p);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const d=D.Event.fromNodeEventEmitter(w.stdout,"data"),E=D.Event.fromNodeEventEmitter(w.stderr,"data");d(i=>this.f.info(c.identifier.id,c.manifest.version,`post-${L}`,i)),E(i=>this.f.error(c.identifier.id,c.manifest.version,`post-${L}`,i));const t=D.Event.any(D.Event.map(d,i=>({data:`%c${i}`,format:[""]})),D.Event.map(E,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}j(v){return(0,f.join)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};m=de([_(0,g.IUserDataProfilesService),_(1,b.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[147],Q([0,1,10,21,27,25,40,13,17,11]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends N.AbstractExtensionsProfileScannerService{constructor(m,k,v,L,h,c){super(l.URI.file(m.extensionsPath),k,v,L,h,c)}};b=de([_(0,f.INativeEnvironmentService),_(1,y.IFileService),_(2,O.IUserDataProfilesService),_(3,R.IUriIdentityService),_(4,D.ITelemetryService),_(5,T.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[148],Q([0,1,11,17,40,48,13,9,10,28,27,21]),function(x,e,T,O,R,D,N,y,f,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends D.NativeExtensionsScannerService{constructor(v,L,h,c,p,w,d,E){super(T.URI.file(p.builtinExtensionsPath),T.URI.file(p.extensionsPath),p.userHome,T.URI.file(p.userDataPath),v,L,h,c,p,w,d,E)}};m=de([_(0,g.IUserDataProfilesService),_(1,R.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,f.ILogService),_(4,O.INativeEnvironmentService),_(5,l.IProductService),_(6,b.IUriIdentityService),_(7,y.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(Z[149],Q([0,1,5,3,2,118,4,84,9,21]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var g;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(g=e.StorageScope||(e.StorageScope={}));var m;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function k(p){const w=p.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=k;class v extends R.Disposable{constructor(w={flushInterval:v.a}){super(),this.j=w,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,d){if(d===e.TARGET_KEY){switch(w){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:d,target:this.F(w)[d]})}r(w){this.f.fire({reason:w})}get(w,d,E){return this.L(d)?.get(w,E)}getBoolean(w,d,E){return this.L(d)?.getBoolean(w,E)}getNumber(w,d,E){return this.L(d)?.getNumber(w,E)}store(w,d,E,t){if((0,N.isUndefinedOrNull)(d)){this.remove(w,E);return}this.t(()=>{this.u(w,E,t),this.L(E)?.set(w,d)})}remove(w,d){this.t(()=>{this.u(w,d,void 0),this.L(d)?.delete(w)})}t(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,d){const E=[],t=this.F(w);for(const a of Object.keys(t))t[a]===d&&E.push(a);return E}u(w,d,E){const t=this.F(d);typeof E=="number"?t[w]!==E&&(t[w]=E,this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.z;default:return this.w}}G(w){const d=this.L(w);return d?k(d):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=b.NONE){this.f.fire({reason:w});const d=this.L(-1),E=this.L(0),t=this.L(1);switch(w){case b.NONE:await T.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await T.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,d=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return c(w,d,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,d){return this.r(b.NONE),(0,l.isUserDataProfile)(w)?this.N(w,d):this.O(w,d)}H(w,d){return!(w.id===d.id||L(d)&&L(w))}I(w,d,E,t){this.t(()=>{if(t)for(const[a,i]of w)d.set(a,i);else{const a=new Set;for(const[i,n]of w)a.add(i),d.get(i)!==n&&this.n(E,i);for(const[i]of d.items)a.has(i)||this.n(E,i)}})}}e.AbstractStorageService=v,v.a=60*1e3;function L(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=L;class h extends v{constructor(){super(),this.p=this.B(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=h;async function c(p,w,d,E,t,a){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;p.forEach((Y,X)=>{n.set(X,Y),r.set(X,i(Y))});const s=new Map,o=new Map;w.forEach((Y,X)=>{s.set(X,Y),o.set(X,i(Y))});const u=new Map,S=new Map;d.forEach((Y,X)=>{u.set(X,Y),S.set(X,i(Y))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const M=[];if(n.forEach((Y,X)=>{M.push({key:X,value:Y})}),console.table(M),console.groupEnd(),console.log(r),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];s.forEach((X,ee)=>{Y.push({key:ee,value:X})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const U=[];u.forEach((Y,X)=>{U.push({key:X,value:Y})}),console.table(U),console.groupEnd(),console.log(S)}e.logStorage=c}),define(Z[150],Q([0,1,19,22,6,12,35,4,11,23,17,24,26,45,13,10,28,47,135,149,25]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const E=D.isWeb?"web":(0,g.getTargetPlatform)(D.platform,N.arch);var t;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function a(...I){return String(I.reduce((P,A)=>P|A,0))}var i;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class u{constructor(P=o){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,A=this.d.pageSize){return new u({...this.d,pageNumber:P,pageSize:A})}withFilter(P,...A){const F=[...this.d.criteria,...A.length?A.map($=>({filterType:P,value:$})):[{filterType:P}]];return new u({...this.d,criteria:F})}withSortBy(P){return new u({...this.d,sortBy:P})}withSortOrder(P){return new u({...this.d,sortOrder:P})}withFlags(...P){return new u({...this.d,flags:P.reduce((A,F)=>A|F,0)})}withAssetTypes(...P){return new u({...this.d,assetTypes:P})}withSource(P){return new u({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:A,pageSize:F,sortBy:$,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:P,pageNumber:A,pageSize:F,sortBy:$,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const P=this.d.criteria.filter(A=>A.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(I,P){const A=(I||[]).filter(F=>F.statisticName===P)[0];return A?A.value:0}function M(I){const P="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(F=>F.assetType.indexOf(P)===0).reduce((F,$)=>{const G=X(I,$.assetType);return G&&F.push([$.assetType.substring(P.length),G]),F},[])}function U(I){if(I.properties){const P=I.properties.filter($=>$.key===n.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=P.filter($=>A.test($.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(I,n.Repository)}function Y(I){return{uri:`${I.fallbackAssetUri}/${n.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${n.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function X(I,P){return I.files.filter(F=>F.assetType===P)[0]?{uri:`${I.assetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function ee(I,P){const A=I.properties?I.properties.filter($=>$.key===P):[],F=A.length>0&&A[0].value;return F?F.split(",").map($=>(0,m.adoptToGalleryExtensionId)($)):[]}function ie(I){const P=I.properties?I.properties.filter(A=>A.key===r.Engine):[];return P.length>0&&P[0].value||""}function ne(I){const P=I.properties?I.properties.filter(A=>A.key===r.PreRelease):[];return P.length>0&&P[0].value==="true"}function ae(I){const P=I.properties?I.properties.filter(F=>F.key===r.LocalizedLanguages):[],A=P.length>0&&P[0].value||"";return A?A.split(","):[]}function fe(I){return I.properties?.find(P=>P.key===r.SponsorLink)?.value}function re(I){return I.indexOf("preview")!==-1}function me(I){return I.targetPlatform?(0,g.toTargetPlatform)(I.targetPlatform):"undefined"}function B(I){const P=(0,T.distinct)(I.versions.map(me)),A=!!I.tags?.includes(g.WEB_EXTENSION_TAG),F=P.indexOf("web");return A?F===-1&&P.push("web"):F!==-1&&P.splice(F,1),P}function j(I,P){const A=(0,g.getFallbackTargetPlarforms)(P);for(let F=0;F<I.length;F++){const $=I[F];if($.version===I[F-1]?.version){let G=F;const te=me($);if(te===P)for(;G>0&&I[G-1].version===$.version;)G--;else if(A.includes(te))for(;G>0&&I[G-1].version===$.version&&me(I[G-1])!==P;)G--;G!==F&&(I.splice(F,1),I.splice(G,0,$))}}return I}e.sortExtensionVersions=j;function C(I,P,A){I.telemetryData={index:P,querySource:A}}function V(I,P,A){const F=I.versions[0],$={manifest:X(P,n.Manifest),readme:X(P,n.Details),changelog:X(P,n.Changelog),license:X(P,n.License),repository:U(P),download:Y(P),icon:X(P,n.Icon),signature:X(P,n.Signature),coreTranslations:M(P)};return{identifier:{id:(0,m.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:P.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:fe(F),description:I.shortDescription||"",installCount:S(I.statistics,"install"),rating:S(I.statistics,"averagerating"),ratingCount:S(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:A,assets:$,properties:{dependencies:ee(P,r.Dependency),extensionPack:ee(P,r.ExtensionPack),engine:ie(P),localizedLanguages:ae(P),targetPlatform:me(P),isPreReleaseVersion:ne(P)},hasPreReleaseVersion:ne(F),hasReleaseVersion:!0,preview:re(I.flags),isSigned:!!$.signature}}let W=class{constructor(P,A,F,$,G,te,oe,ge){this.k=A,this.l=F,this.n=$,this.o=G,this.q=te,this.u=oe,this.w=ge;const ve=oe.extensionsGallery,le=ve?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=le?ve.servicePPEUrl:ve?.serviceUrl,this.g=le?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.j=(0,p.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,A,F){const $=O.CancellationToken.isCancellationToken(A)?{}:A,G=O.CancellationToken.isCancellationToken(A)?A:F,te=[],oe=[],ge=[],ve=[];let le=!0;for(const se of P){se.uuid?oe.push(se.uuid):te.push(se.id);const ue=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:ue}),se.version&&ve.push({id:se.id,uuid:se.uuid,version:se.version}),le=le&&!!se.hasPreRelease&&!ue}if(!oe.length&&!te.length)return[];let ce=new u().withPage(1,P.length);oe.length&&(ce=ce.withFilter(i.ExtensionId,...oe)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),($.queryAllVersions||le)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),$.source&&(ce=ce.withSource($.source));const{extensions:we}=await this.z(ce,{targetPlatform:$.targetPlatform??E,includePreRelease:ge,versions:ve,compatible:!!$.compatible},G);return $.source&&we.forEach((se,ue)=>C(se,ue,$.source)),we}async getCompatibleExtension(P,A,F){if((0,g.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(P,A,F))return P;const $=new u().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:G}=await this.z($,{targetPlatform:F,compatible:!0,includePreRelease:A},O.CancellationToken.None);return G[0]||null}async isExtensionCompatible(P,A,F){if(!(0,g.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,F)||!A&&P.properties.isPreReleaseVersion)return!1;let $=P.properties.engine;if(!$){const G=await this.getManifest(P,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");$=G.engines.vscode}return(0,k.isEngineValid)($,this.u.version,this.u.date)}async y(P,A,F,$,G){if(!(0,g.isTargetPlatformCompatible)(me(P),$,G)||A!=="any"&&ne(P)!==(A==="prerelease"))return!1;if(F)try{const te=await this.E(P);if(!(0,k.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,R.getErrorMessage)(te)),!1}return!0}async query(P,A){let F=P.text||"";const $=P.pageSize??50;let G=new u().withPage(1,$);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Category,we||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Tag,we||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):P.ids?G=G.withFilter(i.ExtensionId,...P.ids):P.names?G=G.withFilter(i.ExtensionName,...P.names):G=G.withSortBy(4),typeof P.sortBy=="number"&&(G=G.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(G=G.withSortOrder(P.sortOrder)),P.source&&(G=G.withSource(P.source));const te=async(le,ce)=>{const{extensions:we,total:se}=await this.z(le,{targetPlatform:E,compatible:!1,includePreRelease:!!P.includePreRelease},ce);return we.forEach((ue,be)=>C(ue,(le.pageNumber-1)*le.pageSize+be,P.source)),{extensions:we,total:se}},{extensions:oe,total:ge}=await te(G,A),ve=async(le,ce)=>{if(ce.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await te(G.withPage(le+1),ce);return we};return{firstPage:oe,total:ge,pageSize:G.pageSize,getPage:ve}}async z(P,A,F){const $=P.flags;!!(P.flags&t.IncludeLatestVersionOnly)&&!!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(P.flags&t.IncludeLatestVersionOnly)&&!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags,t.IncludeLatestVersionOnly)),A.versions?.length&&(P=P.withFlags(P.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),P=P.withFlags(P.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(P,F);if(!(P.flags&t.IncludeLatestVersionOnly)){const le=[];for(const ce of G){const we=await this.A(ce,A);we&&le.push(we)}return{extensions:le,total:te}}const ge=[],ve=new Map;for(let le=0;le<G.length;le++){const ce=G[le],we={id:(0,m.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,y.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(be=>(0,m.areSameExtensions)(be,we))?.includePreRelease;if(A.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(B(ce),A.targetPlatform))continue;const ue=await this.A(ce,A);!ue||ue.properties.isPreReleaseVersion&&(!se||!ue.hasReleaseVersion)||!ue.properties.isPreReleaseVersion&&ue.properties.targetPlatform!==A.targetPlatform&&ue.hasPreReleaseVersion?ve.set(ce.extensionId,le):ge.push([le,ue])}if(ve.size){const le=new Date().getTime(),ce=new u().withFlags($&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(i.ExtensionId,...ve.keys()),{extensions:we}=await this.z(ce,A,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const se of we){const ue=ve.get(se.identifier.uuid);ge.push([ue,se])}}return{extensions:ge.sort((le,ce)=>le[0]-ce[0]).map(([,le])=>le),total:te}}async A(P,A){const F={id:(0,m.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},$=A.versions?.find(ge=>(0,m.areSameExtensions)(ge,F))?.version,G=(0,y.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(ge=>(0,m.areSameExtensions)(ge,F))?.includePreRelease,te=B(P),oe=j(P.versions,A.targetPlatform);if(A.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(te,A.targetPlatform))return null;for(let ge=0;ge<oe.length;ge++){const ve=oe[ge];if(!($&&ve.version!==$)){if(await this.y(ve,G?"any":"release",A.compatible,te,A.targetPlatform))return V(P,ve,te);if($&&ve.version===$)return null}}return $||A.compatible?null:V(P,P.versions[0],te)}async B(P,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,a(t.Unpublished));const F=await this.j,$=JSON.stringify(P.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)},te=new Date().getTime();let oe,ge,ve=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&P.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:$,headers:G},A),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,c.asJson)(oe);if(le){const ce=le.results[0],we=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return ve=se&&se.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw ge=le,le}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String($.length),duration:new Date().getTime()-te,success:!!oe&&(0,c.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ge?(0,R.isCancellationError)(ge)?"canceled":(0,R.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(P,A,F,$){if(!this.isEnabled())return;const G=D.isWeb?this.x(`/itemName/${P}.${A}/version/${F}/statType/${$==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${A}/${F}/stats?statType=${$}`),te=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},O.CancellationToken.None)}catch{}}async download(P,A,F){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const $=(0,m.getGalleryExtensionTelemetryData)(P),G=new Date().getTime(),te=le=>this.o.publicLog("galleryService:downloadVSIX",{...$,duration:le}),oe=F===2?"install":F===3?"update":"",ge=oe?{uri:`${P.assets.download.uri}${f.URI.parse(P.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${P.assets.download.fallbackUri}${f.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:P.assets.download,ve=await this.D(ge);await this.q.writeFile(A,ve.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(P,A){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const F=await this.D(P.assets.signature);await this.q.writeFile(A,F.stream)}async getReadme(P,A){if(P.assets.readme){const F=await this.D(P.assets.readme,{},A);return await(0,c.asTextOrError)(F)||""}return""}async getManifest(P,A){if(P.assets.manifest){const F=await this.D(P.assets.manifest,{},A),$=await(0,c.asTextOrError)(F);return $?JSON.parse($):null}return null}async C(P,A){const F=X(P,n.Manifest);if(!F)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:$});return await(0,c.asJson)(G)}async getCoreTranslation(P,A){const F=P.assets.coreTranslations.filter($=>$[0]===A.toUpperCase())[0];if(F){const $=await this.D(F[1]),G=await(0,c.asTextOrError)($);return G?JSON.parse(G):null}return null}async getChangelog(P,A){if(P.assets.changelog){const F=await this.D(P.assets.changelog,{},A);return await(0,c.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(P,A,F){let $=new u().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?$=$.withFilter(i.ExtensionId,P.identifier.uuid):$=$.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:G}=await this.B($,O.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const oe=[];await Promise.all(G[0].versions.map(async le=>{try{await this.y(le,A?"any":"release",!0,te,F)&&oe.push(le)}catch{}}));const ge=[],ve=new Set;for(const le of j(oe,F))ve.has(le.version)||(ve.add(le.version),ge.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ne(le)}));return ge}async D(P,A={},F=O.CancellationToken.None){const $=await this.j,G={type:"GET"},te={...$,...A.headers||{}};A={...A,...G,headers:te};const oe=P.uri,ge=P.fallbackUri,ve={...A,url:oe};try{const le=await this.k.request(ve,F);if(le.res.statusCode===200)return le;const ce=await(0,c.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ce}`)}catch(le){if((0,R.isCancellationError)(le))throw le;const ce=(0,R.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ce});const we={...A,url:ge};return this.k.request(we,F)}}async E(P){let A=ie(P);if(!A){const F=await this.C(P,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");A=F.engines.vscode}return A}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,c.asJson)(P),F=[],$={};if(A){for(const G of A.malicious)F.push({id:G});if(A.migrateToPreRelease)for(const[G,te]of Object.entries(A.migrateToPreRelease))(!te.engine||(0,k.isEngineValid)(te.engine,this.u.version,this.u.date))&&($[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(A.deprecated)for(const[G,te]of Object.entries(A.deprecated))te&&($[G.toLowerCase()]=(0,y.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:$}}};W=de([_(1,c.IRequestService),_(2,L.ILogService),_(3,b.IEnvironmentService),_(4,d.ITelemetryService),_(5,v.IFileService),_(6,h.IProductService),_(7,l.IConfigurationService)],W);let q=class extends W{constructor(P,A,F,$,G,te,oe,ge){super(P,A,F,$,G,te,oe,ge)}};q=de([_(0,w.IStorageService),_(1,c.IRequestService),_(2,L.ILogService),_(3,b.IEnvironmentService),_(4,d.ITelemetryService),_(5,v.IFileService),_(6,h.IProductService),_(7,l.IConfigurationService)],q),e.ExtensionGalleryService=q;let K=class extends W{constructor(P,A,F,$,G,te,oe){super(void 0,P,A,F,$,G,te,oe)}};K=de([_(0,c.IRequestService),_(1,L.ILogService),_(2,b.IEnvironmentService),_(3,d.ITelemetryService),_(4,v.IFileService),_(5,h.IProductService),_(6,l.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K}),define(Z[151],Q([0,1,44,11,17,13,10,67,27,21]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends l.UserDataProfilesService{constructor(k,v,L,h){super(v,L,k,h),this.a=v}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=de([_(0,f.IUriIdentityService),_(1,R.INativeEnvironmentService),_(2,D.IFileService),_(3,N.ILogService)],b),e.ServerUserDataProfilesService=b;let g=class $e extends b{constructor(k,v,L,h,c){super(v,L,h,c),this.N=k}G(){return(0,T.revive)(this.N.getItem($e.b,[]))}I(){return(0,T.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};g=de([_(0,y.IStateService),_(1,f.IUriIdentityService),_(2,R.INativeEnvironmentService),_(3,D.IFileService),_(4,N.ILogService)],g),e.UserDataProfilesService=g}),define(Z[152],Q([0,1,38,5,165,2,10]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let y=class extends T.AbstractPolicyService{constructor(l,b){super(),this.j=l,this.k=b,this.a=new O.Throttler,this.b=this.B(new D.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((b,g)=>{try{this.b.value=(0,R.createWatcher)(this.k,l,m=>{this.m(m),b()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),g(m)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const b in l){const g=l[b];g===void 0?this.g.delete(b):this.g.set(b,g)}this.h.fire(Object.keys(l))}};y=de([_(0,N.ILogService)],y),e.NativePolicyService=y}),define(Z[69],Q([0,1,120,5,14,4,20,85,166,167]),function(x,e,T,O,R,D,N,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(t,a){let i=a.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=a}}e.ExtractError=b;function g(E){const t=E.externalFileAttributes>>16||33188;return[448,56,7].map(a=>t&a).reduce((a,i)=>a+i,t&61440)}function m(E){if(E instanceof b)return E;let t;return/end of central directory record signature not found/.test(E.message)&&(t="CorruptZip"),new b(t,E)}function k(E,t,a,i,n,r){const s=R.dirname(t),o=R.join(i,s);if(!o.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const u=R.join(i,t);let S;return r.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((M,U)=>{if(!r.isCancellationRequested)try{S=(0,T.createWriteStream)(u,{mode:a}),S.once("close",()=>M()),S.once("error",U),E.once("error",U),E.pipe(S)}catch(Y){U(Y)}}))}function v(E,t,a,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),E.close()}),new Promise((s,o)=>{const u=new O.Sequencer,S=M=>{M.isCancellationRequested||(r++,E.readEntry())};E.once("error",o),E.once("close",()=>n.then(()=>{i.isCancellationRequested||E.entryCount===r?s():o(new b("Incomplete",new Error(y.localize(1,null,r,E.entryCount))))},o)),E.readEntry(),E.on("entry",M=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(M.fileName)){S(i);return}const U=M.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(U)){const ee=R.join(t,U);n=(0,O.createCancelablePromise)(ie=>N.Promises.mkdir(ee,{recursive:!0}).then(()=>S(ie)).then(void 0,o));return}const Y=h(E,M),X=g(M);n=(0,O.createCancelablePromise)(ee=>u.queue(()=>Y.then(ie=>k(ie,U,X,t,a,ee).then(()=>S(ee)))).then(null,o))})})}function L(E,t=!1){return new Promise((a,i)=>{(0,f.open)(E,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(m(n)):a((0,D.assertIsDefined)(r))})})}function h(E,t){return new Promise((a,i)=>{E.openReadStream(t,(n,r)=>{n?i(m(n)):a((0,D.assertIsDefined)(r))})})}function c(E,t){return new Promise((a,i)=>{const n=new l.ZipFile;t.forEach(s=>{s.contents?n.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&n.addFile(s.localPath,s.path)}),n.end();const r=(0,T.createWriteStream)(E);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>a(E))})}e.zip=c;function p(E,t,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=L(E,!0);return a.overwrite&&(r=r.then(s=>N.Promises.rm(t).then(()=>s))),r.then(s=>v(s,t,{sourcePathRegex:n},i))}e.extract=p;function w(E,t){return L(E).then(a=>new Promise((i,n)=>{a.on("entry",r=>{r.fileName===t&&h(a,r).then(s=>i(s),s=>n(s))}),a.once("close",()=>n(new Error(y.localize(2,null,t))))}))}function d(E,t){return w(E,t).then(a=>new Promise((i,n)=>{const r=[];a.once("error",n),a.on("data",s=>r.push(s)),a.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=d}),define(Z[153],Q([0,1,69,93]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(D){return(0,T.buffer)(D,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=R}),define(Z[154],Q([0,1,5,22,34,6,3,2,36,16,14,12,18,41,4,11,31,20,69,92,58,17,145,24,26,40,48,133,146,153,126,134,29,45,13,9,10,28,25,27,21]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w,d,E,t,a,i,n,r,s,o,u,S,M,U,Y,X,ee,ie,ne,ae,fe,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(a.IExtensionManagementService);let me=class extends t.AbstractExtensionManagementService{constructor(I,P,A,F,$,G,te,oe,ge,ve,le,ce){super(I,P,A,ve,ce),this.Y=$,this.Z=G,this.ab=te,this.bb=ge,this.cb=le,this.X=new Map,this.kb=new f.ResourceSet;const we=this.B(oe.createInstance(o.ExtensionsLifecycle));this.S=this.B(oe.createInstance(B,ue=>we.postUninstall(ue))),this.U=this.B(new S.ExtensionsManifestCache(F,this)),this.W=this.B(oe.createInstance(s.ExtensionsDownloader));const se=this.B(new M.ExtensionsWatcher(this,this.Y,ce,G,le,ge,A));this.B(se.onDidChangeExtensionsByAnotherSource(ue=>this.jb(ue))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(I){this.v.trace("ExtensionManagementService#zip",I.identifier.id);const P=await this.ib(I),A=await(0,p.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,P);return L.URI.file(A)}async unzip(I){return this.v.trace("ExtensionManagementService#unzip",I.toString()),(await this.install(I)).identifier}async getManifest(I){const{location:P,cleanup:A}=await this.eb(I),F=b.resolve(P.fsPath);try{return await(0,u.getManifest)(F)}finally{await A()}}getInstalled(I,P){return this.S.scanExtensions(I??null,P)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(I,P={}){this.v.trace("ExtensionManagementService#install",I.toString());const{location:A,cleanup:F}=await this.eb(I);try{const $=await(0,u.getManifest)(b.resolve(A.fsPath));if($.engines&&$.engines.vscode&&!(0,Y.isEngineValid)($.engines.vscode,this.w.version,this.w.date))throw new Error(w.localize(0,null,(0,i.getGalleryExtensionId)($.publisher,$.name),this.w.version));return await this.z($,A,P)}finally{await F()}}async installFromLocation(I,P){this.v.trace("ExtensionManagementService#installFromLocation",I.toString());const A=await this.S.scanUserExtensionAtLocation(I);if(!A)throw new Error(`Cannot find a valid extension from the location ${I.toString()}`);return await this.nb([A],P),this.v.info("Successfully installed extension",A.identifier.id,P.toString()),A}getMetadata(I){return this.Y.scanMetadata(I.location)}async updateMetadata(I,P){this.v.trace("ExtensionManagementService#updateMetadata",I.identifier.id);const A={...P};return P.isPreReleaseVersion&&(A.preRelease=!0),I=await this.S.updateMetadata(I,A),this.U.invalidate(),I}async updateExtensionScope(I,P){return this.v.trace("ExtensionManagementService#updateExtensionScope",I.identifier.id),I=await this.S.updateMetadata(I,{isMachineScoped:P}),this.U.invalidate(),I}async reinstallFromGallery(I){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",I.identifier.id),!this.t.isEnabled())throw new Error(w.localize(1,null));const P=await this.getTargetPlatform(),[A]=await this.t.getExtensions([{...I.identifier,preRelease:I.preRelease}],{targetPlatform:P,compatible:!0},O.CancellationToken.None);if(!A)throw new Error(w.localize(2,null));await this.S.setUninstalled(I);try{await this.S.removeUninstalledExtension(I)}catch(F){throw new Error(w.localize(3,null,(0,R.toErrorMessage)(F)))}return this.installFromGallery(A)}markAsUninstalled(...I){return this.S.setUninstalled(...I)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(I,P){const{location:A}=await this.W.download(I,P);return A}async eb(I){if(I.scheme===l.Schemas.file)return{location:I,async cleanup(){}};this.v.trace("Downloading extension from",I.toString());const P=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.ab.download(I,P),this.v.info("Downloaded extension to",P.toString()),{location:P,cleanup:async()=>{try{await this.bb.del(P)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(I,P,A){let F;if(L.URI.isUri(P))F=new V(I,P,A,this.t,this.S,this.v);else{const $=i.ExtensionKey.create(P).toString();F=this.X.get($),F||(this.X.set($,F=new C(I,P,A,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete($)))}return new W(F,A.profileLocation,this.cb,this.y,this.Y,this.Z)}R(I,P){return new q(I,P.profileLocation,this.Z)}async ib(I){const P=async F=>{let $=await c.Promises.readdir(F);$=$.map(oe=>b.join(F,oe));const G=await Promise.all($.map(oe=>c.Promises.stat(oe)));let te=Promise.resolve([]);return G.forEach((oe,ge)=>{const ve=$[ge];oe.isFile()&&(te=te.then(le=>[...le,ve])),oe.isDirectory()&&(te=te.then(le=>P(ve).then(ce=>[...le,...ce])))}),te};return(await P(I.location.fsPath)).map(F=>({path:`extension/${b.relative(I.location.fsPath,F)}`,localPath:F}))}async jb({added:I,removed:P}){if(P)for(const A of P.extensions)this.v.info("Extensions removed from another source",A.id,P.profileLocation.toString()),this.p.fire({identifier:A,profileLocation:P.profileLocation});if(I){const F=(await this.S.scanExtensions(1,I.profileLocation)).filter($=>I.extensions.some(G=>(0,i.areSameExtensions)(G,$.identifier)));this.m.fire(F.map($=>(this.v.info("Extensions added from another source",$.identifier.id,I.profileLocation.toString()),{identifier:$.identifier,local:$,profileLocation:I.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(P=>this.kb.add(P)));const I=await this.bb.resolve(this.Y.userExtensionsLocation);for(const P of I.children??[])P.isDirectory&&this.kb.add(P.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(P=>this.mb(P)))}async mb(I){if(!I.affects(this.Y.userExtensionsLocation,1))return;const P=[];for(const A of I.rawAdded){if(this.kb.has(A)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(A),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(A,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(A).startsWith(".")||!(await this.bb.stat(A)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(A);F&&F.installedTimestamp===void 0&&(this.kb.add(A),P.push(F))}P.length&&(await this.nb(P,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",P.map(A=>A.identifier.id)))}async nb(I,P){await this.Z.addExtensionsToProfile(I.map(A=>[A,void 0]),P),this.m.fire(I.map(A=>({local:A,identifier:A.identifier,operation:1,profileLocation:P})))}};me=de([_(0,a.IExtensionGalleryService),_(1,ae.ITelemetryService),_(2,ie.ILogService),_(3,E.INativeEnvironmentService),_(4,r.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,d.IDownloadService),_(7,ee.IInstantiationService),_(8,X.IFileService),_(9,ne.IProductService),_(10,fe.IUriIdentityService),_(11,re.IUserDataProfilesService)],me),e.ExtensionManagementService=me;let B=class extends y.Disposable{constructor(I,P,A,F){super(),this.j=I,this.k=P,this.l=A,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(I,P){const A={includeInvalid:!0,profileLocation:P};let F=[];return I===null||I===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},A,!1)):I===1&&F.push(...await this.l.scanUserExtensions(A)),F=I!==null?F.filter($=>$.type===I):F,Promise.all(F.map($=>this.u($)))}async scanAllUserExtensions(I){const P=await this.l.scanUserExtensions({includeAllVersions:!I,includeInvalid:!0});return Promise.all(P.map(A=>this.u(A)))}async scanUserExtensionAtLocation(I){try{const P=await this.l.scanExistingExtension(I,1,{includeInvalid:!0});if(P)return await this.u(P)}catch(P){this.m.error(P)}return null}async extractUserExtension(I,P,A,F){const $=I.toString(),G=b.join(this.l.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),te=b.join(this.l.userExtensionsLocation.fsPath,$);try{await c.Promises.rm(te)}catch{throw new a.ExtensionManagementError(w.localize(4,null,te,I.id),a.ExtensionManagementErrorCode.Delete)}await this.p(I,P,G,F),await this.l.updateMetadata(L.URI.file(G),A);try{this.h.fire(L.URI.file(te)),await this.s(I,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(oe){try{await c.Promises.rm(G)}catch{}if(oe.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",I.id);else throw this.m.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,G),oe}return this.t(L.URI.file(te),1)}async updateMetadata(I,P){return await this.l.updateMetadata(I.location,P),this.t(I.location,I.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...I){const P=I.map(A=>i.ExtensionKey.create(A));await this.n(A=>P.forEach(F=>{A[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(I){await this.n(F=>delete F[I.toString()]);const A=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(I))||null;return A?this.updateMetadata(A,{installedTimestamp:Date.now()}):null}async removeExtension(I,P){this.m.trace(`Deleting ${P} extension from disk`,I.identifier.id,I.location.fsPath),await c.Promises.rm(I.location.fsPath),this.m.info("Deleted from disk",I.identifier.id,I.location.fsPath)}async removeUninstalledExtension(I){await this.removeExtension(I,"uninstalled"),await this.n(P=>delete P[i.ExtensionKey.create(I).toString()])}async n(I){return this.g.queue(async()=>{let P;try{P=await c.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let A={};if(P)try{A=JSON.parse(P)}catch{}return I&&(I(A),Object.keys(A).length?await c.Promises.writeFile(this.c,JSON.stringify(A)):await c.Promises.rm(this.c)),A})}async p(I,P,A,F){this.m.trace(`Started extracting the extension from ${P} to ${A}`);try{await c.Promises.rm(A)}catch($){throw new a.ExtensionManagementError(this.w($).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(P,A,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${A}:`,I.id)}catch($){try{await c.Promises.rm(A)}catch{}let G=a.ExtensionManagementErrorCode.Extract;throw $ instanceof p.ExtractError&&($.type==="CorruptZip"?G=a.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(G=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError($.message,G)}}async s(I,P,A,F){try{await c.Promises.rename(P,A)}catch($){if(g.isWindows&&$&&$.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${P} to ${A} with 'EPERM' error. Trying again...`,I.id),this.s(I,P,A,F);throw new a.ExtensionManagementError($.message||w.localize(5,null,P,A),$.code||a.ExtensionManagementErrorCode.Rename)}}async t(I,P){const A=await this.l.scanExistingExtension(I,P,{includeInvalid:!0});if(A)return this.u(A);throw new Error(w.localize(6,null,I.path))}async u(I){const P=await this.k.resolve(I.location);let A,F;return P.children&&(A=P.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,F=P.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:I.identifier,type:I.type,isBuiltin:I.isBuiltin||!!I.metadata?.isBuiltin,location:I.location,manifest:I.manifest,targetPlatform:I.targetPlatform,validations:I.validations,isValid:I.isValid,readmeUrl:A,changelogUrl:F,publisherDisplayName:I.metadata?.publisherDisplayName||null,publisherId:I.metadata?.publisherId||null,isApplicationScoped:!!I.metadata?.isApplicationScoped,isMachineScoped:!!I.metadata?.isMachineScoped,isPreReleaseVersion:!!I.metadata?.isPreReleaseVersion,preRelease:!!I.metadata?.preRelease,installedTimestamp:I.metadata?.installedTimestamp,updated:!!I.metadata?.updated}}async v(){const I=await this.getUninstalledExtensions(),P=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),A=new Set;for(const G of P)I[i.ExtensionKey.create(G).toString()]||A.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(P,G=>G.identifier);await T.Promises.settled(F.map(async G=>{const te=G.sort((oe,ge)=>k.rcompare(oe.manifest.version,ge.manifest.version))[0];A.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const $=P.filter(G=>G.metadata&&I[i.ExtensionKey.create(G).toString()]);await T.Promises.settled($.map(G=>this.removeUninstalledExtension(G)))}w(I){const P=Array.isArray(I)?I:[I];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((A,F)=>new Error(`${A.message}${A.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};B=de([_(1,X.IFileService),_(2,r.IExtensionsScannerService),_(3,ie.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,v.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(I,P,A,F,$){super(),this.identifier=I,this.source=P,this.l=A,this.m=F,this.n=$,this.j="Unverified",this.k=2}async o(I,P){try{const A=await this.p(I.key);if(A)return this.m.updateMetadata(A,I.metadata)}catch{throw g.isMacintosh?new a.ExtensionManagementError(w.localize(7,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(w.localize(8,null),a.ExtensionManagementErrorCode.Internal)}return this.s(I,P)}async p(I){if(!await this.q(I))return null;this.n.trace("Removing the extension from uninstalled list:",I.id);const A=await this.m.setInstalled(I);return this.n.info("Removed the extension from uninstalled list:",I.id),A}async q(I){return!!(await this.m.getUninstalledExtensions())[I.toString()]}async s({zipPath:I,key:P,metadata:A},F){const $=await this.m.extractUserExtension(P,I,A,F);return this.n.info("Extracting completed.",P.id),$}}class C extends j{constructor(I,P,A,F,$,G){super(P.identifier,P,A,$,G),this.t=I,this.u=P,this.v=F}async h(I){const A=(await this.m.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.u.identifier));A&&(this.k=3);const F={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,U.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||A?.isMachineScoped,isBuiltin:this.l.isBuiltin||A?.isBuiltin,isSystem:A?.type===0?!0:void 0,updated:!!A,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,v.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:A?.preRelease)};if(A?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(A,F),metadata:F};const{location:$,verificationStatus:G}=await this.v.download(this.u,this.k);try{return this.j=G,this.x($.fsPath),{local:await this.o({zipPath:$.fsPath,key:i.ExtensionKey.create(this.u),metadata:F},I),metadata:F}}catch(te){try{await this.v.delete($)}catch(oe){this.n.warn("Error while deleting the downloaded file",$.toString(),(0,D.getErrorMessage)(oe))}throw te}}async x(I){try{await(0,u.getManifest)(I)}catch(P){throw new a.ExtensionManagementError((0,t.joinErrors)(P).message,a.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=C;class V extends j{constructor(I,P,A,F,$,G){super({id:(0,i.getGalleryExtensionId)(I.publisher,I.name)},P,A,$,G),this.t=I,this.u=P,this.v=F}async h(I){const P=new i.ExtensionKey(this.identifier,this.t.version),F=(await this.m.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),$=await this.x(this.identifier.id,this.t.version,I);if($.isApplicationScoped=(0,U.isApplicationScopedExtension)(this.t),$.isMachineScoped=this.l.isMachineScoped||F?.isMachineScoped,$.isBuiltin=this.l.isBuiltin||F?.isBuiltin,$.installedTimestamp=Date.now(),F)if(this.k=3,P.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(w.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&k.gt(F.manifest.version,this.t.version)&&await this.m.setUninstalled(F);else{const te=await this.p(P);if(te)try{await this.m.removeExtension(te,"existing")}catch{throw new Error(w.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:b.resolve(this.u.fsPath),key:P,metadata:$},I),metadata:$}}async x(I,P,A){try{let[F]=await this.v.getExtensions([{id:I,version:P}],A);if(F||([F]=await this.v.getExtensions([{id:I}],A)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get verificationStatus(){return this.d.verificationStatus}constructor(I,P,A,F,$,G){this.d=I,this.g=P,this.h=A,this.j=F,this.k=$,this.l=G,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const I=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[I.local,I.metadata]],this.g),I}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(I,P,A){super(),this.extension=I,this.j=P,this.k=A}async h(I){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[155],Q([0,1,129,5,15,6,2,4,23,17,130,10,128,168]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends N.Disposable{constructor(h,c,p){super(),this.h=h,this.i=c,this.j=p,this.k(),this.B(h.onDidChangeConfiguration(w=>{w.affectsConfiguration("http")&&this.k()}))}k(){const h=this.h.getValue("http");this.a=h?.proxy,this.b=!!h?.proxyStrictSSL,this.f=h?.proxyAuthorization}async request(h,c){this.j.trace("RequestService#request (node) - begin",h.url);const{a:p,b:w}=this;let d;try{d=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(a){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",a))}const E={...process.env,...d},t=h.agent?h.agent:await(0,m.getProxyAgent)(h.url||"",E,{proxyUrl:p,strictSSL:w});h.agent=t,h.strictSSL=w,this.f&&(h.headers={...h.headers||{},"Proxy-Authorization":this.f});try{const a=await this.m(h,c);return this.j.trace("RequestService#request (node) - success",h.url),a}catch(a){throw this.j.trace("RequestService#request (node) - error",h.url,a),a}}async l(h){return((0,T.parse)(h.url).protocol==="https:"?await new Promise((w,d)=>{x(["https"],w,d)}):await new Promise((w,d)=>{x(["http"],w,d)})).request}m(h,c){return O.Promises.withAsyncBody(async(p,w)=>{const d=(0,T.parse)(h.url),E=h.getRawRequest?h.getRawRequest(h):await this.l(h),t={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,y.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(t.auth=h.user+":"+h.password);const a=E(t,i=>{const n=(0,y.isNumber)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...h,url:i.headers.location,followRedirects:n-1},c).then(p,w);else{let r=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,k.createGunzip)())),p({res:i,stream:(0,R.streamToBufferReadableStream)(r)})}});a.on("error",w),h.timeout&&a.setTimeout(h.timeout),h.isChromiumNetwork&&a.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&a.write(h.data),a.end(),c.onCancellationRequested(()=>{a.abort(),w(new D.CancellationError)})})}async resolveProxy(h){}};v=de([_(0,f.IConfigurationService),_(1,l.INativeEnvironmentService),_(2,g.ILogService)],v),e.RequestService=v}),define(Z[169],Q([0,1,33,5,15,34,6,2,16,14,12,35,11,20,23,125,58,127,17,106,150,24,59,132,40,48,154,148,13,117,119,46,115,62,63,136,10,121,122,38,152,139,28,47,155,67,131,68,25,138,39,140,141,27,143,21,151,142,147]),function(x,e,T,O,R,D,N,y,f,l,b,g,m,k,v,L,h,c,p,w,d,E,t,a,i,n,r,s,o,u,S,M,U,Y,X,ee,ie,ne,ae,fe,re,me,B,j,C,V,W,q,K,I,P,A,F,$,G,te,oe,ge,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends y.Disposable{constructor(se){super(),this.b=se,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.f();return se.invokeFunction(async be=>{const je=be.get(ie.ILogService),Ce=be.get(o.IFileService),Ne=be.get(p.INativeEnvironmentService),z=be.get(te.IUserDataProfilesService);je.info("CLI main",this.b),this.g(je),await this.h(Ne,Ce,z,se),await Promise.all(ue.map(H=>{(0,O.raceTimeout)(H.flush(),1e3)}))})}async f(){const se=new Y.ServiceCollection,ue={_serviceBrand:void 0,...me.default};se.set(B.IProductService,ue);const be=new w.NativeEnvironmentService(this.b,ue);se.set(p.INativeEnvironmentService,be),await Promise.all([be.appSettingsHome.fsPath,be.extensionsPath].map(De=>De?k.Promises.mkdir(De,{recursive:!0}):void 0));const je=(0,ie.getLogLevel)(be),Ce=[];Ce.push(new ne.SpdLogLogger("cli",(0,l.join)(be.logsPath,"cli.log"),!0,!1,je)),je===ie.LogLevel.Trace&&Ce.push(new ie.ConsoleLogger(je));const Ne=this.B(new ie.MultiplexLogService(Ce));se.set(ie.ILogService,Ne);const z=this.B(new u.FileService(Ne));se.set(o.IFileService,z);const H=this.B(new S.DiskFileSystemProvider(Ne));z.registerProvider(f.Schemas.file,H);const J=new W.StateService(be,Ne,z);se.set(V.IStateService,J);const he=new G.UriIdentityService(z);se.set($.IUriIdentityService,he);const pe=new oe.UserDataProfilesService(J,he,be,z,Ne);se.set(te.IUserDataProfilesService,pe);const Oe=b.isWindows&&ue.win32RegValueName?this.B(new re.NativePolicyService(Ne,ue.win32RegValueName)):be.policyFile?this.B(new ae.FilePolicyService(be.policyFile,z,Ne)):new fe.NullPolicyService;se.set(fe.IPolicyService,Oe);const Se=this.B(new L.ConfigurationService(pe.defaultProfile.settingsResource,z,Oe,Ne));se.set(v.IConfigurationService,Se),await Promise.all([J.init(),Se.initialize()]),pe.setEnablement(ue.quality!=="stable"||Se.getValue(te.PROFILES_ENABLEMENT_CONFIG)),se.set($.IUriIdentityService,new G.UriIdentityService(z)),se.set(j.IRequestService,new M.SyncDescriptor(C.RequestService,void 0,!0)),se.set(h.IDownloadService,new M.SyncDescriptor(c.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new M.SyncDescriptor(ve.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new M.SyncDescriptor(s.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new M.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(r.INativeServerExtensionManagementService,new M.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),se.set(E.IExtensionGalleryService,new M.SyncDescriptor(d.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(X.ILanguagePackService,new M.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Le=[],Ie=(0,P.isInternalTelemetry)(ue,Se);if((0,P.supportsTelemetry)(ue,be)){ue.aiConfig&&ue.aiConfig.ariaKey&&Le.push(new A.OneDataSystemAppender(Ie,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:De}=be,Fe={appenders:Le,sendErrorTelemetry:!1,commonProperties:(async()=>{let Re;try{Re=await(0,ge.resolveMachineId)(J)}catch(Te){Te.code!=="ENOENT"&&Ne.error(Te)}return(0,q.resolveCommonProperties)(z,(0,T.release)(),(0,T.hostname)(),process.arch,ue.commit,ue.version,Re,Ie,De)})(),piiPaths:(0,P.getPiiPathsFromEnvironment)(be)};se.set(K.ITelemetryService,new M.SyncDescriptor(I.TelemetryService,[Fe],!1))}else se.set(K.ITelemetryService,P.NullTelemetryService);return[new U.InstantiationService(se),Le]}g(se){(0,N.setUnexpectedErrorHandler)(ue=>{const be=(0,D.toErrorMessage)(ue,!0);!be||se.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",ue=>(0,N.onUnexpectedError)(ue)),process.on("unhandledRejection",ue=>(0,N.onUnexpectedError)(ue))}async h(se,ue,be,je){const Ce=(se.args.profile?be.profiles.find(Ne=>Ne.name===se.args.profile)??be.defaultProfile:be.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(se,ue,this.b["install-source"]);if(this.b["list-extensions"])return je.createInstance(a.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ce);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Ne={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ce};return je.createInstance(a.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Ne,!!this.b.force)}else{if(this.b["uninstall-extension"])return je.createInstance(a.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ce);if(this.b["locate-extension"])return je.createInstance(a.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}i(se){return se.map(ue=>/\.vsix$/i.test(ue)?m.URI.file((0,l.isAbsolute)(ue)?ue:(0,l.join)((0,g.cwd)(),ue)):ue)}async j(se,ue,be){await ue.writeFile(m.URI.file(se.installSourcePath),R.VSBuffer.fromString(be.slice(0,30)))}}async function ce(we){const se=new le(we);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/243854703b7fa371abb752ec0df7817a615a308b/core/vs/code/node/cliProcessMain.js.map
